Visual SourceSafe Start Page

Visual SourceSafe 6.0

Welcome to Visual SourceSafe 6.0, the version control system that enables you to manage your individual and team projects easier than ever before!

Visual SourceSafe 6.0 is a member of the Visual Studio 6.0 family of development products which includes:
  • Visual Basic
  • Visual C++
  • Visual FoxPro
  • Visual InterDev
  • Visual J++
  • Visual SourceSafe
  • MSDN Library

Copyright
Accessibility

Getting Started with Visual SourceSafe 6.0
If you're new to Visual SourceSafe or to version control, begin here.

What's New in Visual SourceSafe 6.0
Take a look at our new features!

Using Visual SourceSafe 6.0
Visit this section to learn how to use Visual SourceSafe.

Visual SourceSafe on the Web
Go to Web for the latest Visual SourceSafe information.


Documentation Map

The Microsoft Visual SourceSafe 6.0 (VSS) Help system describes VSS features and how to use them.

For information about using the Windows environment, see Help on the Windows Start menu.


Contents

New Features

Introduces you to VSS.

Using VSS

This section explains the features of VSS Explorer, and gives procedures for accomplishing your tasks. It is broken into several sections:

  • Files and Projects — covers the basic features of VSS.

  • Customize VSS — covers how to optimize VSS performance.

  • Version Control and History — covers version control, history, and merges.

  • Branch and Share Files and Projects — covers the branching and sharing features of VSS.

  • Web Projects — covers VSS Explorer's Web features.

  • Using the Command Line — covers the command-line commands for VSS Explorer.

Using VSS Administrator

This section explains the features of VSS Administrator, and gives procedures for accomplishing the administrator's tasks. It is divided into several sections:

  • VSS Administrator Tasks

  • Installation

  • Maintain the User List

  • Manage the Database

  • Rights Propagation

  • Samples of SS.INI and SRCSAFE.INI Files

  • Security Access Rights

Glossary

This section provides definitions for terms found throughout this Help system.

Reference

This section is a reference containing command summaries, initialization variables, and keyboard shortcuts for both VSS Explorer and Administrator.

Technical Support

This section provides technical support, troubleshooting, and accessibility information for people with disabilities.

World Wide Web Site

www.microsoft.com/ssafe


Where To Go First

If you are new to VSS, refer to Getting Started, which explains the key features of VSS.

If you have used VSS before, refer to New Features.

If you are a VSS client and VSS has been installed, see Working with Explorer for an explanation of the basic features of VSS and Understanding Projects for information on designing and organizing projects.


What's New with Visual SourceSafe 6.0

See Also

Microsoft VSS 6.0 has many new features, including:

  • Archive and Restore — These operations can now be performed from a user-friendly VSS Administrator wizard. In previous versions of VSS, Archive and Restore were only available from the command line.

  • Move files — When you move a file, VSS now automatically shares the file to a new project, deleting it from the original project. In the new project, the file appears as shared.

  • Compare differences in multiple projects — This feature allows you to compare differences in a project against another project.

  • Deploy individual files — In earlier versions of VSS you could only deploy a folder; using the new wizard, you can now deploy a file as well.

  • Fast Get — Because of VSS's improved capabilities, you can perform a Get two times faster than in older versions of VSS.

  • Filter history information — You can now view history of files and projects without including labels.

  • Label promotion — This feature allows you to promote or add a file to an existing label.

  • Clean temporary folder option — This feature allows you to easily clean temporary folders now.

  • Check external hyperlinks — In previous versions of VSS only internal hyperlinks and jumps within the project were checked. Now VSS allows you to check hyperlinks and jumps outside the project.

  • Create desktop shortcuts to VSS databases (from VSS Explorer) — This feature allows you to create a shortcut on your desktop that opens a specified VSS database.

  • HTML Help — Previous versions of VSS used WinHelp.


Optimizing VSS

Your VSS installation can be optimized to maximize performance. This optimization is broken down into two categories:

  • Features You Can Disable

  • General Optimization


Features You Can Disable

See Also

Your VSS administrator can disable any of the following features to optimize the speed of many VSS commands.

  • Shadow Folders

  • Journal Files

  • Project Security System


General Optimization

See Also

You can set these options on the Local Files tab in the Options dialog box on the Tools menu:

  • Copy keyword-expanded files into working folder — Useful if you use keyword expansion. Selecting this text box forces VSS to copy the file containing expanded keywords back into the working folder after it has been checked into the database. Clearing this check box may increase speed, as it tells VSS not to get a file after checkin.

  • Compare files by — Controls how VSS determines if you already have the latest copy of a file in your working folder. The Time setting sometimes does not behave as you expect when you try to get earlier versions. A solution is to occasionally delete your local copy to force a Get operation to occur.


Using VSS 4.0a and 5.0 with VSS 6.0

See Also

VSS 6.0 has a new database format. If you upgrade to this new format, VSS 4.0a, VSS 5.0, Macintosh, and UNIX 4.0/5.0 users will not be able to access the database until they upgrade.

The new database format must be enabled for faster database performance and label promotion.


Using VSS to Work on Multiple Versions of a Product at the Same Time

Two scenarios may occur in the ongoing development of a project. The first is where you don't expect to change many files and the second is where you may be changing several files, potentially several times. In the first scenario, use VSS' new Label-Promotion feature. In the second scenario, use Share/ Pin/ Branch.

Label Promotion is the best method to use when your development is done in the same project tree and bug fixes are routinely performed before other changes have been made in the project. A common example is when working on a major release with several milestones, such as Beta 1 and Beta 2. In this instance, you'd label the project when you believe you've hit Beta 1, then continue working toward Beta 2. If few fixes are needed for Beta 1, at this point use the Label-Promotion feature. For details, see Maintaining Multiple Versions of a Project.

Share/ Pin/ Branch is the best method to use for parallel development on a project over an extended period of time. A common example is when you're working on two releases that share code, both of which have milestones. For example, you've shipped Version 1.0, and now you're working on Version 2.0, however an interim patch for several bug fixes is needed. This patch will be released as Version 1.1. In this instance, you'd work on Version 2.0 and Version 1.1 in different project trees, then merge changes between them as necessary. For details, see Share, Pin and Branch to Create Service Pack Projects (Bug Fixes).


Using VSS with UNIX and Macintosh Computers

See Also

To use VSS with UNIX or Macintosh computers, contact MetroWerks (Macintosh) or MainSoft (UNIX). The default VSS installation is simple to create and use, but may not be optimized for performance. Therefore, you can customize your system to improve performance:

  • Copy as much information as possible from the network to your hard disk. This change is useful for all network users, but is essential for Macintosh users on Intel networks. You can use the VSS Netsetup.exe program (on the VSS server) to copy the VSS executable files to your local computer.

  • Fine-tune your initialization files for performance. Most fine-tunings involve compromises, such as disabling certain features that involve time-consuming overhead. None of these optimizations provides as much benefit as copying information from the network to your hard disk.


Getting Started with Visual SourceSafe 6.0

To take full advantage of Microsoft VSS, it's helpful to understand what VSS can do for you, including how it implements version control, how to set up working folders, and how to work with documents. To do this refer to the following topics:

  • VSS Overview

  • Understanding Projects

  • Understanding Version Control

  • Working with Explorer

  • Working with Files


VSS Overview

See Also

Microsoft VSS helps you manage your projects, regardless of the file type (text files, graphics files, binary files, sound files, or video files) by saving them to a database. When you need to share files between two or more projects, you can share them quickly and efficiently. When you add a file to VSS, the file is backed up on the database, made available to other people, and changes that have been made to the file are saved so you can recover an old version at any time. Members of your team can see the latest version of any file, make changes, and save a new version in the database.

VSS project organization makes team coordination easy and intuitive; for more information on projects, see Projects and for more information on files, see Files.

When a file (or set of files) is ready to deliver to another person, group, Web site, or any other location, VSS makes it easy to share and secure different versions of the selected set of files.

More and more, developers are accessing VSS functions from within their development environment. VSS can be easily integrated with Microsoft Access, Visual Basic, Visual C++, Visual FoxPro, and other development tools. If VSS is integrated into your development environment, you do not need to run VSS separately to realize the advantages of source code control.

To better understand VSS, see:

  • How VSS Treats Binary Files

  • Understanding Projects

  • Understanding Version Control

  • Understanding Working Folders

  • Working with Explorer

  • Working with Files

You will then be able to begin working with documents including, but not limited to doing the following:

  • Add Files, Folders, and Projects

  • Branch and Share Files

  • Check In, Check Out, and Edit Files

  • Get and View Files

  • Label Files and Projects

  • Merge Files

  • Move Files and Projects

  • Pin Files

  • To use VSS, you (or someone else in your work group) must perform some administrative tasks to set up a VSS database. To learn more about these tasks, refer to VSS Administrator Tasks.


Files

See Also

When you want to modify a document, you either check it out of the database, or tell VSS you want to edit the file. VSS copies the file from the database into your working folder. You can then modify the file. If anyone else attempts to check out the same file for editing, VSS generates a message stating the file is already checked out. This simple checkout protocol ensures that conflicts do not arise among multiple users working on the same file. If desired, you can change the project properties to allow multiple checkouts of the same file to different users. Note that binary files are never allowed to be checked out by multiple users.

After you are finished editing the document, you check it in to VSS. This copies the modified document from your folder into the VSS database, making your changes accessible to other users. VSS stores all the changes that have been made to the document; the most recent copy is always available, but earlier versions can be retrieved as well. The VSS reverse delta technology ensures that all versions of a document are available, but uses a minimum of disk space.

If you've made no changes to the file, you can also undo your checkout. The file returns to the way it was before you checked it out.

If you want to just read a file, and don't need to edit it, you can either Get the file into your working folder, or use the View File command to get the most recent version of the document.


How VSS Treats Binary Files

VSS makes a distinction between text files (files that contain only characters) and binary files (all others). For most operations, you can treat text and binary files exactly the same [image] VSS uses its highly disk-efficient reverse delta storage on all files, text and binary.

It is important to understand how VSS determines the type of a file and how VSS treats these two.

How VSS Identifies Files

When you add a file to VSS, it's automatically assigned a type: text or binary. The default mechanism for creating this assignment is a simple test: VSS scans the file for NULL characters (bytes with value 0). If it finds such a character, VSS identifies the file as binary.

Although generally accurate, this method may on occasion incorrectly assign the text type to a binary file. Therefore, VSS allows you to explicitly set the file type.

When you add a file, you can set the file type option: Auto-Detect, Binary, or Text. Auto-Detect is the default. After you add a file, it retains the type it was originally given, unless you explicitly change it.

Note Use the General tab in the Properties dialog box on the File menu to view and change the file type setting.

How VSS Handles Files

There are significant differences in how VSS treats binary and text files:

  • Storing changes — Internally, VSS uses different mechanisms for storing changes for text files (which have distinct lines as units of comparison) and binary files (which have no obvious line delimiter). That's why it is important for VSS to correctly identify the type of a file. VSS identifies files as binary if a NULL character exists in the file.

  • Show Differences command — With a binary file, VSS stores each change as a small record of which bytes moved where; this is useful for reconstructing earlier versions, but not for display. VSS can tell you if the file has changed, but it cannot display how the file has changed.

  • Merging binary files — This operation cannot be performed in VSS.

  • Multiple checkouts on binary files — This operation cannot be performed in VSS.

  • End-of-line characters — With a text file, VSS automatically translates end-of-line characters between different operating systems; with a binary file, VSS does not alter the contents of the file except with keyword expansion.


Projects

See Also

A project is a collection of files (any type) that you store in VSS. You can add, delete, edit, and share files within and among projects. A project has much in common with an operating system folder, but has better support for file merging, history, and version control.

Your projects exist in a VSS database. To open a database, see Open/Close a Database.

Files are stored in projects in the VSS database. You never work with the master copy of the file that is stored in VSS except occasionally to examine it or to compare another copy to it.

VSS provides each user with a copy of the file to read or change in the user's working folder. Although you can view a file without a working folder, in order to really work with VSS it is necessary to set up a working folder. See How to Set a Working Folder.

To learn more about designing and organizing projects, see Designing and Organizing Projects.


Version Control

See Also

VSS can maintain multiple versions of a file, including a record of the changes to the file from version to version.

Version control addresses the following areas:

  • Team coordination — making sure, by default, that only one person at a time is modifying a file. This prevents files from accidentally being replaced by another user's changes. Your administrator can change this default to allow multiple simultaneous checkouts of a single file, while still preventing overwrites of other changes.

  • Version tracking — archiving and tracking old versions of source code and other files, which can be retrieved for bug tracking and other purposes.

  • Cross-platform development — tracking portability issues involved in maintaining one code base across multiple development platforms.

  • Reusable or object-oriented code — tracking which programs use which modules so that code can be reused.

  • For more information on version control, see the Version Control and History section of VSS Help.


Working Folders

See Also

The working folder is where you actually work on a file. When you Check Out or Get a file, VSS copies the item into your working folder for that project. After you make changes to the file and check it in, VSS copies it from your working folder back into the database.

From then on, VSS manages your working folder by creating folders as needed on your computer when you check files out.

A working folder can be set or changed at any time. See Set Working Folders for more information. Files can also be viewed without a working folder. See Get and View Files and Projects for additional information.


Working with Explorer

See Also

VSS Explorer displays important status information, such as your current working folder, search criteria, number of files, and so on. Some of this information is shown in file pane column headings, and other information is shown in the status bar at the bottom of the VSS Explorer window. The title bar of VSS Explorer shows the database you are connected to. VSS Explorer uses symbols to provide information about the files and projects.

When you start Microsoft VSS, it first prompts you for your password, if you have set a password. If you have not set a password, you see VSS Explorer. From the Explorer window, you can navigate the VSS database, view your project list, examine file statistics, and execute commands that act on projects and files.

The project pane shows the project list, and includes information on special projects, like those you have designated Web site projects, cloaked projects, or the currently open project. The file pane shows the file list, which is a list of all files in the current project. The results pane displays the results from VSS operations. For example, when you check in a file, this pane shows the file name being checked in.

Just below the menu bar, the toolbar in VSS Explorer provides command buttons so you can quickly access the most common VSS commands.

At the bottom of the default VSS Explorer is the Results pane. This pane shows the results of your current VSS operation. As with other Explorer panes, you can resize this pane. You can also eliminate it entirely by clearing the Show results pane check box on the View tab in the Options command on the Tools menu.

To learn more about how to work with VSS Explorer files and projects refer to:

  • Drag and Drop

  • File List Symbols

  • Project List Symbols

  • Refresh List View

  • Resize List View

  • Right Mouse Button

  • Sort List View

  • Toolbar Command Buttons


Using Visual SourceSafe 6.0

When you work with VSS, you work with projects and the files they contain. You can store any type of file in VSS. Operations that VSS enables you to perform include:

  • Add Files, Folders, and Projects

  • Branch and Share Files and Projects

  • Check In and Check Out Files

  • Cloak Projects

  • Create New Projects

  • Customize the SS.INI and SRCSAFE.INI Files

  • Customize VSS

  • Delete and Recover Files and Projects

  • Edit Files

  • Get and View Files and Projects

  • Label Files and Projects

  • Merge Files

  • Move Files and Projects

  • Open/Close a Database

  • Pin Files and Projects

  • Rollback to Previous Versions

  • Search for Files

  • Set Working Folders

  • Set Default File Types

  • Set Passwords

  • Use the Command Line

  • Use the Options Dialog Box

  • Version Control and History

  • View or Modify File or Project Properties

  • Work with Shadow Folders

  • Work with Web Projects

  • Writing Batch Files

  • Use VSS Off-line


Overview of Files and Projects

A project is a collection of interrelated files that you store in VSS. You can add, delete, edit, and share files within and among projects. A project has much in common with an operating system folder; however, it provides additional support for file history and file version control.

Your projects exist in a VSS database. Files are stored in projects.

You can read or change a copy of a file in your working folder. See How to Set a Working Folder.

To learn more about how to work with files and projects refer to:

  • Add Files, Folders, and Projects

  • Branch and Share Files and Projects

  • Check In and Check Out Files

  • Cloak Projects

  • Create New Projects

  • Customize the SS.INI and SRCSAFE.INI Files

  • Customize VSS

  • Delete and Recover Files and Projects

  • Edit Files

  • Get and View Files and Projects

  • Label Files and Projects

  • Merge Files

  • Move Files and Projects

  • Open/Close a Database

  • Pin Files and Projects

  • Rollback to Previous Versions

  • Search for Files

  • Set Working Folders

  • Set Default File Types

  • Set Passwords

  • Use the Command Line

  • Use the Options Dialog Box

  • Version Control and History

  • View or Modify File or Project Properties

  • Work with Shadow Folders

  • Work with Web Projects

  • Writing Batch Files


Add Files, Folders, and Projects to VSS

See Also

Before you can add files to the VSS database, you must have a project to place the files in. When you begin working with VSS, the first thing to do is create one or more projects.

After you have created a project, you can add files or folders from your computer to the VSS database.

For information on how to add files, folders, and projects to VSS, refer to:

  • Add Files and Folders Using Drag and Drop

  • Add Folders

  • Add Multiple Files

  • Add Single Files


How to Add Files, Folders, and Projects to VSS

For information on how to add files, folders, and projects to VSS, see the following:

  • Add Files and Folders Using Drag and Drop

  • Add Folders

  • Add Multiple Files

  • Add Single Files


Branch and Share Files and Projects

See Also

In VSS, one file can be shared among multiple projects. Changes to the file from one project are automatically seen by other projects sharing the file. This encourages code reuse. Use the Links tab in the Properties command on the File menu to see a list of projects sharing a file.

Branching is the process of taking a file in two directions (that is, branches or paths) at once. VSS keeps track of these branches by tracking the different paths as a project.

Note In other (non-project-oriented) version control systems, branches are tracked through extended version numbers: for example, version "2.3.9.2" is the second revision of the ninth branch of version 2.3. In VSS, however, branches are tracked with different and distinct project names.

Branching a file breaks the shared link, making the file in that project independent of all other projects. The changes you make in the file are not reflected elsewhere, and vice versa. A branch has been created: two files (the file in the project, and its counterpart in other projects) have a shared history up to a certain point, and divergent histories after that time.

After you branch a file, the Links tab does not show the link that has been broken. Instead, you use the Paths tab (also available from the Properties command on the File menu) to view the branch history of the file.

For information on how to branch and share files and projects, refer to:

  • Branch Shared Files

  • Create File Links and Paths

  • Share and Branch a File in One Operation

  • Share, Pin and Branch to Create Service Pack Projects (Bug Fixes)


How To Branch and Share Files and Projects

For information on how to branch and share files and projects, see the following:

  • Branch Shared Files

  • Create File Links and Paths

  • Share and Branch a File in One Operation


How to Share Files

Note To view projects sharing a file, select the file, then go to the Links tab in the Properties command on the File menu.

To share a file:

  1. In VSS Explorer, select the project in which you want to share a file.

  2. On the SourceSafe menu, click Share to display the Share dialog box.

  3. In the File to share list, select the file you want to share. If the file you want to share is not displayed, select the project containing the file from the Projects list.

  4. Click Share.

  5. Click Close.


Check In, Check Out, and Edit Files and Projects

See Also

To make changes to a file you must first check it out of the VSS database. When you Check Out an item, VSS places a writable copy in your working folder. A file that is checked out cannot be checked out by anyone else unless your installation of VSS has been set up to allow multiple checkouts; see your VSS administrator for more details. You can see who an item is checked out to in the User column of the file pane. You can check out one file, multiple files, or all files in a project depending on what item(s) you have selected when you perform the checkout operation.

In addition to checking out an item, you can also View or Get the item. See Get and View Files and Projects for more information.

When a file is checked out, the following options are available:

  • Check In your updated file or project, thus storing your changes in the current project in VSS.

  • Undo your checkout, canceling your changes both in VSS and in your working folder — the file or project returns to the way it was before you checked it out.

For information on how to check in, check out, and edit files and projects, refer to:

  • Check In Files or Projects

  • Check Out Files or Projects

  • Edit Files

  • Rename Files or Projects

  • Undo Check Out


How to Check In, Check Out, and Edit Files and Projects

For information on how to check in, check out, and edit files and projects, see the following:

  • Check In Files or Projects

  • Check Out Files or Projects

  • Edit Files

  • Rename Files or Projects

  • Undo Check Out


Cloak Projects

See Also

Cloaking is a way of designating projects that you generally do not work on, and which you therefore do not necessarily want to keep local copies of. If a project is cloaked, Get, Check In, Check Out, Undo Check Out, and Project Difference commands do not apply to the project when attempted indirectly (as part of a recursive operation). Direct commands (with the cloaked project selected in VSS Explorer) still work normally.

As an example: suppose that you work on a project called $/OurApp. In this project there are subprojects called Code and Tests that you need and another subproject called Docs, which you never use. You might find yourself recursively getting $/OurApp, and then deleting the Docs subfolder from your hard disk, in order to obtain the configuration you need.

The solution is to cloak $/OurApp/Docs. Even though the project is cloaked, you can still get this project or its files at any time. However, when you recursively Get $/OurApp, the Docs project (and its subprojects) will be ignored. In other words, cloaking a project says, "Ignore this project when I act on higher-level projects recursively."

When you cloak a project, its subprojects are implicitly cloaked when you use a recursive operation on the cloaked project or on a higher project in the project list. In other words, a cloak says, "When something recursive happens above me, stop here."

For information on how to cloak projects, refer to:

  • How to Cloak Projects


How to Cloak Projects

To cloak a project:

  1. Click the project you want to cloak.

  2. On the File menu, click Properties, and click the General tab if it isn't already selected.

  3. Select the This project is Cloaked for me check box.

  4. Click Close.


Command Line Overview

See Also

VSS provides a command-line interface, which is particularly useful for the following users:

  • Programmers working on the command line who find typing VSS commands faster than launching VSS Explorer and using menus.

  • Administrators or builders who write and maintain batch files and macros that execute many VSS commands in rapid succession.

VSS supports command-line commands by using the SS.exe program, which is usually in the Win32 subfolder under the folder you choose in the setup program.

Use the MS-DOS command prompt to access the command line from within Windows NT or Windows 95. You can use the command line by changing your current folder to the folder in which SS.exe resides, or from any folder by typing a complete path to the SS.exe file; for example:

C:\Vss\Win32\SS.exe

The command line displays output from most commands in traditional character cell format. Certain commands, however, such as the View command, display output in windows. When the command's action is complete, VSS returns you to the command prompt. Each time you enter a command from the command line, VSS prompts you for your username and, if one is set, your password. You can avoid this step by performing certain actions based on your environment. See Avoid the Logon Prompt for more information.

When you are working with the VSS command-line interface, commands such as Get and Check Out place files into your current folder, not into your working folder for the project as they do in the Windows interface.

For information on how to use the command line, refer to:

  • Avoid the Logon Prompt

  • Enter Comments at the Command Line

  • Use Alternate Command Line Commands

  • Use Command Line Commands and Options

  • Use Command Line Syntax

  • Use the Command Line after Running a Client Setup

  • Using the Working Folder at the Command Line


How to Use the VSS Command Line

For information on how to use the command line, see the following:

  • Avoid the Logon Prompt

  • Enter Comments at the Command Line

  • Use Alternate Command Line Commands

  • Use Command Line Commands and Options

  • Use Command Line Syntax

  • Use the Command Line after Running a Client Setup

  • Use the Working Folder at the Command Line


Create New Projects

See Also

A project is a group of related documents or a collection of files. VSS allows you to easily store and organize your projects, in any hierarchy you like.

To create a project, use the Create Project command on the File menu. To add files to a project, use the Add Files command.

For information on how to create new projects, refer to:

  • How to Create New Projects


How to Create New Projects

You can create a single project or multiple projects in VSS.

To add a single project to VSS:

  1. On the File menu, click Create Project to display the Create Project dialog box.

  2. In the Project box, type the project name.

  3. In the Comment box, enter a brief description of the project.

  4. Click OK.


Customize VSS

You can customize the behavior of VSS in many ways. You can change the way that VSS behaves to optimize its performance, change the display, or insert expanding keywords into your files. Customizing VSS can increase your productivity, as well as make VSS run more smoothly for Macintosh and UNIX users.

You can customize fonts in VSS Explorer using the Font command on the Tools menu. You can also customize the VSS toolbar using the Customize Toolbar command on the Tools menu.

For information on how to customize VSS, refer to:

  • Check Out Multiple Files

  • Expand Keywords

  • Format Keywords

  • Optimize Performance

  • Perform an Exclusive Checkout


How to Customize VSS

For information on how to customize VSS, see the following:

  • Check Out Multiple Files

  • Expand Keywords

  • Format Keywords

  • Optimize Performance

  • Perform an Exclusive Checkout


Delete and Recover Files and Projects

When you want to remove a file from VSS, you must first decide whether you want to simply remove a file from a project, or from the VSS database. You must also decide if you want to delete the file with the option of recovering it, or destroy the file permanently.

VSS provides three ways to remove files:

  • Delete

    Removes a file from a project. When you use this command, the file is still in the VSS database and in other projects that share it, and it can be recovered. You can also use this command on projects.

  • Destroy

    The Delete dialog box contains the Destroy Permanently check box. When you select this check box, you remove the selected file or project from the VSS database. When you destroy a file or a project, you cannot recover it.

  • Purge

    Use this command to permanently remove a file that you deleted, but did not destroy permanently. You can use this command to purge an entire project and all the files it contains. When you purge a file or project, you cannot recover it.

The exception to this behavior concerns shared files. If a file is shared by two or more projects, the Delete command and Destroy Permanently command remove the file only from the currently selected project. The file remains in the other projects sharing it and in the VSS database.

For information on how to delete and recover files and projects in VSS, refer to:

  • Delete a File or Project

  • Destroy a File or Project

  • Purge Deleted Files

  • Recover Deleted Files


How to Delete and Recover Files and Projects

For information on how to delete and recover files and projects in VSS, see the following:

  • Delete a File or Project

  • Destroy a File or Project

  • Purge Deleted Files

  • Recover Deleted Files


Get and View Files and Projects

See Also

When you want to view a file or project, but not modify it, use the Get or View command. Get copies the file or project from the current project into your working folder. The file placed in your working folder is read-only — any modifications you make to it at this point cannot be saved in the VSS project.

If you do not have a working folder, you can still retrieve a read-only copy of a file with the View command.

For information on how to get and view files and projects in VSS, refer to:

  • Always Include Subprojects

  • Always Keep Files Checked Out

  • Fast Get

  • Get Earlier Version

  • Get Latest Version

  • View Files without a Working Folder

  • View Files without Getting or Checking Out


How to Get and View Files and Projects

For information on how to get and view files and projects in VSS, see the following:

  • Always Include Subprojects

  • Always Keep Files Checked Out

  • Fast Get

  • Get Earlier Version

  • Get Latest Version

  • View Files without a Working Folder

  • View Files without Getting or Checking Out


Label Files and Projects

See Also

VSS uses version numbers to keep track of every change you make to your files and projects. This gives you the ability to retrieve any version of a file or project.

VSS keeps track of old versions in 3 ways - by internal version number, by date, and by user-defined labels.

Version Number

The internal version number is assigned and maintained by VSS. VSS gives every version of a file and project a version number, and displays it in the History of File or History of Project Details dialog box. This version number is always a whole number.

Labels

Far more useful, however, are user-defined labels. You can associate a label with any version of any file or project. A label can be a string of up to 31 characters. Any of the following are valid labels: "1.0", "2.01b", "Final Beta", and "Approved for QA". After you apply these labels, you can retrieve files associated with a particular state of your project from the History dialog box, which is accessed from the Show History command on the Tools menu.

You will probably find that at a project level, you refer to user-defined labels, and not internal version numbers. On the other hand, it is rare to label individual files.

Note When you label a project with a descriptive text string, all the files in that project and subproject inherit the label.

Consider the following when you use the Label command:

  • When you use the Label command, you create a new version in History of the selected project or file, however, the file or project itself remains the same.

  • If you assign a label to a version that already has a label, you overwrite the old label. VSS issues a warning before removing the old label.

  • When you edit a label in the History Details dialog box, you do not create a new version of the file or project, you merely assign a new label to an existing version.

  • If you add a label to a version of a file or project in which the label already existed on another version, you will be prompted to remove the old label.

For information on how to label files and projects in VSS, refer to:

  • How to Label Files and Projects

For information on how to maintain multiple versions of a project at the same time, refer to:

  • Maintain Multiple Versions of a Project


How to Label

For information on how to label files and projects in VSS, see the following:

  • How to Label Files and Projects

  • Maintain Multiple Versions of a Project


How to Label Files and Projects

See Also

Note When you label a project with a descriptive text string, all the files in that project and subproject inherit the label.

To label the current version of a file or project:

  1. Select the file or project you want in VSS Explorer.

  2. On the File menu, click Label to display the Label dialog box.

  3. In the Label box, type a string of up to 31 characters; optionally, in the Comment box, type a comment.

  4. Click OK.

To label an older version of a file or project:

  1. Select the file or project you want in VSS Explorer.

  2. On the Tools menu, click Show History to display the History dialog box.

  3. Click Details to display the History Details dialog box.

  4. In the Label box, type a user-defined label; optionally, in the Comment box, type a comment.

  5. Click Close to exit the History Details dialog box.

  6. Click Close to exit the History dialog box.


Maintain Multiple Versions of a Project

See Also

If you are developing a product and are nearing a milestone, you have the option of maintaining multiple versions of that project, at the same time. Using VSS you can use share, pin, and branch as described in the topic Share, Pin and Branch to Create Service Pack Projects (Bug Fixes). Or you can also use labels.

If your situation requires a few lightweight patches with minimal changes to the build process, labeling is the way to go. If, however, you plan on a lot of ongoing development, performing a share, pin, and branch is the way to go. For instance, you would use the label-promotion feature to freeze the source tree during a Beta, and also to make fixes to the Beta. If, however, you are working on Version 1.1 and Version 2.0 of a product at the same time, the way to go is to make each version a new project, and then share and pin all the files, branching them when needed. When 1.1 has shipped, you can label the 1.1 project, then merge changes back into Version 2.0.

Below are some scenarios using the label-promotion feature you can use as a guide.

Scenario #1 — The ideal

  1. Develop and test your project in the drive toward Beta 1.

  2. At the point where you're ready to go to Beta 1, label the project "Beta 1" (or something similar).

  3. Begin working on Beta 2.

Scenario #2 — A different existing version of a file needs to be in Beta 1

Note The label-promotion feature only works if the new database format has been turned on. Run the DDUPD.EXE utility to activate the new database format. See DDUPD for more information.

  1. Develop and test your project in the drive toward Beta 1.

  2. At the point where you're ready to go to Beta 1, label the project "Beta 1" (or something similar).

  3. Begin working on Beta 2.

  4. If the wrong version of a file was included in the original Beta 1 label, select the file, then click Tools, Show History to display the History dialog.

  5. Select the version of the file that should be included as part of Beta 1 and label it "Beta 1."

  6. Get the project at Beta 1. This will get the project as it was at the date and time you labeled it "Beta 1" except that it gets the new version of file you just labeled individually as "Beta 1."

Scenario #3 — A fix of the current version of a file needs to be in Beta 1, while no other files have changed

  1. Develop and test your project in the drive toward Beta 1.

  2. At the point where you're ready to go to Beta 1, label the project "Beta 1" (or something similar).

  3. Begin working on Beta 2.

  4. You realize that the version of the file included in the Beta 1 label (e.g., Version 4) has a bug in it that must be fixed. No other files in the project have yet changed.

  5. Check out the file, make the change, then check it in.

  6. Label the project "Beta 1" again. (You'll be asked to confirm that you want to remove the old label.)

Scenario #4 — A fix of the current version of a file needs to be in Beta 1, while other files HAVE been changed

Note The label-promotion feature only works if the new database format has been turned on. Run the DDUPD.EXE utility to activate the new database format. See DDUPD for more information.

  1. Develop and test your project in the drive toward Beta 1.

  2. At the point where you're ready to go to Beta 1, label the project "Beta 1" (or something similar).

  3. Begin working on Beta 2.

  4. You realize that the version of the file included in the Beta 1 label has a bug in it that must be fixed. Unfortunately, other files in the project have been changed and the changes have been checked in.

  5. Check out the file that needs to be fixed, make the change, then check it in, creating a new version.

  6. Label the file "Beta 1" (the same label as you labeled the project). This promotes the new version of that file into the label "Beta 1."

Now, if you do a Get of the project at Beta 1, it will get the project as it was at the date and time you labeled it "Beta 1" except that it gets the newer version of the file you just labeled individually as "Beta 1."

Scenario #5 — An older version of a file needs to be fixed and added to Beta 1

Note The label-promotion feature only works if the new database format has been turned on. Run the DDUPD.EXE utility to activate the new database format. See DDUPD for more information.

  1. Develop and test your project in the drive toward Beta 1.

  2. At the point where you're ready to go to Beta 1, label the project "Beta 1" (or something similar).

  3. Begin working on Beta 2.

  4. You realize that the version of the file included in the Beta 1 label has a bug in it that must be fixed. For example, the current version of the file is Version 6 and it contains changes made on the road to Beta 2 you don't want included in Beta 1.

  5. Check out the file (Version 6).

  6. Get Version 4, overwriting the local copy of Version 6.

  7. Make the changes necessary to fix the bug for Beta 1, then check in the file. This makes a Version 7 of the file (Version 4 plus the fix you've just made, minus all the changes in Versions 5 and 6).

  8. Label Version 7 of the file "Beta 1." This promotes Version 7 of the file into the label "Beta 1."

    Now, if you do a Get of the project at Beta 1, it will get the project as it was at the date and time you labeled it "Beta 1" except that it gets Version 7 of the file (the one you just labeled individually).

  9. To continue work toward Beta 2, recovering changes made in Versions 5 and 6, check out the file again (i.e., check out Version 7).

  10. Get Version 6.

  11. Overwrite the local copy of Version 7, or merge the two file versions (this ensures the local copy becomes Version 6 plus the fix you made in Version 7 for Beta 1).

  12. Make any other changes if you want, then check in the file. This creates version 8. You can now resume work toward Beta 2.


Merge Files

See Also

Merging is the process of combining differences in two or more changed copies of a file into a single, new version of the file.

VSS cannot resolve merge conflicts, but instead presents them to you for resolution. There are two methods that can be used for viewing and resolving merge conflicts [image] visual merge and manual merge.

You choose which method to use on the General Options tab of the Options dialog box on the Tools menu. Visual merge is chosen by default for all merged files where conflicts are identified.

  • Visual Merge — The first method, recommended in most cases, is the visual merge. This method provides a graphical dialog box in which you can resolve all the conflicts quickly and with maximum control. See Resolve Merge Conflicts with Visual Merge.

  • Manual Merge — If you want to merge files manually, see Resolve Merge Conflicts without Visual Merge.

In VSS, a merge can occur in three different circumstances [image] when using multiple checkouts, when explicitly merging previously branched files, and when getting a file.

  • Multiple Checkouts — If multiple users have checked out a file, the first user simply checks in the file. Subsequent users also check in the file, but their changes are merged with all other users' changes, and VSS retains all the modifications.

  • Branching — When file branches are merged back into one of the branched projects, VSS takes the changes made along one line of the project and merges the changes with the other line.

In any merge, what happens is the same. VSS takes the file(s) with differences, compares them to the original file, then creates a resultant file containing all the changes. For example, if you check in a file that causes a merge, the file on your hard disk and the file in the project are then combined into a resultant file containing both sets of changes. This operation is sometimes referred to as a three-way merge.

Merge on Get

After a multiple checkout, there are two instances when changes can be merged in [image] at Check In, and during a Get Latest Version command (only if you have the Replace Writable Files option in the Local Files Options tab set to Merge).

In this instance, differences between your local copy of a file and the version saved in the VSS database are merged into the local copy when you get the latest version.

Note If a file is exclusively checked out, merge is not available when performing a Get Latest Version command.

After a Merge

After a merge, the file in your working folder is changed. If the merge was successful, that file represents the complete merge. If there was a merge conflict, VSS opens the Visual Merge window (unless you have opted for the manual merge). The Visual Merge window gives you a point-and-click way of choosing how to resolve each conflict, at the end of which you can save the completely merged file. Visual Merge is the recommended way to resolve your conflicts.

For those who have worked with earlier VSS versions or for batch scripts that must run without user intervention, you can choose the manual VSS merge to place identifying markers (six consecutive equal signs) in your file. In any text editor, you can search for and edit them manually.

In addition, after completing a merge, VSS observes the following rules.

  • If there were conflicts, VSS keeps the file checked out. You must resolve the conflicts to check in the new file to VSS.

  • If you use the Merge Branches command to merge a file into a project where you already have the file checked out, you still have the file checked out.

  • In all other circumstances, VSS gives you the option of either checking in the file automatically after the merge, or leaving the file checked out to your working folder so that you can inspect it before updating.

When the conflicts are resolved, check the file in again. VSS rechecks for any new conflicts, and if all conflicts have been resolved, then it checks in the file.

For information on how to use merge in VSS, refer to:

  • Merge Branched Files

  • Resolve Merge Conflicts without Visual Merge

  • Resolve Merge Conflicts with Visual Merge


How to Use Merge

For information on how to use merge in VSS, see the following:

  • Merge Branched Files

  • Resolve Merge Conflicts without Visual Merge

  • Resolve Merge Conflicts with Visual Merge


Move Files and Projects

See Also

Moving Files

The only way to move a file is to share it with the new parent project, and then delete or destroy the file in the original project. The history of the file will be retained. You cannot move individual files with the Move Project command.

Moving Projects

Note To use the Move command, you must have the Add access right in the parent project being moved to, and the Destroy access right in the parent project being moved from. See your administrator to change your rights.

You can relocate a subproject from one parent project to another by using the Move command. This command redefines the project path to a given subproject. For example, you select the project $/WordProcessor/SpellChecker and move it to the existing project $/Database. The new project is $/Database/SpellChecker and it is identical to the former project $/WordProcessor/SpellChecker.

This command does not rename a project; use the Rename command for that. The Move command does not change the contents or history of a subproject. It does, however, affect the histories of the old and new parent projects. Finally, a Move is very different from both a Share and a Branch.

Warning When you move a project, you make it impossible to faithfully reconstruct an old version of its parent project. After the preceding example, any attempt to recursively get a pre-moved version of $/WordProcessor generates a warning that subproject $/SpellChecker has been moved and is no longer available.

For information on how to move files and projects in VSS, refer to:

  • Move files

  • Move projects


How to Move Files and Projects

For information on how to move files and projects in VSS, see the following:

  • Move files

  • Move projects


Open/Close a Database

See Also

When you use VSS, your files and projects are stored in a database. This safely stores your information and provides important historical information and version tracking.

To create a new database, see your VSS administrator.

For information on how to open and close a database in VSS, refer to:

  • Open an Existing Database

  • Close a Database


How To Open/Close a Database

When you use VSS, your files and projects are stored in a database. For information on how to open and close a database in VSS, see the following:

  • Open an Existing Database

  • Close a Database


Options Dialog Box

You can customize a number of VSS options using the Options dialog box. Some tasks you can customize in VSS include:

  • How command dialogs are displayed

  • How command-line options function

  • How VSS displays file difference information

  • How routine actions are carried out, such as checkin and checkout

  • How and what VSS Explorer is set to display (for example, the toolbar, status bar, and so on)

For information on the Options Dialog box, refer to:

  • Command Dialogs Options Tab

  • Command Line Options Tab

  • Difference Options Tab

  • File Types Options Tab

  • General Options Tab

  • Local Files Options Tab

  • View Options Tab

  • Warnings Options Tab


Command Dialogs Options Tab

In this tab you can specify whether command dialog boxes are displayed when you perform VSS commands.

If you do not use the options provided on the Get Latest Version dialog box, for example, you can turn the dialog box off. When the Get Latest Version command is performed, the dialog box is not shown.

You can specify whether a dialog box appears in the following file commands:

  • Get Latest Version

  • Check Out

  • Undo Check Out

  • Show Differences

  • History

  • View and Edit

You can specify whether a dialog box appears in the following project commands:

  • Get Latest Version

  • Check Out

  • Undo Check Out

  • Show Differences

  • History

  • Deploy

  • Create Site Map

To display the Command Dialogs tab:

  1. On the Tools menu, click Options.

  2. Click the Command Dialogs tab.

Important Override any setting you make in this dialog box by holding down the SHIFT key while performing any of the preceding commands. The command dialog box appears even if the corresponding Options check box has not been selected.


Command Line Options Tab

See Also

In this tab you can specify how VSS's command-line options are performed. These options don't affect the behavior of VSS Explorer.

To display the Command Line Tab:

  1. On the Tools menu, click Options.

  2. Select the Command Line Options tab.

The first two options affect how VSS interacts with your working folder during command-line operations. By default in the Explorer, VSS expects a working folder to be set for each project, and will check out files to that folder only. By default on the command line, VSS assumes your current project and current folder are what you want to be working with, and ignores any working folders set for a specific project. You can modify this behavior by checking one of the following options.

The first two tab options determine how the working folder you've set is used.

Assume Working Folder Based on Current Project

  • If this option is selected, a file is put into your working folder for the project, even if that is not the current folder when you execute a command on a file from the command line.

  • If this option is not selected, subprojects go into their own respective working folders.

Assume Project Based on Working Folder

  • If this option is selected, VSS looks at your current folder whenever you execute any VSS command. If this is the working folder for a VSS project, VSS automatically changes to that project before executing the command. If you set this option, it is highly recommended that you don't give two projects the same working folder; VSS will not know which project to switch into.

  • If this option is not selected, VSS does not change to your current project when you execute any VSS command.

Check Out Comments

  • No Comment on Check Out — select this option if you don't want to be prompted for a comment upon checkout.

  • Apply Same Comment to All Files — select this option if you want VSS to take one comment (up to 64 characters) and apply it to all files involved in the checkout operation.

  • Apply Different Comment to Each File — select this option if you want to add a separate comment for each file involved in the checkout operation.

Comment Prompt

  • Prompt for Comments on the Command Line — select this option if you want VSS to ask for comments on the command line.

  • Use an Editor to Prompt for Comments — select this option if you want to use an editor to enter your command-line comments. After you select it, enter the path for the selected editor in the Editor box. Click Browse to search your file system for this information.

  • Use Prompt String — select this option if you want to specify that a prompt string (asking for a comment) be inserted into your editor when it opens. The prompt string is not saved with your comment unless you change the string in your editor.

  • Editor — enter the path for the selected editor. Click Browse to search for an editor.

Note This option is disabled when Prompt for Comments on the Command Line is selected.


Difference Options Tab

See Also

In this tab you can specify options for viewing differences between files or projects. These options are used in other VSS dialog boxes such as the Project Difference dialog box, the Visual Merge dialog box, the default VSS editor, and the VSS results pane.

To display the Difference options tab:

  1. On the Tools menu, click Options.

  2. Select the Difference tab.

Tab Options

You can specify/change all of the following options.

Colors

Select colors for lines VSS will use. The selected line color is shown in the Sample box.

Foreground

Select the foreground color.

Background

Select the background color.

Font

Select the font to be used in VSS Explorer and all its dialog boxes. To modify the font, click the Modify button.

Sample

The option(s) you've selected are displayed in this box.

Reset

Click here to reset all values on this tab to their defaults.

Tabstop Width

Specify the equivalent number of spaces each tab stop equals.

Shows Line Numbers

Select this box to show line numbers in the visual difference viewers.

Ignore White Space Differences when Merging Files

Select this box to ignore differences in white space (tabs, space characters, and so on) when merging two files.


Files Types Options Tab

File Types Options Tab

See Also

In this tab you can specify options for the types of files you store in VSS.

To display the File Types tab:

  1. On the Tools menu, click Options.

  2. Select the File Types tab.

Many of the VSS dialog boxes contain file lists that allow you to select multiple files for a specific operation. You can use this tab to filter these file lists so that they are more meaningful to the type of work you do.

Tab Options

You can specify/change all of the following options.

Binary Files

Overrides VSS's automatic detection of text and binary files, so that you can indicate that certain file types are always binary. For example, you can enter *.obj, *.xls, *.frx in this box to specify that all object files, Microsoft Excel worksheets, and Visual Basic .frx files should always be treated as binary files.

Create SCC File

This box is useful only for Visual Basic and Visual C++ users. When you work with a Visual Basic project in VSS, a special file is created in your working folder called Mssccprj.scc. This file can never be added to VSS: it stays in your working folder and stores important information used by the VSS integration in Visual Basic.

Create SCC File dictates when VSS creates this file. Its default setting (*.vbp, *.mak) means that whenever you get or add a file with an extension of .vbp (Visual Basic 4.0 project file) or .mak (used by older versions of Visual Basic), VSS creates the Mssccprj.scc file. This file is very important because without it, VSS integration inside Visual Basic will not function properly.

Visual C++ makes some of the SCC file. Add "*.dsp files" to this field to help Visual C++ easily locate VSS projects.

File Groups

Together with the File Types Included in File Group option, this option allows you to group file types into logical groups, which are then displayed in the List Files of Type options in many VSS dialog boxes. For example, if you are a C++ developer, you may want to store .cpp, .h, .rc, and .bmp files in VSS. If you are a Visual Basic developer, on the other hand, you may want to store .vbp and .frm files instead. You can use this tab to restrict the file lists to display just these file types rather than all the files in a specific folder.

Add

Click here to add a new group of file extensions to the list. In the Add File Group dialog box, type a name for the new file group you want to add, like "VC" or "VB."

Delete

Click here to delete the currently selected group.

Note The <Relevant Masks> file group is a unique case. It cannot be deleted, as it indicates which files you would typically place into a project.

File Types Included In File Group

This option allows you to modify a specific file group, as it shows the list of file types (extensions) included in the selected file groups. To modify a file group, edit the contents of the file types included in groups shown in the File Groups box.


General Options Tab

In this tab you can set properties for the selected project.

To display the General options tab:

  1. Select a project in VSS Explorer.

  2. On the Tools menu, click Options.

  3. Click the General tab if it isn't already selected.

Note To display this tab from within Visual Basic, after adding a Visual Basic project to VSS, on the Visual Basic Add-Ins menu, choose SourceSafe, and then choose SourceSafe Properties.

Tab Options

You can specify/change all of the following options.

Always Keep Files Checked Out

Select this box to keep a file checked out to your working folder, even if you check it in to the project database. The file is copied to the VSS database, but left checked out to you, so that you can update the database with your changes, but continue working on the file.

Act on Projects Recursively

Select this box to perform all actions on a selected project recursively, that is, the command is applied to the subprojects (and their subprojects, and so on) as well as to the selected project. This is useful if you have a project with many subprojects that you want to check out and check in as a unit.

Reuse Last Comment

Select this box to reuse the last comment for the next command. For example, if you check in a file with the comment "Added hyperlink jumps to our Help menu," and then check another file in, the same comment is entered in that file's comment box. If you modify the comment, VSS uses the changed comment for the next command.

Check In Unchanged Files

When you check in a file, and you have made no changes to it, VSS looks at this option to determine what to do.

Select one of the following:

  • Check In — instructs VSS to record the checkin as a new version, even if no changes to the file are detected.

  • Undo Check Out — instructs VSS to automatically undo checkout on any unchanged file you try to check in.

  • Ask — instructs VSS to display a dialog box asking what you want to do for each unchanged file.

  • Default — instructs VSS to depend on the specific initialization file settings for each project. This tells VSS how to determine what to do with unchanged files.

The default selection is Undo Check Out.

Use Visual Merge

Specify here when you want VSS to use the Visual Merge feature. VSS uses Visual Merge when merging files after a branch or multiple checkout. Your options include using Visual Merge only if there are conflicts, always use it (yes), or never use it (no). The default setting is Use Only If there are Conflicts. Change the setting to yes to see all changes during a merge.

Double-click on a File

Specify which command VSS should execute when you double-click on a file.

Your choices include:

  • Ask — instructs VSS to have a dialog box prompt you for what you'd like to do in every operation.

  • View file — instructs VSS to automatically display the file for viewing — you've no ability to edit the file.

  • Edit file — instructs VSS to check out the file automatically to your working folder, and open it for editing.

The default setting is Ask.

Editor for Viewing Files

If you want to use an editor to view text files, specify the path for the selected editor in this box, or click Browse to search for an editor.

Folder for Temporary Files

Specify here where you want VSS to store temporary files, or click Browse to search for and select a temporary file location. The default is the Temp subfolder under the folder in which SRCSAFE.INI is stored.

Note Creating your Temp folder locally, rather than on a server, may increase VSS performance.


Local Files Options Tab

See Also

In this tab you can set or change how files in the working folder are handled.

To display the Local Files tab:

  1. On the Tools menu, click Options.

  2. Select the Local Files tab.

Tab Options

Remove Local Copy After Add or Check In

This option causes VSS to automatically delete the local copy of files after add or checkin. It helps keep disk usage to a minimum, and ensures that you always get the most recent version when you start work on a file. Do not use this if you are using VSS integration with Visual Basic, Visual C++, or others.

Remove Local Copy After Delete

This option causes VSS to automatically remove the working folder copy of a file you delete in VSS. This helps keep disk clutter to a minimum. And, as long as you haven't destroyed or purged the file in the VSS database, you can always recover the file later.

Use Read-Only Flag for Files That Are Not Checked Out

Select this option to set the read-only flag on files in your working folder. VSS then assumes that files in your working folder that aren't checked out are read-only. It is highly recommended you leave this option turned on.

Copy Keyword-Expanded Files into Working Folder

Select this option to update keyword information in your working folder upon checkin. When you check in a file and have keyword expansion enabled, VSS updates the keyword information in your file. The modified file is replaced directly into VSS. If you do not check this option, a copy of the file will not be automatically placed in your working folder. Not using this option (clearing it) improves performance, but the copy in your working folder won't be up-to-date.

Append End-Of-Line To All Text Files

Set this option to append an end-of-line character whenever VSS retrieves a text file that does not already end with one. Some compilers require that all the files they compile end in an end-of-line character. If you are working in such an environment, you may want to set this option.

Compare Files By

This option allows you to set how VSS determines if your local copy is up-to-date. The following options are in order of increasing speed:

  • Contents [image] Compares the full contents of your local file to VSS's copy. This is the slowest method, but is the most accurate.

  • Checksum [image] Compares by a checksum stored by VSS. Use Checksum comparison for most VSS uses.

  • Time [image] Compares the date/time flags. The exact method of date comparison depends on the setting of the Set Date/Time On Local Files option: If set to Check In, VSS replaces the local copy if the time of the last check in (or add) is more recent than the local copy's modification date. If set to Current (the default) or Modification, VSS replaces the local file if VSS file's modification time is different from the local file's modification time.

Replace Writable Files

When you get or check out a file, VSS copies the file into your working folder. If there is already a writable copy of the file in your working folder, replacing the file may erase your work. This option allows you to specify how you want VSS to handle writable files.

  • Ask [image] Instructs a dialog box to ask you what you'd like to do for every operation.

  • Replace [image] Replaces (overwrites) the local file.

  • Skip [image] Does not replace the local file, and generates an error in the Results pane if you have it displayed.

  • Merge [image] Merges the changes between the checked-out-file and the one you are now getting or checking out. If the file cannot be merged (that is, it is a binary file), an error is displayed in the Results pane if you have it displayed. Your VSS administrator must enable multiple checkouts on the files involved for this to work properly.

Set Date/Time on Local Files

This option allows you to specify how VSS sets the date/time for files in your working folder. The option you choose is the time you will see when you view files in the Windows Explorer.

  • Current [image] Sets the date and time of the file to the current date and time, whenever VSS gets a file. This signals the compiler that the file has just changed, and needs to be recompiled. This is the default.

  • Modification [image] Sets the local copy to the date and time the file was last modified.

  • Check In [image] Sets the local copy to the date and time the file was last checked in.


View Options Tab

In this tab you can set VSS Explorer view options.

To display the View options tab:

  1. On the Tools menu, click Options.

  2. Select the View tab.

Tab Options

SourceSafe Window

  • Show Results Pane — Select this option to show the Results pane in VSS Explorer. The Results pane, at the bottom of VSS Explorer, shows you the results of your VSS commands.

  • Show Toolbar — Select this option to show the toolbar in VSS Explorer. The toolbar contains a set of buttons you can use to carry out commonly used commands.

  • Show Status Bar — Select this option to show the status bar in VSS Explorer. The status bar shows you status information about VSS, such as the current file pane sort order, the current username, and the number of items in the file list.

File List

  • Always Use MS-DOS Format Filenames — Select this option to truncate the long file names supported in 32-bit platforms. This option keeps the file name column of the display narrow, and is also useful if you have computers with several different operating systems using your VSS database.

  • Make Selected Project the Current Project — This option is normally selected. However, if your network suffers from poor performance, you may want to be able to scroll the project list without VSS updating the current project as you do so. In this case, turn off this option. If it is turned off, you must press the ENTER key on a project (or double-click with the mouse) to make it the current project.

  • Automatically Refresh File List — Select this option to have VSS automatically refresh its file list. Refreshing keeps VSS Explorer up-to-date, but it also causes a momentary delay (and a network load). If you select this option, enter the refresh interval in minutes in the box below. If you do not select this option, you can manually refresh the file list using the Refresh File List command on the View menu.


Warnings Options Tab

In this tab you can specify whether warnings are displayed before actions that might result in accidental loss or deletion of data.

To display the Warnings options tab:

  1. On the Tools menu, click Options.

  2. Click the Warnings tab.

Tab Options

When you delete a file from the VSS database, VSS asks "Are you sure you want to delete?" Some users find the warning helpful, because it prevents accidental deletion of data. Others find it annoying, because it requires an extra keystroke. This and other VSS warnings are therefore entirely configurable.

You can choose whether you want to receive warnings before VSS executes the following:

  • Undo checkout of a modified file

  • Delete a file or project

  • Destroy a file or project

  • Purge a file or project

  • Roll back a file

  • Check out an already checked-out file — If this option is disabled, multiple checkouts are turned off — see your VSS administrator.

  • Quit VSS


Passwords

See Also

Use the Change Password command to set and change your password. To change your password, you must first know what it is. If you forget your password, ask your VSS administrator to change it for you.

Upon log in, VSS prompts for a password if the operating system prevents it from determining user identity. It will not prompt for a password if the VSS administrator has specified the user network name is the same as the user log in name.

Note While your VSS password can be the same as or different from your operating system password, it is not meant to replace the operating system password.

For information on how to change your password, refer to:

  • How to Change Your Password


How to Change Your Password

To change your password:

  1. From the Tools menu, click Change Password to display the Password dialog box.

  2. In the Old Password box, type your current password.

  3. In the New Password box, type your new password.

    Note A password can consist of any combination of 1 to 15 valid characters. As you type, the characters are displayed as asterisks. Microsoft VSS passwords are not case-sensitive.

  4. In the Verify box, retype your new password to confirm the change.

  5. Click OK.


Pin Files and Projects

See Also

Pinning is most useful when applied to shared files, although it is not limited to shared files: You can pin any file. When you pin a shared file, however, you cannot thereafter make changes to it. Pinning is not the same as branching; for one thing, you are not making a copy of the file. For another, you are not planning to change the file. You are sticking a pin into the file so that a particular version of the file becomes the version that is part of your project.

If a file already pinned is then shared, and the pinned version is the version that is shared, the projects sharing the file cannot change it. If a file is shared first, and then pinned in one project, other projects can still change and update the file.

For information on how to pin and unpin files in VSS, refer to:

  • Pin Files

  • Unpin Files


How to Pin Files and Projects

For information on how to pin and unpin files in VSS, see the following:

  • Pin Files

  • Unpin Files


Properties

VSS allows you to view or edit certain file or project properties by using the Properties command on the File menu. For example, you can change the file's type, its comments, and specify whether to store only the latest version to save disk space.

For information on how to view or modify file or project properties in VSS, refer to:

  • Append End-of-Line to all Text Files

  • Edit Properties

  • View Deleted Files List

  • View File Links

  • View File Paths

  • View File Properties

  • View Size of Selected File


How to View or Edit File Properties

For information on how to view or modify file or project properties in VSS, see the following:

  • Append End-of-Line to all Text Files

  • Edit Properties

  • View Deleted Files List

  • View File Links

  • View File Paths

  • View File Properties

  • View Size of Selected File


Rollback to Previous Versions

See Also

Rollback returns a file to a previous version, erasing all the versions and changes since then. All changes made after the version rolled back to are lost. For example, if you click on version 5 and then click Rollback, all changes since version 5 are lost.

If the file you roll back to is being shared by more than one project, the rollback affects only the project you specify (the current project, by default). To accomplish this, rollback performs an implicit branch, that is, it branches the file in the specified project away from the same file in all other projects, and creates a new development path. To bring the disparate development paths back together, if you make changes to the specified project, you have to merge the files.

Note You can also perform a Virtual Rollback, which doesn't erase all versions and changes of a file. This is the preferred method for performing a rollback.

For information on how to rollback to previous versions in VSS, refer to:

  • Rollback to a Previous Version of a file

  • Virtual Rollback to a Previous Version of a File


How to Rollback to Previous Versions

For information on how to rollback to previous versions in VSS, see the following:

  • Rollback to a Previous Version of a File

  • Virtual Rollback to a Previous Version of a File


Samples

See Also

For examples of when to use operations in VSS, see the following:

  • Branching Example

  • Date/Time Stamp Example

  • Labeling Example

  • Sample Batch File

  • Sharing Example


Branching Example

See Also

Example 1 [image] Customized Versions of a Program

Suppose you are working on two programs for two clients. The two programs are virtually identical, but you want to tailor the programs' behavior in one or two files.

To begin, you share one project, $/WORD, to a new project, $/CLIENT2. (If $/WORD has subprojects, you recursively share them as well.) You now have two projects that are identical in every way.

Next, you select the few files you want to tailor in $/CLIENT2 and branch them. Now when you modify these specific files in $/CLIENT2, your changes do not propagate to $/WORD. All the other files, however, are still shared between the two projects. If you modify any of the shared files, the changes will be propagated to Word.

Branching is quick and easy, and powerful. But keep in mind that if you subsequently add a file to one project and then you decide you want to include it in the other project, you'll have to either add or share it into the other. If you delete a file from one project, you have to delete it in the other as well.

Note This technique can also be used when you are supporting one program under multiple platforms, or in any other case where two versions follow each other through time, but retain different code in specified ways.

Example 2 [image] Parallel Versions of the Same Program

Suppose that after your project reaches version 3.1, development proceeds in two different directions. One team is working toward the next major release, the 4.0 version. The other team is working on a maintenance release, version 3.2.

You create a new project, labeled $/PATCH, to represent the 3.2 version. You share and branch all the files into it. You branch because you don’t want the projects to track each other, because versions 3.2 and 4.0 are going in different directions. Accordingly, changes made in one are not automatically reflected in the other.

The projects now proceed in different directions, independent of each other. Later, you may want to merge the version 3.2 changes [image] bug fixes or minor feature enhancements, for example [image] into version 4.0. You will then be able to merge those changes using the "merge branches" command.


Date/Time Stamp Example

See Also

In this example, a C programmer has the file Help.c in VSS and in his working folder. His compiler turns this source code file into the object module Help.obj. At any given time during the development cycle, both files, Help.c and Help.obj, can exist in the same folder. Each time the developer types MAKE from the operating system, his Make utility compares the date/time stamp of Help.c with Help.obj to determine if it should compile, using the following rules.

  • If Help.c is more recent than Help.obj, the code has changed, and a recompile is necessary.

  • If Help.obj is more recent than Help.c, the code has already been compiled, and no recompile is necessary.

This behavior is simple, logical, and consistent, ensuring that every Make builds the entire program from the most recent version of the code as quickly as possible.

Now consider the ramifications for VSS. You compile Help.c into Help.obj, giving the latter a new date/time. If you execute Make again without changing anything, Help.c is not recompiled. Satisfied with your changes, you check Help.c into VSS; and the next morning, you get Help.c again.

If Help.c has not changed, VSS recognizes that its own copy and yours are identical. It does not perform a Get, the file date/time does not change, and the file is not recompiled, which is as it should be.

If another developer has changed Help.c, VSS recognizes that the file is different. It Gets Help.c, and sets the file's date/time to the current time (instead of the time the file was checked in). When you execute the Make command, the file is recompiled, again as it should be. Hence, VSS's behavior sends the correct signal to the Make utility regardless of whether anyone has changed the file.


Labeling Example

See Also

This example illustrates how project-level labels are different from file-level labels. Keep in mind that labels are also separate and distinct from version numbers.

Example

Let’s say you label the project $/NorWind "Version 2.2". You then revise the

Hyper.c file within the $/NorWind project, and label it "Version 2.2." Because that version of the file did not exist when you labeled the project, however, if you get the project at label Version 2.2, you will not get the latest version of the file Hyper.c. In other words, if you select "Version 2.2" of the $/NorWind project in the File History dialog box and click the Get button, you will not get the latest version of Hyper.c. You will get the version of that file that was in the project $/Norwind when the project was labeled Version 2.2.


Sample Batch File

See Also

If you type ss Checkout Help.c Help.H, and one of the two files is already checked out, VSS checks the other file out. The following batch file avoids this situation by checking the status of all the specified files and only checking them out if none of them is checked out.

The following sample demonstrates many of the features described in the two help topics How to Redirect Output and How to Disable Input, including the use of the following options:

  • -o to disable output

  • -y to specify a username

  • -c to specify a comment

This sample also uses the exit code of the Status command to determine whether files are checked out.

Sample of a Batch File

@echo off
ss status -o- -yThomas %1 %2 %3 %4 %5 %6 %7 %8 %9
if errorlevel 100 goto BAD_FAILURE
if errorlevel 1 goto CHECKED_OUT

rem Exit code 0, no files were checked out
echo No specified files are checked out: checking all out.
ss checkout "-cChecked out automatically" -yThomas %1 %2 %3 %4 %5 %6 %7 %8 %9
goto END

rem Exit code 1, something is checked out
:CHECKED_OUT
echo One or more files is checked out: quitting without checking anything out.
goto END

rem Exit code 100, something went wrong.
:BAD_FAILURE
echo Visual SourceSafe could not run successfully

:END


Sharing Example

See Also

To appreciate the advantages of file sharing, consider the following scenario:

Your team develops a suite of tools that do different things, but work on the same data format. They are built around a common set of core code, modules and header files that are used by many programs. You store each tool's files in its own project. You also share the common files among projects so that any change made to a common file is immediately propagated to all the tools.

For example, the database group of the office tools team wants to add a spelling checker. The word processing group already has a spelling checker. The database group could just add the spelling checker files to its project, but the two groups would not be connected. If the database team found a bug in the spelling checker, the word processing group would have to duplicate the change. By sharing the files, both groups work with common source files and all changes are automatically seen by both projects.


Search for Files

Ordinarily, the list view shows all the files in the current project. However, you can also use the Search command to see only files that match certain criteria, such as all files with the *.c extension (wildcard search), or to view only checked-out files. Searches can be recursive, to search all the subprojects under the current project, or global searches, to search the entire project list.

Search strings can be up to 63 characters long.

For information on how to use search in VSS, refer to:

  • Cancel Search

  • Search by String

  • Search for Checked Out Files

  • Search with a Wildcard


How to Search for Files

For information on how to use search in VSS, see the following:

  • Cancel Search

  • Search by String

  • Search for Checked Out Files

  • Search with a Wildcard


Set Default File Types

See Also

Individual users can change or set their own default file type settings. The VSS administrator can also set defaults that apply to all users. Default file type settings are used by VSS on add/share dialog boxes to help filter for those files specified.

For information on how to set default file types in VSS, refer to:

  • How to Set Default File Types


How to Set Default File Types -- Individual Settings

How to Set Default File Types — Individual Settings

See Also

To set default file types for an individual VSS user:

  1. On the VSS Explorer Tools menu, click Options to display the SourceSafe Options dialog box.

  2. Click the File Types tab.

  3. Enter or select applicable information on this tab, including:
    • Binary Files

      Type file masks for files you want VSS to treat as binary. By default, when VSS must know what type a file is, it uses its auto-detect mechanism. By entering values in this edit box, however, you tell VSS that all files of the type you enter are to be considered binary. For example, if you enter "*.obj, *.exe, *.doc" VSS always treats all files with those extensions as binary.

    • Create SCC File

      Type file masks for files you want VSS to place in your SCC file.

      This box is useful only for Visual Basic users. When you work with a Visual Basic project in VSS, a special file is created in your working folder called Mssccprj.scc. This file can never be added to VSS: it stays in your working folder and stores important information used by the VSS integration in Visual Basic.

      Create SCC File dictates when VSS creates this file. Its default setting (*.vbp, *.mak) means that whenever you get or add a file with an extension of .vbp (Visual Basic project file) or .mak (used by older versions of Visual Basic), VSS creates the Mssccprj.scc file. This file is very important because without it, VSS integration inside Visual Basic will not function properly.

      On the other hand, Visual C++ and other development environments do not use this file at all. You may not want this useless file appearing in your Visual C++ folder. To prevent the appearance of the Mssccprj.scc file in your Visual C++ folder, remove the *.mak from this field. (You should make this change only if you do not use Visual Basic .mak files.)

    • File Groups

      Select a group of files to which you assign file masks. Add and Delete allow you to add or delete file groups, with one exception: you cannot delete the <Relevant Masks> group. This mask is provided for your convenience. It enables you to create a relevant group of the files you use most often; this <Relevant Masks> group then becomes the group of default file types in the Add File, Share, and other dialog boxes used to manipulate files within projects.

    • File types included in file group

      Type file masks in this box for the group you selected from the File Groups box. For example, when you click Visual Basic files in the File Groups box, type the file types to make up this group: *.bas, *.frx, *.vbp, *.vbx.

  4. Click OK.


Set Working Folders

VSS is a tool for storing and managing files, but editing or compiling files is done in a folder that you specify for VSS to use. This folder is called a working folder. A working folder can be an existing folder or a new folder that VSS creates for you. VSS Explorer displays your working folder path above the list view.

A working folder is set per user, per project, per machine. If Joe works on projects $/SpreadSheet and $/WordProcessor, he has two different working folders, one for each project. If Hanna works on the same projects, she has her own working folders for each project.

When you set a working folder for a project, you can set it for the entire project, including all subprojects under that project. You can, however, explicitly set a working folder for any subproject.

You must specify a working folder to perform any action that copies a file out of VSS, including the Check Out and Get Latest Version commands. When you attempt to use any of these commands without a working folder, VSS displays a message asking if you would like to set a working folder. If you choose not to set a working folder, VSS stops the command.

The only operation you can perform without a working folder is viewing a file. See Get and View Files and Projects for additional information.

For information on how to set working folders in VSS, refer to:

How to Set a Working Folder


How to Set a Working Folder

You must specify a working folder to perform any action that copies a file out of VSS, including the Check Out, Check In, Undo Check Out, Get Latest Version, and Merge commands.

To set a working folder:

  1. Select the project for which you want to set a working folder.

  2. On the File menu, click Set Working Folder to display the Set Working Folder dialog box.

  3. Select the drive with the folder that you'd like to use.

  4. In the Folders box, navigate down to the folder you'd like to use as a working folder.

  5. Click OK. The path to your working folder is displayed in VSS Explorer above the list view.


Shadow Folders

See Also

A shadow folder is a centralized folder on your network server that contains all the files in a project. Shadow folders must be set up by your VSS administrator.

A shadow folder does not contain the master copy of the files (the master copy of every file is in the VSS database), and it does not contain the local copy of the files in your working folder. It contains a copy of the most recently checked-in version of each file in the project. Therefore, it serves as a centralized area to view and compile your source code.

A shadow folder is completely optional. It is generally used in one of two situations:

  • To allow users to view but not modify files. There may be users who want to see the files, but who do not have access to VSS.

  • To prevent your working folder from keeping its own compilable copy of the project. To make sure that every user has the most recent version of files, it may be desirable for all users to compile source code out of a centralized folder, instead of in personal working folders. In this case, shadow folders are frequently used in conjunction with the Remove local copy after Add or Check In option on the Local Files tab in the Options dialog box on the Tools menu.

Important Shadowed folders do not track changes to their subprojects. For example, if you have shadowed project $/A that contains two subprojects $/A/1 and $/A/2, and you rename $/A/2 to $/A/B, the name change is not shadowed. Project level changes need to be tracked manually, or you can use Reconcile All from the Project Difference dialog box occasionally to update the shadow folder. You can also repair a shadow folder with out-of-date files by performing a Get to the shadow folder.


SS.INI and SRCSAFE.INI File Overview

See Also

VSS provides two initialization files that contain settings you can use to customize your VSS environment:

  • SS.INI, for individual user variables

  • SRCSAFE.INI, for the VSS database global variables

Each user has an SS.INI file that can be edited.

Important Only the VSS administrator should edit SRCSAFE.INI.

Manually editing the initialization files is not recommended, unless you are very familiar with VSS initialization variables and their behavior. Instead, you should set most initialization variables directly in VSS in the Options dialog box on the Tools menu. You can set the SRCSAFE.INI variables in the VSS Administrator Options dialog box.

For information on how to customize the SS.INI and SRCSAFE.INI files, refer to:

  • Customize SS.INI and SRCSAFE.INI Files

  • Set a Working Folder in SS.INI

  • Use Project Headers in SS.INI


How to Customize the SS.INI and SRCSAFE.INI Files

For information on how to customize the SS.INI and SRCSAFE.INI files, see the following:

  • Customize SS.INI and SRCSAFE.INI Files

  • Set a Working Folder in SS.INI

  • Use Project Headers in SS.INI


Using VSS Off-line

You can use VSS to work off-line in the following situations:

  • When the network is down

  • When working on a laptop

  • When working from home, using RAS


Working from Home (Using RAS)

VSS 6.0 has been improved for using a RAS connection, however, file transfer over a modem is typically slow. Here are some tips to speed things up:

  • If you are taking files home on a portable disk, copy the vssver.scc file and all the source files into the same directory. The vssver.scc file helps VSS determine if the latest version is being used, which will minimize network traffic over the phone line. If you use this tip, you must copy all files to your home machine or VSS may think you have newer versions of files than you do, and fail to do a get for some files.

  • Doing a get over RAS when many files have changed is inherently a slow operation, even after VSS 6.0 performance enhancements. For the best results, perform a get to a portable disk before you leave work, and only do check in and check out's from home. Get files over RAS only when you really need to, to save yourself time. (For example, if you check out the latest version of a file using RAS, the check out operation may copy a file that needs other new files to compile. At this point, you'd have to do a get of the entire project, extremely time-consuming.)

  • To avoid doing gets over RAS, you can check out old versions of a file from the VSS History dialog box (via Tools, Show History) or from the command line. Multiple checkouts must be enabled to use this feature. See your VSS Administrator to enable multiple checkouts.

  • The command line is usually faster to use from home than the GUI.

Here are some ways to configure VSS to run faster over RAS:

  • Configure VSS to use a local temp directory.

  • Configure VSS to compare files by Checksum instead of contents (Checksum is the default).

  • Do not use the keyword expansion feature.

  • Change the users.txt file to configure VSS to use a local ss.ini file, as follows:

Note Make sure you've done a backup first!

Change:USER_NAME=\USERS\USER_NAME\SS.INI

to:USER_NAME=<local drive>\SS\USER\SS.INI

If you work from home often, you may also want to ask your VSS Administrator to configure VSS for faster access over RAS by doing any of the following:

  • Turn off shadow directories.

  • Turn off the journal file.

  • Turn off project security.


Working on a Laptop

When using VSS on a laptop, before you leave the office, check out any files you think you might want to change.

If multiple checkouts are enabled, feel free to check out all the project files. You can undo check out later on those you didn’t need. If multiple checkouts is NOT enabled, then only check out those files you think you will need.

Checking out binary files will prevent anyone else from checking them out, so use discretion when doing this.


Working when the Network is Down

If you can’t get to the net, and discover you need to check out a file, all is not lost, but you will have some additional work. Here are the steps to follow:

  1. Change the read-only attribute on the file to writeable using attrib, or Windows Explorer.

  2. Make your changes to the file.

  3. When you get back onto the network, use the History dialog box (via Tools, Show History) and the diff button to determine what numbered version of the file you took home. You can do this by doing a diff against successively older versions until you find a diff that only contains the changes that you made.

  4. Check out that numbered version of the file from the History dialog box, using the Don’t get local copy option. (You may need to hold down the shift key to see this option.) This option is also available from the command line.

    Now, the file is in the exact state it was before network disconnection and you can proceed safely.

Note The VSS Administrator must enable multiple checkouts before you are allowed to check out old versions of files. If multiple checkouts is not enabled, you can check out the latest version of the file by selecting the Don’t get local copy box, but you must manually merge in any changes that happened since you left.

  5. You may need to do a merge before you check in. Make sure your merge does not destroy the work of anyone who checked in since the network went down (or you left the office).


Version Control and History

See Also

VSS provides version control and history services, to ensure that each version of a file is recoverable. The date/time stamp is used to record when files are checked out or changed. See How VSS Uses the Date/Time Stamp for more information.

VSS uses three methods to track versions of files and projects:

  • Version numbers. These are internal numbers maintained by VSS. You, the user, have no control over these numbers. Every version of every file and project in VSS has a version number. The version number is always a whole number and always increases.

  • Labels. These are strings that you can apply to any version of a project or file. A label is a free-form string of up to 31 characters. The following are all valid labels: "1.0", "2.01b", "Field Test 3", and "Approved by QA".

  • Date/Time stamp. These tell when a file was last modified, or when a file was checked in. VSS supports both 12-hour format (with "a" or "p" suffix) and 24-hour format.

The following table compares and contrasts version numbers and labels.

Version number | Label
Assigned automatically by VSS | Assigned by user, using the Label command from the File menu or the History dialog box
Always a numeric value | Any combination of letters, numbers, symbols, and spaces up to 31 characters
Always increases to next whole number | Anything user assigns
Increases each time an action that affects storage is taken on a file or project such as adding, checking in, or branching | Assigned when user feels that a significant milestone has been reached
Displayed in history, paths, links, share, and file properties dialog boxes and in file pane of VSS Explorer | Displayed in history dialog boxes as a user-supplied string. Indicated by a label icon next to the project name in place of a version number. The user-supplied label string is displayed in the Action column of the History dialog box.
Does not create a new version, simply identifies a new version | Creating a label can create a new version of the file or project and the label is associated with the new version
Cannot be edited or changed by user | Can be edited in the History Details dialog box

Note Some software development groups label VSS with every build. You can get equivalent functionality and less database clutter by doing a history, get at a specific date-time stamp.

For information on how VSS uses the date/time stamp, refer to:

  • How VSS Uses the Date/Time Stamp


How VSS Uses the Date/Time Stamp

See Also

When you get or check out a file from VSS into your working folder, VSS sets a modification date that your operating system then tracks for each file.

VSS uses the following rules to determine the date/time it gives your file:

  • If you already have a local copy of the file and it's identical to the file you are retrieving, VSS does nothing [image] the file's time stamp remains unchanged.

  • If VSS does retrieve the file (you don't already have it or your copy is not up-to-date), it gives the file the current date/time, at the time of the retrieval.

Why VSS Works This Way

The modification date/time is used by many compilers and make systems as a signal of whether a file has changed and therefore has to be recompiled. VSS's treatment of date/time is designed to optimize this process, ensuring that you compile only when you need to.

Changing the Date/Time Stamp

The behavior described above is VSS's default behavior. If your needs are different, you can change the behavior with the options on the Local Files tab of the Options dialog box on the Tools menu or by using the Advanced options on certain dialog boxes like the Get dialog box.

If your computer is out of sync with another computer, unpredictable results may occur. For instance, you may check in a file after someone else, but VSS may think your checkin happened first, because your system clock was off. The best solution for this problem is to synchronize your local date/time with the network on a regular basis. This will ensure that all users are in sync. With NT this can be done with a Domain Time Source Server. Please check the http://www.novell.com site for information on time synching with Novell NetWare servers.


View File History

Every VSS file keeps a detailed record of its history. From the History dialog box, you can view version information, comments, and general details of a file's history, as well as get an old version of a file or check it out.

Note Only files can be checked out from the History dialog box; projects cannot be checked out.

You can also do gets, checkouts, differences, pins, unpins, rollbacks, and reports from the History dialog box.

For information on how to view file history, refer to:

  • View Check In Information

  • View Check In Comments

  • View Details of File History


How to View File History

From the History dialog box VSS enables you to do the following:

  • View Check In Information

  • View Check In Comments

  • View Details of File History


Web Projects

See Also

VSS has several features designed to support Webmasters and Web authors who are tasked with organizing and maintaining a World Wide Web site. Typically, Web sites involve a multitude of HTML and graphics files organized into various folders. Because these files change frequently, VSS is an ideal way to keep track of file versions, archive your files, and track changes to solve broken links and other problems.

The basic idea is that you collect a set of HTML, graphics, and supporting files that embody a Web site and check them into a VSS project. Then, your VSS administrator designates that project as a Web site project. When this is done, a special icon ( [image]) is used in VSS Explorer to show that the project is a Web site project.

When a Web site project is selected, the commands on the VSS Web menu are enabled. These are:

  • Check Hyperlinks — this allows you to check links between files in projects.

  • Create Site Map — this allows you to create a map of all the HTML files in your project.

  • Deploy — this allows you to deploy a set of Web files to a designated Web server.

VSS also supports a new form of keyword expansion that makes adding a "Last modified on" date much simpler for HTML files.

For information on how to work with Web projects, refer to:

  • Check Hyperlinks on a Web Project

  • Create a Site Map

  • Deploy Web Files to a Server

  • Use Keyword Expansion in HTML Files


How to Work with Web Projects

For information on how to work with Web projects, see the following:

  • Check Hyperlinks on a Web Project

  • Create a Site Map

  • Deploy Web Files to a Server

  • Use Keyword Expansion in HTML Files


Writing Batch Files

See Also

In batch files and macros, there are many reasons to change the way that the command line interacts with the user. Some examples are as follows:

  • Disable Input — You can disable input so that batch files can run undisturbed, without stopping to wait for user input.

  • Redirect Output — You can redirect program output to a file.

  • Use Command Line Exit Codes — You can use VSS exit codes to test for successful batch file completion.

For information on how to work with batch files, refer to:

  • Disable Input

  • Redirect Output

  • Use Command Line Exit Codes


How to Work with Batch Files

For information on how to work with batch files, see the following:

  • Disable Input

  • Redirect Output

  • Use Command Line Exit Codes


VSS Administrator Tasks

As the VSS administrator, it is your job to make the VSS database as useful to VSS clients as possible. There are various ways in which you can change the behavior of VSS, for example to allow clients to use multiple file checkout, or to take advantage of VSS's new Web features.

As the administrator, you can do any of the following:

  • Create a New Database

  • Create Web Site Projects

  • Create Shadow Folders

  • Customize the SRCSAFE.INI or SS.INI File

  • Enable Keyword Expansion

  • Enable Multiple Checkouts

  • Open a Database

  • Set Default File Types


How to Perform Administrator Tasks

As the administrator, you can do any of the following:

  • Create a New Database

  • Create Web Site Projects

  • Create Shadow folders

  • Customize the SRCSAFE.INI or SS.INI File

  • Enable Keyword Expansion

  • Enable Multiple Checkouts

  • Open a Database

  • Set Default File Types


Create a New Database

See Also

As the VSS administrator, use the MkSS.exe program to create a new empty database.

To create a new empty database:

  1. Create a folder for the new database, for example, you could name it "data."

  2. Open a command prompt.

  3. From the command prompt, go to the \Win32 folder of your VSS Server installation.

  4. Run MkSS for the database and its new folder.

    For example, MkSS d:\vss\data

  5. Run Ddnconv for the database and its new folder.

    For example, Ddnconv d:\vss\data

Note If you upgrade to the new VSS format for Fast Get, you will also need to run Ddupd after you complete steps 1–5.


Create Web Site Projects

See Also

VSS includes several features that make managing World Wide Web sites easier. For example, you can designate a specific VSS project as a Web site project, and then quickly create a site map of the HTML files in the project (and subprojects), check hyperlinks in the project files, and deploy the files to an Internet server location when they are ready. To be able to use any of these features, you need to first designate the project as a Web project.

To create a Web site project:

  1. On the VSS Administrator Tools menu, click Options.

  2. Click the Web Projects tab.

  3. Click Browse to search for the project you want to designate as a Web project, then click OK to quit the Set Web Site At dialog box.

  4. Enter a Web address in the URL box.

  5. Click OK to quit the SourceSafe Options dialog box.

  6. Quit the Administrator and have all your clients quit and restart VSS Explorer.

You should now see a special icon ( [image]) on the project in VSS Explorer that you've designated a Web project.

Note You must set a proxy if you plan to deploy the files using FTP. See the Web tab in the Options dialog box on the Tools menu.


Create Shadow Folders

See Also

The VSS administrator is responsible for creating shadow folders because these folders affect all users.

A shadow folder is optional. It's generally used in one of two situations:

  • For users who want to see the files, but who do not have access to VSS. A shadow folder allows them to view but not modify files.

  • To prevent working folders from keeping their own copies of the project. To make sure that every user has the most recent file versions, it may be desirable for all users to compile source code out of a centralized folder, instead of in personal working folders.

When you set a shadow folder for a particular project, you are making an assignment for the entire project tree, unless you override that assignment for particular subprojects.

Note Ensure that all users with add/checkin rights have write privileges to the shadow folder.

To create a shadow folder:

  1. On the VSS Administrator Tools menu, click Options to display the SourceSafe Options dialog box.

  2. Click the Shadow Folders tab.

  3. In the Set Shadow Folder for Project box, enter the name of the project to shadow, or click Browse to search for a project from the VSS project list.

  4. In the Set Shadow Folder To box, type the name of the folder to be used as a shadow folder, or click Browse to search for a folder.

  5. Click OK and wait while the folder is built.


Customize SRCSAFE.INI or SS.INI File

See Also

VSS provides two initialization files that contain settings you can use to customize your VSS environment:

  • SS.INI, for individual user variables. See SS.INI Example.

  • SRCSAFE.INI, for the VSS database global variables. See SRCSAFE.INI Example.

Each user has an SS.INI file that can be edited. Only the VSS administrator should edit the global SRCSAFE.INI file.

Important Manually editing the initialization files is not recommended, unless you are very familiar with VSS initialization variables and their behavior. Instead, users can set most initialization variables directly in the VSS Explorer SourceSafe Options dialog box on the Tools menu. VSS administrators can set SRCSAFE.INI variables in the VSS Administrator SourceSafe Options dialog box on the Tools menu. For a list of all initialization file variables, see Initialization Variables in the Reference section of VSS Help.

When you use the SourceSafe Options dialog box, VSS saves your changes in memory, but does not write the changes to the SS.INI or SRCSAFE.INI file until you quit VSS. Therefore, if you start a second VSS session before quitting the first, your changes are not yet in effect. The changes will only take effect after you quit VSS and start a new session.

You can read and modify initialization files with any text editor. Initialization file line length is limited to 511 characters, although this maximum may be further restricted by a limit of 31 characters for variable names (such as project path limitations).

Usually, SS.INI files are located in the Users subfolder of the folder in which VSS is installed. Each user added by the administrator has an SS.INI file in the Users subfolder. For example, if a user called JohnSmith is added by the administrator, he has his own SS.INI file located in the Users\JohnSmith subfolder of the VSS folder. The exact location of each user's SS.INI file is recorded in the Users.txt file, located in the VSS folder. You can move your SS.INI file provided you tell VSS of the change by editing the Users.txt file.

The SrcSafe.INI file is usually placed in the main VSS folder on a server.

Note Initialization variables set in SS.INI files override settings in the SRCSAFE.INI file.

File Format

There are three kinds of lines in SS.INI and SRCSAFE.INI:

  • Initialization variables, which are the functional lines, have the format:
    Initialization variable = value

    Values can be set as Yes, No, True, or False.

  • Comments begin with a semicolon:
    ; This is a comment line.

    VSS ignores all comments.

  • Headers are provided in brackets:
    [$/Word]

    Most headers specify particular project paths. Other headers, such as [Keyword Comments], are used for specific purposes.

The order of variables inside an initialization file does not matter; however, the header under which a variable is placed does matter. If a variable is placed under the wrong header [image] for instance, if a general-purpose variable is placed under [Keyword Comments] [image] it is ignored.

SS.INI on Multiple Platforms

If you are running a multi-platform VSS installation, you may want certain variables to have different values on the different platforms. In this instance, you can place a platform specifier in parentheses after the variable, to indicate that the variable applies only on that platform, for example:

Use_ReadOnly (Win) = Yes

The setting in the example applies only under Microsoft Windows. Settings include UNIX, Win, NT, MAC, and PC [image] the last is a catchall for personal computer operating systems.

VSS recognizes computer names as platform specifiers. Only 10 platform specifiers are allowed per user, or 10 per SS.INI file.


Enable Keyword Expansion

Keyword expansion refers to VSS's ability to place certain information directly into your file to create a file header for you. To use this feature, you place certain keywords into the text of your file in comments so that it does not affect your code. When you add or check in the file, VSS looks for these keywords, and places the relevant information after them.

Because keyword expansion requires VSS to scan each file for keywords, it can considerably slow the Check In and Add Files commands.

Note Keyword expansion is by default disabled for all files. As VSS administrator, after you have enabled keyword expansion (from the VSS Administrator program), you must tell VSS which files to scan for keywords.

To enable keyword expansion:

  1. On the VSS Administrator Tools menu, click Options.

  2. Click the General tab if it isn't already selected.

  3. In the Expand Keywords in Files of Type box, enter the types of files in which you want keyword expansion to occur; for example, *.txt.

    If you use more than one extension, you must separate them with commas; for example, *.txt, *.c, *.bas.

  4. Click OK.

Note You can also enable keyword expansion by adding Keyword_Masks = *.txt to the SRCSAFE.INI file on the server. Place it before the first occurrence of a section header, for example, [$/MyProj]. Again, if you use more than one extension, separate them with commas.


Enable Multiple Checkouts

By default, VSS prevents more than one user from checking out the same file at the same time. However, as the VSS administrator you can allow multiple users to check out a file simultaneously.

Note To enable multiple checkouts on a project-by-project basis, you must edit the appropriate .INI variable in each project in which you want to enable multiple checkouts.

For example, to enable multiple checkouts in the project "Features," the .INI file would display:

[$/Features]
Multiple_Checkouts = yes

To enable multiple checkouts:

  1. On the VSS Administrator Tools menu, click Options.

  2. Click the General tab if it isn't already selected.

  3. Select the Allow Multiple Checkouts check box.

  4. Click OK.


Open a Database

To open a VSS database:

  1. From the VSS Administrator Users menu, click Open SourceSafe Database to display the Open SourceSafe Database dialog box.

  2. Select a database from the list.

    Note If the database you want is not in the list of available databases, click Browse. Navigate to the SRCSAFE.INI file for an existing VSS database, then click the SRCSAFE.INI file. Click Open to add the database to the list.

  3. Click Open on the Open SourceSafe Database dialog box.


Set Default Files Types -- Administrative Settings

Set Default File Types — Administrative Settings

See Also

As the VSS administrator, you can set default file type(s) for VSS. VSS then applies the default type(s) to file lists that appear in many dialog boxes. The defaults apply to all users.

Individual users can, however, change or set their own default file type settings, using the Options command on the Tools menu of VSS Explorer.

To set default file types for all users:

  1. On the VSS Administrator Tools menu, click Options to display the SourceSafe Options dialog box.

  2. Click the File Types tab.

  3. Enter or select applicable information on this tab, including:
    • Binary files

      Type file masks for files you want VSS to treat as binary. By default, when VSS must know what type a file is, it uses its auto-detect mechanism. By entering values in this box, however, you tell VSS that all files of the type you enter are to be considered binary. For example, if you enter *.obj and *.exe, VSS always treats all files with those extensions as binary.

    • File groups

      Select a group of files to which you assign file masks. The Add and Delete buttons allow you to add or delete file groups, with one exception: you cannot delete the <Relevant Masks> group. This group is provided for your convenience. It enables you to create a group of the files you use most often; this <Relevant Masks> group then becomes the group of default file types in the Add File, Share, and other dialog boxes used to manipulate files within projects.

    • File types included in file group

      Type file masks in this box for the group you selected from the File Groups box. For example, when you click Visual Basic files in the File Groups box, type the file types to make up this group: *.bas, *.frm, *.frx.

  4. Click OK.


Installation

Before you can install and use VSS on a user's computer (client installation), you, as the VSS administrator, must first install the source code control database maintained by VSS on a drive that is accessible to all VSS users (server installation).

The most versatile method of working with VSS is to perform a server installation to a network drive, and then a client installation on each workstation. The server setup is all that is actually required; but having only a server setup can generate large amounts of network traffic, which sometimes results in impaired performance. To avoid large volumes of network traffic, perform a client installation on every workstation in addition to the server installation(s).

The setup program detects the platform from which you are installing (Intel or Alpha, for example) and installs only the binaries (files) required for that platform. Thus, if you plan to use VSS in a mixed-platform environment (Alpha and Intel computers, all using the same VSS database, for example), you must do a server installation once from each different kind of platform in your environment and point to the same server location. You will then have all the binaries your clients need.

Note Installing binaries will not overwrite any existing data you have.

For information on how to install VSS, refer to:

  • Client Installation from a Disk. Allows VSS users to install from a compact disc to the hard disk of their client computer only the files necessary to run VSS. The client installation does not install the VSS database.

  • Client Installation from a Network. Allows VSS users to install from a network to the hard disk of their client computer only the files necessary to run VSS. The client installation does not install the VSS database.

  • Server Installation. Allows the VSS administrator to install VSS to a computer that is accessible to all users.

  • Custom Installation. Allows the VSS administrator to select which parts of the server installation to install.


How to Install VSS

During installation, VSS asks you to choose the type of installation you want to perform. Select one of the following:

  • Client Installation from a Disk. Allows VSS users to install from a compact disc to the hard disk of their client computer only the files necessary to run VSS. The client installation does not install the VSS database.

  • Client Installation from a Network. Allows VSS users to install from a network to the hard disk of their client computer only the files necessary to run VSS. The client installation does not install the VSS database.

  • Server Installation. Allows the VSS administrator to install VSS to a computer that is accessible to all users.

  • Custom Installation. Allows the VSS administrator to select which parts of the server installation to install.

Depending on which installation option you've selected, VSS installs folders at specific project locations; see Folders Installed by Setup for details.


Client Installation from a Disk

See Also

This option installs on the hard disk of a client computer only those files necessary to run VSS. It does not install the VSS database or support files. Typically, client installation is done by a VSS user, not by an administrator.

Note The client installation should follow a server installation and cannot be used alone.

Choose this option in the following situations:

  • You have heavy traffic on your network. The client option can help decrease the network load and improve performance on the client computer compared with running VSS from a server.

  • You are integrating VSS with Microsoft Access, Visual FoxPro, Visual Test, Visual Basic, or Visual C++. The client installation (either from compact disc or using Netsetup) is necessary for VSS to work properly with Visual Basic or Visual C++.

    Important To integrate VSS with Visual Basic, first perform a server setup of VSS, install Visual Basic, then either run Netsetup or perform a client setup from disc. To integrate VSS with Visual C++, run Netsetup or perform a client setup from disc, either before or after installing Visual C++. For more information on VSS integration with Visual Basic, Visual C++, Visual FoxPro, Visual Test, and Microsoft Access, see documentation for those products.

To perform a client installation from disc:

  1. Insert the compact disc in the CD-ROM drive.

  2. Double-click Setup.exe.

  3. Follow the setup instructions in the setup wizard.

  4. When asked what type of installation you'd like, click Client.


Client Installation from a Network

See Also

This option installs on the hard disk of a client computer only those files necessary to run VSS. It does not install the VSS database or support files. Typically, client installation is done by a VSS user, not by an administrator.

The Netsetup program performs a client setup over a network. Netsetup does not require you to have an installation disc at your computer.

Note Netsetup must follow a server installation.

Choose this option in the following situations:

  • You have heavy traffic on your network. The client option can help decrease the network load and improve performance on the client computer compared with running VSS from a server.

  • You are integrating VSS with Microsoft Access, Visual FoxPro, Visual Test, Visual Basic, or Visual C++. The client installation (either from compact disc or using Netsetup) is necessary for VSS to work properly with Visual Basic or Visual C++.

    Important To integrate VSS with Visual Basic, first perform a server setup of VSS, install Visual Basic, then either run Netsetup or perform a client setup from disc. To integrate VSS with Visual C++, run Netsetup or perform a client setup from disc, either before or after installing Visual C++. For more information on VSS integration with Visual Basic, Visual C++, Visual FoxPro, Visual Test, and Microsoft Access, see documentation for those products.

To perform a client installation from a network:

  1. In the folder in which VSS is installed on the server, double-click Netsetup.

  2. Follow the setup instructions in the setup wizard.


Custom Installation

See Also

This option enables you to install only the parts of VSS that you want. It provides the following choices, and shows the amount of space required on your hard disk for each choice:

  • Create VSS database

  • Client program install

  • Administrative program install

  • Enable VSS integration

  • Help files

  • Conversion utilities (Pvcs and Delta)

  • Network client setup

Use the custom installation option when you want to omit parts of the server installation.

Note The custom installation option is the only way to install the VSS database on your local hard disk and then have it accessible for integration with Visual Basic and Visual C++. For more information on VSS integration with Visual Basic and Visual C++, see documentation for those products.

To perform a custom installation:

  1. Insert the VSS compact disc in the CD-ROM drive.

  2. Double-click Setup.exe.

  3. Follow the setup instructions in the setup wizard.

  4. When asked what type of installation you'd like, click Custom.

  5. Select the custom options you'd like to install, then click Continue.


Server Installation

See Also

As the VSS administrator, you use this method to install VSS to a computer that is accessible to all users.

To perform a server installation:

  1. Insert the VSS compact disc in the CD-ROM drive of the server or a machine connected to the server.

  2. Double-click Setup.exe.

  3. Follow the setup instructions in the setup wizard.

  4. When asked what type of installation you'd like, click Server.


Folders Installed by Setup

The VSS directory structure installed by the setup program is similar for both server and client options. The person doing the installation specifies the folder in which VSS is installed. On a server, all folders and files may be present. On a client, only the \Win32 and \Setup folders are installed.

The following table lists VSS folders and their contents for the most common installations.

VSS Folders and Contents for Common Installations

Folder | Contents | Installation type
\Data | Database of all files and projects | Server
\Users | User initialization files (SS.INI) | Server
\Temp | Temporary files | Server
\Win32 | Windows 95 and Windows NT 32-bit Intel application programs | Server, client
\Setup | Files used by the Setup.exe program to install additional components or uninstall VSS | Server, client
\Netsetup | Files used by the Netsetup.exe program to install VSS to a client computer | Server
\Ntaxp | Windows NT on AXP RISC programs | Server


Maintain the User List -- Basic Tasks

Maintain the User List — Basic Tasks

The user list in VSS Administrator allows you to control who has access to the VSS database, as well as what level of access they have. VSS Administrator lets you add and delete users from the user list, assign access rights to specific users, and change their VSS passwords.

  • When you add a new user, VSS automatically creates an SS.INI file for that user based on the default SS.INI template in the \VSS\Users folder. You can modify this template file to create a different default SS.INI file for each new user. For more information, see Customize SRCSAFE.INI Files

For information on how to maintain the VSS user list, refer to:

  • Add a User

  • Change Passwords

  • Create a User List

  • Delete a User

  • Edit User Attributes


How to Maintain the User List

As the VSS administrator, you maintain the VSS user list by performing any of the following tasks:

  • Add a User

  • Change Passwords

  • Create a User List

  • Delete a User

  • Edit User Attributes


Add a User

See Also

To add a user to a VSS database:

  1. Make sure the correct database is selected in VSS Administrator. For more information, see Open a VSS Database.

  2. On the VSS Administrator Users menu, Click Add User to display the Add User dialog box.

  3. In the User name box, type a name. You can also type a password in the Password box.

    Note User names can be up to 31 characters long, cannot begin or end with a space, and cannot include any punctuation. Passwords can be up to 15 characters long, and can contain any characters.

  4. To give the new user read-only rights, select the Read only check box.

    Note If you do not select this check box, the new user has read/write rights. See Security Access Rights for more information.

  5. Click OK.


Change_Passwords

See Also

VSS security relies on passwords that are stored with the data. Every user can have a password that allows access to VSS. There is no way to find out what a user's password is. If a user forgets his or her password, the VSS administrator can use this dialog box to assign a new password. You cannot recover an old password.

In many cases, you may want to change the password to something very simple, such as the username, and then instruct the user to create a new password from within VSS. Refer users to How to Change your Password for instructions on how to change their passwords.

As the administrator, you have a special password that is used to run VSS Administrator. You must enter the old password in order to change it. If you cannot remember the old password, contact Microsoft Technical Support.


Change Administrator Password

For an explanation of this procedure, see Change Passwords.

To change the administrator's password:

  1. In the VSS Administrator user list, select the Admin.

  2. On the Users menu, click Change Password to display the Change Password dialog box

  3. In the Old password box, type the old password.

  4. In the New password box, type the new password.

  5. In the Verify box, type the new password again to verify it.

  6. Click OK.


Change User Password

Change a User Password

For an explanation of this procedure, see Change Passwords.

To change a user's password:

  1. In the VSS Administrator user list, select a user.

  2. On the Users menu, click Change Password to display the Change Password dialog box

  3. In the New password box, type the new password.

  4. In the Verify box, type the new password again to verify it.

  5. Click OK.

Note If you tell VSS to use the user's network username, this bypasses the VSS logon dialog box.


Create a User List

See Also

To create a VSS user list:

  1. Select the desired database in VSS Administrator. For more information, see Open a VSS Database.

  2. From the VSS Administrator Users menu, click Add User to display the Add User dialog box.

  3. Enter the first user's name in the User name box. User names can be up to 31 characters long, cannot begin or end with a space, and cannot include any punctuation.

  4. Enter the user's password in the Password box. Passwords can be up to 15 characters long, and can contain any characters.

  5. To give the user read-only rights, select the Read only check box.

    Note If you do not select this check box, the new user has read/write rights. See Security Access Rights for more information.

  6. Click OK.

  7. Repeat steps 1-6 until you've created your entire VSS user list.


Delete User

Delete a User

See Also

When you delete a user from the user list, VSS automatically deletes the SS.INI file that it created for that user.

Note You can't delete the Admin user.

To delete a user:

  1. From the VSS Administrator user list, select a user.

  2. On the Users menu, click Delete User.

  3. VSS displays a warning box asking "Are you sure you want to delete?"

  4. Click OK.


Edit User Attributes

See Also

To edit user attributes:

  1. From the VSS Administrator user list, select a user.

  2. On the Users menu, click Edit User to display the Edit User dialog box.

  3. Select the Read only check box to give the user read-only rights. (By default, VSS gives all new users read/write rights.)

    – Or –

    Rename the user by typing a new name.

  4. Click OK. VSS changes the selected user's rights and/or logon name.


Manage the Database

As the VSS administrator, it is your job to manage the database. This includes analyzing the data folder to look for signs of database corruption, archiving the database when it becomes too large, and cleaning the Temp folder.

You may need to lock the database before you can perform some of these actions, in order to keep user actions from interfering.

Sometimes a user inadvertently leaves a file checked out. If the user cannot be located, the VSS administrator can undo the user's checkout.

For information on how to manage the database, refer to:

  • Analyze the Data Folder

  • Archive Databases

  • Clean Temporary Folder

  • Lock a Database

  • Restore Databases

  • Undo Checkout of a File or Project

  • Using DDUPD to Take Advantage of Performance Enhancements and Label Promotion

  • Work with Multiple Databases


How to Manage the Database

As the VSS administrator, you maintain the VSS database by performing the following tasks:

  • Analyze the Data Folder

  • Archive Databases

  • Clean Temporary Folder

  • Lock a Database

  • Restore Databases

  • Undo Checkout of a File or Project

  • Using DDUPD to Take Advantage of Performance Enhancements and Label Promotion

  • Work with Multiple Databases


Analyze the Data Folder

See Also

Note Doing a full backup of your Data folder on a regular basis is highly recommended.

The VSS Data folder contains the database of all your files and projects. Although every precaution has been taken to ensure the integrity of all VSS files, file corruption due to network or operating system problems is possible. The Analyze.exe utility is provided to enable you to search for and fix any corruption or errors.

To run Analyze.exe:

  1. Lock out all users and have them quit VSS. See Lock a Database for more information.

    Note VSS users can have files checked out when a database is locked.

  2. Open a command prompt to run Analyze.

    For example, you might enter:

    C:\vss\win32\analyze ..\data

The program goes through the VSS database, reporting any possible problems. If errors or corrupted files are discovered, you can fix them using the -F, -C, and -D parameters.

We recommend that you run Analyze twice [image] first with the -F option (to fix any errors found), and the second time to check if any errors remain. If you still have errors after the first run, you can check the Microsoft Knowledge Base article Q152807 for more information.


Archive Databases

See Also

Periodically, you may want to back up your VSS database or parts of it. You can now archive databases from the VSS Administrator program. In previous versions of VSS, Archive and Restore were only available from the command line.

Archiving allows you to:

  • Save disk space on your VSS database server.

  • Make the Show History command work more quickly.

  • Transport files and projects between VSS databases, keeping history information intact.

  • Back up all or part of the VSS database to a compressed file

To archive a database:

  1. Open the database from which you want to archive information. See How to Open a Database for more information.

  2. On the Archive menu, click Archive Projects… to display the Archive Wizard.

  3. Select the project you want to archive.

  4. Click OK.

  5. If there are additional projects you'd like to add to the archive, do so in step 1 of the wizard.

  6. Click Next.

  7. In step 2 of the wizard, specify how you want the project to be archived.

  8. If Save data to file or Save data to file, then delete from database to save space is selected, enter the name of the file to save the project(s) to in the Archive File box.
    • Or —

    Click Browse to search for and select an archived file. This will overwrite existing files.

    • Or —

    If Delete Data Permanently is selected, the Archive File box will be disabled.

  9. Click Next.

  10. In step 3 of the wizard, specify the version of the data you'd like archived (version range). You can also add a comment to the Comment box if you'd like.

Note To archive by version number, enter just the number in the Version box, i.e., 5. To archive by label, enter L followed by the label string, i.e., "LmyLabel". To archive by date, enter D followed by a date string, i.e., D11/26/98.

  11. Click Finish to complete the archive.


Clean Temporary Folder

See Also

As the VSS administrator, you are responsible for cleaning the Temp folder pointed to by the Temp_Path initialization variable in the SRCSAFE.INI file.

VSS usually places files in its Temp folder while running, and deletes them before quitting. Some circumstances, such as having to restart, can cause files to remain in the Temp folder [image] a waste of disk space.

Once every few weeks, when no users are running VSS or VSS Administrator, clean the Temp folder.

To clean the temporary folder:

  1. On the Tools menu, click Clean up Temp Directory to display the Clean Up Local Temporary Files Directory dialog box.

  2. Click OK.


Lock a Database

See Also

Locking a database does not automatically lock out those users presently logged on. The VSS administrator should ask users to quit VSS before locking the database.

To lock a VSS database:

  1. From the VSS Administrator Tools menu, click Lock SourceSafe Database to display the Lock Visual SourceSafe Database dialog box.

  2. Select the Lock all users out of Visual SourceSafe check box.

  3. Click OK.

    Important You will have to clear the Lock all users out of Visual SourceSafe check box before your users will be able to access VSS again.


Restore Databases

See Also

You can now restore databases using the VSS Administrator program. In previous versions of VSS, Archive and Restore were only available from the command line.

To restore a database:

  1. Open the database into which you want to restore information. See How to Open a Database for more information.

  2. On the Archive menu, click Restore Projects… to display the Restore Wizard.

  3. Click Browse to select the archived file you want to restore.

  4. Click Open.

  5. In step 1 of the wizard, click Next.

  6. In step 2 of the wizard, select the project or projects you'd like to restore.

  7. Click Next.

  8. In step 3 of the wizard, specify where you want the project(s) restored to. You may also add a comment in the Comment box if you'd like.

  9. Click Finish to complete the restore.


Undo Checkout of a File or Project

See Also

To undo checkout of a file or project:

  1. Log on to VSS Explorer as Admin, using the administrator password if there is one.

  2. Select the checked-out file in the proper project.

  3. On the SourceSafe menu, click Undo Check Out.


Using DDUPD to Take Advantage of Performance Enhancements and Label Promotion

See Also

To take advantage of Performance Enhancements in VSS 6.0 and Label Promotion, upgrade your database by running the DDUPD.exe command-line utility. DDUPD.exe resides in the \Win32 folder of your VSS server installation. DDUPD can also be used to undo an upgrade.

Note Ask VSS users to quit VSS before you run DDUPD.

To run DDUPD.exe:

  1. Go to the \Win32 folder of your VSS server installation in a command prompt window.

  2. Type the following:
    DDUPD <path to data directory> [-undo] [-redo]

To upgrade a database, for example, type:

   DDUPD \\server\share\vss\data

To undo an upgrade (stop taking advantage of the performance enhancements and label promotion), type:

   DDUPD \\server\share\vss\data -UNDO

If you experience problems where projects containing subprojects don't appear in the list with the correct expansion glyph ([+] or [-]), or if you have problems with label gets, you may need to run DDUPD again to correct the display, or:

   DDUPD \\server\share\vss\data -REDO


Work with Multiple Databases

See Also

A default VSS installation stores all its files in one centralized database. If you can, always store all your project files in one database. This is usually preferable to having more than one database, because of the following limitations inherent to multiple-database systems:

  • You cannot share files among multiple databases.

  • It is difficult to bring your multiple databases into one centralized system (you need to use the Archive utility).

  • For security reasons, VSS's list of users and passwords is stored with the data. This approach can be a considerable advantage if security is the reason you want separate databases, but you must add new users separately to each database.

For these reasons, the recommended method is to organize your files into projects within a single database whenever that is possible. Sometimes, however, there is a requirement for more than one database. For example, large companies, especially those in which people are working on many diverse and relatively unrelated projects, may need to decentralize.


Rights Propagation

See Also

When you add a new user and set that user's rights for a particular project, you create an assignment in the VSS database. That assignment propagates down the project list until another assignment is reached.

For example, you assign Add rights (RCA) to user Maria in $/, the root project. In the $/Samples project you give her no explicit assignment, so she automatically has the same rights (RCA) as in the parent project, $/. However, in $/Samples/BusinessObject, you set up a new assignment giving her read-only (R) rights.

This action blocks the earlier assignment in $/Samples from propagating down the tree, so that she has read-only rights in $/Samples/BusinessObjects and any projects under it.

In project $/NorWind, you give Maria no specific assignment, so her rights from the root project, $/, propagate down the project list to $/NorWind. Therefore, she has RCA rights in $/NorWind and in its subproject.

Access rights always propagate down in this manner, so a user's rights in the root project ($/) form a set of default rights for that user. These default rights apply to all projects in which you do not explicitly set assignments.

When you first add a user, that user is given rights in the root project based on the default rights that you've established on the Project Security tab. You can, if appropriate, change the user's rights to globally modify the user’s permission level.


Samples of SS.INI and SRCSAFE.INI

Samples are provided for:

  • SS.INI File

  • SRCSAFE.INI File


SS.INI Example

See Also

The following example shows a sample SS.INI file.

; SS.INI
;
; This file contains all the variables that "customize" Visual SourceSafe
; to your particular needs. The SS.INI variables are documented in
; Online Help. Only a few of them are placed in this file by default.

; C programmers should remove the semicolon from the following line, to
; uncomment it. Other programmers REPLACE the line with different masks.
; Relevant_Masks = *.c, *.h, *., *.asm

; The following line prevents you from being asked for a check out
; comment.
Checkout_Comment = -

Project = $/Samples
Maximized (Win) = No
Sort_Order = Date
[$/Features]
[$/MyProject]

If you are running a multi-platform VSS installation, you may be using one SS.INI file under several different operating systems. If so, you probably want certain variables to have different values on the different platforms. You can place an identifier in parentheses after the variable name, to indicate that the variable should apply only on the platform referred to by that identifier. For example:

Use_ReadOnly (NT) = Yes

This setting, as specified, applies only under Microsoft Windows 95 and Windows NT. The same SS.INI file might have other settings for other platforms or conditions. You can, for example, set initialization variables to distinguish between the command line (CL) and the Explorer (UI). For example:

Force_Dir (UI) = No
Force_Dir (CL) = Yes

If the preceding values are the only ones containing parenthetical expressions that are present in your SS.INI file, when you run the Explorer, Force_Dir is set to No, and when you invoke VSS from the command line it is set to Yes. If a Force_Dir line that contains (for example) your machine name or "NT" is present in the file, however, it takes precedence over both of the lines given in this example.

Computer names are known to VSS as platform specifiers. Only 10 platform specifiers are allowed per user, or 10 total per SS.INI file.


SRCSAFE.INI Example

See Also

The following example shows a sample SRCSAFE.INI file.

; SRCSAFE.INI
;
; Three of these variables -- Data_Path, Users_Path, and Users_Txt -- must
; be in SRCSAFE.INI. Any other variable here can be overridden in SS.INI.
; Similarly, any SS.INI variable can be placed in SRCSAFE.INI to set a
; system "default," which individual users can still override in SS.INI.

; The two important paths used by SourceSafe.
Data_Path = data
Temp_Path = temp

; This tells admin where to put personal directories for new users.
Users_Path = users

; From this, find users.txt; from that, in turn, find SS.INI for a user.
Users_Txt = users.txt

; The following line contains common file groupings.
File_Types = Visual Basic (*.bas;*.cls;*.frm;*.frx;*.res;*.vbp;*.mak), Visual C++ (*.cpp;*.c;*.hpp;*.h;*.rc;*.mak), Visual FoxPro (*.h;*.pjt;*.pjx;*.prg;*.frx;*.frt;*.scx;*.sct;*.vcx;*.vct;*.lbx;*.lbt;*.qpr;*.mnx;*.mnt), Visual Test (*.mst;*.inc)
Img_File = HTMLFILE.GIF
Img_Folder = FOLDER.GIF
[$/Features]
[$/MyProject]


Security Access Rights

When you install VSS, the default security system is enabled. You can, however, customize security in your installation to allow only specific users to have access to certain projects and certain commands.

Default Security

Default security in a VSS installation is simple. The administrator has only two levels of access rights to choose from when adding new users to the VSS installation:

  • Read-only rights: The user can see everything in VSS but can change nothing.

  • Read/write rights: The user can see and change anything in the VSS database.

Each time you add a user to your installation, you determine the level of access rights for the new user. The Add User dialog box contains a check box labeled Read only. When you select this check box, the new user can read files but cannot change them. When you leave the box clear, the new user has read/write access to all commands and all projects.

If these levels of access rights are adequate for your installation, you need do nothing further to enhance security. With this level of security, security-related commands available from the Tools menu are disabled. For more options, see "Project Security User Access Rights" later in this topic.

Setting Security for VSS Administrator

All VSS security is governed from inside VSS Administrator. Any user who can run that program can effectively do anything within VSS, so access to the Administrator program should be protected. You have two ways to guard access:

  • Assign a password to the Admin user by using the Change Password command.

    Important If you forget the password assigned to the administrator, you cannot run VSS Administrator to change it. Write the password in a very safe place. If the administrator's password is lost, contact Microsoft Technical Support for assistance.

  • Protect VSS Administrator by controlling access to the folder that it runs from at the operating system level.

Project Security User Access Rights

Project security in VSS is based on user access rights. Each project is accessible only to those users who have the appropriate rights. Each command can be used only by those users who have the rights associated with that command.

There are four user access rights, described in the following table.

Note Each right includes all the rights that precede it. For example, the Check Out right includes the Read right.

Rights | Description
Read (R) | View, but not change, files by using such commands as View and Get.
Check Out (C) | Modify files by using such commands as Check Out, Check In, and Undo Check Out. These rights are often assigned to QA engineers and to technical writers.
Add (A) | Modify the file list by using such commands as Add, Delete, Label, and Rename. Some companies give all programmers this right while other companies reserve this right for project managers.
Destroy (D) | Perform destructive operations on files by using such commands as Destroy, Purge, and Rollback. In organizations where security is prized, this right is granted only to project managers or the administrator. You must have Destroy rights to deploy a Web site.

When you activate project security, you enable the security-related commands on the Tools menu: Rights by Project, Rights Assignments for User, and Copy User Rights.

Each VSS command has certain access rights associated with it. For example, the Label command requires Add rights. For more information, you can check the Microsoft Knowledge Base article Q138479.

For information on how to set security access rights, refer to:

  • Assign Rights by Project

  • Enable Project Security

  • Set Default Security Rights


How To Set Security Access Rights

As the VSS administrator, you can ensure VSS security by doing any of the following:

  • Assign Rights by Project

  • Enable Project Security

  • Set Default Security Rights


Assign Rights by Project

See Also

To assign rights by project:

  1. From the VSS Administrator Tools menu, click Rights by Project to display the Project Rights dialog box.

  2. Under Projects, select a project.

  3. Under Users, select a user. VSS Administrator displays the current rights for the user in the selected project.

  4. You can add or delete rights by selecting or clearing the User rights check boxes.

  5. To add a user to the currently selected project, click Add User. VSS Administrator displays the Add Users for Project dialog box, with a list of users who currently do not have rights in the selected project. Select the check box next to the right(s) you would like to assign the user, then click OK.

  6. To delete a user from the currently selected project, click Delete User.

    When you delete a user's access to a project, VSS Administrator performs the deletion with no confirmation.

  7. Click Close.

Use the Rights Assignments for User command to view all the project security rights of a particular user.


Enable Project Security

See Also

To enable project security:

  1. From the VSS Administrator Tools menu, click Options to display the SourceSafe Options dialog box.

  2. Click the Project Security tab.

  3. Select the Enable Project Security check box to enable project security.

  4. Under Default user rights, clear the check boxes next to the access rights you do not want to grant.

By default, when you enable project security, new users have the full set of access rights to the database.

You can establish a new set of default user rights by selecting only the check box next to the highest level right you want to use as a default.


Set Default Security Rights

See Also

To change a user's default security level:

  1. Select the desired user in the VSS Administrator user list.

  2. From the Users menu, click Edit User.

  3. Select the Read only check box to restrict a user to read-only rights.

    Or

    Clear the Read only check box to grant read/write access rights.


About Visual SourceSafe Command (Help Menu)

About VSS (Help Menu)

Displays a dialog box with information about your copy of Microsoft VSS, including the version number, the platform type, and the copyright, legal, and licensing notices.

Click OK to close the dialog box.


Add Users Command (Users Menu)

Add User Command (Users Menu)

See Also

Adds a new user to VSS Administrator's user list.

Remarks

The username and read-only access rights can be changed later with the Edit Users command, and the password can be changed with VSS Administrator's Change Password command. Users can also change their own passwords using VSS Explorer's Change Password command.

Dialog Box Options

User Name

Type the valid username of the user you want to add to the system.

Password

Type an optional VSS password. As you type, the characters are displayed as asterisks.

Read Only

Assigns the Read access right. Select if you don't want the user to have Read/Write access rights.

OK

Adds the user.

Cancel

Cancels the Add Users command and returns to VSS Administrator.


Change Password Command (Users Menu)

See Also

Sets the password for users, including the Admin user.

Remarks

Changing a user's password is something the administrator rarely has to do, because users can change their own passwords in VSS Explorer (Change Password command on the Tools menu). When users forget their passwords, however, they can't run VSS. It is not possible to find out what the user's password is. You can, without knowing the password, use the Change Password command to change it.

Note When you run VSS Administrator, you are prompted for the Admin user's password. If you want to provide a password for the Admin user, use the Change Password command to give the Admin user a password. After you have done this, make sure not to forget the Admin user's password, as there is no way to discover it; you must call Microsoft Technical Support Services for assistance.

Dialog Box Options

User Name

Name of the user selected in VSS Administrator.

New Password

Type the new password. A password can consist of any combination of one to 15 characters. As you type, the characters are displayed as asterisks. VSS passwords are not case-sensitive.

Verify

Retype the new password to verify it.

OK

Confirms the new password.

Cancel

Cancels the Change Password command.


Copy User Rights Command (Tools Menu)

See Also

Acts as a template and copies one user's access rights to another user.

Remarks

Instead of adding a user's access rights to every project a user is working on, you can simply copy all access rights from another similar user.

To copy user rights

  1. In the user list, click the user whose access rights you want to modify.

  2. On the Tools menu, click Copy User Rights. The Copy Rights Assignments to User dialog box is displayed, providing a list of all VSS users.

  3. Click a user to use as an access rights template, and then click Copy.

After you copy rights, the two users have identical access rights in every project. You can, however, individually change their access rights in specific projects. Future changes to one user are not duplicated for the other, unless you use this command to copy user rights again.

Dialog Box Options

Copy From

User whose access rights you want to copy.

Copy

Copies access rights from the user selected under Copy From to the user selected in VSS Administrator.

Cancel

Cancels the Copy User Rights command.


Delete Users Command (Users Menu)

Delete User Command (Users Menu)

Deletes a user from VSS Administrator's user list.

Remarks

To delete a user

  • Click the user you want to delete in VSS Administrator's user list, and then on the Users menu, click Delete. Click OK to confirm the deletion.

The user is deleted from the list, and is no longer able to run VSS.

If the deleted user has files checked out, a warning is not generated. To unlock those files, run VSS as the Admin user and use the Undo Check Out command.


Edit Users Command (Users Menu)

Edit User Command (Users Menu)

See Also

Changes the username and access rights of the user selected in VSS Administrator.

Remarks

Use the Change Password command on the Users menu to change a user's password.

Note A shortcut for displaying the Edit User dialog box is to select the username in VSS Administrator's user list, and then press enter.

Dialog Box Options

User Name

Type a new name to change the name of the user selected in VSS Administrator.

Read Only

Assigns the Read access right. Select if you don't want the user to have Read/Write access rights.

OK

Confirms your changes.

Cancel

Cancels the Edit Users command.


Exit Command (File Menu)

Exits VSS.

Access Rights

Any VSS user can use this command.


Font Command (Tools Menu)

Changes the font used in either the VSS Explorer or VSS Administrator.

Remarks

You set the font name, style, and size for VSS in the Font dialog box. The Sample box displays a preview of the currently selected font.

The font setting does not affect the font used in the file difference viewer. To set those options, use the Difference Options tab.


Help Menu Commands

The Help menu commands provide Help on using VSS and Help on specific VSS commands. In addition, you can press F1 at any time to view Help on the currently selected menu item or dialog box.

Help command | Action
Contents | Runs Help and displays the VSS Table of Contents.
Search For Help On | Displays the Help Search dialog box so you can quickly find the information you want.
Technical Support | Displays information about Microsoft Product Support Services.
About Microsoft Visual SourceSafe | Displays a dialog box with information about your copy of Microsoft VSS, including the version number and the copyright, legal, and licensing notices.

Access Rights

Any VSS user can use these commands.

Remarks

A quick way to find information is to use Search, an automated index with hundreds of index entries and extensive cross-referencing.

You can also look for Help topics in the VSS Table of Contents.

As you read a topic in VSS Help, you can scroll through the topic with the scroll bar, the arrow keys, or the PAGE UP and PAGE DOWN keys.


Lock SourceSafe Database Command (Tools Menu)

See Also

Allows you to lock all users out of the VSS database while you run a utility, upgrade the executables, or back up the database.

Access Rights

You must have Administrator permission to use this command.

Remarks

Use this command if you need to archive, back up, or run a VSS utility on the database. Note that the act of selecting the check box in the Lock SourceSafe Database dialog box is what actually locks users out. After this box is checked, no one will be allowed to log into the database. The users listed, who are already logged in, will be unaffected [image] you will need to notify them manually to log out.


Open SourceSafe Database Command (File Menu)

See Also

Allows you to switch between VSS databases.

Access Rights

You must have the Read access right to use this command.

Remarks

Use this command if you regularly need to access different VSS databases. You need access permissions both on the server storing the database and in the database you are trying to access. When you use this command, the current VSS database is closed and the newly specified one is opened.

You can give each database an easy-to-remember name, and each time you connect to a new database it is added to the list in the Open SourceSafe Database dialog box.

Note If you used Visual SourceSafe version 4.0 with multiple databases, you may have used the old initialization variable method of switching between databases. In most cases, each separate database will have its own SRCSAFE.INI file, and you can use the Browse button once to find each database and add it to your database list, and then use the Open SourceSafe Database command from then on.

If you don't have a SRCSAFE.INI for one database, create a SRCSAFE.INI file for that database. Put this SRCSAFE.INI file in the directory immediately above the DATA directory.


Options Command (Tools Menu)

See Also

Enables you to customize the VSS environment for all users.

Remarks

Click the tab with the information you want. Each tab contains groups of options you can set to alter VSS's behavior in certain situations. The tabs in the SourceSafe Options dialog box change the behavior for all users in VSS Administrator's user list. (Individual users can override some settings by using the Options command on VSS Explorer's Tools menu.)

Dialog Box Tabs

General

Sets general options applicable to a number of commands in VSS.

Project Security

Sets security options, such as whether project security is enabled, and the default user rights assignment.

Web Projects

Designates a project as a Web project.

Web

Sets how certain Internet information is transmitted for Web projects.

File Types

Sets how file type information is determined for all users.


Rights Assignments for User Command (Tools Menu)

See Also

Displays and changes project access rights to the VSS database explicitly assigned to the user selected in the user list.

Remarks

Default user access rights are assigned to each new user under default security or on the Project Security tab in the SourceSafe Options dialog box on the Tools menu.

Note To use the Rights Assignments for User command, you must first select the Enable Project Security check box on the Project Security tab in the SourceSafe Options dialog box on the Tools menu.

The Rights Assignments for User dialog box displays only those access rights assignments that were explicitly changed; the effect of rights propagation is not shown. To see the propagation of access rights, use the Rights by Project command on the Tools menu.

Dialog Box Options

User Rights

Specifies the level of access rights [image] Read, Check Out, Add, or Destroy [image] held by the user in the project selected under Projects. To change these assignments, click the project you want and then select the appropriate access right check box.

Rights

Level of access rights assigned to the selected user for each project. You can change the column size of this column by dragging the column separator after the word "Rights."

Project

Projects in which the selected user has been explicitly assigned access rights.

Close

Closes dialog box and returns to VSS Administrator.

Add Assignment

Displays the Add Assignments for User dialog box. To add projects and assign or change access rights for the selected user, select a project in the project list, click the level of access rights you want to assign, and then click OK.

Delete Assignment

Deletes a user's access rights in the selected project(s).


Rights By Project Command (Tools Menu)

See Also

Displays and changes access rights for selected users in selected projects.

Remarks

Default user access rights are assigned to each new user under default security or on the Project Security tab in the SourceSafe Options dialog box on the Tools menu.

This command shows the effect of rights propagation in the Project Rights dialog box. For example, if a user has the Destroy access right in the root project, then under Projects, you see that the user has the Destroy access right in all subprojects [image] unless you explicitly change the access rights. Explicit changes are displayed in the Rights Assignments for Users dialog box, available from the Tools menu.

Note To use the Rights by Project command, you must first select the Enable Project Security check box on the Project Security tab in the Visual SourceSafe Options dialog box on the Tools menu.

Dialog Box Options

Projects

Project list of the current VSS database. Select the project for which you want to view or change users' rights.

Rights

Access rights assigned to the user.

Users

Users who have access rights in the selected project.

User Rights

Specifies the level of access rights [image] Read, Check Out, Add, or Destroy [image] that you want to assign the user selected in the User column. To change the selected user's access rights for the selected project, select the appropriate check box.

Close

Closes this dialog box and returns to VSS Administrator.

Add Users

Displays the Add Users for Project dialog box, which adds users to the project selected under Projects.

Delete Users

Deletes the selected user's access rights to the selected project, after a warning message.


Add Assignment for User Dialog Box

See Also

Changes access rights for the user selected in the user list.

To display the Add Assignment for User dialog box:

  1. On the Tools menu, click Rights Assignments for User.

  2. In the Rights Assignments for User dialog box, click Add Assignment.

Remarks

To assign or change access rights for the selected user, under Project, select a project in the project list, and then click the User Rights check box with the level of access rights you want to assign.

Note To use the Add Assignment for User dialog box, you must first select Enable Project Security on the Project Security tab in the SourceSafe Options dialog box on the Tools menu.

Dialog Box Options

Project

Project list for the current VSS database.

User Rights

Specifies the level of access rights [image] Read, Check Out, Add, or Destroy [image] held by the user in the selected project.

OK

Confirms selections.

Cancel

Cancels selections and returns to the Rights Assignments for User dialog box.


Add File Group Dialog Box

See Also

Adds a new file group to the File Types tab in the SourceSafe Options dialog box (Tools menu).

To display the Add File Group dialog box:

  • On the Tools menu, click Options, and then click File Types. Click the Add button.

Dialog Box Options

Name

Type the name of the file group as you would like to identify it in the file group list on the File Types tab.

OK

Adds the file group.

Cancel

Cancels the Add File Group command.


Add Users for Project Dialog Box

Add User for Project Dialog Box

See Also

Adds users to the project selected under Projects in the Project Rights dialog box.

Remarks

The users displayed in this dialog box are users in the VSS database who do not have access rights in the project selected in the Project Rights dialog box.

To display the Add Users for Project dialog box:

  • On the Tools menu, click Rights by Project, and then in the Project Rights dialog box, click Add User.

Note To use the Add User for Project dialog box, you must first select Enable Project Security on the Project Security tab in the SourceSafe Options dialog box on the Tools menu.

Dialog Box Options

Rights

Access rights assigned to the user.

Users

Users who don't have access rights in the selected project.

User Rights

Specifies the level of access rights [image] Read, Check Out, Add, or Destroy [image] that you want to assign to the user selected in the Users column. After you select a check box, the access rights are displayed under Rights.

Note If the user you want to add to the project has the read-only access right and you want to assign additional access rights, on the Users menu, click Edit User, and then clear the read-only check box.

OK

Confirms selections.

Cancel

Cancels selections and returns to the Project Rights dialog box.


Browse Folder Dialog Box

For more information on the Set Working Folder dialog, see the Set Working Folder Command (File Menu) topic.

Dialog Box Options

Name

Name and path of folder.

Folder

Your current folder.

Folders

Specifies a folder.

Drives

Selects the drive that contains the folder.

OK

Confirms the folder selection.

Cancel

Cancels the selection, closes the dialog box, and returns to VSS Administrator.

Create Folder

Creates a new folder as specified. Type a new folder name in the Name box, then click Create Folder to create the folder.


Browse for VSS Database Dialog Box

See Also

Allows you to name a VSS database.

Dialog Box Options

Database path

Specifies the path to the selected database. You cannot change this value here.

Database name

Specifies the friendly name you want to give this database. This name is displayed in the Open SourceSafe Database dialog box.

OK

Confirms your selections.

Cancel

Cancels your selections.


File Types Options Tab

File Types Options Tab - VSS Administrator

See Also

Sets options relating to the types of files that users store in VSS.

Remarks

Many of the VSS dialog boxes contain file lists that enable users to select multiple files for a specific operation. Use this tab to filter these file lists so that they are more meaningful to the type of work your users do. For example, if your users are Microsoft Visual C++ developers, they may want to store .c, .h, .obj, and .exe files in VSS. If they are Microsoft Visual Basic developers, on the other hand, they may prefer .mak and .frm files.

To display the File Types tab:

  • On the Tools menu, click Options, and then click the File Types tab.

Dialog Box Options

Binary Files

Overrides VSS's automatic detection of text and binary files, and indicates that certain file types are always binary. For example, you could enter *.obj, *.xls, *.frx in this box to specify that all object files, Microsoft Excel worksheets, and Microsoft Visual Basic .frx files should be treated as binary files.

File Groups

Groups file types for your users' type of work, together with the File Types Included in the File Group option. These groups are displayed under List Files of Type in many VSS dialog boxes, so you can specify groups that filter the file list efficiently for your users.

Add

Adds a new group of file types to the list. In the Add File Group dialog box, type a name for the new file group you want to add, like "VC" or "VB."

Delete

Deletes the currently selected group.

File Types Included In File Group

Shows the list of file types included in the currently selected file group under File Groups. To modify a specific group, select the group under File Groups, and then add or delete extensions in this box.

OK

Confirms selections.

Cancel

Cancels selections.


General Options Tab (Tools Menu)

Sets general user options.

Remarks

Settings affect all users in VSS Administrator's user list.

To display the General Tab:

  • On the Tools menu, click Options, and then click the General Tab.

Dialog Box Options

Allow Multiple Check Outs

Controls whether many people can check out one file simultaneously. Under ordinary circumstances, only one person can have a file checked out of VSS at one time. If you select this box, however, VSS allows many people to check out the same file. When the first user checks in the file, VSS updates the file; thereafter, VSS merges in all subsequent changes.

Use Network Name For Automatic User Log In

Sets whether VSS reads users' logon names from the operating system. If you select this box, VSS automatically attempts to get usernames from the operating system. Clear this box if you want users to use logon names different from their network logon names [image] VSS displays a Login dialog box unless users supply a username in some other way (with an environment variable, for example).

Database Name

Sets the name of the current VSS database as displayed in the VSS Explorer title bar. If undefined, the VSS Explorer title bar reads "Visual SourceSafe Explorer," with no database name.

Tip If you have a lot of different VSS databases, you can often end up running VSS without knowing which one you're connected to. You can use the Database Name option to uniquely identify the database, and if you want to know what folder the copy of VSS is in, you can include the folder or share name in the database name. There is a 31-character limit for the database name.

Note If you want to use Database Name, either do so before anyone runs VSS or have users delete the listing from their registry HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\SourceSafe\Databases, then start a new session of VSS.

Expand Keywords In Files Of Type

Indicates on which files to use keyword expansion. By default, VSS does not scan files for keyword expansion when it performs Check In or Add Files commands.

Log All Actions In Journal File

Sets the file where all VSS commands that change stored data are logged. (Commands that don't change data in the VSS database are not logged.) If you select this option, the specified file is a text file listing all VSS actions used by users.

OK

Confirms selections.

Cancel

Cancels selections.


Lock SourceSafe Database Dialog Box

See Also

Allows you to lock all users out of the VSS database while you run a utility, upgrade the executables, or back up the database.

Dialog Box Options

Lock all users out of Visual SourceSafe

Select this box to lock all users out of the VSS database. Remember to clear the box when you are finished with your administrative duties.

Note that the act of selecting the check box in the Lock SourceSafe Database dialog box is what actually locks users out. After this box is selected, no one will be allowed to log on to the database. The users listed who are already logged on will not be affected [image] you will need to notify them manually to log off.

X users logged in

This section of the dialog box shows the users who are currently logged on.

Close

Closes this dialog box.


Open Database Dialog Box

See Also

This dialog lets you browse for a SRCSAFE.INI file associated with a VSS database.

Dialog Box Options

File Name

Enter the file name to search for. When looking for a VSS database, use SRCSAFE.INI.

List files of type

Filter the file list box by displaying files only of the selected type. SourceSafe Database is the default.

Folders

Select the folder to look in.

Drives

Select the drive letter to look on.

OK

Selects the database file listed in the File Name box.

Cancel

Cancels the browse operation.

Network

Lets you map a drive letter to a different network server, if necessary.


Open Dialog Box

Dialog Box Options

File Name

The name of the file you are looking for. You can specify wildcards here, such as *.exe, to look for more than one file matching the wildcard.

List files of type

Specify the type of files to include in the File Name list box.

Folders

Specifies a folder.

Drives

Selects the drive that contains the folder.

OK

Confirms the file selection.

Cancel

Cancels the selection, closes the dialog box, and returns to VSS Administrator.

Network

Allows you to connect a network drive to search.


Open SourceSafe Database Dialog Box

See Also

Allows you to open different VSS databases and store their locations.

Dialog Box Options

Available databases

Specifies the databases you have already visited, giving friendly name and path information for each. If the database you want is not shown in the list, you can click the Browse button to look for it. After you find it, and click OK in the Browse dialog box with a specific SRCSAFE.INI file selected, you have the opportunity to give the database a familiar name for future reference.

Username

Specifies the username with which you want to log on to the new database. If you change this to a new username with a different password, you will be prompted to enter the new password. You cannot change this option in the Administrator program.

Open this database next time I run Visual SourceSafe

Select this box to designate this database as your startup database.

Remove

Removes a selected database from the list. You cannot remove the current database from the list.

OK

Confirms your selections.

Cancel

Cancels your selections.


Project Security Options Tab

See Also

Controls VSS project security. Use this tab to turn security on and off; if security is enabled, you can set default access rights for users.

Remarks

Your first decision is whether to enable project security. If the Enable Project Security check box is clear, project-level security is disabled (VSS's default security is always operating). If the Enable Project Security check box is selected, you can set default access rights for new users added to the VSS Administrator user list. The Add Users command on the Users menu adds users to the user list.

For instance, if the Read, Check Out, Check In, Add, Rename, or Delete check box is selected, new users are given the Add access right in the root project (and therefore in all projects) by default. You can then change these rights in any project using the Rights by Project or Rights Assignments for User command.

To display the Project Security tab:

  • On the Tools menu, click Options, and then click the Project Security tab.

Tab Options

Enable Project Security

Enables the project security system, which provides the four levels of access rights shown below.

Read

Permits a user to view read-only copies of files.

Check Out/Check In

Permits a user to use the Check Out and Check In commands, but does not permit renaming, adding and deleting of files or projects, and so on.

Add/Rename/Remove

Permits a user to use the Add, Rename, Delete, Check Out, and Check In commands, but does not permit actions that permanently destroy files or projects.

Destroy

Permits a user to use all VSS commands. Equal to read/write access rights under the default security system.


Set Shadow Folder or Web Site Dialog Box

Choose a project for which to set a shadow folder or a web site in your VSS database.

Dialog Box Options

Project

Select the project for which you want to set up a shadow folder or web site.

OK

Accepts the project you have selected.

Cancel

Cancels the shadow project or web site selection.


Shadow Folders Options Tab

See Also

Sets shadow folders.

Remarks

Use the Set Shadow Folder for Project option to specify a project. After it is specified, all other options on the tab apply only to the specified project.

To display the Shadow Folders tab:

  • On the Tools menu, click Options, and then click the Shadow Folders tab.

Dialog Box Options

Set Shadow Folder For Project

Specifies the project for which you want to set up the shadow folder. Click Browse to browse through the VSS database for the project you want. After you have entered a project name, any existing shadow information for that project is displayed in the remaining fields of the tab. Remember that shadow settings for a particular project may be set explicitly for that project or inherited from parent projects.

Set Shadow Folder To

Specifies the shadow folder. This folder can be anywhere on the network, but in most cases is on the server with the VSS database. Click Browse to search the file system for a suitable location.

Set Another

Applies the shadow folder specified in the other fields of this dialog box, and clears the dialog box so you can set another shadow folder. This button is not enabled unless you have specified a valid project and folder in the next two fields.

Set Read-Only Flags For All Files

Controls whether files in the shadow folder are read-only.

End-Of-Line Character For Files

Sets the end-of-line character used in the shadow folder. When VSS copies a file into the shadow folder, it uses the end-of-line character used by its own operating system. For example, VSS on Windows uses a carriage-return/line-feed pair. In a multi-platform environment, the files in the shadow folder are a mixture of end-of-line characters, based on which operating system each file was updated from most recently.

This setting overrides that mechanism, forcing all versions of VSS to use the specified end-of-line character. Set this field to LF for line feed (the UNIX default), CR for carriage return, or CR/LF for carriage-return/line-feed pairs (the Intel default). Note that Macintosh compilers can generally accept carriage-return/line-feed pairs, so CR/LF is a good setting for Intel [image] Macintosh installations.

File Date/Time

Sets the date/time stamp given to files in the shadow folder.

By default, whenever VSS places a file in the shadow folder, its sets the date/time of the file to the current date/time.

However, if you set this variable to Modification or Check In, VSS sets the shadow folder file to the date/time that the file was last modified or checked in, respectively.

OK

Confirms selections, and saves the shadow settings to the SRCSAFE.INI file.

Cancel

Cancels selections and returns to VSS Administrator.


Web Options Tab

See Also

There are three general settings that apply to all your Web projects in your VSS database at once. Two apply to Web projects that are deployed through a File Transfer Protocol (FTP) firewall, and one applies to the Check Hyperlinks command. Set these with the Web tab. Don't confuse the Web tab with the Web Projects tab, which sets options for a specific Web project rather than for all Web projects at once.

Proxy for deploying over FTP

If you need to deploy remotely through a firewall, use this field to specify a proxy. Sets the Deploy_Proxy initialization variable in SRCSAFE.INI.

Do not use the proxy for these local servers

Use this field to specify local servers for which the proxy is not appropriate because they are inside the firewall. Sets the Deploy_Host_Local initialization variable in SRCSAFE.INI.

Default filename for Web pages

Use this field to specify the file name that VSS appends to a URL that ends in a folder name, during a Check Hyperlinks run. Defaults to "Default.htm"; you only need to specify this if you want something different. Sets the Web_Default_Filename initialization variable in SRCSAFE.INI.

OK

Confirms selections, and saves the Web settings to the SRCSAFE.INI file.

Cancel

Cancels selections and returns to VSS Administrator.


Web Projects Options Tab

See Also

Sets information applicable to Web projects; that is, projects that contain files meant for HTML browsers. Don't confuse the Web Projects tab with the Web tab, which sets options for all Web projects at once rather than for one individual Web project.

Remarks

Use the top list box to specify an existing VSS project as a Web project. After it is specified, all other options on the tab (except proxy information, which is global) apply only to the specified project.

To remove the Web project designation from a project, simply clear the URL field and click OK.

To display the Web Projects tab:

  • On the Tools menu, click Options, and then click the Web Projects tab.

Dialog Box Options

This tab contains five text fields. The first field and either or both of the URL and Virtual Root fields must be filled in before you can designate a project as a Web project. The remaining two fields are optional.

This project represents a Web project

Type the name of the project into this field, or use the Browse button to locate the project. The other settings apply to this project.

URL

Type the Uniform Resource Locator address for the Web project into this field.

Virtual Root

Some Web server software supports this; if you have specified a virtual root in your server software, you should specify it here, without an initial slash. Entering a value in this field sets a Virtual_Root variable in SRCSAFE.INI. Note that lookups check through the SRCSAFE.INI file for any project with the specified virtual root.

Site map filename

Fill this field with the name of the file you want VSS to use when it creates a site map. (If you don’t specify a value, Sitemap.htm is used by default.)

After you fill in the fields in the tab, have the clients involved in the Web project exit from VSS and restart. VSS Explorer displays the designated project with a special icon to indicate that it is a Web project.

Note You must designate a URL and/or a virtual root for the project. The other fields are optional at the time the project is being designated as a Web project.

Deployment path

A deployment location can be on a hard drive on your computer or elsewhere on a local area network. If a deployment location is local, you specify it with a drive letter or in UNC format. Click the Browse button to search for servers on your network. Entering a value in this field sets a Deploy_Path initialization variable in SRCSAFE.INI.

Alternatively, the location can be remote, in which case it is reached through File Transfer Protocol (FTP). Use URL format to specify an FTP path. The path must include the protocol specification ("ftp://") and the location. To these you can add a username or a username and a password, and (if necessary) a folder path. Separate username and password with a colon (:). You can specify more than one path in this field; separate the paths with commas.

For example:

ftp://www.trassi.com/

ftp://SamBal@www.trassi.com/ssafe

ftp://SamBal:baDJak@www.trassi.com/ssafe

ftp://www.trassi.com/ssafe,\\my\server\ssafe

VSS stores the entire FTP path in the Deploy_Path variable.

Note You can deploy any project that has been designated as a Web project, regardless of the types of files it contains. A single command then sends the entire project to the remote location or locations you’ve specified.

You can enter several deployment paths in this box, separated by commas. For instance, you could set it up so that whenever a user deploys this Web site, it will go to your FTP location and also to a folder on your local server.

When defining a path for an FTP site, the folder information works from the FTP server's root. When using typical FTP commands on Intel or UNIX, you normally log on to the FTP server and begin at a home path that's typically not the server root. You may think of this as a "home" root.

For example, if you wanted to drop a file into your Web site at North Carolina State University, you would perform the following steps:

  1. ftp://ftp.eos.ncsu.edu

  2. Enter your username and password.

  3. Change folder to temp (a subfolder).

  4. Use the FTP "put" command to write the file.

To specify that location in the Deploy dialog box, type:

ftp://username:password@ftp.eos.ncsu.edu/usr/name/temp

Note the necessity of specifying /usr/name/ [image] because the deployment to FTP works from the server root and not the current folder. Also note that many systems use a tilde (~) to specify the user's home folder. So you may have to enter the following (where the UNIX server supports this common syntax):

ftp://username:password@ftp.eos.ncsu.edu/~/temp

Also, you should be careful where you enter the "/". For example "cd ~/temp" is a valid FTP command, but "cd /~/temp" is not.

Set Another

Applies the Web site information specified in the other fields of this dialog box, and clears the dialog box so you can set another Web site project. This button is not enabled unless you have specified a valid project and URL in the top field.

OK

Confirms selections, and saves the Web site settings to the SRCSAFE.INI file.

Cancel

Cancels selections and returns to VSS Administrator.

To Remove Web Project Designation

Clear the URL and virtual root fields on this tab; then click OK.


-? Command-Line Option

Use the -? option with any command to get Help for that command. You can also use the -H option to obtain online Help.

The following table lists one way to use the -? option.

Option | Description
ss Share -? | Displays Help for the Share command.


-C Command-Line Option

See Also

Use the -C option for any command that requires a comment. If you do not specify the -C option, VSS requests a comment for each item specified on the command line. If you do specify the option, all items receive the same comment.

The following table lists ways to use the -C option.

Option | Description
-C | All items receive the same comment.
-C- | No comment is used.
-Ctext | Uses the string text as the comment for all items.
-C@File.txt | Uses the contents of File.txt as the comment for all items.
-C? | Returns to the VSS default; requests a comment for each individual file.

To set any of the options listed in the table as the default for the Check Out command, use the Checkout Comment variable in SS.INI. If you have set a default in SS.INI, you can replace it for a particular command with the option -C?. VSS then asks for a comment for each individual file (the VSS default).

You can set the Comment_Editor variable in SS.INI to invoke an executable editor of your choice as an alternative to the prompt-driven method of entering comments that VSS uses.


-G Command-Line Option

See Also

The Get command copies files from a VSS project into a folder. VSS gets files in response to the Get command and also in response to other commands such as Check Out, Undo Check Out, and Share.

For any of these commands, the -G option is used to change the nature of the Get operation. Many of these options provide command-specific overrides that can be set in the SS.INI file.

The following table lists ways to use the -G option.

Option | Description
-G- | Get operation is not performed.
-GCC | Determines whether the local copy of the file is current by comparing the file's contents.
-GCD | Date and time comparison is used to determine whether the local copy of the file is current.
-GCK | Checksum is used to determine whether the local copy of the file is current.
-GF | Enables the Force_Dir initialization variable for this command.
-GF- | Disables the Force_Dir initialization variable for this command.
-GLpath | Copies a file to the specified folder, not to the current or working folder.
-GN | Specifies the linefeed as the end-of-line character in text files.
-GR | Specifies the carriage return as the end-of-line character in text files.
-GRN | Specifies the carriage return–linefeed pair as the end-of-line character in text files.
-GTC | Local copy is given the current date and time.
-GTM | Local copy is given the date and time that the file was last modified, not the current date and time.
-GTU | Local copy is given the date and time that the file was last updated, not the current date and time.
-GWA | Displays a dialog box asking the user to choose between replacing, skipping, or merging write-only files on Get Latest Version and Check Out operations.
-GWM | Merges write-only files on certain operations (Get and Check Out).
-GWR | Replaces write-only files on certain operations (Get and Check Out).
-GWS | Skips write-only files on certain operations (Get and Check Out).


-I Command-Line Option

There are a number of circumstances when VSS commands ask for input from the user (for example, warnings containing Yes or No questions). This is not desirable when writing scripts or macros that execute the VSS command line from inside other programs. Use the -I- option to ensure that VSS never asks for user input.

When using the –I option, include the -C option to avoid the comment prompt.

The following table lists ways to use the -I option.

Option | Description
-I-Y | Instructs VSS to answer Yes to all Yes or No questions.
-I-N | Instructs VSS to answer No to all Yes or No questions.


-N Command-Line Option

On operating systems that support long file names, the -N option switches between the long and short file name mode, one command at a time.

The following table lists ways to use the -N option.

Option | Description
-NL | Use long file name mode.
-NS | Use short file name mode.


-O Command-Line Option

The -O option controls the output from commands that might display large amounts of information. If you do not specify -O, the information scrolls by on the screen too quickly to be read.

The following table lists ways to use the -O option.

Option | Description
-O | All output is presented.
-O- | Error output only is presented.
-O@File.txt | All output is sent to File.txt. This is the command-line method for exporting reports, such as the History report, to a file or printer. If the named file already exists, output is appended to that file.
"-O&File.txt" | Standard error output is sent to File.txt, in addition to the command output. Note that the quotation marks are required on Windows NT platforms, and optional on others. If the named file already exists, output is appended to that file.
-O&- | No output is provided.


-R Command-Line Option

The -R option is used with VSS commands that operate on projects; it makes the commands recursive to subprojects. Normally, commands act only on the specified project and the files in it. For example, if you get a project, you get all the files that are in that project. However, subprojects and the files and subprojects inside them are ignored. When you use the -R option to make a command recursive, the command acts on the entire project hierarchy. For example, if you type SS Get projectname -R, folders are created for that project's subprojects, and the subprojects inside of them, and so on.


-S Command-Line Option

See Also

The Smart_Mode initialization variable in SS.INI puts VSS in SmartMode. With SmartMode enabled:

  • After you create a project, SmartMode sets that project as your current project.

  • When you delete or destroy a file, VSS automatically deletes the corresponding local file.

  • When you rename a file, VSS automatically renames the corresponding local file.

The -S option overrides the Smart_Mode variable for a particular command.

The following table lists ways to use the -S option.

Option | Description
-S | Enables SmartMode.
-S- | Disables SmartMode.


-V Command-Line Option

The -V option enables you to specify earlier versions of files or projects. For example, you may want to view the exact state of a project or file from last month.

The following table lists ways to use the -V option.

Option | Description
-V14 | Displays version 14.
-Vd2-29-92 | Displays the version dated 2-29-92.
"-VLFinal Beta" | Displays the version with the label Final Beta.

The -V option displays all files and projects identified by the version number specified on the command line. You can also specify a version number for one particular item, by following that item with a semicolon and then the version number.

The following table shows how to specify a particular item on the command line.

Option | Description
Help.C;14 | Displays version 14 of Help.C.
Show.prg;d2-29-92 | Displays Show.prg as it appeared on 2-29-92.
"$/CW;L Beta 1" | Displays the version of the project $/CW with the label Beta 1.

Occasionally, you will want to reference a time along with the date in a VSS command. To do this, use the -vd switch.

For example, to list the history of the $/Test project from 9 A.M. to 3 P.M. on 3/3/95, issue the command:

ss history $/test -vd3/03/95;3:00p~3/03/95;9:00a

In the preceding command "a" or "p", refers to a.m. or p.m. respectively. The tilde (~) indicates that you want the history between the dates and times specified. Note that the later date and time must be specified first.


-W Command-Line Option

See Also

When a file is not checked out, your local copy is locked, or made read-only to remind you that it should not be altered. The Use_ReadOnly variable in SS.INI changes this default behavior. The -W option changes it for a specific command.

The following table lists ways to use the -W option.

Option | Description
-W | Local files are made read/write.
-W- | Local files are made read-only.


-Y Command-Line Option

The -Y option specifies a username in case you want to execute a command as a user other than yourself.

The following table lists ways to use the -Y option.

Options | Description
-YMary | Specifies a username.
-YMary,Mypass | Specifies a username and password.


Add to Source Control Dialog Box

Use this dialog box to put files under source-code control in the source-code control project associated with your project workspace. You can add files initially, when the project workspace is created or later, after the project workspace has already been created.

Dialog Box Options

Files

Lists all the files currently in your project, but not currently under source-code control, with a check against files selected in FileView. If this list does not contain the desired files, click the check boxes in the list to change the selection.

Keep checked out

Checks the files out to you after adding the master versions of the files to the source-code control project.

Comment

Adds a comment about the files that you are adding.

Advanced

Accesses additional options. If your source-code control system does not support such options, this button is inactive.


Add to SourceSafe Project Dialog Box (Development Environment)

Adds the current development environment project to the source code control database.

To Add a Project To Source Code Control:

  • On the Tools menu, select the Source Control item, and then click Add to Source Control.

Note If you specify the name of your source code control provider, that name is displayed in place of "Source Code Control."

Dialog Box Options

Project

Specifies the VSS project that files will be added to.

$/

Displays the VSS project tree and shows you which project in VSS your files will be added to.

Create Command Button

Creates a new project in the VSS database.

Remarks

The Add Project to Source Code Control command takes the selected files in the development environment project window and creates a new source code control project containing those files. This command is available only when you select a project not already under source code control. Each selected file is automatically added at this time.


Advanced Check Out Options Dialog Box

Sets default Check Out command options.

To display the Advanced Check Out Options:

  • Click the Advanced button on the Check Out dialog box.

Dialog Box Options

Replace Writable

Determines how VSS behaves when you try to check out a file that is already marked as writable in your working directory. Select one of the following in the list box:

  • Ask [image] Asks you what to do with each file.

  • Replace [image] Replaces the file with a read-only version.

  • Skip [image] Skips the check out operation.

  • Merge [image] Merges the changes between the checked out file and the one you are now getting or checking out.

  • Default [image] Uses the defaults set on the Local Files Options tab in the SourceSafe Options dialog box (Tools menu).

Set File Time

Changes the time assigned to the check out operation. Select one of the following in the list box: current time, the last file modification time, the last file check-in time, or the default time (set on the Local Files Options tab).

End of Line

Specifies the end-of-line character that VSS gives to each line in the file it retrieves. Select one of the following in the list box: line feed (LF) for the UNIX platform, carriage return (CR) for the Macintosh, carriage-return/line-feed (CR/LF) for MS-DOS/Windows, or the default (set on the Local Files Options tab). Visual Basic users should always set this to CR/LF.

Don't Get Local Copy

Tells VSS not to copy the file to your working directory. VSS records that the file is checked out, but does not give you a new copy.


Advanced Comment Dialog Box

Advanced Options

Store Only Latest Version

Indicates you do not want to save old versions of the file(s) being added to the VSS database. VSS keeps a file history of change records with comments. However, the older versions of the file are not stored, and you cannot recover them.

Note To increase performance and save disk space, use this option when storing executable programs in VSS.

Check Out Immediately

Checks out the file to you immediately after adding it to VSS.

Remove Local Copy

Deletes the file from your working folder after adding it to VSS.

File Type

Select an option from the list box:

  • AutoDetect [image] VSS determines the file type.

  • Binary [image] VSS treats the file as a binary file.

  • Text [image] VSS treats the file as a text file.

Note When adding a folder, VSS ignores the File Types field. However, VSS filters the files added during a folder Add Files operation by the Relevant_Masks setting on the File Types tab in the SourceSafe Options dialog box.


Advanced Get Options Dialog Box

Sets default Check Out command options.

To display the Advanced Get Options dialog box:

  • On the Tools menu, click Get, and then click the Advanced button.

Dialog Box Options

Replace Writable

Determines VSS's behavior when you attempt to get a file that is already marked as writable in your working directory. Select one of the following in the list box:

  • Ask [image] Asks you what to do in each case.

  • Replace [image] VSS replaces the file with a read-only version.

  • Skip [image] Skips the Get operation.

  • Merge [image] Merges the changes between the checked out-file and the one you are now getting or checking out.

Default [image] Uses the default set on the Local Files Options tab, via the Tools menu, Options command.

Set File Time

Changes the time assigned to the Get operation. Select one of the following in the list box: current time, the last file modification time, the last file check-in time, or the default time (set on the Local Files Options tab).

End of Line

Specifies the end-of-line character that VSS gives to each line in the file it retrieves. Select one of the following in the list box: line feed (LF) for the UNIX platform, carriage return (CR) for the Macintosh, carriage-return/line-feed (CR/LF) for MS-DOS/Windows, or the default (set on the Local Files Options tab).

Make Writable

Retrieves the file and makes it writable. This is not equivalent to a Check Out operation, because the Get command is a non-exclusive one or more people can perform the Get command on the same file. You cannot check in changes after a Get operation with this option set.


Check Hyperlinks Dialog Box

See Also

Allows you to specify options for checking a set of HTML files for invalid links to other files.

Dialog Box Options

Project

Specifies the project that will be checked for invalid HTML links.

URL

Shows the URL represented by this project. Your VSS administrator sets this URL for each Web site project using the Administrator program.

Check which files?

This area is used to specify which files you want to check. You can choose to check the files in your working folder or those in your VSS project. If you have made changes since checking your files out, click Check files in my working folder. If you are checking a project with subprojects, select the Recursive box to include those subprojects.

There are basically two scenarios. First, all your HTML files are checked in, you are about to deploy, and you want to make sure nothing is broken. In that case, check the files in your project. Second, you are about to check your files in, but want to make sure you don't break anything before you do: in that case, check the files in your working folder.

OK

Confirms your selections.

Cancel

Cancels your selections.


Check Hyperlinks Results Dialog Box

This dialog is shown after VSS has scanned your Web files for broken hyperlinks. VSS differentiates between two kinds of hyperlinks: internal, and external.

Internal links are within your Web site: that is, one file refers to another file in the same VSS project tree. VSS checks all internal links, and displays any potential problems. Problems are not determined by actually searching for files on your Web site; instead, VSS searches for files inside your project tree. For instance, suppose that the file $/My/Web/FU.ASP contains the line:

<A HREF=“ORDER.HTM”>

VSS will make sure that $/My/Web/ORDER.HTM exists. If that file exists, the hyperlink is valid, and is not displayed. If the file does not exist, this hyperlink is listed as broken.

External hyperlinks are jumps to sites on the World Wide Web that are not in your project tree. VSS will try to resolve the external hyperlinks in your web page.

Check Hyperlinks Results Windows

File - Invalid Links - Ignored Links

Lists the file being checked, with a summary of the number of invalid links and the number of links ignored.

Links which appear invalid in file

Lists the internal and external hyperlinks that VSS determined to be invalid.

Links that were not checked in file

Lists the internal and external hyperlinks that were not checked.

Note Double clicking on an ignored link will launch Internet Explorer, which will attempt to resolve the link and display the results.


Check In File(s) to <Project Name> Dialog Box

Checks in changes made in your development environment working directory to your source code control database.

To use the Check In command:

  • On the Visual Basic Tools menu, click Get.

Dialog Box Options

Files To Be Checked In

Lists the files available for check in. Click the files you want to check in, or click Select All to select all the files listed.

Comment

Type an optional comment.

Keep Checked Out

Updates the source code control database with your changes but keeps the file checked out to you.

OK

Checks in the selected files.

Cancel

Cancels the Check In command.


Check Out File(s) from Dialog Box

Checks out a copy of the selected file(s) from your source code control provider and places a writable copy in the corresponding development environment working directory.

To use the Check Out command:

  • On the Visual Basic Tools menu, click Check Out.

Dialog Box Options

Files to be Checked Out

Lists the files available for check out. Click the files you want to check out, or click Select All to select all files listed.

Comment

Type a brief description of the reason for the check out.

Advanced

Displays the Advanced Checkout dialog box.

OK

Confirms Check Out.

Cancel

Cancels the Check Out command.

Select All

Selects all files listed.


Check Out Status Properties Tab

See Also

Displays check out information on a VSS file.

To display the Check Out Status tab:

  1. Select a file in the file pane of VSS Explorer.

  2. On the File menu, click Properties, and then click the Check Out Status tab.

Access Rights

You must have the Read access right to use this tab.

Remarks

If more than one user has a file checked out, clicking Check Out Status first displays a list of all check outs. Double-click a particular check out to see details on that check out. You can also check in a file, or undo the check out of a file.

If the selected file has not been checked out, when you click Check Out Status VSS tells you the file has not been checked out, and does not display the tab options.

Tab Options

Name

Name of the selected file.

By

User who checked out the selected file.

Date

Date and time the selected file was checked out.

Version

Version number of the selected file.

Computer

Name of the computer from which this file was checked out.

Folder

Working folder the checked out file is in.

Project

Name of the project the file is in.

Exclusively Checked Out

If checked, this box indicates that the file or project is checked out exclusively to one user.

Comment

Comment that was entered for the file. You can edit or add a new comment in this box, up to 64 characters.

Close

Closes the Properties dialog box and returns to VSS Explorer.

Report

Sends a report to the Clipboard, a file or a printer.


Checkouts Dialog Box

Shows the various locations to which you have a file checked out.

To display the Checkouts dialog box:

  • On the SourceSafe menu, click File Properties and select the Check Out Status tab.

Dialog Box Options

Check Outs

Lists the locations that the file is checked out to.

Details

Shows check out status for the selected file.

Check In

Checks in the selected file.

Undo Check Out

Undoes the check out of the selected file.

Close

Closes the dialog box, and cancels the command.


Choose Project From SourceSafe (Development Environment)

Allows user to specify location of VSS project that contains the files the user wished to work on.

Dialog Box Options

Working Folder

Specifies the location of the directory that VSS will use to store the working copies of files retrieved from the VSS database.

SourceSafe Project to Use

Allows the user to select the VSS project that contains the files the user wishes to work on.


Command Dialogs Options Tab

Specifies whether command dialogs are displayed with commands.

To display the Command Dialogs tab:

  • On the Tools menu, click Options, and then click Command Dialogs.

Access Rights

Any VSS user can use this tab.

Remarks

If you never use the options provided by, for example, the Get Latest Version dialog box, you can turn it off so that VSS no longer displays it when you execute the Get Latest Version command. You can specify behavior depending on whether a project or a file is selected with the following five commands.

  • Get Latest Version

  • Check Out

  • Undo Check Out

  • Show Differences

  • Show History

You can also specify command dialogs for the project-level Deploy and Create Site Map commands.

You can override any setting you make in this dialog by holding down the SHIFT key while you select one of the above commands. In this case, the command dialog will be displayed even if you do not have the corresponding box checked.


Command-Line Options Tab

Controls options that affect VSS's command line. These options don't affect the behavior of VSS Explorer.

To display the Command Line tab:

  • On the Tools menu, click Options, and then click Command-Line Options.

Access Rights

Any VSS user can use this tab.

Tab Options

The first two options affect how VSS interacts with your working folder during command-line operations. By default in the Explorer, VSS expects a working folder to be set for each project, and will check out files to that folder only. By default on the command line, VSS assumes your current project and current folder are what you want to be working with, and ignores any working folders set for a specific project. To change current projects, you need to use the CP command. You can modify this behavior by checking one or the other of the following two options:

Assume Working Folder Based On Current Project

Determines how the working folder you've set is used:

  • If this option is selected, a file is put into your working folder for the project, even if that is not the current folder when you execute a command on a file from the command line.

  • If this option is not selected, subprojects go into their own respective working folders instead of subfolders under the main folder.

Assume Project Based On Working Folder

Automatically sets the current project, based on the current folder. If set, VSS looks at your current folder whenever you execute any VSS command. If this is the working folder for a VSS project, VSS automatically changes to that project before executing the command. Hence, you can change folders to move around your projects, without ever executing the ss CP command. If you set this option, it is highly recommended that you do not give two projects the same working folder, because VSS won't know which project to switch into.

If not set, VSS does not change to your current project when you execute any VSS command.

No Comment On Check Out

Does not prompt for a comment on check out.

Apply Same Comment To All Files

Prompts you for one comment only (up to 64 characters), which VSS applies to all files involved in that check out operation.

Apply Different Comment To Each File

Prompts you for a separate comment for each file involved in the check out operation.

Prompt For Comments On The Command Line

Asks for comments on the command line.

Use Editor To Prompt For Comments

Lets you specify an editor with which to enter your command-line comments. Once you have selected this option, you can enter the path for the selected editor in the Editor box. You can browse your file system for this information using the Browse button. If you leave the Prompt String box blank, no prompt is displayed in your editor.

Use prompt string

Specifies that a prompt string asking for a comment is inserted into your specified editor when it opens. Disabled when Prompt for comments on the command line is selected. The prompt string is not saved with your comment (you don't have to delete it), unless you change the string in your editor.


Comment Dialog Box

Allows you to specify a comment for an Add Files, Share, or Merge Branches command.

Dialog Box Options

Comment

Enter a comment for this operation.

OK

Enters the selected comment(s) in the VSS database.

Cancel

Cancels the Add Files, Share, or Merge Branches command.

The following options are available only during an Add Files operation:

Apply same comment for all

Applies the same comment to all files involved in the Add Files operation. If this check box is clear, you can enter a separate comment for each file. The default is checked (your comment is applied to all files selected for this operation).

Recursive

Indicates you want files in all subfolders added when you select an entire folder to add. Available only when you select a folder and then click Add.

Advanced Options

Store Only Latest Version

Indicates you do not want to save old versions of the file(s) being added to the VSS database. VSS keeps a file history of change records with comments. However, the older versions of the file are not stored, and you cannot recover them.

Note To increase performance and save disk space, use this option when storing executable programs in VSS.

Check Out Immediately

Checks out the file to you immediately after adding it to VSS.

Remove Local Copy

Deletes the file from your working folder after adding it to VSS.

File Type

Select an option from the list box:

  • AutoDetect [image] VSS determines the file type.

  • Binary [image] VSS treats the file as a binary file.

  • Text [image] VSS treats the file as a text file.

Note When adding a folder, VSS ignores the File Types field. However, VSS filters the files added during a folder Add Files operation by the Relevant_Masks setting on the File Types tab in the SourceSafe Options dialog box.


Connect to VSS Dialog Box

Allows the user to specify the location of the database they want to connect to.

To display the Connect to VSS dialog box:

  • On the Add-Ins menu, click SourceSafe, and then click Open New SourceSafe Project.

Dialog Box Options

SourceSafe database path

Type the full path and name of the VSS database you want to connect to. Use the Browse button to browse for the full name.

Data path (optional)

Type the identifier for the data project you want. See your VSS Administrator for more assistance with this identifier. (Your VSS administrator must set up this identifier using the Data_Path variable.)

OK

Connects to the specified database, if available.

Cancel

Cancels the database connection.


Contents of <Project Name> Dialog Box

Displays the contents of the selected VSS project

To display the Contents of <Project Name> dialog box:

  1. Select a project in VSS Explorer.

  2. On the Tools menu, click Show History.

  3. Click OK in the History Options dialog box.

  4. Select a file from the list in the History of Project dialog box.

  5. Click View.

Dialog Box Options

Date/Time stamp

Lists the timestamp of the latest version of the file in VSS.

Files

Lists the files in the project along with their current version numbers.


Create Local Project From SourceSafe Dialog Box

Allows user to create a new development project from an existing VSS project.

To use the Download SourceSafe Project command:

  1. From the File menu, click Open Workspace.

  2. Select the Source Control button in the lower right corner of the dialog box.

Dialog Box Options

Create a new project in this folder

The working folder for the selected project. Click Browse to create or change the working folder.

SourceSafe Project to download

VSS project list. Click the project you want to open.

OK

VSS gets the files, places them in your working folder, and opens the project in your development environment so that you can edit it.

Cancel

Cancels the Download SourceSafe Project command.


Create Site Map Dialog Box

See Also

Allows you to create a map of your Web site, using HTML files checked into your VSS project as targets for HTML jumps.

Dialog Box Options

To

Specifies the file containing the resulting HTML site map code. Click Browse to search the file system for a suitable location.

Check in to VSS

Check this box to have the resulting file checked into the VSS project.

OK

Confirms your selections.

Cancel

Cancels your selections.


Deleted Items Properties Tab

See Also

Displays a list of files and subprojects that have been removed from the current project.

To display the Deleted Items tab:

  1. Select a project in the project pane of VSS Explorer.

  2. On the File menu, click Properties, and then click the Deleted Items tab.

Access Rights

You must have the Read access right to use this tab.

Remarks

When you use the Delete command to delete a file or project from VSS, the deleted item is removed from VSS Explorer. However, VSS continues to store the item, so that you can retrieve it if you want to build an earlier version of the project. After you recover or purge an item, however, it no longer appears in the list in the Deleted Items tab.

Tab Options

Items

The list of all removed files and subprojects in the current project.

Recover

Recovers (undeletes) an item, and places it in the file list or project list.

Purge

Permanently deletes an item, so that it can no longer be recovered.

Close

Closes the Deleted Items tab and returns to VSS Explorer.

Report

Sends a report to the Clipboard, a text file, or a printer.


Deploy Dialog Box

Allows you to set options for your Web site project deployment.

Dialog Box Options

If you enable the Deploy command dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu), or hold down the SHIFT key when you click the Deploy command, you have the following options:

To

Type the path where you want VSS to place the files. You can Browse for the appropriate location.

Make Writable

Sets the read-write flag so the file is writable. This is not the default behavior, but may be useful if you want to try a temporary change in the file, or want to rename the file after getting it.


Designate Makefile Dialog Box

Allows the user to specify which Visual Basic project file in VSS to make a new Visual Basic project from.

Note This dialog box will only appear when a user clicks the Create Project From SourceSafe command and they have two or more Visual Basic project files stored in the same VSS project. Since Visual Basic doesn't know which of the VSS items to create a new Visual Basic project from, it will prompt the user to decide.

Dialog Box Options

Select the Visual Basic file

Shows the user a list of the Visual Basic project files stored in VSS from which they can use to create a new Visual Basic project file.

OK

VSS will create a new Visual Basic file from the item selected in the Select the Visual Basic file list.

Cancel

Cancels the Create Project from VSS command.


Difference for Project Dialog Box

Shows the differences between files in the selected VSS database project and the working folder set for that project. You can also see what is different within a file, and reconcile differences if desired.

To display the Differences For Project dialog box:

  1. Select a project in the project pane of VSS Explorer.

  2. On the Tools menu, click Show Differences. Select options in the Project Difference dialog box (if it's enabled), then click OK.

Note To enable the display of the Project Difference dialog box, check the Difference checkbox in the Project column on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

Dialog Box Options

This powerful dialog is composed of two panes, one showing the files in your current project (on the left) and the other showing files in the working folder assigned to the current project (on the right). This dialog also has its own toolbar, with buttons for adding files, deleting files, getting files, checking files out and in, undoing file check outs, viewing files, reconciling the differences between the project and working folder, and more.

Files in both panes are sorted alphabetically, by file name or folder name (if there are subfolders). Remember that the list of files in the right and left panes is filtered by the choices you made in the Show Differences command dialog. For example, if you choose to show only files that are different in both places, you will not see files that are the same in both your working folder and your current project. You can size the columns in the left pane by dragging the column bar with your left mouse button. Pressing F5 will refresh your dialog box with current information (but may be slow for large projects).

There are four types of files which may appear in the lists.

  • Files that are the same in project and your working folder appear in black letters against a white background by default. There is no action you need to take for these files.

  • Files that are in the project, but not in your working folder, appear in blue against a gray background by default. Such a file generally represents a file that another user added to the project (in which case you may wish to Get it), or a file that you deleted from your working folder (in which case you may wish to delete it from VSS).

  • Files that are in your working folder, but not in the project, appear in green against a gray background by default. Such a file generally represents a file that you created (in which case you may wish to Add it to VSS), or which another user deleted from the project (in which case you may wish to delete your local copy).

  • Files that are in both places, but different, appear in red against a gray background by default. Such a file generally represents a file which you have checked out (which you may wish to check in), or a file which another user has checked in (which you may wish to Get).

Note You can set your default colors for added, changed, and deleted text by using the Difference tab of the Tools Options dialog box.

The above is a complete list of the four types of files, but not a complete list of the possibilities. For instance, if another user renames a file in VSS you will see a file you do not actually have, in the File List for that project in VSS Explorer; and in your working folder for the project there will be a file that is not present in the VSS database. So you would want to get VSS's file, and delete your local one, to reconcile the differences.

File icons in the left pane of the dialog box represent the same things they do in the main Explorer window [image] a checkmark next to a file means the file is checked out, etc. File icons in the right pane represent conditions specific to you [image] for example, a checkmark in the right pane means the file is checked out to you specifically, in your working folder. Double-clicking a file views it. Double-clicking a folder does nothing.

Toolbar commands in this dialog generally work in the same way as the standard VSS commands, but some work slightly different, as follows:

  • The Add command moves a file or directory from the right pane to the left pane. In other words, it adds a file that is in your working folder to the VSS project. The keyboard shortcut for this command is the Windows95 application key + A.

  • The Delete command works normally if a file in the left pane is selected. If a file in the right pane is selected, you can use the Delete command to delete the local file or directory from your working folder. The keyboard shortcut for this command is the Delete key.

  • The Get Latest Version command works normally, getting a file or project from the left pane to the right pane. The keyboard shortcut for this command is the Windows95 application key + G.

  • The Check Out command works normally, reconciling the differences between a file that is different between panes and is not checked out in the right pane, by checking out the file and overwriting the file in your local working folder. The keyboard shortcut for this command is the Windows95 application key + O.

  • The Check In command works normally, reconciling a file that is in both panes, but different, and is checked out in both panes. With this command, you save the latest changes to the file in your working folder. The keyboard shortcut for this command is the Windows95 application key + I.

  • The Undo Check Out command works normally, reconciling a file that is different between panes and is checked out in both panes by undoing the check out on the file. With this command, you lose the latest changes to the file in your working folder. The keyboard shortcut for this command is the Windows95 application key + U.

  • The View command works on a file selected in the left pane just like the Explorer's View command [image] it displays the file in the VSS database. The View command works on a file selected in the right pane by opening the appropriate viewer directly on the file in the folder. The keyboard shortcut for this command is the Windows95 application key + V.

  • The Difference command compares two selected files. If only one file is selected, Difference compares it between the VSS project and the folder. The keyboard shortcut for this command is the Windows95 application key + S.

  • The Refresh File List command brings the file list up to date.

  • The Reconcile All command reconciles differences found in the compared projects. Reconciliation can mean several different things, depending on the settings you choose in the dialog boxes that are displayed after you choose this command.

  • The Report command generates the standard Report dialog box. The keyboard shortcut for this command is the F5 key.

Note If you use a mouse, you can access many of the preceding commands with the right mouse button


Difference Options Dialog Box

Displays the differences between the local copy of file or project with the copy stored in the VSS database.

To display the History of File dialog box:

  1. Select a file or project in the VSS Explorer.

  2. On the Tools menu, click Show Differences.

Dialog Box Options

Compare

Enter the name of the file you want to compare. Use the Browse button if necessary to find the file. You can browse through files in your VSS projects, or in your Windows folders on your hard disk. To compare to a specific version of a file, you must add a semicolon and version number to the filename. For example:

HELP.C; 5

To

Enter the name of the file you want to compare the first file to. Use the Browse button if necessary to find the file. You can browse through files in your VSS projects, or in your Windows folders on your hard disk.

Format

Click Visual to use the VSS Visual viewer format (a side by side format), click SourceSafe to use the old-style SourceSafe format (showing only the lines added, deleted, or changed), or click Unix to use the Unix format (showing only the changed lines, marking the old and new versions).

Ignore White Space

Check this box to have VSS ignore differences in white space; that is, lines that differ only in space, tab, or other white space characters.

Ignore Case

Check this box to have VSS ignore differences in case.

OK

Confirms your selections.

Cancel

Cancels your selections.

Report

Allows you to print a report of the error information to the Clipboard, a printer, or a file.

Advanced Options

Click this button to specify advanced File Difference options.

Ignore OS Differences

Check this box to have VSS ignore differences in the file caused by development on differing operating systems (such as end of line characters).

Save Settings

Check this box to save the settings you have chosen for use in subsequent Show Difference operations.

Show Context

Check this box to show contextual information. (Essentially, this means that besides showing just a changed line, VSS will also show the lines surrounding the changed line to provide some context to the information.) This option does not apply when you are using the visual format, only to the SourceSafe and Unix formats.

Lines

If Show Context is checked, this box lets you specify the number of lines of contextual (surrounding) information you wish to see.

Skip This Dialog

Skips this dialog box during future file difference operations, and uses the settings you've entered as the default. To restore the dialog box, clear the appropriate box on the Command Dialogs tab in the SourceSafe Options dialog box. Pressing the SHIFT key when clicking the Show Difference command always displays this dialog box, overriding the setting on the Command Dialogs tab.


Difference Options Tab

See Also

Allows you to specify options for viewing differences between files or projects. These options are used in other VSS dialog boxes such as the Project Difference dialog box and the Visual Merge dialog box.

Dialog Box Options

Reset

Resets all values on this tab to their defaults.

Colors

This area of the tab contains a list of line and text types. Select each type and you will see the corresponding color used for that line or text type in the Sample area.

Note The color of a bookmark in the visual viewers is the same as the Selection Text background color.

Foreground

This control is a drop down list box used to select the foreground color.

Background

This control is a drop down list box used to select the background color.

Font

Shows the selected font used in the difference viewer windows. Click Modify to change the font.

Tabstop width

Shows the equivalent number of spaces each tab stop equals.

Show line numbers

Shows line numbers in the visual difference viewers.

Ignore white space differences when merging file

Check this box to ignore differences in white space (tabs, space characters, etc.) when merging two files.

OK

Confirms your selections.

Cancel

Cancels your selections.


Differences For File Dialog Box

See Also

Shows differences between a working folder version of the selected file and the VSS database version of the file.

To display the Differences For File dialog box:

  1. Select a file in the file pane of VSS Explorer.

  2. On the Tools menu, click Show Differences.

  3. If the files compared are the same, a message tells you the files are identical. VSS cannot display differences for binary files; it can only tell you whether or not binary files differ. If text files differ, VSS displays the File Difference dialog box.

  4. Make selections in the File Difference dialog box (if it's enabled), then click OK.

Note Enable the display of the File Difference dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

Remarks

The Difference For File dialog box displays two files side-by-side. It uses three colors to show deleted, modified, and changed lines. You can change the colors by setting the options on the Difference tab of the Tools Options dialog box. You cannot make changes to the files from this dialog box [image] it is for display of differences only.

Note To compare a current VSS file to an older version of the same file, select the file in the file pane of VSS Explorer, and on the Tools menu, click Show History. Then click Diff.

Dialog Box Options

This dialog has a toolbar containing all the commands you'll need for finding and marking differences:

Find

Lets you search for a string in the file. The shortcut key is Alt+F3.

Find Next

Lets you search for the next matching occurrence of a string in the file. The shortcut key is F3.

Find Previous

Lets you search for a previous matching occurrence of a string in the file. The shortcut key is Shift+F3.

Toggle Bookmark

Lets you turn a bookmark on or off in a file. The shortcut key is Ctrl+F2.

Next Bookmark

Lets you go to the next bookmark in the file. The shortcut key is F2.

Previous Bookmark

Lets you go to the previous bookmark in the file. The shortcut key is Shift+F2.

Clear All Bookmarks

Lets you clear all bookmarks in the file.

Previous Difference

Lets you find the previous difference in the file. The shortcut key is Shift+F7.

Next Difference

Lets you search for the next difference in the file. The shortcut key is F7.


Difference for File Dialog Box

Differences For File Dialog Box

See Also

Shows differences between a working folder version of the selected file and the VSS database version of the file.

To display the Differences For File dialog box:

  1. Make sure that you have the SourceSafe or Unix button selected in the Difference Options dialog box.

  2. Select a file in the file pane of VSS Explorer.

  3. On the Tools menu, click Show Differences.

  4. If the files compared are the same, a message tells you the files are identical. VSS cannot display differences for binary files; it can only tell you whether or not binary files differ. If text files differ, VSS displays the File Difference dialog box.

  5. Make selections in the File Difference dialog box (if it's enabled), then click OK.

Note Enable the display of the Difference Options dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

Remarks

This dialog box is used only when you have not selected the visual difference comparison. (For visual differences, make sure you select the Visual option from the Difference Options dialog box.) By default, VSS uses the Visual Difference dialog box. The visual difference option shows each file side by side, and lets you easily make changes from one to the other. The SourceSafe Difference shows a simple list of lines that were added, deleted, and changed, optimized for readability. The Unix option shows differences in the format used by the UNIX Diff utility.

If you specify a UNIX display, VSS uses the SourceSafe display options for Ignore Case and Ignore White Space. The SourceSafe display option has line widths calculated to fit on your screen, and no context lines.

Note To compare a current VSS file to an older version of the same file, select the file in the file pane of VSS Explorer, and on the Tools menu, click Show History. Then click Diff.


File History Options Dialog Box

Allows you to specify options for presenting the file history.

Dialog Box Options

Include Labels

Allows you to control whether file labels will show in the history for the specified file.

Labels only

Includes only labels in project history if you have selected the Include file checkins option. You can use this checkbox with the From and To fields to find all projects with the designated label, however files within those projects will not be searched for designated labels.

From

Restricts the history report to begin at the date specified. Type a date, date;time, version, or label. Use the prefix D to indicate a date and/or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "Lbeta1". Dates can be entered in 08.15.95, 08-15-95, or 08/15/95 format, but not as August 15, 1995.

To

Restricts the history report to end at the date specified. Type a date, date;time, version, or label. Use the prefix D to indicate a date and/or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "LBeta1". Dates can be entered in 08.15.95, 08-15-95, or 08/15/95 format, but not as August 15, 1995.

User

Shows a history of files worked on by the specified user.

OK

Displays History of Project dialog box. In this dialog box, select any of the items in the list, and then click Details to display the History Details dialog box. From within the History Details dialog box, you can click the Next and Previous buttons to move up and down in history display. You can also edit the comment and label associated with the version you are viewing.

Skip This Dialog

Skips this dialog box during future Show History operations, and uses the settings you've entered as the default. To restore the dialog box, click the appropriate check box on the Command Dialogs tab of the SourceSafe Options dialog box.


File/Project History Options Dialog Box

Allows you to specify options for presenting the project history.

Dialog Box Options

Include file checkins (project history only)

Includes files in project history.

Recursive (project history only)

Includes subprojects and all files within them.

Labels only

Includes only labels in project history if you have selected the Include file checkins option.. You can use this checkbox with the From and To fields to find all projects with the designated label, but it will not search through the files in those projects for designated labels.

From

Restricts the history report to begin at the date specified. Type a date, date;time, version, or label. Use the prefix D to indicate a date and/or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "Lbeta1". Dates can be entered in 08.15.95, 08-15-95, or 08/15/95 format, but not as August 15, 1995.

To

Restricts the history report to end at the date specified. Type a date, date;time, version, or label. Use the prefix D to indicate a date and/or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "LBeta1". Dates can be entered in 08.15.95, 08-15-95, or 08/15/95 format, but not as August 15, 1995.

User

Shows a history of files worked on by the specified user.

OK

Displays History of Project dialog box. In this dialog box, select any of the items in the list, and then click Details to display the History Details dialog box. From within the History Details dialog box, you can click the Next and Previous buttons to move up and down in history display. You can also edit the comment and label associated with the version you are viewing.

Skip This Dialog

Skips this dialog box during future Show History operations, and uses the settings you've entered as the default. To restore the dialog box, click the appropriate check box on the Command Dialogs tab of the SourceSafe Options dialog box.


File Types Options Tab

File Types Options Tabs

There are two Files Types Options Tabs available, one for the VSS user, the other for the VSS Administrator.

Select from one of the following:

  • VSS Administrator - Files Types Options Tab

  • VSS User - File Types Options Tab


File Types Options Tab

File Types Options Tab - VSS User

See Also

Sets options relating to the types of files you store in VSS.

To display the File Types tab:

  • On the Tools menu, click Options, and then click File Types.

Access Rights

Any VSS user can use this tab.

Remarks

Many of the VSS dialog boxes contain file lists to let you select multiple files for a specific operation. Use this tab to filter these file lists so that they are more meaningful to the type of work you do. For example, if you are a C++ developer, you may want to store .CPP, .H, .RC, and .BMP files in VSS. If you are a Visual Basic developer, on the other hand, you may want to store .VBP and .FRM files instead. You can use this tab to restrict the file lists to display just these file types rather than all the files in a specific folder.

Tab Options

Binary Files

Overrides VSS's automatic detection of text and binary files, so that you can indicate that certain file types are always binary. For example, you can enter *.OBJ, *.XLS, *.FRX in this box to specify that all object files, Microsoft Excel worksheets, and Visual Basic .FRX files should always be treated as binary files.

Create SCC File

This box is useful only for Visual Basic users. When you work with a Visual Basic project in VSS, a special file is created in your working folder called MSSCCPRJ.SCC. This file can never be added to VSS: it stays in your working folder and stores important information used by the VSS integration in Visual Basic.

Create SCC File dictates when VSS creates this file. Its default setting (*.VBP, *.MAK) means that whenever you get or add a file with an extension of .VBP (Visual Basic 4.0 project file) or .MAK (used by older versions of Visual Basic), VSS creates the MSSCCPRJ.SCC file. This file is very important because without it, VSS integration inside Visual Basic will not function properly.

On the other hand, Visual C++ and other development environments do not use this file at all. You may not want this useless file appearing in your Visual C++ folder. To prevent the appearance of the MSSCCPRJ.SCC file in your Visual C++ folder, remove the *.MAK from this field. (You should make this change only if you do not use Visual Basic 3.0 .MAK files!)

File Groups

Together with the "File types included in file group" option, this option groups file types into logical groups. These groups are displayed in the List Files of Type options in many VSS dialog boxes, so you can specify groups that filter the file list efficiently for your work.

Use the Add button to add a new group of file extensions to the list, and the Delete button to delete the currently selected group. The following example would create file groups including .FRM files, .BAS files, but explicitly not the HELP.FRM file:

*.frm; *.bas; !HELP.FRM

The <Relevant Masks> file group is a special case. This group cannot be deleted, and indicates which files you would typically place into a project. This does not prevent you from placing other files into the project; however, it does have several potentially useful effects.

  1. If you add an entire folder into VSS in one command (by typing ss add * on the VSS command line, or dragging a folder from File Manager into VSS), only files matching the relevant masks are added. Other files can then be added individually.

  2. When you perform the VSS Show Differences command on a project level to compare the current project to your working folder, files that do not match the relevant masks are not displayed as differences.

  3. The relevant masks are used as the default option under Add Files of Type in the Add Files dialog box; therefore, by default, only these files are displayed.

File Types Included In File Group

Shows the list of file types (extensions) included in the currently selected file group under File Groups. To modify a specific group, select the group under File Groups, and then add or delete extensions.

Add

Adds a new group of file extensions to the File Groups list.

Delete

Deletes the currently selected File Group.


Find Dialog Box

Allows you to enter a string to search for in the current file.

To display the Find dialog box:

  • In the SourceSafe file viewer, press ALT+S or click on the Find toolbar button. (You use the SourceSafe file viewer when you view a file for which you have not established another file association.)

Dialog Box Options

Find What

Enter the string you want to find.

Match Whole Word Only

Check this box to match the specified string only if the string is a whole word, not just part of a word.

Match Case

Check this box to make the search case-sensitive.

Regular Expression

If this box is not checked, the * and ? characters are interpreted literally. Therefore, A*B matches only one string, A*B.

If this box is checked, the * and ? characters are interpreted as wildcards. Therefore, A?B matches ABB or AQB, and A*B matches ADSFFDFDSB, within a line.

Set Bookmarks on All

Sets bookmarks on all matches in the file.

Direction

Specifies whether the search continues up or down in the file.

Find Next

Confirms the search selection.

Cancel

Cancels the search.


Find File Dialog Box

Allows you to browse the VSS database for a file to use in a comparison with another file (using the Show Differences command). Tab or use the mouse to choose between the project and file panes of this dialog, and then select the file you wish to compare another to.


Find In Files Results Dialog Box

This dialog box shows the results of the Find in Files command.

Dialog Box Options

File

Shows the name of the file(s) containing matching strings.

Matches

Shows the number of matches found in the file.

Matches

Lists the matches found, in context.

Close

Closes the Find in Files results dialog box.

Report

Allows you to print a report of the match information to the Clipboard, a printer, or to a file.

Links

Shows any links the file has to other projects.


General File Properties Tab

Displays general properties for the selected file.

To display the General File Properties tab:

  1. Select a file in the file pane of VSS Explorer.

  2. On the File menu, click Properties, and then click General.

Note To display this tab from within Visual Basic, after adding a Visual Basic project to VSS, on the Visual Basic Add-Ins menu, click SourceSafe, and then click SourceSafe Properties.

Access Rights

You must have the Read access right to use this tab.

Remarks

If you have a file selected, the General File Properties tab shows you the filename, file type (text or binary), size, whether all versions or just the latest version are stored in the VSS database, the version number and version date, and any comment applied to the file. It also shows the latest label applied to the file, if there is one. You can change the comment, file type, and whether just the latest version is stored from this dialog. If you change a file from storing just the latest version to storing all versions, the change is effective from the time you make it, and is not retroactive.


General Options Tab

See Also

Sets and changes general configuration options.

To display the General tab from VSS:

  • On the Tools menu, click Options, and then click the General tab.

Access Rights

Any VSS user can use this tab.

Tab Options

Always Keep Files Checked Out

Keeps a file checked out to your working folder, even if you check it in. With this option, a file is copied to the VSS database, but left checked out to you, so that you can update the database with your changes, but continue working on the file.

Act On Projects Recursively

Performs all actions on a selected project recursively, that is, the command is applied to the subprojects (and their subprojects, and so forth) as well as to the selected project. This is useful if you have a project with many subprojects that you want to check out and check in as a unit.

Reuse Last Comment

Uses the last comment for the next command. For example, if you check in a file with the comment "Added hyperlink jumps to our Help menu," and then check another file in, the comment " Added hyperlink jumps to our Help menu " is automatically entered in the comment box. If you modify the comment, VSS uses the changed comment for the next command.

Check In Unchanged Files

When you check in a file, and you have made no changes to that file, VSS looks at this option to determine what to do. Click Check In to have VSS automatically update the VSS database even if VSS detects no changes to the file being checked in. This also increments the file's version number. Click Undo Check Out to have VSS automatically undo the check out of any unchanged file you try to check in. Click Ask to have VSS display a dialog box asking what you want to do for each unchanged file you try to check in. Click Default to have VSS depend on the specific initialization file settings for each project to determine what to do with unchanged files.

Use visual merge

Click Yes to always use VSS's Visual Merge feature when merging files after a branch or multiple check out. Click No to use VSS's manual merging feature (used in previous versions of VSS). Click "Only if there are conflicts" to use VSS's Visual Merge feature when there are conflicting changes in the two files to be merged, and use VSS's automatic merge otherwise.

Double-click on a file

This option controls what command VSS executes when you double-click on a file in the VSS Explorer. Click Ask (the default) to always ask whether to view a file or edit the file on a double-click selection from the VSS Explorer. Click View File to always view the VSS database version of this file (without being able to edit it), or click Edit File to always edit the file (open the file, with checked-out status, in your working folder). Holding the Shift key down while double-clicking a file will override this setting to Ask.

Editor For Viewing Files

Sets the editor used to display files when you select the View command. Click Browse to display the Open dialog box and select an editor.

Folder For Temporary Files

Sets a folder in which to store temporary files used by VSS. The default is the TEMP subfolder under the folder in which SRCSAFE.INI is stored. Click Browse to display the Select Temporary Folder dialog box.


General Project Properties Tab

Shows properties for the selected project.

To display the General Project Properties tab:

  1. Select a project in the project pane of VSS Explorer.

  2. On the File menu, click Properties, and then click General.

Note To display this tab from within Visual Basic, after adding a Visual Basic project to VSS, on the Visual Basic Add-Ins menu, click SourceSafe, and then click SourceSafe Properties.

Access Rights

You must have the Read access right to use this tab.

Remarks

If you have a project selected, the General Project Properties tab shows you the project name, any folder this project is shadowed to, the number of files and subprojects in the project (including the number of deleted files and subprojects, if any), the version number and date of that version, and the comment for the project. It also shows the latest label applied to the project, if there is one. From this tab, you can change the project comment.

This tab also contains the checkbox titled "This project is cloaked for me". If this box is checked for this project, a Get, Check Out, Check In, Undo Check Out, or Project Show Difference commands that include this project recursively will not be applied to this project. This feature is meant for people who prefer to have an entire project's structure on their local computer, but do not want to take up space with files they don't work on. Cloaking is described more fully in the topic Cloaking VSS Projects.


Get From <Project Name> Dialog Box

Gets the selected files from your source code control provider and places a read-only file in the development environment project.

To use the Get command:

  • On the Visual Basic Tools menu, click Get.

Dialog Box Options

Files to Get/Check In

Selects the file or files you want to get or check in.

Advanced

Displays the Advanced Options dialog box.

OK

Confirms your selections.

Cancel

Cancels your selections.

Select All

Selects all files listed.


GoTo Dialog Box

Jumps to a specified position in a file.

To display the GoTo dialog box:

  1. Select a file in the file pane of VSS Explorer.

  2. On the Tools menu, click Show Differences, and in the File Difference dialog box click OK.

    Note Enable the display of the File Difference dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

  3. In the Difference for File dialog box, click Report.

  4. In the File Difference Report dialog box, click Preview.

  5. Press ALT+G.

Dialog Box Options

Go to what

Select the type of item you want to go to. Different options are available depending on the operation you are performing, for example, you can go to a bookmark, conflict, difference, line or offset (the number of bytes from the beginning of the file). You may want to use File Offset if you are receiving an error during loading after a certain byte, or if you have a file with a fixed byte length and need to find a specific byte in the file.

Enter position number

Type the position to which you want to go. (Position is relative to the type specified under Go to What.)

Go To

Goes to the specified location.

Previous

Goes to the previous item of type specified in the Go to What field.

Close

Cancels the GoTo command.


History Details Dialog Box

See Also

Displays details of the history of a file or project.

To display the History Details dialog box for a file:

  1. Select a file in the file pane of VSS Explorer.

  2. On the Tools menu, click Show History

    Make selections in the File History Options dialog box if it is enabled, and click OK.

    Note Enable the display of the File History Options dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

  3. In the History of File dialog box, click Details.

To display the History Details dialog box for a project:

  1. Select a project in the project pane of VSS Explorer.

  2. On the Tools menu, click Show History.

    Make selections in the Project History Options dialog box if it is enabled, and click OK.

    Note Enable the display of the Project History Options dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

  3. In the History of Project dialog box, click Details.

Access Rights

Any VSS user can use this dialog box.

Dialog Box Options

File

Name of the selected file.

Version

Version number of the selected file.

Date

Date and time the selected file was created or last checked out.

User

User who created the version.

Label

Shows the label, if any, for the file or project. You can also change the label.

Comment

Adds a new comment or changes an existing comment for a specific version of a file or project. Every version of every file or project in VSS is associated with a user-defined comment. The new comment replaces the old comment, which cannot be recovered.

Label Comment

Shows the comment entered at the time a label was applied.

Next

Shows information on the next item in the History list.

Previous

Shows information on the previous item in the History list.

Close

Closes the History Details dialog box.


History of File Dialog Box

See Also

Shows historical information for the selected file.

To display the History of File dialog box:

  1. Select a file in the file pane of VSS Explorer.

  2. On the Tools menu, click Show History.

    Makes selections in the File History Options dialog box if it is enabled, and click OK.

Note Enable the display of the File History Options dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu). The dialog box gives you the option to restrict the history to labels only, to a specified user, or to a range of dates.

Access Rights

You must have the Read access right to use this dialog box.

Remarks

The History of File dialog box displays the history of a selected file, including all significant events, such as the creation date, check in dates, and current version number. Events are listed with the most current event at the top of the display. In VSS, all access to old versions of files is through this dialog box.

Several commands are available from this dialog box. You can perform a command on a version by first selecting an event (or multiple events) and then clicking a command button.

Dialog Box Options

Close

Closes the dialog box and returns to VSS Explorer.

View

Opens an editor, in which you can view the selected file as it is stored in the VSS database. The editor can be set on the General tab in the SourceSafe Options dialog box.

Details

Displays comments associated with an event, along with more detailed event information, such as label information, version information, check-out comments, and so forth.

Get

Performs the Get Latest Version command on the selected version.

Diff

Performs the Show Differences command on the selected file. You can compare the selected version of a file with the current version, to any other version, or with a file in your working folder. To compare two different versions of a file, hold down the Ctrl key while selecting the two versions of interest. Then click the Diff button.

Pin/Unpin

Performs the Pin or Unpin command on the selected file. (This button toggles between Pin and Unpin depending on the pinned state of the selected file.)

Rollback

Performs the Rollback command on the selected file or subproject. The Rollback command discards all versions of a file after the selected version, and returns the current version of the file to the selected version.

Report

Sends the file history information to the Clipboard, a file, or a printer.


History of Project Dialog Box

See Also

Shows historical information for the selected project.

To display the History of Project dialog box:

  1. Select a project in the project pane of VSS Explorer.

  2. On the Tools menu, click Show History.

    Make selections in the Project History Options dialog box if it is enabled, and click OK.

    Note Enable the display of the Project History Options dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu). The dialog box gives you the option to restrict the history to labels only, to include files in the project history list, to make the history list recursive down the project hierarchy, or to restrict the history list to a specified user, or to a range of dates.

  3. Click OK.

Access Rights

You must have the Read access right to use this dialog box.

Remarks

The History of Project dialog box displays the history of a selected project, including all significant events, such as the deletion of files or subprojects, addition of files or subprojects, labeling and renaming of items, and check ins. For each significant event, the dialog box shows the affected file or subproject, the user who performed the action, the date and time of the event, and the description of the event. Events are listed with the most current event at the top of the display.

Several commands are available from this dialog box. You can perform a command on a file or subproject by first selecting an event and then clicking a command button.

Dialog Box Options

Close

Closes the dialog box and returns to VSS Explorer.

View

Displays a dialog box containing a list of all files (with their version numbers) as the project existed at the selected point in the project's history.

Details

Shows the comments associated with an event, along with more detailed event information, such as label information, version information, and so forth.

Get

Performs the Get command on the selected file or subproject version. If you select a file, VSS displays a dialog box asking you to clarify whether you want to get just the selected file, or to get (that is, re-create) the entire project as it existed at the point in time the selected file version existed.

Check Out

Performs the Checkout command on the selected file or subproject version. If you select a file, VSS displays a dialog box asking you to clarify whether you want to checkout just the selected file, or to checkout (that is, re-create) the entire project as it existed at the point in time the selected file version existed. You may get an error message if the file has been destroyed since the point in history from which you attempt to checkout.

Share

Performs the Share command on the selected file or project. With this command, you can share the current or an old version of the project files with another project. This lets you create a branch from an old version of your project. You may want to do this if you need to fix some bugs for a customer while continuing development on the next version of your product.

Report

Sends the project history information to the Clipboard, a file, or a printer.


History Report Dialog Box

See Also

Sends a report of historical information on a file or project to a printer, a file, or the Clipboard.

To display the History Report dialog box:

  1. Select a file or project in VSS Explorer, and on the Tools menu, click Show History.

  2. Make selections in the File History Options or Project History Options dialog box (if enabled), and click OK.

    Note Enable the display of the File History Options dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

  3. In the History of File or History of Project dialog box, click Report.

Dialog Box Options

Include Details

Includes all historical details of the selected file(s) in the report. Details include creation date, user who modified the file for each check in, comments applied to the file, and time/date information for each event.

Include Differences

This option is useful when you are comparing two different versions of a file or project. The report includes differences between the selected files or projects in the report.

Report To

Sends the history report to a printer, a file, or the Clipboard.

OK

Prepares the specified report.

Cancel

Cancels the report.

Preview

Shows a preview of the specified report, so that you can determine if it is what you wanted before committing it to the printer queue or a file.


Hyperlinks Errors Dialog Box

See Also

Allows you to see the HTML links identified as errors, and optionally mark them as OK.

Dialog Box Options

File

Lists the files in which VSS identified HTML link errors. Also shows the number of errors found in each file.

Internal links which appear invalid

Lists the errors found in the file selected in the File list box.

External Links (not checked)

Lists the HTML recognized as an external link. External links are not checked.

Close

Closes this dialog box.


Integration Options Dialog Tab

Displays information about the integration between your Visual Basic project and the corresponding VSS project.

To display the Integration Options tab:

  • On the Add-Ins menu, click SourceSafe, then Options, and then click the Advanced button. From this dialog box, select the Integration tab.

Access Rights

You must have Read access right to use this dialog box.

Remarks

The Integration Options tab is most useful for seeing how your VSS and Visual Basic projects are connected. However, you can also set a couple options on this tab: whether to display intermediate dialog boxes for the History and Show Differences command, and whether to prompt for the VSS database to use when opening a new project.

Tab Options

SourceSafe project

Shows the full name of the VSS project associated with this Visual Basic project.

Database name

Displays the name (if any) of the VSS database the project is stored in.

Database path

Displays the path to the VSS database the project is stored in.

Data specifier

Displays the data directory for a specific project. (Your VSS Administrator can set up different data directories for different projects using the Data_Path variable.)

Display dialog box for

Check the box corresponding to the command if you want an options dialog box displayed when you select that command.

Choose SourceSafe database

Set to Use Default Database to always look in the default VSS database for your project information. Set to Prompt to display a prompt dialog box, allowing you to specify the database name, path, and data specifier each time you open a project.

OK

Sets the options as specified on the tab.

Cancel

Closes the Integration Options tab.


Links Properties Tab

See Also

Shows all the projects sharing a specified file.

To display the Links tab:

  1. Select a file in the file pane of VSS Explorer.

  2. On the File menu, click Properties, and then click the Links tab.

    Note To display this tab from within Visual Basic, after adding a Visual Basic project to VSS, on the Visual Basic Add-Ins menu, click SourceSafe, and then click SourceSafe Properties.

Access Rights

You must have the Read access right to use this tab.

Remarks

Use the Share command to create a share link between files. A file that is shared by multiple projects is the same in all projects that share it.

Tab Options

Projects Sharing <file>

The list of projects sharing the selected file. When you check in a file, all the projects shown in this list automatically receive the checked-in version of the file. If a file is deleted from a project, or if a project is pinned to a specific version of the file (instead of the latest version), that is also indicated in the list window. Deleted items are noted with a text string, and pinned items are noted with the version number following the filename, for example, $/CODE/HEADER.H; 4.

Close

Closes the Properties dialog box and returns to VSS Explorer.

Report

Displays the Links Report dialog box, in which you can preview a report, and send it to the Clipboard, a text file, or a printer.


Local Files Options Tab

See Also

Sets or changes working folder options.

To display the Local Files tab:

  • On the Tools menu, click Options, and then click the Local Files tab.

Access Rights

Any VSS user can use this tab.

Tab Options

Remove Local Copy After Add or Check In

Automatically deletes the working folder copy of files you add or check in. This helps keep your disk usage to a minimum, and ensures that you always get the most recent version when you start work on a file.

Remove Local Copy After Delete

Automatically deletes the working folder copy of a file you delete with the Delete command. This helps keep disk clutter to a minimum. And, as long as you haven't destroyed or purged the file in the VSS database, you can always recover the file later.

Use Read-Only Flag for Files That Are Not Checked Out

Sets the read-only flag on files in your working folder. VSS assumes that files in your working folder that you don't have checked out are read-only. VSS sets the read-only flag when you perform a Get Latest Version, Add, Check In, or Undo Check Out command on a file, and uses it as a signal that you have not been modifying the file (so VSS can replace it).

Copy Keyword-Expanded Files Into Working Folder

Copies modified files directly back into your working folder. When you check in a file and have keyword expansion enabled, VSS may replace certain keywords in your file with version information. The modified file is replaced directly into VSS. If you do not set this option, the file is not automatically copied back; this improves performance, but the copy in your working folder may not be completely up-to-date.

Append End-Of-Line To All Text Files

Appends an end-of-line character whenever VSS retrieves a text file that does not already end with one. Some compilers require that all the files they compile end in an end-of-line character. If you are working in such an environment, you may want to set this option.

Compare Files By

Sets how VSS determines if your local copy is up-to-date. The following options are in order of increasing speed:

  • Contents [image] Compares the full contents of your local file to VSS's copy. This is the slowest method, but is most likely to work.

  • Checksum [image] Compares by a checksum stored by VSS.

  • Time [image] Compares the date/time flags. The exact method of date comparison depends on the setting of the Set Date/Time On Local Files option: If set to Check In, VSS replaces the local copy if the time of the last check in (or add) is more recent than the local copy's modification date. If set to Current (the default) or Modification, VSS replaces the local file if the VSS file's modification time is different from the local file's modification time.

Replace Writable Files

When you get or check out a file, VSS copies the file into your working folder. If there is already a writable copy of the file in your working folder, replacing the file may erase your work.

  • Ask [image] Gives you an option each time.

  • Replace [image] Replaces (overwrites) the file.

  • Skip [image] Does not replace the file, and generates an error in the Results pane if you have it displayed.

  • Merge [image] Merges the changes between the checked out-file and the one you are now getting or checking out. If the file cannot be merged (i.e. it is a binary file), an error is displayed in the Results pane if you have it displayed. Your VSS Administrator must enable multiple check outs on the files involved for this to work properly.

Set Date/Time on Local Files

This option controls the date/time that VSS gives files in your working folder. The option you choose here is the time that you will see when you view files in the Windows Explorer

  • Current [image] Sets the date and time of the file to the current date and time by default, whenever VSS gets a file. This signals the compiler that the file has just changed, and needs to be recompiled.

  • Modification [image] Sets the local copy to the date and time the file was last modified.

  • Check In [image] Sets the local copy to the date and time the file was last checked in.


Login Dialog Box

Logs you on to VSS. The Login dialog box is displayed when you start VSS.

To log on to VSS:

  1. In the User Name box, type your username.

  2. Type your VSS password (if you have one).

  3. Select the VSS database you want to log in to, and press ENTER to log on to VSS. (You can Browse for a different database.)

Access Rights

Any VSS user can use this dialog box.

Remarks

If you are unsure of your VSS username or password, see your VSS administrator.


Microsoft VSS Trial Version

Your free VSS Trial Version expired 30+ days ago.

Some VSS functionality has now been disabled.

To comply with your license agreement and restore full VSS functionality, you must order a license.

To order Microsoft VSS or to receive a reseller referral, in the United States or Canada, call (800) 621-7930. Outside the United States or Canada, please contact your local Microsoft subsidiary.

Otherwise, you must completely de-install VSS.


Paths Properties Tab

See Also

Shows all branches of the specified file.

To display the Paths tab:

  1. Select a file in the file pane of VSS Explorer.

  2. On the File menu, click Properties, and then click the Paths tab.

    Note To display this tab from within Visual Basic, after adding a Visual Basic project to VSS, on the Visual Basic Add-Ins menu, click SourceSafe, and then click SourceSafe Properties.

Access Rights

You must have the Read access right to use this tab.

Remarks

When you use the Branch command to branch a file, the share link is broken and an independent file branch is created. Once a file is branched, modifications made to that file in one project are not reflected in the other projects. Nonetheless, it is sometimes valuable to track these relationships.

For example, suppose you find a bug in a file, and fix it. All the projects sharing that file are immediately updated with the new version. However, projects that used to share that file, and then branched from it, are not updated; use the Paths tab to find those projects and then manually update them.

When you view paths, you view the entire branch history of the file, including all the times the Branch command was used to move it to different projects on different development paths. Changes made to the file, however, are not shown [image] use the Show History command to view these.

Using the Paths command might result in a display like the following.

Projects with independent branches
$/A         1->5
--$/B         6->7
--$/D         4->4

This display means that there are 3 branches of this file (because there are 3 lines); the first branch has moved from version 1 of the file to version 5, the second branch has the first as its parent (meaning that versions 1 through 5 of the file are the same in this branch), began its life at version 6 and was checked in once since then, moving it to version 7 currently. The third branch began its life at version 4 and has not changed since then.

You can select each branch and click the Links button to see where that particular file is shared. So, how do you use this information? Assume a bug was introduced in this file at version 5 of the first branch. You know, from looking at this display, that the third branch is unaffected by this bug (because it is still at version 4), but that the second branch needs to have the fix manually inserted, because that branch came from the first (its parent), but began at version 6. Of course, once you have fixed the file in each of these branches, any other projects that share the file will automatically include the fix.

Tab Options

Projects with independent branches

Lists the projects the selected file has been shared in.

Versions

Lists the file version number that was branched in the corresponding project.

Links

Displays the Links tab of the Files Properties dialog box.

Close

Closes the Properties dialog box and returns to VSS Explorer.

Report

Sends a report to the Clipboard, a text file, or a printer.


Preview Dialog Box

Shows a preview of the specified report, so that you can determine if it is what you wanted before committing it to the printer queue or a file. You can use the viewer accelerator keys in this dialog box to navigate in the file.

Dialog Box Options

Close

Closes the report preview.


Print Dialog Box

See Also

Sets printing options.

To display the Print dialog box:

  1. Select a file or project in VSS Explorer, and on the Tools menu, click Show History.

  2. Make selections in the File History Options or Project History Options dialog box if it is enabled, and click OK.

    Note Enable the display of the History Options dialog boxes on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

  3. In the History of File or History of Project dialog box, click Report.

  4. Under Report To, click Printer, and then click OK.

Dialog Box Options

Printer

Printer selected in the Print Setup dialog box. To display the Print Setup dialog box, click Setup.

Copies

Type the number of report copies to print.

Print To File

Sends the report to a PostScript file, and prints the report.

Setup

Displays the Windows Print Setup dialog box.


Purge Command

See Also

Permanently removes previously deleted files and projects from the VSS database.

To use the Purge command:

  1. Select a project in the project pane of VSS Explorer.

  2. On the File menu, click Properties, and then click the Deleted Items tab.

  3. Click Purge. You receive a warning message, because you can't undo a Purge command.

Access Rights

You must have the Destroy access right to use this command.

Remarks

When you use the Delete command to delete files or projects from VSS, the deleted items are removed from VSS Explorer. However, VSS continues to store the items so that you can recover them [image] and, for example, rebuild earlier versions of the project that required them.

To permanently delete these files from the VSS database [image] and free up the disk space they are using [image] use the Purge command.

When you purge a previously deleted file from a project, the file is permanently removed from the project, and cannot be recovered. Consequently, if you use the Get Latest Version command to get any version of the project that contained that file, the file can't be found. For this reason, the Purge command should be used with extreme caution: You must be confident that you will never want this file or project, or any of its earlier versions, for any reason.

Note The purpose of purging is to get rid of obsolete files and thereby free up disk space. However, the Purge command may not always have that effect. If a file is being shared by more than one project, and you purge it in one project, no disk space is freed up, because the file is still being used. Only if you purge the file in all the projects that are using it is the file permanently deleted from your VSS database.


Reconcile All Options Dialog Box

See Also

You can find the Reconcile All button in the Show Differences dialog box along the toolbar. The Reconcile All button displays a dialog box with the following options. These options specify what you want VSS to do when it encounters specific situations while reconciling differences between projects.

Reconcile files that appear in only one list…

Files that are not in your working folder. This specifies what you want to happen when VSS finds files that are not in your working folder, but are in the project. Click Get Latest Version (the default) to get files missing from your working folder. Click Ignore to take no action with these files.

Files that are deleted in the project. This specifies what you want to happen when VSS finds files that are in your working folder, but have been deleted in the project. Click Delete from folder (the default) to delete these files from your working folder. Click Recover deleted file to recover the deleted file and place a copy in your working folder. Click Add to project to add these files back to your project. Click Ignore to take no action with these files.

Files that are not in the project at all. This specifies what you want to happen when VSS finds files that are not in your project, but are in your working folder. Click Add to Project (the default) to add these files to your VSS project. Click Ignore to take no action with these files.

Reconcile files that appear in both lists…

Files that you have checked out. This specifies what you want to happen when VSS finds files that are checked out to you, and are different in your working folder. Click Check In (the default) to check these files into your VSS project. Click Undo Check Out to undo the check out on these files. Click Get Latest Version to overwrite your checked out file with a read-only copy (losing any changes you may have made). Click Ignore to take no action with these files.

Files that you do not have checked out. This specifies what you want to happen when VSS finds files that are not checked out to you, but are different in your working folder. Click Get Latest Version (the default) to get the latest version of these files. Click Ignore to take no action with these files.

OK

Performs the Reconcile All command with the options chosen.

Cancel

Cancels the reconciliation.


Recover Command

See Also

Replaces a file or project that had been deleted.

To use the Recover command:

  1. Select a project in the project pane of VSS Explorer.

  2. On the File menu, click Properties, and then click the Deleted Items tab.

  3. Click Recover.

Access Rights

You must have the Add access right to use this command.

Remarks

When you use the Delete command to delete a file or project from VSS, the deleted items are removed from VSS Explorer. However, VSS continues to store them, so that it can rebuild old versions of the project that required them.

The Recover command reverses the Delete command and restores the file. After the file has been recovered, it is once again part of its parent project.

If the file being recovered is shared by other projects, it may have been modified while in those projects. Therefore, the file you recover may not be exactly the file you deleted.

When you delete a project, all the subprojects and files under it become unavailable. However, when you recover the project, its subprojects are also recovered.


Report Dialog Box

Creates a formatted report of selected information that you can send to the Clipboard, a file, or a printer.

Dialog Box Options

Report To

  • Printer [image] Sends report to printer.

  • File [image] Sends report to File dialog box.

  • Clipboard [image] Places report on Clipboard.

OK

Confirms the report selection.

Cancel

Cancels the report.

Preview

Shows a preview of the specified report, so that you can determine if it is what you wanted before committing it to the printer queue or a file.


Rollback Command

See Also

Eliminates all changes since an earlier version of a file.

To use the Rollback command:

  1. Select a file in the file pane of VSS Explorer.

  2. On the Tools menu, click Show History.

  3. Make selections in the File History Options dialog box, if it is enabled.

    Note Enable the display of the File History Options dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

  4. Select a previous version of the file, and then click Rollback. When you rollback a file, you will lose all changes made to that file after the version you roll back to. For example, if you click on version 5 and then click Rollback, all changes since version 5 are lost.

Access Rights

You must have the Destroy access right to use this command.

Remarks

Rollback returns a file to a previous version, erasing all the versions and changes since then; all changes made after the version rolled back to are lost. The Rollback command cannot be reversed.

If the file you roll back is being shared by more than one project, the rollback affects only the project you specify (the current project, by default). To accomplish this, Rollback performs an implicit branch, that is, it branches the file in the specified project away from the same file in all other projects, and creates a new development path. To bring the disparate development paths back together, if you make changes to the specified project, you have to merge the files.

There are workarounds for undoing a rollback. For a shared file, you can delete the resulting file and re-share it from another project. For an unshared file, if you do not want to lose all the intervening steps, one method is to check out the file, get an earlier version, then check in the file. The earlier version you get then becomes the most recent version, but no information is lost.


Save Report to File Dialog Box

See Also

Designates a file in which to save a report.

To display the Report to File dialog box:

  1. On Tools menu, click Files Report.

  2. Under Report To, click File, then click OK.

Dialog Box Options

File Name

Name and path of the file to write the report to.

Folders

Specifies a path to the file.

Drives

Lets you select from the available drives.

List Files of Type

Filters the file list to display only files of the specified type.

Append

Appends the report to the end of an existing file.

OK

Confirms selection.

Cancel

Cancels the selections, closes the dialog box, and returns to VSS Explorer.

Network

Displays the Windows Connect Network Drive dialog box.


Select Dialog Box

Many of VSS's most common commands [image] such as Get Latest Version, Check Out, and Check In [image] can work on more than one file at once. For them to do so, however, you must select multiple items before choosing the menu command you want to execute.

To select multiple items with the Select dialog box:

  1. Click in the file pane of VSS Explorer, and then on the Edit menu, click Select.

    VSS displays the Select dialog box.

  2. In the Item box, type a filename using wildcard characters. For example, type *.* to select all items.

    Click Select or press ALT+S.

  3. To add additional items to the selection list, separate items with a semicolon in the list.

  4. Click Close to confirm the selection and close the dialog box.

To select items with the mouse:

  • Select an item in VSS Explorer.

    Or

    Hold down the CTRL key as you choose each item you want; to select a block of items, click the first item, hold down the SHIFT key, and click the last item.

To select items with the keyboard:

  • Press SHIFT+SPACEBAR to select each item you want. Use the arrow keys to move to each.

To deselect items with the Invert Selection command:

  • On the Edit menu, click Invert Selection to change selected items to deselected items, and vice versa.


Share Dialog Box

See Also

Allows you to specify a project to share with the current project.

To display the Share dialog box:

  1. In the project pane of VSS Explorer, select a project into which you want to share another project.

  2. On the SourceSafe menu, click Share.

  3. In the Share with Project dialog box, select a project to share and click Share.

Dialog Box Options

New Name

Enter the name of the project you are sharing with the current project.

Recursive

Check to make the Share operation recursive (include all subprojects and their files).

Comment

Enter a comment for this operation.

OK

Returns to the Share with Project dialog box, which shows the selected project to share with the selected files.

Cancel

Cancels the Share command.


Share From Project Dialog Box

See Also

Shares a project with the current project, and pins it to a past version.

To display the Share From Project dialog box:

  1. In the project pane of VSS Explorer, select a project into which you want to share another project.

  2. On the Tools menu, click Show History. Make selections in the Project History Options dialog box if it is enabled, and click OK.

    Note Enable the display of the Project History Options dialog box on the Command Dialogs tab in the SourceSafe Options dialog box (Tools menu).

  3. In the History of Project dialog box, click Share.

When you use this dialog box, what you are going to do is create a brand new project, which is identical to an old version of this project. For instance, suppose you could create a project that is exactly identical to $/A/B as it existed last Monday at midnight. Your new project is named, let's say, $/A/C. C is identical to B--has all the same subprojects and files--but the files in C represent old versions of the files in B. There are two ways that this can happen. The files can be pinned to the old versions (but still shared with their counterparts in B), or they can be rolled back to those versions (no longer shared with B); you choose between these two methods based on whether you click the Branch after share checkbox.

To do this as described in the example above, you would choose B (the place you want to share from; note that this is the reverse of the normal share direction), go into the History dialog box, and click the Share button. Then, specify the location and name of the new project, whether you want to branch, whether you want to do it recursively, and so on.

Dialog Box Options

Projects

Shows the project list so that you can browse for the project to share with the current project.

Branch After Share

Branches immediately after sharing, rolling back the project you just created to the specified version. With this option, you can easily create a separate version of the project as it was in a former version.

OK

Shares the selected project into the current project and pins it to the selected version. If the selected project is the current version, the shared project is pinned at that version.

Cancel

Cancels the Share From Project command.


Source Code Control Options Dialog Box

Customizes your source code control provider environment.

To use the Options command:

  • After you've added a development environment project to your source code control provider, on the Add-Ins menu, click the name of your source code control provider, then click Options.

Remarks

The Options command displays the Source Code Control Options dialog box.

Dialog Box Options

  • Get checked in version of project files when opening a project?

  • Check in files when closing the project?

  • Add files to source code control when adding them to Visual Basic?

  • Remove files from source code control when deleting them from Visual Basic?

For each option, you can specify Yes, No, or Ask. Ask is the default.

Advanced

Displays advanced options.

OK

Confirms selections.

Cancel

Cancels selections.


Source Code Control Results Dialog Box

Places command results in a window.

To display the command result dialog box:

  1. Set the Results_Window variable to yes in the SRCSAFE.INI file.

  2. Perform a get or check out of a file.

When you carry out a command that generates a status or error message, VSS displays the results of the command in the Results window. This window remains displayed until you press the ENTER key, click Cancel (or Close), or click the VSS Explorer window.

If you'd like, you may instruct VSS not to display the Results window. Clear the Show Results Window box in the View tab of the SourceSafe Options dialog box (Tools menu). This automatically sets the Results_Windows initialization variable to No in your SS.INI file. Error messages, however, are still displayed.


SourceSafe Command Status Dialog Box

This dialog is displayed briefly when you are performing a get or a checkout of a file.

Dialog Box Options

Cancel

This button will cancel the file get operation.


Undo Check Out for <Project or File Name>

See Also

Cancels a Check Out operation, undoing all changes. You must have a working folder set for this command to work properly.

Access Rights

You must have the Check Out access rights to use this command.

Remarks

The Undo Check Out command undoes all your changes. The file is no longer checked out by you, but rather VSS retains the version it previously had and it copies over the file in your working folder.

You can use the Undo Check Out command only on files that you currently have checked out, not on files checked out by other users.

Note Your VSS administrator can undo the check out of another user.

Dialog Box Options

Note Enable the display of this dialog box on the Command Dialogs tab, via the Tools menu, Options command.

Local Copy

  • Replace [image] Replaces the file in your working folder. VSS performs the Get Latest Version command on the file. This keeps your working folder synchronized with the contents of the project, because all your changes are ignored.

  • Delete [image] Deletes the file in your working folder.

  • Leave [image] Leaves the file alone.

  • Default [image] Uses defaults set on the Local Files tab or inherited from a parent project. This option cannot be set; it is used automatically when you explicitly (in the file list) or implicitly (by checking Recursive) select multiple files.

Only show this dialog when the Shift key is down

Skips this dialog box during future Undo Check Out operations, and uses the settings you've entered as the default. To force this dialog to appear without holding down the shift key, keep this option checked. Or to restore the dialog box on a more permanent basis, click the appropriate check box on the Command Dialogs tab of the SourceSafe Options dialog box.

Recursive (project-level Undo Check Out only)

Undoes the check out on all files in the selected project, and all files in all subprojects of the selected project.

Override Working Folders (project-level Undo Check Out only)

Overrides the working folder set for the subprojects involved in a recursive operation. This is useful if you have files checked out in more than one project, and want to undo the check out of all of them at the same time. Available only when you click the Recursive check box.


Undo Check Out from <Project Name> Dialog Box

Overwrites your changes to a file, and copies the latest checked in version to your development environment working directory.

To use the Undo Check Out command:

  • On the Visual Basic Tools menu, click Undo Check Out.

Dialog Box Options

Files to Un-Check Out

Lists the currently checked out files. Click the files whose check out you want to undo, or click Select All to select all the listed files.

Advanced

Displays the Undo Checkout Advanced Options.

OK

Confirms the selection.

Cancel

Cancels the selection.

Select All

Selects all files listed.


View/Edit Dialog Box

This dialog box allows you to specify whether you want to view the VSS database version of the file you double-clicked, or would prefer to edit this checked-out file in your working folder.

You will see this dialog box only if you have specified that it should be presented when a file is double-clicked in the VSS Explorer. You can change this specification from the Tools Options General tab. Or, if you hold the SHIFT key down while double-clicking a file in the Explorer, this dialog will always be presented regardless of the setting on the Tools Options General tab.

In this dialog, select your choice (or click Cancel to cancel the operation) and click OK.


View Options Tab

Sets VSS Explorer view options.

To display the View tab:

  • On the Tools menu, click Options, and then click View.

Access Rights

Any VSS user can use this tab.

Tab Options

Show Results Pane

Shows or hides the Results pane in VSS Explorer. The Results pane, at the bottom of the VSS Explorer, shows you the results of your VSS commands.

Show Toolbar

Shows or hides the toolbar in VSS Explorer. The toolbar contains a set of buttons you can choose to carry out commonly used commands.

Show Status Bar

Shows or hides the status bar in VSS Explorer. The status bar shows you status information about VSS, such as the current file pane sort order, the current username, and the number of items in the file list.

Always Use MS-DOS Format Filenames

Truncates the long filenames supported on 32-bit platforms. This option keeps the filename column of the display narrow, and is also useful if you have computers with several different operating systems using your VSS database.

Make Selected Project the Current Project

This option is normally selected. However, if your network suffers from poor performance, you may want to be able to scroll the project list without VSS updating the current project as you do so. In this case, turn off this option. If it is turned off, you must press the ENTER key on a project (or double-click with the mouse) to make it the current project.

Automatically Refresh File List

Controls whether VSS automatically refreshes its file list. Refreshing keeps VSS Explorer up-to-date, but it also causes a momentary delay (and a network load). If you select this option, enter the refresh interval in minutes in the box below. If you do not select this option, you can manually refresh the file list using the Refresh File List command on the VSS View menu.


VSS Viewer Dialog Box

Allows you to edit or view a file without a file association.

Dialog Box Options

This dialog box includes a toolbar with the following buttons:

Save

Saves your edited file to disk.

Cut

Cuts the selection out of the file and places it on the Clipboard. The shortcut key is Ctrl+X.

Copy

Copies the selection and places it on the Clipboard. The shortcut key is Ctrl+C.

Paste

Pastes the Clipboard contents at the cursor location. The shortcut key is Ctrl+V.

Undo

Undoes your last editing action. The shortcut key is Ctrl+Z.

Redo

Redoes your last undone editing action. The shortcut key is Ctrl+A.

Find

Lets you search for a string in the file. The shortcut key is Alt+F3.

Find Next

Lets you search for the next matching occurrence of a string in the file. The shortcut key is F3.

Find Previous

Lets you search for a previous matching occurrence of a string in the file. The shortcut key is Shift+F3.

Toggle Bookmark

Lets you turn a bookmark on or off in a file. The shortcut key is Ctrl+F2.

Next Bookmark

Lets you go to the next bookmark in the file. The shortcut key is F2.

Previous Bookmark

Lets you go to the previous bookmark in the file. The shortcut key is Shift+F2.

Clear All Bookmarks

Lets you clear all bookmarks in the file.


Warnings Options Tab

Specifies whether warnings are displayed before actions that might result in accidental loss or deletion of data.

To display the Warnings tab:

  • On the Tools menu, click Options, and then click Warnings.

Access Rights

Any VSS user can use this tab.

Remarks

When you delete a file from the VSS database, VSS asks "Are you sure you want to delete?" Some users find the warning helpful, because it prevents accidental deletion of data. Others find it annoying, because it requires an extra keystroke. This and other VSS warnings are therefore entirely configurable.

You can choose whether you want to receive warnings before VSS executes the following:

  • Undo check out of a modified file

  • Delete a file or project

  • Destroy a file or project

  • Purge a file or project

  • Rollback a file

  • Check out an already checked out file

  • Exit VSS


A deleted copy of this <File> file already exists in this project. Do you want to recover the existing file?

See Also

This warning has the following cause and solution:

  • When a file is deleted in a project, it is no longer displayed but it still exists. So when you attempt to add a file of the same name, VSS prompts you to decide if you want to recover the deleted file or add the one you indicated.

    Click Yes if you want to recover the deleted file in the project, and not add the new file.

    Click No if you want to the deleted file to remain deleted and add the new file.

    Click Cancel if you want to abandon the operation.


A deleted file of the same name already exists in this VSS project. Do you want to recover the deleted file instead of adding your local <File name>?

A file with the same name as the file you are adding to VSS was deleted but not purged from the database. The deleted file is still part of the project, it is just on the projects deleted list. Since two files of the same name cannot exist in the same project, VSS is giving you the option of recovering the deleted file or using the new file you are trying to add. In either event, the other file will be permanently replaced in the project.


A deleted link of file <File> already exists in the destination project

Do you want to recover the linked file?


A link in <File> was ignored because it was too long

This error has the following cause and solution:

  • The URL is too long for the internal buffer.

    Use a shorter URL.


A merge of <File> produced a 0 byte file. Data may have been lost. Would you like to undo the merge? (recommended)

This error has the following cause and solution:

  • A zero length file indicates a possible internal VSS error resulting in loss of data during the merge operation.

    Recommended: undo the merge by clicking Yes. If you are certain, however, that you've performed an action that resulted in a valid zero length file, you can click No to save the zero length merge file.


A more recent version is checked out

Multiple versions of a file can be checked out at any given time. However, when a newer version of the file exists, VSS will warn you that you might be overwriting a more recent version of the file.


A project cannot be shared under a descendant

This error has the following cause and solution:

  • You are attempting to share this project recursively to a subproject under this project. This would create infinite recursion and is therefore not allowed.


A writable copy of <File> already exists

When you get a VSS file, the file is tagged as read-only. You cannot modify the file. When you check out the file for modification, the read-only flag is deleted. When you check it in, the file is flagged read-only again. This error has the following cause and solution:

  • You attempted to use the Get Latest Version command on a file that already exists on your hard disk in read/write form. If the local copy is read/write, you probably have it checked out; VSS does not replace the file, and displays this error message.

    Click Yes or Yes All to replace the file or files with the current version in the VSS database.

    Click No or No All to not replace the file(s).

    Click Cancel to cancel the Get Latest Version command.


Access to file <File> denied

Under certain conditions, VSS denies a user access to a file. This error has the following causes and solutions:

  • You were denied access (read or write privileges) to a file that VSS was attempting to open.

    It is possible that another user has the file momentarily locked; try again.

  • You may not have sufficient network privileges to take the action you are attempting.

    See your VSS Administrator for more information on your VSS access rights. Also see the Administration chapter of the Microsoft Visual SourceSafe User's Guide for a description of the network access rights required for various users in different directories.


Adding the name <Group Name> would overflow the maximum File_Types length of <Maximum Length>. Please decrease the name size or remove other names.

This error has the following cause and solution:

  • The combined length of the filter values on the File Types tab in the SourceSafe Options dialog box on the Tools menu is too long. VSS uses the Types Included in Group field to create a filter for the Share and Add dialog boxes. This error occurs when the combined length of the groups is too long. The total buffer length is 511 characters.

    To remedy and prevent this error, shorten the File Group name or delete other File Group names from the list.


All conflicts have been resolved, would you like to save the file?

This message has the following cause and solution:

  • You have successfully resolved all merge conflicts.

    Click Yes to save the file, or No to discard your changes.


Always share the latest version of <File>?

See Also

Generally, every project sharing a file always has the latest version of the file. When you check in the file in any project, all the projects are automatically updated. However, you can use the Pin button in the History of File dialog box to share an explicit version of a file. This message has the following cause and solution:

  • By clicking the Pin button in the History of File dialog box, you've chosen to share the most recent version of the file.

    If you click No, the project shares the pinned version explicitly, and does not receive checked-in changes from other projects.

    If you click Yes, the project returns to a sharing state in which it is always using the latest version of the file.


An automatic merge has occurred and there are conflicts. Edit <File> to resolve them

See Also

Changes you made to the file since you checked it out conflict with other changes made (and checked in) to the source file by another user. This error has the following cause and solution:

  • You have to resolve the conflicts between your changes to a file and another user's changes before you can check in the file.

    Open the file in your working folder and search for six consecutive equal signs (======). VSS uses these to mark the location of a conflict.

You may prefer to use the Visual Merge feature to make conflict resolution easier. To avoid this situation, your VSS Administrator can disable multiple check outs in your project.


An error occurred while checking hyperlinks for <File>

This error has the following cause and solution:

  • The working folder path, VSS specification, or URL was too long.

    Check that you aren't exceeding path limits for folder, specification, or URL. Check that Htmlfilt.dll is still present on your system and registered properly (running the client installation again should fix this problem).


An item named <item> was already deleted from this project

See Also

In VSS, you can delete only one instance of a file or project with a given name in a given project. This error has the following cause and solution:

  • You deleted a file, created a new file with the same name, and then attempted to delete that file as well.

    You can click Yes to purge the old file, or No to cancel the delete operation. If you purge the original file, you will lose all historical information in it, but you can then continue with the current delete operation. If you want to keep the history of the old file, you can click No and then rename the new file before deleting it.


An item with the name <name> already exists

See Also

Each item in a VSS project must have a unique name. This error has the following cause and solution:

  • You have attempted to name a file or an immediate child project with the same name as the project. (An item with that name can exist in other projects in the database, including subprojects.)

    To resolve this error, give the new item a different, unique file name. Or, you can delete or rename the existing item.

Note File and project names in VSS are not case-sensitive. For example, if you have a file named Test.C, you cannot create a subproject or file named "Test.c" or "test.c" in the same project.


An older version of File <File> cannot be shared because only its latest version is stored

This error has the following cause and solution:

  • You've tried to share an old version of a file. VSS only stores the latest version of a file.

    You can share only the most recent version of a file.


Are you sure you want to delete?

This warning has the following cause and solution:

  • This is the standard delete warning displayed by VSS.

    Click Yes, and VSS deletes the item(s).

    Click No, and VSS cancels the delete command.


Are you sure you want to remove all the files in <Project>?

This warning has the following cause and solution:

  • This action will remove all the files specified in your temp directory.

    Either cancel the operation or proceed to remove all the temporary files.


Bad username syntax: <syntax>

This error has the following cause and solution:

  • You have entered a username with invalid VSS user syntax.

    Ask your VSS Administrator for your correct VSS username.


Binary files differ

This message has the following cause and solution:

  • The binary files you've selected differ.

    The Show Differences command does not display line-by-line differences for binary files. Therefore, VSS can only tell you whether or not the VSS master copy is different from your local copy.


Cannot change project to <Project>

This error has the following cause and solution:

  • VSS was unable to change the project to the project specified.

    Please make sure that the project is a valid existing one.


Cannot check out <File>. It is binary and is already checked out.

This error has the following causes and solution:

  • The file you specified is binary and is already checked out. VSS does not allow multiple checkouts of binary files, because their changes cannot be merged.

    Wait to check out the file until after the other user has checked it back in.


Cannot check out an old version of <File name> because the file has been deleted

See Also

This warning has the following cause and solution:

  • You were attempting to check out an older version of the file. However, that version of the file has been deleted and cannot be checked out.

    Recover the file from the project before attempting to check out the file. You can recover files from the Deleted Items tab of the project Properties dialog.


Cannot check out an old version of a file

See Also

The Check Out command always uses the most recent version of a file. This error has the following cause and solution:

  • You are trying to check out an old version of a file.

To use and modify a previous version

  1. Check out the most recent version of the file.

  2. Delete it from your working folder (not the VSS database).

  3. Get the old version that you want to modify.

  4. Make your changes to the old version. (This may require removing its read-only flag manually.)

  5. Check the modified file into VSS.

Note You can also use the Rollback button in the History of File dialog box (on the Tools menu, click Show History). If you roll back to a certain version, all versions subsequent to that version are deleted. You can then check out the file and start modifying it. The disadvantage of this method, however, is that you lose all the subsequent versions, and cannot retrieve them.


Cannot delete the root project

This error has the following cause:

  • The Delete, Rename, and Move Project commands cannot be applied to the root project ($/), which is analogous to the root folder of your hard disk (C:\).


Cannot delete, rename, or move the root project

This error has the following cause and solution:

  • The Delete, Rename, and Move Project commands cannot be applied to the root project ($/), which is analogous to the root folder of your hard disk (C:\).

    Since the root project cannot be changed in any way, consider restructuring your project.


Cannot delete/rename/edit the Admin user

This error has the following cause and solution:

  • You attempted to delete, rename, or change the Admin user. The VSS Administrator must always exist in your VSS Administrator user list, although you should not use Admin as an actual user.

    However, you can change the Admin user's password used to log on to VSS Administrator.


Cannot difference the specified item <item>

At least one of the items you selected to compare with another item cannot be differentiated by VSS.


Cannot edit the Admin user

This error has the following cause and solution:

  • You attempted to edit the Admin user's access rights.

    The Admin user's name and access rights cannot be changed. Select another user on which to use this command.


Cannot find Help file <File>

This error has the following cause and solution:

  • The Help file isn't available.

    Try reinstalling VSS to get a copy of the Help file. If the file is still missing, call Technical Support.


Cannot find initialization variable <variable>

VSS cannot find an initialization variable it needs to perform an operation. This error has the following cause and solution:

  • The specified initialization variable is missing and is required to complete the operation.

    Search Help or the Microsoft Visual SourceSafe User's Guide for information on the variable, determine a proper value for it, and add it to your initialization file.


Cannot find SS.INI file

VSS cannot find your SS.INI file. This error has the following causes and solution:

  • The SS.INI file is not where VSS expects to find it. (See your VSS Administrator if you have moved this file.)

  • You have inadvertently deleted your SS.INI file.

    You can copy an SS.INI file from another user into your VSS folder, then modify it to customize VSS. Your VSS Administrator must then set VSS to look in the proper place.


Cannot find the SS.INI file for user <user name>.

VSS cannot find the SS.INI file for this user. The default location is vss\users\<username>.

This error has the following causes and solution:

  • The SS.INI file is not where VSS expects to find it. (See your VSS Administrator if you have moved this file.)

  • The user's SS.INI has been renamed or deleted.

    You can copy an SS.INI file from another user into this user's folder, then modify it to customize VSS. Your VSS Administrator must then set VSS to look in the proper place.


Cannot move a project under itself

See Also

A project cannot be a project of itself. This error has the following cause and solution:

  • You attempted to create an invalid loop in your project hierarchy, for example, moving the project $/Word under the project $/Word, or, more subtly, moving $/Word under $/Word/Apps. This creates an endless recursive loop, which causes this error.

    Restructure your project hierarchy so that there is no invalid loop.


Cannot move the root project

This error has the following cause and solution:

  • The Delete, Rename, and Move Project commands cannot be applied to the root project ($/), which is analogous to the root folder of your hard disk (C:\).

    Since the root project cannot be changed in any way, consider restructuring your project.


Cannot rename the Admin user

You attempted to rename the Admin user. The VSS Administrator must always exist in your VSS Administrator user list, although you should not use Admin as an actual user.

You can, however, change the Admin user's password, used to logon to VSS Administrator.


Cannot rename to another volume

There is no Help for this topic.


Cannot rename to <File>; that name already exists

See Also

The file name specified already exists in the project. This error has the following cause and solution:

  • When you rename a file that is shared by many different projects, the name of the file changes in all the projects that are sharing it. If any one of these projects already has a file with the same name, you create an ambiguous and invalid situation: two files in the same project with the same name. The Rename operation then fails.

    To correct this, select another name for the file.


Cannot roll back to the most recent version of <File>

See Also

The Rollback command returns a file to a previous version of itself. This error has the following cause and solution:

  • You have attempted to roll back a file to its most recent version or have not specified a version to roll back to.

    You cannot roll back a file to the current version in VSS. If you meant to specify an earlier version, retry the command with the earlier version specified.


Cannot Rollback to the most recent version of <File>

This error has the following cause and solution:

  • Rollback is a function that allows you to destroy permanently all file versions from the most recent version to the version indicated with the –V switch. However, the version you've indicated in the –V switch is the most recent version and therefore no rollback has been performed.

    Use the ss history <File> command to see if there are older versions of the file. Then use one of the older file versions with the ss rollback <File> -V command.


Cannot share a file or project to itself

This error has the following cause and solution:

  • VSS will not allow more than one file or subproject with the same name to exist in a single project. At the command line, you are attempting to share a file or subproject to a project that contains the same named file/subproject.

    Use the ss cp command to change your current project to a project that doesn’t contain a file/project with the same name. You can also select a different project or file to share.


Checkout the entire project at this label?

This warning has the following cause and solution:

  • You are attempting to check out an older version of a labeled project from the project history window.

    Click Yes to check out all the files in the project at that labeled version you selected.

    Click No to cancel the operation.


Checkout the entire project containing this file version?

This warning has the following cause and solution:

  • You are attempting to check out an older version of a file from the project history window.

    Click Yes to check out all the files in the project at the version you selected.

    Click No to check out only the file version you selected.

Note If you are looking at the recursive history of a higher-level Project and you attempt to check out an earlier version of a file in a subproject, you must select the Recursive check box in the Check Out <filename> dialog box. Otherwise, the file will not get checked out.


Checkouts for <path> (<user>) deleted

This is an informational message by archive that some check outs have been removed. You can re-check out any files at any time.


Collision accessing database, please try again

There is no Help for this topic.


Continue with other items?

Do you wish to continue processing the other items?


Corrupted history in file <File> after revision <number>

This error has the following cause and solution:

  • The VSS database has been corrupted.

    Ddconv.exe saves as much of the database as possible, but some information will be irretrievably lost (unless you have backed up the database and can recover the information from there).


Could not Deploy <Project> to <host>

This error has the following cause and solution:

  • VSS was unable to open a connection to the specified ftp host and deploy your project.

    Check your network connections, and check that you've entered the correct syntax for your ftp host. This error can also occur if your ftp host is not available at this time.

    This message can also mean that you are out of disk space. It can also mean that you don't have permission to write to the location although you may have read permission.


Could not display this URL

This error has the following cause and solution:

  • You tried to check an external Web link, but there was no Web browser present in the register to handle an http path; or, the link syntax was incorrect for ShellExecute (this could happen if you tried to check a virtual root by double-clicking on it instead of setting the virtual root).

    Install Internet Explorer version 3.0 or later.


Could not find the file referred to by shortcut <File>

This error has the following cause and solution:

  • The file referred to by this .lnk file could not be found.

    Check that the file has not been moved or deleted. Click OK to accept and retry.


Could not login to <ftp site>

This error has the following cause and solution:

  • You cannot log in to the specified ftp site.

    You may be using an invalid address, invalid username, invalid password, or perhaps the site is just not responding. Make sure you have the right ftp address.


Current database does not match request

This error has the following cause and solution:

  • A VSS internal error has occurred. VSS assumes that the database you are logged into should be in a new format.

    Call your VSS Administrator to run DDUPD –redo, or to contact tech support.


Current project setting in SS.INI file invalid or missing

This warning has the following cause and solution:

  • When a user exits VSS, it records the last project the user was in to the users configuration file. If that project is removed, when the user attempts to perform an action at the command line, this message will appear.

    Use the ss cp <project> command to switch to an existing project.


<Database> is already in your database list

This error has the following cause and solution:

  • The database already exists in your list of Available Databases.

    Select the existing entry for the database as listed in the Available Databases.


<Database> is already in your database list. Would you like to rename it?

This error has the following cause and solution:

  • You are renaming a VSS database entry in your Open SourceSafe Database list.

    Click Yes to rename the specified entry, or No to leave the database entry as it is on the list.


Delete all specified items?

See Also

This warning has the following cause and solution:

  • You are about to delete a file or project.

    Click Yes, and VSS deletes the file or project.

    Click No, and VSS does not.

    Use the Recover command to undo Delete.

Note If you do not want to receive this message every time you delete a file or project, you can disable it on the Warnings tab in the SourceSafe Options dialog box on the Tools menu.


Delete local file: <local file>?

This warning has the following cause and solution:

  • You have Smart Mode turned on and are attempting to delete a file from a project. VSS is offering to delete your local copy as well.

    Click Yes to delete the local copy.

    Click No to leave the local copy. The copy in VSS will be deleted.

    To turn off Smart Mode, go to Tools, Options, Local Files tab, and deselect Remove local copy after delete.


Delete the rights for <User Name>?

Deletes the user rights of a specific user for a selected VSS project. These changes will affect the user the next time they log into VSS.


Delete the user rights for <Project Name>?

Deletes previously assigned user rights to a VSS project for a specified user. This change will affect the specified user the next time they log into VSS.


Destroy cannot be undone; information will be lost permanently!

See Also

This warning has the following cause and solution:

  • When you use the Destroy command on a file or project, the action is not reversible.

    Click Yes to continue with the Destroy operation. Click No to cancel the operation.

Note If you do not want to receive this message every time you destroy a file or project, you can disable it on the Warnings tab in the SourceSafe Options dialog box on the Tools menu.


Disk full

This error has the following cause and solution:

  • You tried to save data to a full disk.

    Free some disk space by deleting or moving unneeded files.


Editor path is a required field when prompting by editor is selected

This message has the following cause and solution:

  • When you check the Use Editor to Prompt for Comments check box, you must specify the appropriate editor.

    Set the path in the Editor field of the Command-Line Options tab in the Tools Options dialog box on the Tools menu.


Error creating <File> while attempting to lock database. Database is not locked.

This error has the following cause and solution:

  • A file needs to be created in the following directory, however the creation process failed: <vss install directory>\data\loggedin

    You may have run out of disk space, or you don't have write access to the folder.

    Check to make sure you have write access to the VSS folder.


Error deleting <File> while attempting to unlock database. Database is not unlocked.

This error has the following cause and solution:

  • A file needs to be deleted in the following directory, however, the deletion process failed: <vss install directory>\data\loggedin

    You do not have delete permissions to the folder.

    Check to make sure you have delete permissions to the VSS folder.


Error loading VSS add-in <add-in name>

There is no Help for this topic.


Error locating local temporary files directory

This error has the following cause and solution:

  • The entry for Temp_Path in the SRCSAFE.INI file is missing.

    Ask your VSS Administrator to fix the Temp_Path entry in the SRCSAFE.INI file


Error reading from file

VSS cannot read from a file it has opened. This error has the following cause and solution:

  • You may have lost your network connection.

    Exit VSS, and then check all network connections before restarting.


Error writing to file

VSS cannot write data into a file that it has opened. This error has the following cause and solution:

  • You may have a full disk.

    Exit VSS, and then free disk space by deleting unnecessary files.


Failure writing merge file for <File>.

An internal error has occurred and the merge operation has been undone.


File <File name> (file <File name> in VSS) was not found

This error has the following cause and solution:

  • VSS was unable to locate the specified file.

    Run the Analyze utility to make sure there are no errors in your VSS database. If running Analyze with the –F switch does not correct the problem please contact Product Support.

Note When running the Analyze utility first run it with no switches to find any errors in the database and then with run it with the –F switch to run in autofix mode.


File <File name> has not been changed. Do you want to create a new version of the file in VSS?

This error has the following cause and solution:

  • You are attempting to check in a checked-out file that you haven't changed.

    Click Yes, and VSS checks it in anyway. (Clicking Yes All checks in all selected files.) A checkin creates a new version of the file, with an optional comment.

    Click No, and VSS undoes the check out of the file. (Clicking No All undoes the check out for all selected files.) No new version of the file is created in this case.

Note To avoid this message in the future, disable this notification on the General tab that is accessed by selecting Options from the Tools menu.


File <File name> is currently checked out by <user name>. Delete anyway?

This warning has the following cause and solution:

  • You are attempting an operation that would delete a file currently checked out to another user.

    If you delete this file, the check out information will be lost, even if the file is not permanently destroyed. In this situation, VSS gives you some options:

    • Click Yes to delete the file.

    • Check Yes All to have your choices in this dialog box apply to all other files checked out to other users.

    • Click No to skip the operation for this file.

    • Click No All to skip the operation for all files checked out to other users.

    • Click Cancel to cancel the operation.


File <File name> is currently checked out by <user name>. Proceed anyway?

This warning has the following cause and solution:

  • You are attempting an operation on a file checked out to another user that would remove the check out information. For example, the Admin user can undo check out of a file checked out by anyone.

    Click Yes to continue the operation, losing the check out information.

    Check Yes All to have your choices in this dialog box apply to all other files checked out to other users.

    Click No to skip the operation for this file.

    Click No All to skip the operation for all files checked out to other users.

    Click Cancel to cancel the operation.


File <File name> is invalid. Files cannot begin with $.

This warning has the following cause and solution:

  • You are trying to add a file to VSS whose name begins with the dollar sign. This is not a legal VSS file name.

    Remove the dollar sign and attempt to add the file again.


File <File name> is not branched, therefore you cannot merge it

This warning has the following cause and solution:

  • In order to merge a file, it must have been branched sometime in its history. The file selected has never been branched.

    Select a file that has been branched.


File <File name> was not found.

VSS could not find the file it was looking for.

This error has the following causes and solution:

  • You may have mistyped a file name in VSS Explorer or in an initialization file variable.

  • The file may not exist.

    Make sure that you've correctly entered the name of the file.


File <File> already exists

This error has the following cause and solution:

  • You tried to create a file or folder with a name that already exists.

    You can give VSS files the same name as many times as you want in different directories, but only once in a given folder. Select a different name or rename the conflicting file or project.


File <File> already exists. Overwrite?

This warning has the following cause and solution:

  • You are trying to copy a file over an existing writable file as part of a Check out or Get command. This typically occurs in integration.

    Click Yes if you want the copy in your local folder to be overwritten by the file you are doing the Get or Check out on.

    Click No if you want to retain the copy in your local folder.


File <File> does not retain old versions of itself

See Also

This message has the following cause and solution:

  • When you check in a file, VSS retains both the current version of the file and the information required to rebuild past versions. You have turned off the historical version storage for this file.

    If you explicitly turn off this change information in the Properties dialog box or when using the Add Files command, VSS can give you the most recent version, but it cannot rebuild old versions.


File <File> has been destroyed, and cannot be rebuilt

See Also

VSS may not be able to reproduce the file you requested. This error has the following cause and solution:

  • You permanently destroyed a file or moved the file to another location. For example, there may have been a file in a project that you deleted or purged. Later, you attempt to go back to an earlier version of the project. VSS attempts to reconstruct the project exactly as it was in the past, but it cannot, because the file cannot be recovered.

    Click Yes, and VSS tries to restore the old file, but restoration is not guaranteed.

    Click No, and the attempt to restore an old file is halted.

    Click Yes All, and VSS does not notify you that other selected files may also be unrecoverable, but continues with the best possible reconstruction.


File <File> has not been changed

This error has the following cause and solution:

  • You are attempting to check in a checked-out file that you have not changed.

    Click Yes, and VSS checks it in anyway. (Clicking Yes All checks in all selected files.) A checkin creates a new version of the file, with an optional comment.

    Click No, and VSS undoes the check out of the file. (Clicking No All undoes the check out for all selected files.) No new version of the file is created in this case.

Note To avoid this message on future occasions, disable this notification on the General tab that is accessed by selecting Options from the Tools menu.


File <File> is already checked out by another user. Continue?

This warning has the following cause and solution:

  • The file you selected for check out is already checked out by another user.

    Either cancel the check out or continue.


File <File> is already open.

This warning has the following cause and solution:

  • Either another user or VSS has the file locked.

    If VSS has the file locked, you can attempt to release the lock by performing a status check of the file or the entire database.

    At a Command Prompt, type the following:

    SS Status $/ -R

    If the file remains locked, contact your network administrator.

    If problems like this continue, you may need to enable VSS locking.


File <File> is already shared with this project

See Also

This error has the following cause and solution:

  • You are attempting to share a file with the current project, and that file already exists in the current project.

    If you want to share a different version of the file, specify a version in the History of File dialog box and click Pin. If you want to share this file with another project, select that project in VSS Explorer and click Share on the SourceSafe menu. Then, select the file to share from the Share dialog box.


File <File> is checked out by <user>

This warning has the following cause and solution:

  • You attempted an operation on a VSS file that is checked out by another user.

    VSS provides this warning before allowing or denying you access to perform actions on a file.


File <File> is checked out to project <Project>, and you are in <Project>

When a file is shared among multiple projects, a file in one project is linked to all other projects that share it. Therefore, when you check out the file from one project, it is also checked out from all the projects that share it. This warning has the following cause and solution:

  • You checked out a file from one project, and you are attempting to check the file in or undo the check out from another project that shares the same file.

    This is a valid action. VSS is simply alerting you in case this is not what you intend. To proceed, click Yes; to cancel the operation, click No.

Note You can check in a file or undo a check out from any project that shares a file.


File <File> is currently checked out by <user>

See Also

This warning has the following cause and solutions:

  • When someone other than you has a file checked out, there are some things you cannot do to the file. For instance, you cannot delete or rename a file that is checked out.

    Click Yes to check out the file anyway. (Yes All checks out all selected files even if they are already checked out by another user.) If you click Yes, there may be conflicts between your changes and those of another user, which will have to be resolved and merged later.

    Click No to cancel the Check Out command. (No All cancels the command for all selected files.)

If you want to work on a checked-out file, it's best to check the User column of VSS Explorer for the name of the user who has it checked out and ask that user to check it in as soon as possible. If the user is unavailable, the VSS Administrator can undo the check out for you.


File <File> is exclusively checked out

This warning has the following cause and solution:

  • If Multiple Checkouts is enabled, users in VSS can check out files in two ways. First they can allow other users to check out the file or they can check it out so no one else can check out that file, namely exclusively. This message appears when a user attempts to checkout a file that is already exclusively checked out by someone else. It frequently appears with the "<File> is already checked out, continue?" message.

    You will not be able to check out this file until the user who has the file checks it in or performs an undo check out. To find out who has the file checked out, you can use the ss status command or look at the Check Out Status tab on the file Properties dialog. The VSS Administrator can also undo checked out files that another user has checked out.


File <File> is locked

This error has the following cause and solution:

  • The file you are trying to access is already being used.

    Wait and try your operation again later.


File <File> is not shared with any other projects

The Branch command is used to break a share link. This error has the following cause and solution:

  • The file you've chosen to apply the Branch command to has no link to other projects.

    Select another command, or select a shared file to apply the Branch command to.


File <File> may be corrupt

This error has the following cause and solution:

  • The specified file may be corrupt.

    Run the Analyze utility to make sure there are no errors in your VSS database. If running Analyze with the –F switch does not correct the problem, contact Product Support.

Note When running the Analyze utility, first run it with no switches to find any errors in the database, then with just the –F switch to run in autofix mode.


File <File> not found

VSS could not find the file it was looking for. This error has the following causes and solution:

  • You may have mistyped a file name in VSS Explorer or in an initialization file variable.

  • The file may not exist.

    Make sure that you've correctly entered the name of the file.


File <File> was checked out to <folder>, not to <folder>

This warning has the following cause and solution:

  • The file you are checking in was checked out in a different folder.

    When dragging a file to check in, you must check it in from the folder where it was checked out. The file you dragged will not be checked in. If you want to check the file in from this folder, use the VSS Check In command from the SourceSafe menu.


File <File> was checked out to folder <path>

When you check out a file, VSS keeps track of the working folder you checked it out to. In general, you make your modifications in that folder, and then check in the file or undo the check out from the same folder when you are finished. This warning has the following cause and solution:

  • You are attempting to check in or undo a check out of the file from a folder different from the one you checked it out to.

    Your working folder for a project is displayed just above the file pane in VSS Explorer, and can be changed with the Set Working Folder command from the File menu (ctrl+d). The checkout folder of a file is displayed in the file list. (The checkout folder may be different from your working folder assigned to the project, if someone else has the file checked out, for example.) Although you can check a file in from a folder other than the one you checked it out to, make sure that this is what you intend.


<File> already exists in project <Project name>, and is not the same as the archived file. No restore possible.

This message has the following cause and solution:

  • You're attempting to restore a file into a database different from the database you archived it from, and there is already a file of the same name present.

    Either keep the existing file, delete, or rename it, and then run SSRESTOR.


<File> has been merged with no conflicts

The current file has been merged. No conflicts were found between the merged versions.


<File> has been merged with no conflicts. Check in now?

This warning has the following cause and solution:

  • This is the standard Merge warning displayed by VSS.

    Click Yes to check the merged file into VSS.

    Click No to not check the merged file into VSS.


<File> has changed. Undo check out and lose changes?

See Also

This warning has the following cause and solution:

  • You are about to undo the check out of a file. If you do so, you discard all the changes made since you checked out the file.

    If you want to put your changes into VSS instead of losing them, use the Check-In command instead.

Note If you do not want to receive this message every time you undo a file check out, you can disable it on the Warnings tab in the SourceSafe Options dialog box on the Tools menu.


<File> is a VSS configuration file and cannot be added

The file specified is a VSS configuration file and cannot be added to the VSS database.


<File> is a VSS local cache file and cannot be added

This error has the following cause and solution:

  • You attempted to add an existing VSS file to VSS.

    Stop the operation.


<File> is already checked out by <user>. Continue?

This warning has the following cause and solution:

  • You attempted an operation on a VSS file that is checked out by another user.

    VSS gives you the option to continue, which means any differences between the changes you make to the file and the changes made by the other user will need to be merged in the future. Click Yes to continue your operation and create a multiple-checkout situation; click No to cancel the check out.


<File> is already in this project; you do not need to share it.

This warning has the following cause and solution:

  • You can’t have two items in a project with the same name. You are attempting to share a file into a project that already contains a file or subproject with the same name.

    If you would like the file to be in the project, you will either have to:

    • Rename the existing file/project before sharing the file into the project, or

    • Delete or destroy the existing item from the project


<File> is an Explorer link file

This message has the following cause and solution:

  • You dragged a .lnk file into VSS.

    When you drag a .lnk file into VSS, you need to tell VSS whether to add the .lnk file itself to the database, or add the file that the .lnk file points to. If you want to add the file referred to by the .lnk file, click Yes. Otherwise, click No.


<File> is an invalid <File> name

See Also

The file name is not a valid name. Please refer to the VSS naming conventions for the proper syntax.


<File> is an invalid or corrupted logfile

This error has the following cause and solution:

  • VSS cannot find or read your logfile.

    Run Analyze.exe with the -F option. If necessary, check with Technical Support for more assistance.


<File> is checked out by <user>; deleting it will cancel the check out. Continue?

This warning has the following cause and solution:

  • You are attempting to delete a checked out file.

    This warning provides the opportunity to avoid deleting the wrong file. If the file name is correct, click Yes to proceed. Click No to cancel the delete operation.


<File> is not a text file

Although most VSS commands work on either text or binary files, this command does not. This error has the following cause and solution:

  • You attempted to execute a command that operates only on text files, such as View File on the Edit menu or Find In Files on the Tools menu.

    Binary file types are set either automatically by VSS or manually using the File Types tab in the SourceSafe Options dialog box on the Tools menu.


<File or Folder> is not a valid file or path, and will be ignored. Add other files?(Y/N)

This error has the following cause and solution:

  • The command line ss add command can accept multiple files or folders as parameters. In this case, one of the parameters does not exist.

    Type Y if you want to continue adding the other files listed in the ss add command.

    Type N if you want to abort the add process and stop adding any other files in the ss add command.


<File> was checked out from <Local Folder>, not from the current folder. Continue anyway? (Y/N)

This warning has the following cause and solution:

  • When a file is checked out, VSS records where the file was copied to. When a file is checked in from the command line, VSS, by default, looks in the current folder for the file. If a copy of the file exists in the current folder, but that not in the location the file was checked out to this message will appear.

    Type Y if you want to check in the file that exists in the current folder.

    Type N if you want to abort the operation and not check in the local folder. If you want to check in a file that doesn’t exist in the current folder, use the –GL switch of the checkout command to tell VSS what folder to check in the file from.


<File name> has been automatically renamed to <file name> in project <Project> to match the current file name in the database.

This message is informational only. It was caused by an archive command.


<File name> is checked out, replace?

This warning has the following cause and solution:

  • You chose to get a file when it was already checked out.

    When you get a file, a new copy is written to your working folder. If you already have the file checked out, you may have made changes that will be overwritten. In this situation, VSS gives you some options:

    • Click Replace to overwrite the working folder file.

    • Click Merge to merge changes from the working folder file into the VSS database file.

    • Click Leave to leave the working folder file alone (the Get command will be ignored for that file).

    • Click Cancel to cancel the Get operation.

    • Check Apply to all items to have your choices in this dialog box apply to all other files you currently have checked out.


<File name> is pinned to a specific version

This warning has the following cause:

  • You are attempting an operation on a file checked out to another user that would remove the check out information. For example, the Admin user can undo check out of a file checked out to others.


<File name> stores only the latest version and is already checked out.

This warning has the following cause and solution:

  • VSS only allows one user to check out a file that is set to store only latest version. This is because VSS can't merge the changes of a second user as the ancestor file has been replaced by the first users check in.

    Identify who has the file checked out and have them perform the Check In or Undo Check Out command. If you can't find the individual, the Admin user can check in files another user has checked out.

    To identify who has a file checked out, view the Check Out Status tab on the file properties dialog or use the ss status command.


<File name> was checked out from project <Project path>, not from <Project path>. Undo check out anyway?

When a file is shared among multiple projects, a file in one project is linked to all other projects that share it. Therefore, when you check out the file from one project, it is also checked out from all the projects that share it.

This warning has the following cause and solution:

  • You checked out a file from one project, and are attempting to check the file in or undo the check out from another project that shares the same file.

    This is a valid action. VSS is simply alerting you in case this is not what you intend.

    To proceed, click Yes.

    To cancel the operation, click No.

Note You can check in a file or undo a check out from any project that shares a file.


<File name> was checked out from project <Project path>, not from <Project path>. Check in anyway?

When a file is shared among multiple projects, a file in one project is linked to all other projects that share it. Therefore, when you check out the file from one project, it is also checked out from all the projects that share it.

This warning has the following cause and solution:

  • You checked out a file from one project, and are attempting to check the file in from another project that shares the same file.

    This is a valid action. VSS is simply alerting you in case this is not what you intend.

    To proceed, click Yes.

    To cancel the operation, click No.

Note You can check in a file or undo a check out from any project that shares a file.


File not checked out by you

See Also

Some VSS operations can only be performed on a file that is checked out. This error has the following causes and solutions:

  • You attempted to check in or undo a check out on a file that you did not have checked out.

    Check out the file before checking it in. If you have made changes to a file, see the Advanced options in the Check Out dialog box, and then under Replace Writable, select Skip to check out the file to you without replacing the changes in your working folder.

  • You attempted to perform an operation that can only be performed on a file that is checked out.

    Check out the file.


File or project not found

See Also

VSS is looking for a file or project that does not exist. This error has the following causes and solution:

  • You mistyped the file or project name, or specified a file or project that does not exist.

  • The VSS database is corrupted.

    Try retyping the name or select the name from the list in VSS Explorer. If you suspect database corruption, run the Analyze.exe utility.


File type <Group> is already in the list

This warning has the following cause and solution:

  • The file group you are adding already exists in the file groups list.

    Specify a different name for the file group you are adding, or delete the existing file group with the same name.


File version not found in local cache

There is no Help for this topic.


Files are not branched

This error has the following cause and solution:

  • You have attempted to Merge Branches on two files that have not been branched.

    You cannot perform Merge Branches on these two files.


Files have no common ancestor

There is no Help for this topic.


Filter string exceeds the maximum length of <number>

This error has the following cause and solution:

  • The combined length of the filter values on the File Types tab in the SourceSafe Options dialog box on the Tools menu is too long.

    VSS uses the File Types Included in File Group field to create a filter string for the Share and Add Files dialog boxes. This error occurs when the combined length of the file groups is too long. The total buffer length is 511 characters. To correct this error, reduce the length of your file-type lists.


Folder <Folder> already exists

This warning has the following cause and solution:

  • You are attempting to create a local folder that already exists on the drive. This can occur when creating a folder from the Set Working Folder dialog.

    Use a different folder name when creating the local folder. Or set the Working Folder to the existing local folder.


Folder <path> not found. Create?

The specified working folder does not exist. This error has the following cause and solution:

  • The folder may have been deleted, or you may have entered its specification incorrectly. Your network connection to a networked location may also have gone down.

    Reset the working folder for this project (using the Set Working Folder command on the File menu), or click Yes to create the folder. This tells VSS that this is the local working folder. When you open the project again, VSS automatically goes to this working folder.

    If your working folder seems fine, check to see if this project is shadowed to another location, and that your connection to that location is still OK.


Folder not found

This error has the following cause and solution:

  • You specified an operating system folder that could not be found.

    Check to make sure the folder specification is correct. Check capitalization on case-sensitive operating systems.


Function is not implemented

There is no Help for this topic.


Get entire project at this label?

This message has the following cause and solution:

  • You chose to do a get from the history dialog on a labeled file. The entire project has the same label.

    Click yes if you want to do a get on the whole project at that label. Click no to get just the file at that label.


Get on Checked Out File Dialog

This message has the following cause and solution:

  • You chose to get a file when it was already checked out.

    When you get a file, a new copy is written to your working folder. If you already have the file checked out, you may have made changes that will be overwritten. In this situation, VSS gives you some options:

    • Click Replace to overwrite the working folder file.

    • Click Merge to merge changes from the working folder file into the VSS database file.

    • Click Leave to leave the working folder file alone (the Get command will be ignored for that file).

    • Click Cancel to cancel the Get operation.

    • Click Apply to all items to have your choices in this dialog box apply to all other files you currently have checked out.


Get the entire project at this label?

This message has the following cause and solution:

  • You've done a get of a file at a label from the Project History dialog box.

    Click yes to get the whole project at that label. Click no to get only the file at that label.


Get the entire project containing this file version?

See Also

This message has the following cause and solution:

  • You have selected a file in the History of File dialog box list and then clicked Get.

    Click Yes, and VSS gets the entire project as it existed immediately after the selected file was checked in.

    Click No, and VSS gets only the file version you selected; it doesn't get any other files in the project.


Has the file <File name> been properly merged?

This warning has the following cause and solution:

  • You have attempted to check in a file changed from the current version stored in VSS.

    This warning message often is displayed when you have checked out the same file to more than one user or computer. It is displayed so you can be sure that any merge conflicts have been resolved. In some cases, this warning may be displayed even if no merge conflicts occurred, and that is potentially confusing. But, if this is the case, just click Yes and continue with your work.

    If there were conflicts, and you did not open the source file to resolve them, click No and do so now. When finished, rerun your Check In operation.


Have the conflicts in <File> been properly resolved?

This message has the following cause and solution:

  • You have attempted to check in a file changed from the current version stored in VSS.

    This warning message often is displayed when you have checked out the same file to more than one user or computer. It is displayed so you can be sure that any merge conflicts have been resolved. In some cases, this warning may be displayed even if no merge conflicts occurred. If this occurs, click Yes and continue with your work.

    If there were conflicts, and you did not open the source file to resolve them, click No. When finished, try your Check In operation again.


Illegal file or project name(s): <File>

See Also

This error has the following cause and solution:

  • You have entered an illegal file or project name.

    Check to make sure that the name was entered correctly. If you are unsure which characters are allowed in a VSS name, check the VSS Naming Syntax and Conventions topic.


Illegal version number

This error has the following cause and solution:

  • An illegal version number was found in the VSS file.

    Run the Analyze utility to make sure there are no errors in your VSS database. If running Analyze with the –F switch does not correct the problem, contact Product Support.

Note When running the Analyze utility, first run it with no switches to find any errors in the database. Then run the Analyze utility with just the –F switch in autofix mode.


Illegal version syntax: <number>

This error has the following cause and solution:

  • The version number you entered uses illegal syntax.

    Check to make sure that the information was entered correctly.


Incompatible database version

The database specified is not in a format that can be read by this version of VSS. For example, you may be trying to open a Version 2.0 database with version 6.0 VSS. Upgrade the database or your software.


Initialization variable <variable> must be between <number> and <number>

An initialization number is out of the valid range. This error has the following cause and solution:

  • An initialization variable has been set to an invalid number.

    Search Help for information on valid settings.

Note You can use any text editor to change or delete the invalid number.


Initialization variable <variable> must be set to "Yes" or "No"

This error has the following cause and solution:

  • An initialization variable that should be set to Yes or No is not.

    Change the variable so that it is set to Yes (or True) or No (or False).

Note You can use any text editor to change or delete the invalid value.


Initialization variable <variable> set to invalid folder path

An initialization variable that should be set to a valid folder path is set to an invalid path. This error has the following cause and solution:

  • The path syntax may be incorrect or the path may not exist.

    Verify that the path exists or that the syntax is correct and change it as necessary.

Note You can use any text editor to change or delete the invalid path.


Initialization variable <variable> set to invalid number

The specified initialization variable has been set incorrectly. This error has the following cause and solution:

  • An initialization variable that should be set with an Arabic number is not. For example, it may be set to "two" when it should be set to "2".

    Search Help for information on the proper syntax of the initialization files.

Note You can use any text editor to change or delete the invalid number.


Initialization variable <variable> set to invalid value

This error has the following cause and solution:

  • An initialization variable is set to an invalid value.

    Search Help for information on the proper syntax.

Note You can use any text editor to change or delete the invalid value.


Invalid access code (bad parameter)

There is no Help for this topic.


Invalid characters in Dir_Umask .ini variable. Ignoring it.

There is no Help for this topic.


Invalid date string

VSS cannot use the date syntax entered. This error has the following cause and solution:

  • The date you entered is invalid.

    Proper date syntax is Month/Day/Year, with each number separated by a slash: for example, 2/29/64 or 11/5/1992.


Invalid DOS path: <File Path>

This error has the following cause and solution:

  • The VSS client cannot find the database specified in #include line of the local SRCSAFE.INI file.

    To resolve the problem, make sure you have access to the folder specified in the #include line of the local SRCSAFE.INI.


Invalid drive: <drive>

This error has the following cause and solution:

  • The drive you are attempting to access is invalid. You may have mistyped the drive specification, either in VSS Explorer or in an initialization file.

    Check to make sure that you've entered the correct drive specification.


Invalid filename: <File>

This error has the following cause and solution:

  • You typed a file name with invalid syntax.

    Check your typing, or select a different name with valid characters. You may also get this error if you have multiple files selected and try to use a command meant for a single file, such as View.


Invalid handle

  • VSS is trying to open a non-existent file, or a file to which the path is incorrect. VSS attempts to resolve file paths relative to the location of the SRCSAFE.INI file located in the server installation folder.

This error has the following possible causes and solution:

  • The Journal_File variable in the SRCSAFE.INI file is set to a location that is unavailable, such as a drive mapping that has been disconnected.

  • You are attempting to show differences on a file whose working directory is a floppy drive, and there is no disk in the drive.

    In either case VSS must be able to locate the file it needs to complete the operation.


Invalid password

This error has the following cause and solution:

  • Your username/password combination is invalid.

    Re-enter the password. Because it does not appear on the screen, it is very easy to type it incorrectly. Note that the VSS password is case-insensitive. If you believe you have typed the password correctly and VSS doesn't recognize it, ask your VSS Administrator to change your username and password. If you have forgotten your password, the VSS Administrator can use Administrator to assign you a new one.


Invalid syntax on line <line> of file <File>

This error has the following cause and solution:

  • The syntax of one or more lines in the initialization file is invalid.

    Search Help for information on the proper syntax of the initialization variable.

Note You can use any text editor to change or delete the invalid line.


Invalid time or date string.

VSS cannot use the date or time syntax entered. This error has the following causes and solutions:

  • The date you entered is invalid.

    Proper date syntax is Month/Day/Year, with each number separated by a slash: for example, 2/29/64 or 11/5/1992.

  • The time you entered is invalid.

    Proper time syntax is Hour:Minute, followed by a one-letter a.m. or p.m. indicator: for example, 9:30A or 5:00p. (The indicator is not case-sensitive.) Or, you can use a 24-hour syntax such as 13:45.


Invalid value <value> on File Types tab

This error has the following cause and solution:

  • You have attempted to create a file type using invalid characters.

    File Type names cannot contain the following characters: [ ] ( ) , ;. The value for a file type is a search pattern, and cannot contain invalid characters. Also, you cannot leave the File type included in this group text box blank. Consequently, some file types must be entered.


Invalid VSS path <path>

See Also

This error has the following cause and solution:

  • You have entered an invalid VSS project or file name.

    Check to make sure that you typed the path correctly, or use VSS Explorer to select the item from the project list or file list.

    If you chose the item from VSS Explorer, it is possible that another user has deleted or renamed the item since you last used VSS. Collapse the root project and expand it again to refresh the project pane.


Invalid VSS syntax: <syntax>

See Also

The syntax you entered is invalid in VSS. This error has the following cause and solution:

  • You have entered a VSS file or project path that does not use valid syntax.

    In VSS syntax, every path starts with a dollar sign followed by a series of project names, which are separated by slashes and optionally followed by a file name. For example:

    • $/ is the root project.

    • $/Code is a subproject of $/.

    • $/Code/Win/Test.C is a file in the $/Code/Win project.

    Many parts of this syntax are optional. You can omit the dollar sign in most circumstances. You can also shorten the path by basing it on your current project; for example, if you are in $/Code, you can type WIN as a shorthand for $/Code/Win, Test.C for $/Code/Test.C, and ".." for the root.

File names can be any valid operating system file name, except for the following restriction that is specific to VSS. File names in VSS must not begin with a dollar sign ($), a semicolon (;), or a period (.), regardless of whether the operating system permits one or more of those characters.

Project names can include spaces and can be up to 256 characters long. Project names are not case-sensitive (for example, to VSS, Code and CODE are the same project).


<Item> has been deleted

See Also

This error has the following cause and solution:

  • You are trying to act on a file or project that has been deleted in the current project.

    Before you can do anything to the file, you must recover it using the Recover command.

    If you want to delete the file from the VSS database permanently, on the File menu, click Properties, and then on the Deleted Items tab, click Purge.


<Item> is not a deleted file or project

See Also

The Recover and Purge commands operate only on items that have been deleted. This error has the following cause and solution:

  • You attempted to use the Recover or Purge command on an item that has not been deleted.

    If you are trying to recover a file or project, the file or project already exists in VSS. To view the file, use the View File command.


<Item> is not an existing file name or project

This message has the following cause and solution:

  • The item specified is not a valid filename or project.

    Run the Analyze utility to make sure that there are no errors in your VSS database. If running Analyze with the –F switch does not correct the problem, contact Product Support.

Note When running the Analyze utility, first run it with no switches to find any errors in the database, then with just the –F switch to run in autofix mode.


<Item> specifies a version number, which is illegal for this command

This command operates only on the most recent version of a file. This error has the following cause and solution:

  • You attempted to execute the command on an older version of the file.

    Select another command, or apply the command you've chosen to the most recent version of the file.


Label comment is invalid when no label specified

This error has the following cause and solution:

  • You specified a comment for a label but no label was supplied.

    If you want to label a file or project, and wish to include a comment, you must specify the label as well as the comment.


<Local file> is writable, replace?

This warning has the following cause and solution:

  • There is a writable file in your working folder with the same name as the one you are attempting to get or check out.

    When you get or check out a file, a new copy is written to your working folder. If you already have a writable copy, you may have made changes that will be overwritten. In this situation, VSS gives you some options:

    • Click Yes to overwrite the working folder file.

    • Check Yes All to have your choices in this dialog box apply to all other files you currently have writable copies of.

    • Click No to skip the operation for this file.

    • Click No All to skip the operation for all files you have writable copies of.

    • Click Cancel to cancel the operation.


Local temporary files directory has been successfully cleaned

Your local temporary files directory has been successfully cleaned.


Local temporary files directory is not found at location <path>

This error has the following cause and solution:

  • The local temporary files directory is missing or was accidentally deleted.

    Create the local temporary files directory as specified, or ask your VSS Administrator to fix the problem.


Lock_Mode INI variable has illegal value. Assuming Native.

This warning has the following cause and solution:

  • VSS can be set up to use its own form of file locking. This is set by the VSS Administrator adding a Lock_Mode = INI file setting to the SRCSAFE.INI file. At the present time, the setting is incorrect.

    Edit the SRCSAFE.INI to correct the Lock_Mode INI file setting to be either Native or Lockfile.


Login failed. The supplied login information is not valid and should be changed to valid login information for this database.

This error has the following cause and solution:

  • Your attempt to login to VSS was unsuccessful.

    Please try logging in again to the correct database, with the proper user information. Make sure Caps Lock is turned off.


Move does not change the name of a project

Moving a project does not change the name of a project. If you want to rename the project, you do so from the VSS Explorer or command line.


Name information for offset <number> not found in archive file. Name will be truncated to <name>.

This message has the following cause and solution:

  • For maintenance reasons, VSS crops long file names to shorter file names. The long file name information was lost for this particular file or project, so VSS will now refer to it by its short name.

    To remedy this, rename the file or project to its original long name.


Network not found

This error has the following cause and solution:

  • No network is installed, or VSS cannot find a valid network.

    Perhaps there is no network installed, or one or more network connections have failed. Check your network hardware, and make sure that all the necessary network drivers are running. Check with your VSS Administrator for additional assistance.


No additional Help is available on this item

  • No more information is available on this dialog box. If the cause of the problem is not clear from the message, please call Technical Support for assistance.


No application is associated with this file type

This error has the following cause and solution:

  • You have attempted to view a file for which no file association exists.

    This error is usually caused by trying to view a binary file. Check that you have selected the correct file, and if you have, associate an editing program with this file extension by using either the Windows Explorer or File Manager.


No deployment path has been setup for <File or Project name>.

This error has the following cause and solution:

  • You tried to Deploy a project without specifying a deployment path for the project in the Administrator program.

    Ask your VSS Administrator to set up a deployment path for your Web project.


No differences were found for project <Project>

This message has the following cause and solution:

  • You compared two items with no differences.

    This is an informational message to tell you that no differences were found between the compared items.


No HTML files were available in this project to check hyperlinks

This message has the following cause and solution:

  • This informational message tells you that no files were checked for Web hyperlinks because no HTML files were found.

    If you expected HTML files in this project, check that they were added properly and that you entered the correct project name.


No items listed to operate on

This error has the following cause and solution:

  • You are attempting to perform an action without first selecting an item to operate on.

    Click an item to select it, and then try the action again.


No items to add

See Also

This error has the following cause and solution:

  • In the Add File dialog, you have attempted to perform an add operation without first selecting an item to add.

    To add a file, first type in the file name or select the file in the file list, then click the Add button. To add a folder, select the folder in the folder list and then click the Add button.


No matches were found

This error has the following cause and solution:

  • VSS has searched all the selected files, and has found no occurrences of the string you are trying to find.

    Check to make sure that you've entered the string correctly.


No more files

This warning has the following cause and solution:

  • VSS was unable to find any more files to process.

    Run the Analyze utility to make sure there are no errors in your VSS database. If running Analyze with the –F switch does not correct the problem, contact Product Support.

Note When running the Analyze utility, first run it with no switches to find any errors in the database, then with just the –F switch to run in autofix mode.


No more folder entries found

This warning has the following cause and solution:

  • No more folder entries were found. This could indicate database corruption.

    Run the Analyze utility to make sure there are no errors in your VSS database. If running Analyze with the –F switch does not correct the problem, contact Product Support.

Note When running the Analyze utility, first run it with no switches to find any errors in the database, then with just the –F switch to run in autofix mode.


No other user available to copy rights from

The VSS Administrator can copy the rights from one user to another. This error has the following cause and solution:

  • You have attempted to copy rights to the currently selected user. However, there is no other existing user that you can copy rights from. (Note that you cannot copy rights from the Admin user.)

    You can only copy user rights when you have two or more users other than the Admin. If you currently have only one user, you need to assign the rights to this user using the Rights by Project command or the Rights Assignments for User command on the Tools menu.


No search pattern was given

This error has the following cause and solution:

  • You have not entered a string or pattern that VSS can use to search through files.

    Enter a string in the Find In Files dialog box and then click OK, or click Cancel to exit the dialog box and return to VSS Explorer.


No VSS Database (SRCSAFE.INI) found. Use the SSDIR environment variable or run NETSETUP.

See Also

This error has the following cause and solution:

  • The SRCSAFE.INI file is missing. This may be the result of performing a client install, rather than a NETSETUP.

    Either do a NETSETUP or set the SSDIR environment variable.

Setting the SSDIR environment variable tells VSS where to find the SRCSAFE.INI file for the VSS server installation to which you want to connect. Do this by typing the following at the MS-DOS prompt:

set ssdir=\\server\share\vss

Where \\server\share\vss is the folder where the srcsafe.ini file is located.

Note Do not put a space between the equal sign and the location of the VSS server installation. The following will not work: set ssdir= \\server\share\vss.


Only one database connection at a time is supported

This warning has the following cause and solution:

  • When you open a Visual C++ or Visual Basic project that is Source Code Controlled, this warning appears.

    To remedy, disconnect the Visual C++ or Visual Basic project from VSS and reconnect by opening the project via the Visual C++ or Visual Basic project integration.


Out of memory

You do not have sufficient computer memory to perform this operation. This error has the following cause and solution:

  • You have too many applications, documents, or source files open.

    Close any unnecessary applications, documents, or source files that are open.

  • You have loaded too many device drivers.

    Eliminate unnecessary device drivers.


Out of memory - the rights changes could not be saved

You do not have sufficient computer memory to perform this operation. The changes you made to the user's rights have not been saved.

This error has the following causes and solutions:

  • You have too many applications, documents, or source files open.

    Close any unnecessary applications, documents, or source files.

  • You have loaded too many device drivers.

    Eliminate unnecessary device drivers.


Parent <Project> for file <File> (<VSS Database File>) does not exist. The file might be corrupted. This parent will be skipped.

This message has the following cause and solution:

  • While Analyze was processing this file, a record of one of the projects it was shared into, or files it was branched from, could not be found.

    This is an informational message only. No action is necessary.


Parent not found

This error has the following cause and solution:

  • Database corruption is indicated.

    Ask your VSS Administrator to run Analyze.exe to find and correct the problem. If that fails, call Microsoft Technical Support for help with recovering the database.


<Path> is not a complete VSS spec or a fully qualified pathname.

This message appears in the Project Differences dialog box when an invalid file name or VSS project name is specified.


Path <path> does not exist

This error has the following cause and solution:

  • You have attempted to open a file for which the specified path does not exist.

    Check the path and enter it again. Make sure you are on the computer to which the path applies.


Path <path> too long

See Also

The path specified is too long. This error has the following cause and solution:

  • You typed a VSS path that is too long.

    VSS project names are limited to 64 characters. Full project path names can be no longer than 255 characters.


Permission denied

This error has the following cause and solution:

  • You are attempting to take an action that you do not have the proper privileges to execute.

    Talk to your VSS Administrator. If you are the VSS Administrator, run VSS Administrator to check on or change your username, password, and access rights.


Please enter a number between 0 and 32767

This message has the following cause and solution:

  • You have not entered a number of context lines between 0 and 32767.

    Context lines are the lines immediately preceding and following a difference. Showing these lines in a difference display helps you understand the context of the change or difference. If you have checked the Show Context box in the Advanced options of the Show Difference command, you need to specify the number of preceding and following lines to show.


Project <Project> does not exist

This error has the following cause and solution:

  • You are attempting to move a project to a parent project that does not exist.

    Check the path of the parent project and try again. If you are unsure of VSS project syntax, try selecting the parent from the project list in VSS Explorer, and then note the project path displayed above the file list.

Note To move a file or subproject to a new parent, you must have already created the new parent project. Use the Create Project command to create a new project.


Project <Project> does not exist, would you like to create it?

This warning has the following cause and solution:

  • The project specified does not exist, would you like to create it?

    If the project you are trying to work with does exist, click No, then select the project.


Project <Project> has been deleted and must be recovered before opening

See Also

This error has the following cause and solution:

  • You are trying to act on a project that has been deleted. This error will occur in the integration because it can’t connect to the project in VSS (the project was deleted from VSS).

    Before you can do anything with the project, you must recover the project in VSS using the Recover command.

    Use the following steps in the VSS Explorer:

    • Select the parent project that contained the deleted project.

    • On the File menu, click Properties.

    • Click on the Deleted Items tab.

    • Select the deleted project, then click Recover.


Project <Project> has been destroyed, and cannot be rebuilt

See Also

VSS may not be able to reproduce the project version you requested. This error has the following cause and solution:

  • You permanently destroyed a subproject or moved the subproject to another location. For example, there may have been a subproject that you deleted or purged. Later, you attempt to go back to an earlier version of the project. VSS attempts to reconstruct the project exactly as it was in the past, but it cannot, because the subproject cannot be recovered.

    Click Yes, and VSS tries to restore the old project version, but restoration is not guaranteed.

    Click No, and the attempt to restore an old project version is halted.

    Click Yes All, and VSS does not notify you that other selected subprojects may also be unrecoverable, but continues with the best possible reconstruction.


<Project or File> will create too long a file or project name

This warning has the following cause and solution:

  • VSS has a restriction of 259 characters for full project path names and 255 characters for files. Either a project you're trying to create or a file you're attempting to add is greater than this length; it exceeds the restriction.

    Use a shorter file name or rename a parent project to a shorter name.


Purge cannot be undone; information will be lost permanently!

See Also

This warning has the following cause and solution:

  • When you purge a file or project, the action is not reversible.

    Click Yes to continue with the Purge operation. Click No to cancel the operation.

    If you do not want to lose the file or project permanently, use the Delete command instead.

Note If you do not want to receive this message every time you delete a file or project, you can disable it on the Warnings tab in the SourceSafe Options dialog box on the Tools menu.


Redo the automatic merge?

There is no Help for this topic.


Remove <database> from your Database list?

This warning has the following cause and solution:

  • You are deleting a VSS database entry from your Open SourceSafe Database list.

    Click Yes to delete the specified entry, or No to leave the database entry on the list.


Rename does not move an item to another project

See Also

The Rename and Move Project commands cannot be implemented at the same time. This error has the following cause and solution:

  • The VSS Rename command and Move command are separate, distinct operations; you cannot do both in one step.

    First perform one action and then do the other.


Rollback cannot be undone; some versions will be lost irretrievably!

See Also

This warning has the following cause and solution:

  • You are about to roll back a file to an earlier version. The Rollback command is not reversible.

To make the old version the most recent version without losing all the versions in between

  1. Check out the file.

  2. Delete the local copy.

  3. Get the version you want to roll back to.

  4. Check that version into VSS.

Note If you do not want to receive this message every time you roll back a file, you can disable it on the Warnings tab in the SourceSafe Options dialog box on the Tools menu.


Rollback is not allowed before a pinned version

This warning has the following cause and solution:

  • You tried to roll back a file to a version before the one it is pinned to.

    A pinned file cannot be rolled back to a version previous to the version it is pinned to. To roll back the file, unpin it first, then do the rollback.


Running more than one instance of the VSS Explorer or the VSS Administrator is not supported under 16-bit Windows

This error has the following cause and solution:

  • You can run only one version of VSS at a time on a 16-bit platform.

    Do not try to run a second instance of VSS. Running multiple instances of VSS is supported with Microsoft Windows 32-bit platforms.


Save the changes?

Do you want to save changes you've made in the History Details dialog box? Click Yes or No.

Note You can make changes to the label or comment of a project/file from the History Details dialog, as well as navigate to the next or previous versions of the project/file.


Set <Folder> as the default folder for project <Project>?

This warning has the following cause and solution:

  • Do you want to set the specified folder as the working folder for this project?

    Click Yes or No.

    By default, all future VSS operations for this project will use the working folder you specify.


Set <folder> as your personal working folder for the project <Project>?

This message has the following cause and solution:

  • You need to establish a working folder for all of your projects. This message is giving you the option to create the working folder immediately, rather than having to create it later using the Set Working Folder command on the File menu.

    Click Yes to set the working folder for this project. Click No to skip this step for now.


Some conflicts have not been resolved. Would you like to save the file anyway?

This warning has the following cause and solution:

  • Not all conflicts in the merged file have been resolved.

    Click Yes to save the unresolved file, or No to discard your changes and exit.


Source control has been disabled for this application. Please restart the application to use source control.

This message has the following cause and solution:

  • The server connection has been lost, so source control was disabled.

    Once the connection to the VSS database is restored, restart the program you were using integration with (for example, Visual C, Visual Basic, or Visual J) to use source control.


The address <address> is not a valid ftp address

This error has the following cause and solution:

  • You specified an invalid ftp address.

    Type the address again; check the spelling and whether the address is legitimate.


The Admin user currently has no VSS password

This message has the following cause and solution:

  • You have not assigned a password for the Admin user of the Administrator program.

    Assign a password to the Admin user by choosing the Users Change Password command. If you don't do this, any user can log on as Administrator and make changes to your VSS database.


The base URL for this Web project, '<Project>', has bad URL syntax

This error has the following cause and solution:

  • The URL that you entered for the base URL for a VSS Web project has bad URL syntax.

    Valid syntax for the URL is shown in these examples:

    http://www.microsoft.com/default.htm
http://www.microsoft.com

    You can change the URL in the Web Projects tab that is accessed by selecting Options from the Tools menu, or edit the URL in the SRCSAFE.INI file.


The Database <database> does not exist. Please select another

This error has the following cause and solution:

  • You are trying to find a database that does not exist.

    Click the Browse button to look for the correct VSS database, or No to cancel the operation.


The Database <database> does not exist. Would you like to search for it?

This error has the following cause and solution:

  • You are trying to find a database that does not exist.

    Click Yes to browse for the correct VSS database, or No to cancel the operation.


The database is unavailable. Would you like to disable source control integration?

This message has the following cause and solution:

  • The VSS database is unavailable. Click yes to disable source control integration.

    Once the connection to the VSS database is restored, restart the program you were using integration with (for example, Visual C, Visual Basic, or Visual J) to use source control.


The default working folder of the current project as inherited from its parent cannot be used because the path is too long

This error has the following cause and solution:

  • VSS creates working directories for projects by inheriting them from parent projects, then appending on the names of any VSS projects following it. However, if the name inherited from is a long name, the limit of 260 characters may be exceeded.

    Either set a new working directory for the project in use, or edit and shorten the working directory for the project inherited from.


The deploy path <path> is not a proper file system or FTP deploy path

This error has the following cause and solution:

  • One of the paths entered for deploying the project either is not a proper operating system file system path or is not a proper ftp URL.

    Ftp paths can look like one of the following.

    ftp://user:user@www.microsoft.com/ssafe
ftp://user@www.microsoft.com/ssafe
ftp://www.microsoft.com/ssafe

    They always start with "ftp://". They always end with the ftp address (server name and, optionally, directory path). In between, you may have nothing (as in the bottom example above). Or, you may have a username (as in the middle), or a username and password (as on the top).


The editor '<editor>' was not found

This message has the following cause and solution:

  • You have attempted to view or edit a file for which the specified editor could not be found. (Editor associations to file extensions are set on the General Options tab that is accessed by clicking Options on the Tools menu.)

    Click Yes if you would like to specify a different editor. Click No to cancel the editing operation.


The <File> file could not be found. Have your VSS Administrator run the Analyze utility to recreate it.

This error has the following cause and solution:

  • The labels.ini file was missing from the VSS database.

    Ask your VSS Administrator to run either the Analyze utility, or ddupd -redo.


The file <File name> could not be mapped to the VSS project <Project name>. Copy the file to <File name>

The file <File name> could not be mapped to the VSS project <Project name>. Copy the file to <Project name>

This error has the following cause and solution:

  • You added a file from a folder other than your project folder (or one of its subdirectories) and VSS can't determine which project corresponds to your new file's home folder.

    VSS must map the local copy into a VSS project path for this operation to work. Copy the file to a subfolder at or below your IDE project. If the file is already in VSS in a different project, share the file to your current project and try the operation again.

    You will continue to get this message for the file as long as the name cannot be mapped. If this happens, you should remove the file from your project file, copy or share it, and then re-add the file.


The file <File name> could not be mapped to the VSS project <Project name>

This error has the following cause and solution:

  • You must have the file in VSS before continuing the operation.

    Click Yes to copy the file to the specified project and continue.

    Click No to cancel the operation.


The file <File name> exceeds the maximum VSS file name size.

This error has the following cause and solution:

  • You have exceeded the maximum number of filenames in the VSS database.

    Please contact Product Support.


The file <File name> is checked out.

There is no Help for this topic.


The file <File name> is not branched in <Project name>

This error has the following cause and solution:

  • The file you are trying to merge is not branched.

    When a file is branched, and you want to merge the different versions of the file into one combined file, you can use the Merge Branches command. In this case, the file is not branched, so Merge Branches has no effect.


The file <File name> is not checked out.

This warning has the following cause and solution:

  • You have attempted to Check In or Undo Check Out a file that is not currently checked out.

    Click the appropriate option on the warning message.


The file <File name> was moved out of the project, and cannot be rebuilt. Continue anyway?

See Also

VSS may not be able to reproduce the project version you requested. This error has the following cause and solution:

  • A subproject of this project was moved to another location. Later, you attempted to go back to an earlier version of the project. VSS attempts to reconstruct the project exactly as it was in the past, but it cannot, because the subproject cannot be recovered.

    Click Yes, and VSS does its best to restore the old project version, but restoration is not guaranteed.

    Click No, and the attempt to restore an old project version is halted.

    Click Yes All, and VSS does not notify you that other selected files may also be unrecoverable, but continues with the best possible reconstruction.


The File Types string has a maximum length of <Number> characters. It currently has <Number> characters and needs to be shortened.

This error has the following cause and solution:

  • You are adding files types in the File types included in file group on the File Types tab of the Tools-> Options dialog. VSS has a limit of 511 characters for any setting in the SS.INI file and you've exceeded this limit.

    Reduce the number of File Groups or the number of file masks used (in any one of the File Groups you are using) to 511 or less characters.


The filename '<File>' contains illegal characters. The file will be ignored.

This error has the following cause and solution:

  • The filename you've specified contains one or more invalid characters.

    When adding files to VSS, they must meet the following requirements.

    • 255 characters or less in length.

    • The complete path cannot exceed 259 characters, including separators.

    • May not begin or end with a space.

    • May not begin with a $.

    • May contain 1 or more file extensions (e.g., MyFile.Ext1.Ext2.Ext3.Txt).

    • Legal characters from 32-255 characters in length, but not: ?”/\<>*|:


The files are identical

This message has the following cause and solution:

  • The files you have selected, the VSS master copy and the local copy, are identical. You may have selected a file in the file list and tried to run the Show Differences command only on that file, in which case the file is being compared to itself and is by definition identical.

    In this case, before applying the Show Differences command again, specify two distinct files.


The folder <Folder name> is in use.

There is no Help for this topic.


The folder '<folder>' already exists

Each item in a VSS project must have a unique name. This error has the following causes and solution:

  • You have attempted to name a file or an immediate child project with the same name as the project. (An item with that name can exist in other projects in the database, including subprojects.)

  • You are using both a 16-bit version and a 32-bit version of VSS for the same project and file names are not being mapped accurately.

    To resolve this error, give the new item a different, unique file name. Or, you can delete or rename the existing item.

Note File and project names in VSS are not case-sensitive. For example, if you have a file named Test.C, you cannot create a subproject or file named "Test.c" or "test.c" in the same project.


The INI file <File name> still has the version 2.2 format. Please run UPDINI.EXE on this INI file.

There is no Help for this topic.


The label cache file <File> could not be found. Have your VSS Administrator run the Analyze program to recreate it.

This error has the following cause and solution:

  • Either someone intentionally deleted this file, or a machine may have crashed while trying to write it.

    Run Analyze on the database as soon as possible. Do not label any more files or projects, or attempt a get on a label until Analyze is complete.


The labels.ini file could not be properly updated. Have your VSS Administrator run the Analyze utility to recreate it.

This error has the following cause and solution:

  • While trying to keep the labels.ini file up to date, VSS was unable to write to the file. Any attempts to perform a get by label will not see the label until your VSS Admin runs Analyze.

    Ask your VSS Administrator to run the Analyze utility.


The local cache file (vss.ver) does not exist

This error has the following cause and solution:

  • Some features such as checkout local version cannot work if there is no vssver.scc file.

    The next get of any file will create a vssver.scc file.


The output filename begins with a non-alphabetic character. Use '@' to create output file <File name>

The output filename begins with a non-alphabetic character. Use ‘@’ to create output file <File name>

This warning has the following cause and solution:

  • VSS has the ability to output command line commands to a file with the use of the –O switch. In this case, the output file used begins with an illegal character.

    Rerun the command using a legal filename for the output file.


The passwords do not match

This error has the following cause and solution:

  • The password you entered for the user did not match.

    When changing a password for a user, you must type the new password twice to guard against typing errors. In this case, the passwords you typed did not match. Try typing them again.


The passwords don't match

This error has the following cause and solution:

  • The password you typed in the Password box does not match the one typed in the Verify box.

    If the passwords you type are identical, VSS assumes you typed them correctly, and changes your password. If you type two different passwords, VSS assumes that you entered an incorrect password.


The project <Project name> was not found. Would you like to browse for the project?

VSS tried to open a project that could not be found in your VSS database. This error has the following cause and solution:

  • You moved or renamed the VSS project in VSS Explorer, then opened your Visual Basic or Visual C++ project that refers to the old VSS project name.

    Click Yes to browse for the project if you know the name of the new project.

    Click No if you don't want the project to be under source code control. If you click No, you must manually re-add the project to VSS in order to use source code control features in the future.


The revision <Revision number> has no changes. Include it anyway?

There is no Help for this topic.


The source code control add in could not connect to Visual Basic

This error has the following cause and solution:

  • The source code control add in could not connect to Visual Basic.

    Please contact Product Support.


The URL <URL> does not have proper HTTP URL syntax

This error has the following cause and solution:

  • The URL that you entered has bad URL syntax.

    Valid syntax for the URL is shown in these examples:

    http://www.microsoft.com/default.htm
http://www.microsoft.com


The URL for project <Project> was not set properly

This error has the following cause and solution:

  • You set a bad URL path for a Web project, or the URL uses a syntax that VSS does not understand (for instance, it might use www.microsoft.com/... instead of http://www.microsoft.com/...).

    Use the Administrator program to set a proper URL.


The user's password has been successfully changed.

You have successfully changed the password of this user.


The version specified in From should come before the version specified in To

The dates specified in the From: and To: fields in the Project History Options dialog box are out of order. The date in the From: field needs to be chronologically earlier than the date listed in the To: field.


The VSS database has been locked by the Administrator

This message has the following cause and solution:

  • You are attempting to access a database that has been locked by the Administrator.

    Your Administrator may be running Analyze to repair the database, or they could be archiving data. Remind your Administrator to unlock the database when they complete their tasks.


The VSS database path <path> does not exist. Please select another database.

This error has the following cause and solution:

  • The VSS database path does not exist. The entry for Data_Path in the SRCSAFE.INI file is invalid.

    Ask your VSS Administrator to check the VSS database path in the SRCSAFE.INI file.


The VSS Explorer could not be run

The VSS Explorer could not be run.

It's possible there is an incorrect pointer to the VSS program location. Please contact Product Support.


The wildcard mask <mask>, is not allowed by this command.

There is no Help for this topic.


There are no deleted items in this project

This error has the following cause and solution:

  • There are no items in this project that have been deleted.

    Because no files have been deleted from this project, there are no files that you can recover or purge.


There are no items in the list

This error has the following cause and solution:

  • You specified a history operation where no items met the specified criteria.

    Examine the check boxes in the History Options dialog box, and make sure they are set correctly.


This command cannot complete without a specified working folder

This error has the following cause and solution:

  • You selected a command that requires a working folder, without having set a working folder.

    Click OK to set a working folder for the current project now, or Cancel to cancel the command. You can also set a working folder at any time by selecting the project and then the Set Working Folder command from the File menu.


This command only works on files

This command can operate only on files. This error has the following cause and solution:

  • You are attempting to perform a file operation (such as using the View command) on a project.

    Select the proper command, or select a file that works with the command you've chosen.


This command only works on projects

This command can operate only on projects. This error has the following cause and solution:

  • You are attempting to perform a project operation (such as the Move Project command) on a file.

    Select the proper command, or select a project that works with the command you've chosen.


This command operates on only one item

For many VSS dialog box lists, you can select more than one item at once, and then act on all the items together. However, some actions cannot operate on more than one item at a time. This error has the following cause and solution:

  • You selected more than one item and then applied a command that operates on only one item at a time. For example, you may have tried to use the View command, which works with one file at a time.

    Press the space bar on an item to make it the only item selected in the list.


This command operates only on files, not on projects (like <Project>)

This command operates only on files. This error has the following cause and solution:

  • You attempted to execute the command on a project.

    In the VSS Explorer, select a file in the file list, then try the command again.


This command operates only on projects, not on files (like <File>)

This command operates only on projects. This error has the following cause and solution:

  • You attempted to execute the command on a file.

    In the VSS Explorer, select a project in the project list, then try the command again.


This command requires Internet components which are not installed on your machine

This error has the following causes and solution:

  • You tried to use the Check Web Links command on a RISC platform, but there wasn't a WinINET.dll to distribute when we shipped VSS. You can get this required DLL when a RISC version of the browser exists.

  • You are missing the correct version of WinINET.dll on your Intel or Alpha computer. Check to see if the file has been moved or renamed.

    To make sure you have the latest Internet components, go to http://www.microsoft.com/ie/ and download Microsoft Internet Explorer version 3.0 or later. Then restart VSS to enable this command.


This Database does not have a name. Please ask your Administrator to name it first.

This error has the following cause and solution:

  • The database does not have a name. The entry for Database_Name in the SRCSAFE.INI file is missing.

    Ask your VSS Administrator to name the database.


This is an inherited label. Changing this label will affect all projects and files below <Project Name>. Save changes?

Changing an inherited label of a project will recursively apply the change to any subprojects or child files of the project. Since this affects the projects and its children recursively, VSS prompts you to save the changes before it completes the action. Click Yes or No.


This is an integration only project. Checking in files is not allowed from the VSS Explorer.

This error has the following cause and solution:

  • Either you are attempting to Check In a Microsoft Access object in the Microsoft VSS Explorer, or the Disable_UI entry has been manually added to the SRCSAFE.INI.

    The VSS Integration Component of Microsoft Access adds a setting to the SRCSAFE.INI file when you add a Microsoft Access database to the VSS server database. This entry flags the files in the VSS database as belonging to a Microsoft Access database integration project, and it looks similar to this:

      [$/Northwind]
      Disable_UI = Yes

This .ini file entry prevents you from using the VSS Explorer to check out the Microsoft Access database files. This is by design because the files are textual representations of Microsoft Access objects that you should only manipulate in the context of a Microsoft Access project.

In some cases, it may be necessary to perform operations on Microsoft Access objects or other files from within the VSS Explorer. If so, close VSS Explorer, remove or remark the Disable_UI line in the SRCSAFE.INI file, and then reopen VSS Explorer. Then you will be able to perform the desired operation from VSS Explorer.

Note that when you reopen the Microsoft Access database, the VSS Integration Component (ACCSCC) adds the Disable_UI = Yes line back to the SRCSAFE.INI file. You can also add the line back to the file yourself.


This is an integration only project. Checking out files is not allowed from the VSS Explorer.

This error has the following cause and solution:

  • Either you are attempting to Check Out a Microsoft Access object in the Microsoft VSS Explorer, or the Disable_UI entry has been manually added to the SRCSAFE.INI.

    The VSS Integration Component of Microsoft Access adds a setting to the SRCSAFE.INI file when you add a Microsoft Access database to the VSS server database. This entry flags the files in the VSS database as belonging to a Microsoft Access database integration project, and it looks similar to this:

      [$/Northwind]
      Disable_UI = Yes

This .INI file entry prevents you from using the VSS Explorer to check out the Microsoft Access database files. This is by design because the files are textual representations of Microsoft Access objects that you should only manipulate in the context of a Microsoft Access project.

In some cases, it may be necessary to perform operations on Microsoft Access objects or other files from within the VSS Explorer. If so, close VSS Explorer, remove or remark the Disable_UI line in the SRCSAFE.INI file, and then reopen VSS Explorer. Then you will be able to perform the desired operation from VSS Explorer.

Note that when you reopen the Microsoft Access database, the VSS Integration Component (ACCSCC) adds the Disable_UI = Yes line back to the SRCSAFE.INI file. You can also add the line back to the file yourself.


This is an integration only project. Getting files is not allowed from the VSS Explorer.

This error has the following cause and solution:

  • Either you are attempting to Get a Microsoft Access object in the Microsoft VSS Explorer, or the Disable_UI entry has been manually added to the SRCSAFE.INI.

    The VSS Integration Component of Microsoft Access adds a setting to the SRCSAFE.INI file when you add a Microsoft Access database to the VSS server database. This entry flags the files in the VSS database as belonging to a Microsoft Access database integration project, and it looks similar to this:

      [$/Northwind]
      Disable_UI = Yes
  • This .INI file entry prevents you from using the VSS Explorer to check out the Microsoft Access database files. This is by design because the files are textual representations of Microsoft Access objects that you should only manipulate in the context of a Microsoft Access project.

    In some cases, it may be necessary to perform operations on Microsoft Access objects or other files from within the VSS Explorer. If so, close VSS Explorer, remove or remark the Disable_UI line in the SRCSAFE.INI file, and then reopen VSS Explorer. Then you will be able to perform the desired operation from VSS Explorer.

    Note that when you reopen the Microsoft Access database, the VSS Integration Component (ACCSCC) adds the Disable_UI = Yes line back to the SRCSAFE.INI file. You can also add the line back to the file yourself.


This is an integration only project. This operation is not valid from the VSS Explorer.

This message has the following cause and solution:

  • You are attempting an operation on a Microsoft Access object in the Microsoft VSS Explorer.

    The VSS Integration Component of Microsoft Access adds a setting to the SRCSAFE.INI file when you add a Microsoft Access database to the VSS server database. This entry flags the files in the VSS database as belonging to a Microsoft Access database integration project, and it looks similar to this:

      [$/Northwind]
      Disable_UI = Yes

This .INI file entry prevents you from using the VSS Explorer to check out the Microsoft Access database files. This is by design because the files are textual representations of Microsoft Access objects that you should only manipulate in the context of a Microsoft Access project.

In some cases, it may be necessary to perform operations on Microsoft Access objects from within the VSS Explorer. If so, close VSS Explorer, remove or remark the Disable_UI line in the SRCSAFE.INI file, and then reopen VSS Explorer. Then you will be able to perform the desired operation from VSS Explorer.

Note that when you reopen the Microsoft Access database, the VSS Integration Component (ACCSCC) adds the Disable_UI = Yes line back to the SRCSAFE.INI file. You can also add the line back to the file yourself.


This is an integration only project. Undoing checkout of files is not allowed from the VSS Explorer.

  • Either you are attempting to Undo Check Out of a Microsoft Access object in the Microsoft VSS Explorer, or the Disable_UI entry has been manually added to the SRCSAFE.INI.

    The VSS Integration Component of Microsoft Access adds a setting to the SRCSAFE.INI file when you add a Microsoft Access database to the VSS server database. This entry flags the files in the VSS database as belonging to a Microsoft Access database integration project, and it looks similar to this:

      [$/Northwind]
      Disable_UI = Yes

This .INI file entry prevents you from using the VSS Explorer to check out the Microsoft Access database files. This is by design because the files are textual representations of Microsoft Access objects that you should only manipulate in the context of a Microsoft Access project.

In some cases, it may be necessary to perform operations on Microsoft Access objects or other files from within the VSS Explorer. If so, close VSS Explorer, remove or remark the Disable_UI line in the SRCSAFE.INI file, and then reopen VSS Explorer. Then you will be able to perform the desired operation from VSS Explorer.

Note that when you reopen the Microsoft Access database, the VSS Integration Component (ACCSCC) adds the Disable_UI = Yes line back to the SRCSAFE.INI file. You can also add the line back to the file yourself.


This label <label> is already used. Remove the old label?

A VSS label is used to identify a particular version of a file or project. This error has the following cause and solution:

  • You are attempting to assign a label to a file or project, and another version of that file or project has the same label.

    Click Yes to apply the new label and delete the old label. Click No to leave the old label unchanged. Click Cancel to cancel the labeling operation.


This label <label> is used by a previous version of <File or Project>. Remove the old label?

A VSS label is used to identify a particular version of a file or project.

This error has the following cause and solution:

  • You are attempting to assign a label to a file or project, and another version of that file or project has the same label.

    Click Yes to apply the new label and replace the old label.

    Click No to cancel the action; the old label will remain.

    Click Cancel to cancel the labeling operation.


This version of <File or Project> already has a label. Overwrite with new label?

Any version of a VSS file or project can have a label, which is used to identify that version.

This error has the following cause and solution:

  • One version of a file or project cannot have more than one label. Therefore, when you attempt to label a version that already has a label, VSS displays this message.

    Click Yes to apply the new label and replace the old label.

    Click No to cancel the action; the old label will remain.


This version of <name> already has a label: overwrite?

Any version of a VSS file or project can have a label, which is used to identify that version. This error has the following cause and solution:

  • One version of a file or project cannot have more than one label. Therefore, when you attempt to label a version that already has a label, VSS displays this message.

    Click Yes to apply the new label and replace the old label. Click No to cancel the action and leave the old label in place.


This VSS database has no UUID

There is no Help for this topic.


This will end your VSS session

This message has the following cause and solution:

  • You are about to exit VSS.

    Click OK to exit VSS, or click Cancel to return to VSS.

Note If you do not want to receive this message every time you exit, you can disable it on the Warnings tab in the SourceSafe Options dialog box on the Tools menu.


Timeout locking file: <File name>

This warning has the following causes and solution:

  • VSS can be set up to use its own form of file locking. This has to be set by the VSS Administrator in the SRCSAFE.INI file. This error indicates a lock file (.LCK extension) exists in the \DATA\LOCKS folder. This situation occurs under either of the following circumstances:
    • A user has a file locked. For example, a file is locked while it is updated.

    • A VSS lock file has not been deleted from the \DATA\LOCKS folder.

    • A \DATA\LOCKS folder doesn’t exist.

    If a user has a lock on a file then, just retry the command in a few minutes.

    If the lock hasn’t been deleted from the \DATA\LOCKS folder, go there and delete the .LCK file, however, please make sure everyone is out of VSS before deleting .LCK files or you may affect another users process.

    If this warning appears when you log in to VSS, check to see if a \DATA\LOCKS folder exists. If it doesn’t, create one and attempt to log in again.


Too many file handles open

This error has the following cause and solution:

  • There are too many files open on your system.

    You may want to check whether any of the files can be closed, or you may want to increase the Files count in your operating system's initialization file.


Too many SS.INI environment strings

This warning has the following cause and solution:

  • VSS stores many configurations in a SS.INI file that is individualized for each user. For each INI file setting, VSS will store an environment string. This is typically the name of the computer when this setting was made. This usually occurs because of the ‘Dir (<environment string>) = <Some local folder>’ INI file setting. VSS allows around 25 unique environment strings.

    Manually edit the \USERS\<Username>\SS.INI file for the user who gets this message. Delete any unused INI file settings that have multiple environment strings.

    If you count the number of times you receive this message, it indicates the number of environment strings that need to be removed. If you get this upon start up, it will tell you what lines contain the excessive environment strings.


<Type> is not a valid mask

This error has the following cause and solution:

  • You specified an invalid mask in the File Types tab in the Options dialog box on the Tools menu.

    You must specify a * or ? character in your file mask, and you cannot have any illegal characters such as (, ), [, or ] in the mask.

    Retype the file mask using legal characters.


Unable to deploy <Project> to the ftp host <host>

This error has the following cause and solution:

  • VSS was unable to open a connection to the specified ftp host and deploy your project.

    Check your network connections, and check to be sure you entered the correct syntax for your ftp host. This error could also occur if your ftp host is not available at this time.


Unable to launch the Web browser for page <File>

This error has the following cause and solution:

  • VSS was unable to start your Web browser.

    Check that your Web browser is functioning normally. You may need to install the browser again to verify your registry settings.


Unable to load the HTML parser

This error has the following cause and solution:

  • You have a corrupted VSS installation. Either the DLL is gone or the registry isn't set to the right DLL.

    Install VSS again.


Unable to open a connection to the ftp host <host>

This error has the following cause and solution:

  • VSS was unable to open a connection to the specified ftp host.

    Check your network connections, and whether or not you entered the correct syntax for your ftp host. This error could be caused if your ftp host is not available at this time.


Unable to open user login file <path to login file>

This warning has the following cause and solution:

  • The user does not have Write access to the VSS database.

    Grant the user full rights to the VSS directory and all its subdirectories.

    All VSS users must have the ability to read, write, create and erase files in the VSS directory and all subdirectories.


Unable to rename <item> to <item>

See Also

VSS was unable to rename the item. Please verify that the name specified is a valid name.


Unable to rename the selected file

The file you have selected is in a state where it cannot be renamed. For example, if a file is checked out, it cannot be renamed.


Unknown automation error

There is no Help for this topic.


Unknown Error - 20038

If you are in the middle of a VSS session and lose your connection to a server over the network, the only message you see is a numerical message informing you of an unknown error. When you see, "unknown error - 20038," or something similar, you have lost your network connection. Restart VSS and continue your work.


Use <File> originally checked out to <Local Folder>? (Y/N)

This warning has the following cause and solution:

  • From the command line, you are attempting to check in a file that is multiply checked out to you. VSS is asking you to confirm which checkout to check in.

    Type Y if the indicated local folder location is correct. The check in will be performed.

    Type N if the indicated local folder location is not correct. VSS will repeat this message for each checkout record for the file.


User <user> already exists

This error has the following cause and solution:

  • You attempted to add a user with a username that already exists. You may want to choose another name; for instance, if there is already a Joyce, add JoyceF.

Note Names are not case-sensitive, so if you already have a Joyce, adding JOYCE generates this error.


User <user> not found

This error has the following cause and solution:

  • Your username was not found.

    Talk to your VSS Administrator. If you are the VSS Administrator, run VSS Administrator to add your username.


Username too long

User names cannot be more than 31 characters long.


Using Win 95 you cannot add multiple files from a UNC path that is not mapped to a drive letter

When trying to add multiple files to VSS you must map a drive letter to the remote location you wish to use.


Version not found

See Also

The version specified cannot be found. This error has the following causes and solutions:

  • You specified a version that does not exist.

    In VSS, click the Show History command on the Tools menu, and then select a version from within the History of File dialog box.

  • If you are using VSS from the command line, you may not be using the -V switch properly.

    Search online Help for more information on using the parameter correctly (click the Contents button).


Version <NUMBER> is identical to version <NUMBER> of <File>

This error has the following cause and solution:

  • The two versions you are comparing are identical.

    Check to make sure that the two versions are the ones you want to compare.


Version <number> to <number> of <item> are in <archive file>. No action taken.

This error has the following cause and solution:

  • You are attempting to remove a version range which VSS cannot locate (perhaps it has already been archived).

    Determine the valid version range, then archive that.


VSS cannot find a default database. Would you like to select one?

This error has the following cause and solution:

  • VSS is trying to find a default database that does not exist.

    Click Yes to browse for the correct VSS database, or No to cancel the operation.


<VSS File> (<database file>) is a branch parent for a file which is not being archived. No versions deleted.

This message has the following cause and solution:

  • This is an informational message only, generated while performing an Archive. Archive did not delete a file you asked it to, because it contains a portion of history for a file which is branched elsewhere and still active.

    If you need to delete the file, you'll need to track down all branches of the file (via the Paths tab on the Properties dialog box), then tell Archive to delete all branches of the file, too.


Warning: If you do not use a password, others will be able to log into this VSS account. Proceed with no password?

This warning has the following cause and solution:

  • You attempted to log on without specifying a password.

    This is an informational warning to make sure you want to proceed without setting a password on your account. Click Yes to log on, or No to cancel.


Warning: the Rollback command will branch this file, breaking its link to other projects that share it

This warning has the following cause and solution:

  • This warning occurs when you roll back a file that has been branched or is pinned in another project.

    Click Yes to continue, or No to cancel.


You already have file <File> checked out to another location. Do you want to continue?

This warning has the following cause and solution:

  • The file you selected for check out is already checked out by you in a different location.

    Either cancel the check out, or check out the file to a new location.


You are about to remove the Admin user's VSS password, which will allow any user to run the Administrator's program

This warning has the following cause and solution:

  • You are deleting the Admin user's password.

    Leaving the Admin user with no password is a security risk, because any user can then log into the Administrator program and make changes to your VSS database. Click Yes to continue, or No to cancel the operation.


You are only allowed one folder for this command. <Folder> is not allowed.

This warning has the following cause and solution:

  • Certain VSS commands can only accept one folder at a time. An example of this is the ss workfold command.

    Use only one folder when using this command.


You are only allowed one project for this command. <Project> is not allowed.

This warning has the following cause and solution:

  • Certain VSS commands can only happen in one project at a time. Some of the commands that require this are ss share and ss project.

    Run the command multiple times, indicating just a single project each time.


You are only allowed one relative path for this command. <Folder> must be a full path.

This warning has the following cause and solution:

  • Certain VSS commands can only accept one relative path at a time. An example of this is the ss workfold command.

    Use only one folder when using this command and identify a full path.


You are using an old version of <File>, and cannot change it. Rollback to make that version the most recent if you need to change it

See Also

This error has the following cause and solution:

  • You tried to modify an old version of a file.

    If you want a project to always use a specific version, and not receive checked-in changes made in other projects, you can share a specific version of the file using the Pin command in the History of File dialog box.

    If you want to start modifying the file from an old version, you can roll back the file. The Rollback command only affects the current project; it performs an implicit separate operation. Both branching and rollbacks are available from the History of File dialog box.


You can only share one project at a time

This error has the following cause and solution:

  • The VSS command line share command can only use one project as a parameter. You have indicated more than one project in the ss share command.

    Run the ss share <Project> command once for each project you want to share. You may want to consider using the –R command line switch to recursively share projects.


You cannot add the root folder <folder>

This error has the following cause and solution:

  • In the Add File dialog, you have attempted to add a root folder (e.g., “d:\”). VSS does not allow adding root folders.

    Select and add a file or a folder that is not a root folder.


You cannot change the Admin name or access privileges

This error has the following cause and solution:

  • You have attempted to change the Admin user's name or access privileges.

    The Admin user's name and access rights cannot be changed. Select another user on which to use this command.


You cannot merge a branch with itself

This warning has the following cause and solution:

  • VSS can merge the changes in two files that came from a common ancestor file. However, you cannot merge a file into itself.

    Select one of the other projects the file is branched to. To view the branches, see the File, Properties menu, Paths tab.


You cannot modify the properties of a file that's checked out

See Also

This warning has the following cause and solution:

  • You were attempting to change one of the properties of a file that's checked out from the command line. This message is usually accompanied by an additional message informing you who has the file checked out.

    Identify who has the file checked out with the ss status <filename> command, then have them check in the file. Now you can rerun the ss properties command.


You cannot perform a merge on a binary file, or a file that stores latest version only

This error has the following cause and solution:

  • VSS can only merge text files that come from a common ancestor version. The selected file is either a binary file or is set to store only the latest version. If it is set to store only latest version then VSS can’t determine what the ancestor file looked like and therefore can’t merge the files.

    Choose a text file that stores more than one version.


You cannot set the Store Latest Version flag for the file <File name> because it is pinned to an explicit version.

This warning has the following cause and solution:

  • You were attempting to change the Store only latest version property of a file that is pinned.

    Find out what version the file is pinned to by using the ss dir <File Name> command. Then use the ss unpin <File name> command to unpin the file. At this point you will be able to use the ss properties –L <File Name> command to change the Store only latest version property. Then pin the file to the version it was originally pinned to.


You cannot share a project under itself

This error has the following cause and solution:

  • To prevent confusion, VSS will not allow a project to be shared recursively to itself. You are attempting to share a project at the command line and are currently in that project.

    Use the ss cp command to change your current project to a project other than the one you are trying to share. Or select a different project to share.


You cannot use wildcards with this command

Many VSS commands accept wildcard characters, such as * and ?. But some commands, such as the View command, can operate on only one item at a time. This error has the following cause and solution:

  • The command you have chosen does not accept wildcard characters.

    Use an explicit file name, with no wildcard characters.


You currently have file <File> checked out

See Also

This warning has the following cause and solution:

  • From the command line, you are attempting to check out a file you already have checked out. This message will only appear if Multiple Checkouts is turned off.

    If you want to check out the file a second time, you will have to get the VSS Administrator to enable Multiple Checkouts. Otherwise, check in the file before you attempt to check it out again.


You currently have file <File> checked out

You can only check out a file once per user, per machine. You must login as another user or check the file out from another machine.


You currently have file <File> checked out. Delete anyway?

This warning has the following solution:

When you have a file checked out, there are some things you shouldn't do. For instance, you should not delete or rename a file that is checked out.

  • Click Yes to delete the file anyway. (Yes All deletes all checked out files even if they are already checked out by another user.).

  • Click No to cancel the Delete command. (No All cancels the command for all selected files.)

  • Click Cancel to abort the delete operation.

    If you want delete the file, it is a better practice to either check in your changes or to do an undo checkout on the file first.


You do not have access rights to <command name>

This error has the following cause and solution:

  • Your VSS access rights are insufficient for the command you are attempting to execute. For example, if you are a read-only user, you can use the Get Latest Version command to view files, but you cannot use the Check Out command to modify them.

    If you believe you have received this message in error, contact your VSS Administrator.


You do not have destroy rights to <item>

This error has the following cause and solution:

  • You've tried to destroy something without the proper permissions (destroy rights).

    Ask your VSS Administrator to set you up with destroy rights, or abandon the attempt to destroy.


You do not have file <File name> currently checked out

This warning has the following cause and solution:

  • You are attempting to check in or undo checkout on a file that you don't have checked out. The file may be checked out by another user.

    Identify who, if anyone, has the file checked out and have them perform the Check In or Undo Check Out command. If you can't find the individual, the Admin user can check in files another user has checked out.

    To identify who has a file checked out, view the Check Out Status tab on the file properties dialog or use the ss status command.


You have <File> checked out; deleting it will cancel the check out

This warning has the following cause and solution:

  • You are attempting to delete a file checked out to you.

    If the file name is correct, click Yes to proceed. To cancel the delete operation, click No.


You have <number> days remaining in your free VSS trial

To order Microsoft VSS or obtain a reseller referral in the United States or Canada, call 1-800-621-7930. Outside the United States and Canada, please contact your local Microsoft subsidiary.


You must enter a filename with no path for the Site map

This error has the following cause and solution:

  • You specified a file path for the Site map file, which is not allowed. The Site map file specification does not accept a path.

    Enter just the file name, such as Sitemap.htm.


You must specify a new name

This error has the following cause and solution:

  • You are attempting to rename a file or project without specifying a new name for it.

    Either specify a new name and then click OK, or press the ESC to cancel the rename operation.


You must type more letters than <what you've already typed> to uniquely identify a command

You must type more letters than <what you’ve already typed> to uniquely identify a command

See Also

This error has the following cause and solution:

  • The VSS command line does accept abbreviated versions of its commands. However, the command line has to be able to distinguish which command you are attempting to use. You've used too few of letters.

    Use more letters in the command to uniquely distinguish it from other commands. Three letters should be sufficient for uniquely identifying a command. However, ‘check’ will be interpreted as checkout not checkin.


Your free VSS trial expired 30+ days ago

Some VSS functionality has been disabled.

To comply with your license agreement and restore full VSS functionality, you must order a license.

To order Microsoft VSS or to receive a reseller referral in the United States or Canada, call 1-800-621-7930. Outside the United States and Canada, please contact your local Microsoft subsidiary.

If you choose not to order a licensed version of VSS, you must completely de-install VSS as you are in violation of your evaluation license agreement.


Your free VSS trial has expired!

To continue using Microsoft VSS, you must order a licensed copy. To order VSS or to receive a reseller referral, in the United States or Canada, call 1-800-621-7930. Outside the United States and Canada, please contact your local Microsoft subsidiary.

If you choose not to order a licensed version of VSS, you must completely de-install VSS as you are in violation of your evaluation license agreement.


Your password has been successfully changed

Your password has been changed. When starting a new session of VSS or using the command line, you'll need to use the new password.


Your working folder contains a writable copy of <File>

This error has the following cause and solution:

  • You have a writeable file on your disk not checked out to you, and you've done a Get.

    Select one of the options presented. Either leave the file, replace the file, check out while keeping the changes, or cancel the get.


Your working folder contains a writable copy of an old version of <File>

This error has the following cause and solution:

  • You have a writeable file on your disk not checked out to you, and you've done a Get.

    Select one of the options presented. Either leave the file, replace it, check out the old version while keeping the changes, check out the old version while merging the changes, or cancel the get.


Error executing: <Program>

There is no Help for this topic.


Add Files Command (File Menu)

See Also

Copies a file, or group of files, into the current VSS project. In the Add Files dialog box, you can specify a file on any drive and folder, and that file is copied into the current VSS project.

Access Rights

You must have the Add access right to use this command.

Remarks

You can use the Purge command to undo an Add Files operation, but it is not recommended because it does not retain a recoverable copy of the file in the VSS database. Instead, consider using the Delete command, because it retains a recoverable copy of the file.

Dialog Box Options

File Name

Select or type the name of a file you want to open. This box lists items with the file name extension selected in the List Files of Type box.

List Files of Type

Lists the file type, or tells VSS how to classify a file.

The list of file types available is determined by the File Types Included In File Group filter and the File Groups filter set on the File Types tab in the SourceSafe Options dialog box. All Files (*.*) lists all files in the current folder.

Folders

Specifies the folder that contains the file you want to add.

Drives

Selects the drive that contains the file you want to add.

Close

Closes the dialog box without adding the file to the project.

Add

Opens the Advanced Comment dialog box allowing you to add the selected file(s) or folder to the selected project. The Advanced Comment dialog box displays a comment box in which you can enter comments (optional). Select the Apply same comment for all box to use the same comment for all the files you are adding. Click Advanced from the Advanced Comment dialog box for more options.

View

Displays the selected file with the View File command.

Apply same comment for all

Uses the same comment for all files involved in the Add Files operation. If this check box is cleared, you can enter a separate comment for each file. The default is selected (your comment is applied to all files selected for this operation).

Recursive

Indicates you want files in all subfolders added when you select an entire folder to add. Available only when you select a folder and then click Add.

Advanced Options

Store Only Latest Version

Indicates you do not want to save old versions of the file(s) being added to the VSS database. VSS keeps a file history of change records with comments. However, the older versions of the file are not stored, and you cannot recover them.

Note To increase performance and save disk space, use this option when storing executable programs in VSS.

Check Out Immediately

Checks out the file to you immediately after adding it to VSS.

Remove Local Copy

Deletes the file from your working folder after adding it to VSS.

File Type

Select an option from the list box:

  • AutoDetect [image] VSS determines the file type.

  • Binary [image] VSS treats the file as a binary file.

  • Text [image] VSS treats the file as a text file.

Note When you are adding a folder, the File Types field is ignored. However, the files added during a folder Add Files operation are filtered by the Relevant_Masks setting on the File Types tab in the SourceSafe Options dialog box.


Branch Command (SourceSafe Menu)

See Also

Breaks a share link while retaining a copy of the file.

Note In earlier versions of VSS, this command was called Separate.

Access Rights

You must have the Add access right to use this command.

Remarks

A single file can be shared by multiple projects. Any change made to that file is reflected in all the projects that share it so that, for example, the propagation of bug fixes is handled by VSS.

After you apply the Branch command to the file, two separate branches of the file exist in different projects. You can track the different branches on the Paths tab in the Properties dialog box, and bring them back together with the Merge Branches command.

Dialog Box Options

Comment

Type a comment describing the branching.

OK

Confirms the Branch command.

Cancel

Cancels the Branch command.


Cancel Search Command (View Menu)

See Also

Restores the full file list in VSS Explorer for the current project. This command is used after a search operation, which usually filters the file list to a smaller subset.

Access Rights

Any VSS user can use this command.

Remarks

When you execute the Search command, VSS displays the word Search in the status bar. Click the Cancel Search command to return to the full VSS Explorer file display. The word Search disappears from the status bar.


Change Password Command (Tools Menu)

See Also

Sets the password for the current user.

Access Rights

Any VSS user can use this command.

Remarks

Use the Change Password command to set your password. After you change it, your old password no longer works, and you have to type the new one each time you log on to VSS.

To change your password, you must first know what it is. If you forget your password, ask your VSS administrator to change it for you.

Note Keep in mind that the VSS password is not meant to replace or augment your operating system or network operating system password. Only when the operating system does not allow VSS to determine user identity does VSS ask for the VSS password when you log on. Your VSS password can be the same as or different from your operating system password.

Dialog Box Options

Old Password

Type the current password, or leave blank if the password is blank (a zero-length string).

New Password

Type the new password.

A password can consist of any combination of 1 to 15 valid characters. As you type, the characters are displayed as asterisks. Microsoft VSS passwords are not case-sensitive.

Verify

Retype the new password to verify it.


Check In Command (SourceSafe Menu)

See Also

Updates VSS with changes made to a checked-out file, and unlocks the VSS master copy.

Note In earlier versions of VSS, this command was called Update.

Access Rights

You must have the Check Out access right to use this command.

Remarks

There are two commands you can use to end the check out of a file:

  • The Check In command copies your changes into the VSS database, creating a new version of the file. When other users use the Get Latest Version command or check out the file, they receive all the modifications you have made.

  • The Undo Check Out command voids all your changes and undoes your check out of the file.

When you check in a file, VSS provides a box in which you can enter a comment.

Note To update the master copy of a file while keeping the file checked out, select the Keep Checked Out check box. You can make this the default behavior by selecting the Always Keep Files Checked Out check box on the General tab in the SourceSafe Options dialog box.

You can check in a file that has not changed at all, but still add the unchanged file as a new version to the file history. VSS prompts you in this case to see if you want to perform a checkin operation. If you click No, VSS executes the Undo Check Out command, and no new version is added to the file list.

Note To avoid this message on future occasions, you can disable this notification on the General tab in the SourceSafe Options dialog box on the Tools menu.

Check In from Multiple Check Outs

In a multiple check out situation, when you are the first user to check the file into VSS, your version of the file becomes the latest version. However, if you are a subsequent user to check in the file, VSS performs an automatic merge, creating a new file as the latest version in VSS.

VSS informs you that a merge took place. You can check the file in immediately or keep the merged file in your working folder and review it before returning it to VSS. If there are merge conflicts, you cannot check in the file until you resolve the conflicts.

Dialog Box Options

Comment

Type an optional comment. Comments are limited to 4095 characters.

Keep Checked Out

Updates the master copy with your changes but keeps the file checked out to you.

Remove Local Copy

Removes the local copy from your working folder.

OK

Confirms the selection.

Cancel

Cancels the selection.

Diff

Compares the file you want to check in with the VSS master copy and displays the differences. This feature is useful if you want to enter a meaningful comment when you check in the file.

Recursive (project-level Check In only)

Indicates you want files in all subfolders added when you select an entire project to check in.

Override Working Folders (project-level Check In only)

Overrides the working folder set for the subprojects involved in a recursive operation. This is useful if you have some shared files checked out in more than one project, and want to check them all in at the same time. Available only when you select the Recursive check box.


Check Out Command (SourceSafe Menu)

See Also

Copies the latest version of one or more selected files from the current project into your current working folder.

Access Rights

You must have the Check Out access right to use this command. You should have a working folder set before using this command.

Remarks

The Check Out command retrieves writable files from VSS and places them in your working folder, so that you can modify them. VSS lists the file as checked out in VSS Explorer.

Note There is an important difference between the Check Out and Get Latest Version commands. The Get Latest Version command places a read-only local copy of a file in your working folder. Check Out places a writable copy of the file in your working folder.

To return the file to VSS, you can use the Check In command to confirm your changes and copy your local, modified file into the VSS database.

Note You can also use the Undo Check Out command. Undo Check Out does not update VSS. Instead, it copies the most recent version of the file in VSS over your local copy, so all the changes made to the local copy since you last checked out the file are lost. In addition, the Undo Check Out command cancels your check out and removes the writable version of the file from your working folder. To display a dialog box when you use the Undo Check Out command, use the Command Dialogs tab in the SourceSafe Options dialog box on the Tools menu.

Generally, only one user can have a file checked out for modification at one time. However, if your VSS administrator allows multiple check outs, many users can check out the same file at the same time. When the first user checks the file into VSS, that file becomes the current version. When subsequent users check in their local copies, their changes are merged into the file and a new VSS version is created. Binary format files cannot be checked out by more than one person at a time.

You can also check items out exclusively [image] that is, check them out so that no one else can check them out while you have the file or project checked out. Your VSS administrator can set an administrative option to disable multiple check outs for an entire project all the time, or you can clear the Allow Multiple Checkouts advanced option check box from the Check Out command dialog box to exclusively check the file out on a file-by-file and session-by-session basis.

Dialog Box Options

If you have the file-level Check Out check box selected on the Command Dialogs tab in the Options dialog box on the Tools menu, the Check Out command displays the Check Out dialog box, which has the following options. There is an additional Recursive option if the project-level Check Out check box is selected as well:

Comment

Type a brief description of the reason for the check out. While the file is checked out, the Check Out Status tab displays the comment. The limit for check out comments is 63 characters.

To

Shows the working folder to which VSS copies the file. By default, VSS copies the file with its own file name into your working folder. However, you can enter a different folder and file name, or click Browse to select a different location in your folder tree.

Recursive (project-level Check Out only)

Checks out the project and all its subprojects.

Build Tree Override Working Folders (project-level Check Out only)

Overrides the working folder set for the subprojects involved in a recursive operation, and builds a project tree that mirrors the project organization on your local computer. Working folder settings for individual subprojects are ignored. Available only when you select the Recursive check box.

Don't Get Local Copy

Tells VSS not to copy the file to your working folder. VSS records that the file is checked out, but does not write a new copy to your working folder.

Advanced Options

You can also set the defaults for the first three of these on the Local Files tab in the SourceSafe Options dialog box on the Tools menu.

Allow Multiple Checkouts

Allows multiple users to check out this file/project simultaneously. If another user already has this file checked out, the check box is selected and unavailable. If multiple check outs are disabled for this project, the check box is cleared and disabled. When a file or project is exclusively checked out, the VSS Explorer icon for that item has a red box around it.

Replace Writable

Determines how VSS behaves when you try to check out a file that is already marked as writable in your working folder. Select one of the following in the list box:

  • Ask. Asks you what to do when a writable version of a file is found.

  • Replace. Replaces the writable file with a read-only version.

  • Skip. Skips the check out operation for the writable file. An error is displayed in the Results window if it is open.

  • Merge. Merges the changes between the writable file and the one you are now checking out. If the file cannot be merged (for example, it is a binary file), the check out operation is skipped for that file, and an error is displayed in the Results window if it is open.

  • Default. Uses defaults set on the Local Files tab or inherited from a parent project. You cannot set this option; it is used automatically when you have explicitly (in the file list) or implicitly (by checking Recursive) selected multiple files.

Set File Time

Changes the time assigned to the check out operation. Select one of the following in the list box: current time, last file modification time, last file check-in time, or the default time (set on the Local Files tab).

Skip This Dialog

Skips this dialog box during future check out operations and, by default, uses the settings you've entered. To restore the dialog box, clear the appropriate box on the Command Dialogs tab in the SourceSafe Options dialog box. Pressing the SHIFT key when clicking the Check Out command displays this dialog box, overriding the setting on the Command Dialogs tab.


Check Web Links (Web Menu)

Check Hyperlinks (Web Menu)

See Also

Allows you to check Web links in your HTML files.

Access Rights

You must have the Write access right to use this command.

Remarks

You can use this command to check Web links in your HTML files, either the files in your working folder or in a VSS project. VSS only checks the links that jump to other files in your project [image] links to external pages are not checked.

Links checked are those referred to with HTML <A HREF>, <IMG SRC>, and <OPTION VALUE> tags. Links to other Web addresses created using code, such as VBScript or Java, are not checked.

When the link check is complete, VSS displays a dialog box with three list boxes. The top box lists all files in which errors were found. The middle box lists the internal links (jumps to other files within the Web project) which appear to be invalid in the selected file in the top box, and the bottom box lists the external links that were found but not checked.


Create Project Command (File Menu)

See Also

Creates a new subproject under the currently selected project.

Access Rights

You must have the Add access right in the parent project to use this command.

Remarks

Use the Create Project command to create a subproject under the current VSS project. The subproject is empty until you place files or other subprojects in it. All access rights that you have in the parent project propagate to the newly created project.

Dialog Box Options

Project

Type a name for the new project.

Comment

Type a brief description of the project.


Create Site Map (Web Menu)

See Also

Allows you to automatically create a map of the HTML files in a Web project.

Access Rights

You must have the Write access right to use this command.

Remarks

Site maps are becoming more popular as methods of navigating through a Web site. This command lets you easily generate a list of the HTML files in your Web project, and creates the list as an HTML file with links to each file. With some minor customization, you can then add the resulting file to your Web site and provide your users with a classic method of navigation.

Each time you run this command, a totally new file is created. That is, this command does not compare new material to old and just make the changes. So, if there is some customization you have added to the resulting site map file, you should be prepared to add it again each time you run this command, or to use technology such as server-side include files to store it in a separate place. Also, the HTML generated by this command is fairly rudimentary [image] HTML 2.0 tags. If you want a more customized page, you can cut and paste from the HTML provided by this command, or add HTML tags to the file to make it fit into your Web site better.

The Create Site Map command works by getting the titles of your HTML files from their <TITLE> tag. If you have an HTML file without a <TITLE> tag, VSS will use its file name. To build a good site map, you should use descriptive, unique strings in the <TITLE> tags of your files. Category names in the site map file come from the VSS project name. Therefore, it is important for you to use good, descriptive project names in Web site projects.

Once the HTML site map file is created, you can add it into your project by using the Add Files command. If you add the file to your Web site project, be sure to check it out before running the Create Site Map command.

As an example, consider an external Web project that looks like this:

Running Create Site Map on the external Web project creates an HTML file that displays like this in a Web browser:

Using this HTML:

Of course, at this point, you can customize the HTML to make your site map look like anything you want [image] use a different background color or pattern, change indentation levels, delete or add items, and so on. One way you can customize the site map is to change the graphics files used for the folder and file icon. For more information on doing this, see the IMG_Folder and IMG_File initialization variables.


Customize Toolbar Command (Tools Menu)

See Also

Adds or deletes buttons on your VSS toolbar.

Rights

Any VSS user can use this command.

Remarks

To add a button to the toolbar, on the Tools menu, click Customize Toolbar. From the Customize Toolbar dialog box, select the toolbar button you want from the Available buttons area, then click Add to move it to the Toolbar buttons area. To delete a button, select the toolbar button you want from the Toolbar buttons area, then click Remove to move it to the Available buttons area.

After a button is on the Toolbar, you can drag it to a new location in the dialog box to move it to a new position on the Toolbar.

Dialog Box Options

Add

Moves a selected button from the Available buttons list to the Toolbar buttons list (that is, adds it to the toolbar).

Remove

Moves a selected button from the Toolbar buttons list to the Available buttons list (that is, removes it from the toolbar).

Reset

Resets the toolbar to its default configuration.

Close

Closes the Customize Toolbar dialog box.

Move Up

Moves a button up in the Toolbar buttons list, moving it closer to the left in the VSS Explorer toolbar.

Move Down

Moves a button down in the Toolbar buttons list, moving it closer to the right in the VSS Explorer toolbar.


Delete Command (File Menu)

See Also

Deletes a file or project.

Note In earlier versions of VSS, this command was called Remove.

Access Rights

You must have the Add access right to use this command.

Remarks

If you don't select the Destroy Permanently check box in the Delete dialog box, the Delete command is reversible [image] to make recovery possible, VSS stores a deleted file or subproject.

To recover the file, use the Recover command. Another way to retrieve the file (if it hasn't been purged or destroyed) is to return to an earlier version of the project that contains the file.

Note When you delete a project, all its subprojects and the files contained within them are deleted as well. When you recover the project, its subprojects (and the files therein) are recovered.

A deleted file or subproject can be purged or destroyed, which permanently removes the item.

Dialog Box Options

Item

The name of the file or subproject to be deleted.

Destroy Permanently

Selecting this check box permanently removes the file or subproject, which you cannot thereafter recover. This is the same as performing the Purge command on the items. You must have the Destroy access right to enable this check box.

Caution The Destroy command should be used with extreme caution. Before using it, you must be confident that you will never want the file or project, or any of its earlier versions, for any reason.

If there's any chance that you might want to retrieve earlier versions of the project that contained the file, delete the file without destroying it [image] you can then recover the file later with the Recover command.


Deploy Command (Web Menu)

See Also

Allows you to deploy a set of Web files to a Web server, or multiple Web servers. This command works only on projects, not files.

Access Rights

You must have the Destroy access right to use this command.

Remarks

When you have completed development and testing of your Web pages, the Deploy command is used to copy your files to the live Web server. The location of this server is a folder or FTP site specified by your VSS administrator. When you choose the Deploy command, the contents of your current project are copied to that location.

In many respects, Deploy acts like the Get command: it copies files from a VSS project, to a local folder. However, Get makes a copy for your personal use; Deploy makes the project public, potentially to the entire world. For this reason, the Deploy command requires Destroy-level privileges in the selected project.

Your VSS administrator must set a deployment path in the Web Sites tab of the Administrator Tools Options menu to enable this command. You can deploy only an entire project marked as a Web site project, not single files. The deployment folder can be a comma-delimited set of places you want your files copied to.

When used, the Deploy command overwrites existing files with the same name in the deployment folder, even if you have the Replace Writable files check box of the Tools Options Local Files tab set to Skip.

Note that this command is useful in many instances other than Web site deployment; for example, if you have a set of product specification .doc files that you want to publish to a public server.


Edit File Command (Edit Menu)

See Also

Allows you to edit a source-controlled file by ensuring that it is checked out and then opening the file in the associated editor.

Access Rights

You must have Write permission to use this command.

Remarks

When you select Edit File, VSS first checks to be sure you have the file checked out. If you do not, the file is checked out to you unless something prevents this, such as the file being already checked out by another user (when your VSS administrator has not enabled multiple check outs for that project).

After the file is checked out to you, VSS opens the file. You can select an editor by clicking the Advanced button on the File dialog box.

The default editor is selected by one of the following means, in the following order:

  1. VSS looks in its initialization files for a line with the extension of the file being viewed.

  2. VSS uses Microsoft Windows Explorer (the registration database and Win.ini) to associate an application with the file extension.

  3. VSS looks for your entry in the File Viewer option on the General tab in the SourceSafe Options dialog box.

  4. If VSS cannot determine a file association after using these methods, it displays the file using its own editor.

Note If no editor can be found for a specific file type, the file will remain checked out to you in your working directory, so you can open the file normally with the editor of your choice.

You can also set the double-click behavior of VSS on the General tab of the Tools Options dialog box. Setting the Double-click on a file option to Edit File will allow you to double-click on a file in VSS to edit it; however, setting the option to Ask is recommended (so you don't accidentally write over a local file during the check out operation).


Files Report Command (Tools Menu)

Creates a formatted report of current project and file information that you can send to the clipboard, a file, or a printer.

Access Rights

You must have the Read access right to use this command.

Remarks

You can prepare a report containing a list of all files in the current project. (The report includes only files and subprojects currently in the project, not deleted files or subprojects.) The Files Report command is useful for large projects for which the VSS Explorer may not be able to display all file names on the screen at once.

Note Dialog box options vary depending on whether you have a file or project selected in VSS Explorer.

Dialog Box Options

All Displayed Files (available only when a file is selected)

Includes all files shown in the file pane of VSS Explorer.

Selected Files (available only when a file is selected)

Creates a report for selected files only.

Recursive (available only when a project is selected)

Creates a report that includes information on the subprojects in the current project.

Include Files (available only when a project is selected)

Creates a report that includes file names within a project.

Filenames Only

Creates a report that includes file names only. If this box is not selected, the file report includes four columns instead of just one for file name. The four columns are Filename, Username, Date-Time, and Check Out Folder (as in the VSS Explorer). The Filename column supports long file names, which will wrap in the column as necessary.

Report To

  • Printer [image] Sends report to printer.

  • File [image] Sends report to File dialog box.

  • Clipboard [image] Places report on Clipboard.

OK

Confirms selection.

Cancel

Cancels the report.

Preview

Previews the report.


Find In Files Command (Tools Menu)

See Also

Finds all instances of a specified character string within one or more files.

Access Rights

You must have the Read access right to use this command.

Remarks

Use the Find In Files command to display a list of all occurrences of a character string in the VSS files you specify. You can use the command on a single file or on an entire project.

There are three wildcard characters you can use in a find string, unless Literal Matches is selected:

  • A question mark matches any character.

  • An asterisk matches any string.

  • A backslash makes the character after it literal: \*, \?, and \\. This is necessary if you want to search for asterisks, question marks, or backslashes.

Ordinarily, VSS is case-sensitive, that is, A does not equal a. To make the Find In Files command case-insensitive, click Ignore Case.

The results of the search are shown in a Results window. On top, VSS lists all the files that contained matches. On the bottom, VSS displays the matching strings in the currently selected file. As you scroll through the top list, the bottom display changes to reflect the changing file selection.

Dialog Box Options

Item

Type the file name(s) you want VSS to find.

String

Type the character string you want VSS to search for.

Match Case

Finds exact matches only. The string you enter cannot contain wildcards.

Use Regular Expressions

Select this box if you're using an asterisk in your text string as part of a wildcard search. Clear this box if you're using an asterisk as an ordinary text character.

Recursive (project level only)

Searches through all files in the project and its subprojects.

List All Shared Files Separately (project level only)

In project searches, notes each match found in a shared file as a separate item. (By default, a match in a shared file is listed only for one of the projects that the file exists in.)


Get Command (SourceSafe Menu)

Get Latest Version Command (SourceSafe Menu)

See Also

Retrieves a read-only copy of the selected VSS items. To get the most recent version, click Get Latest Version on the VSS menu. To get an older version, click Get in the History of File or History of Project dialog box.

Access Rights

You must have the Read access right to use this command. You should have a working folder set before using this command.

Remarks

The Get Latest Version command retrieves the most recent version of a file, a group of files, or an entire project from VSS and creates read-only copies for viewing or compiling in your working folder.

Note You can choose a different working folder for the current Get operation by typing a new path in the Get Latest Version dialog box. Click Browse to navigate your folders.

Getting a file does not replace the file that you currently have checked out in your working folder, unless you set the Replace advanced option.

Results of a Get Operation

Using the Get Latest Version command has four possible outcomes:

  • When the file you are retrieving is not already in your working folder, VSS simply gets the file.

  • When the file in your working folder is identical to the file you are retrieving, VSS does not retrieve or modify the file in any way.

  • When the file in your working folder is different from the VSS master copy, and your local copy is read-only, VSS replaces your local copy.

  • When the file in your working folder is not read-only, VSS assumes that you have the file checked out, and doesn't replace the file. You can change the way VSS behaves in this case with the Replace Writable option in the Local Files tab of the Options dialog box.

Merging with the Get Latest Version Command

In a multiple checkout situation, you can use the Get Latest Version command to retrieve other users' changes before checking in your version of the file. You can tell VSS to merge the changes into your local copy of the file, or you can specify that you want to verify each change before permitting the merge. To do this, set the Replace Checked Out Files option to Merge on the Local Files tab in the SourceSafe Options dialog box.

Dialog Box Options

If you enable the Get Latest Version command dialog box on the Command Dialogs tab in the SourceSafe Options dialog box on the Tools menu, or hold down the SHIFT key when you click the Get Latest Version command, you have the following options:

To

Type the path where you want VSS to place the files.

Recursive (project-level Get only)

Gets a project, all the files in the project, and its subprojects. Each file in a subproject is copied into its own working folder, which can be a folder anywhere on your computer or an accessible remote computer. To override the working folder settings, and create a file structure that mirrors the VSS project structure, use the Build Tree option.

Build Tree Override Working Folders (project-level Get only)

Overrides the working folder set for the subprojects involved in a recursive operation, and builds a project tree on your local computer that mirrors the project organization. Working folder settings for individual subprojects are ignored. Available only when you select the Recursive check box.

Make Writable

Sets the read/write flag so the file is writable. This is not the default behavior, but may be useful if you want to try a temporary change in the file, or want to rename the file after getting it.

Advanced Options

You can also set the defaults for the first three advanced options on the Local Files tab in the SourceSafe Options dialog box on the Tools menu.

Set File Time

Changes the time assigned to the get operation. Select one of the following in the list box: current time, last file modification time, last file check-in time, or the default time (set on the Local Files tab).

Replace Writable

Determines how VSS behaves when you try to get a file that is already marked as writable in your working folder. Select one of the following in the list box:

  • Ask. Asks you what to do when a writable version of a file is found.

  • Replace. Replaces the writable file with a read-only version.

  • Skip. Skips the get operation for the writable file. An error is displayed in the Results window if it is open.

  • Merge. Merges the changes between the checked-out file and the one you are now getting. If the file cannot be merged (for example, it is a binary file), the get operation is skipped for that file, and an error is displayed in the Results window if it is open.

  • Default. Uses defaults set on the Local Files tab or inherited from a parent project.

Skip This Dialog

Skips this dialog box during future get operations, and uses the settings you've entered as the default. To restore the dialog box, clear the appropriate box on the Command Dialogs tab in the SourceSafe Options dialog box. Pressing the SHIFT key when clicking the Get Latest Version command displays this dialog box, overriding the setting on the Command Dialogs tab.


Invert Selection Command (Edit Menu)

Selects all files not currently selected, and deselects currently selected files.

Access Rights

Any VSS user can use this command.

Remarks

The Invert Selection command reverses the selection status of each file currently displayed in the VSS Explorer file list. The command can be useful when you have performed one operation on all the selected files, and want to perform another operation on the remaining files.


Label Command (File Menu)

See Also

Assigns a label to the specified version or current version of a file or project.

Access Rights

You must have the Add access right to use this command.

Remarks

Every version of a file has a version number and a date and time, and can be retrieved by a reference to either. To make a version easier to identify, you can assign it a label [image] any string up to 31 characters in length [image] and refer to the version by its label.

With the Label command, a new version of the selected file(s) or project is created, and the label is associated with that version.

Note To change the label of an earlier version, when a file is selected in the file pane of VSS Explorer, on the Tools menu, click Show History, and then click Details.

When you edit a label in the History Details dialog box, you are assigning a label to an existing version of the specified item.

If you want to identify a certain version of a project so you can come back to it, do not assign a label to every file in the project, but rather assign the label to the project itself. Even if you add, delete, and rename files in the future, VSS can accurately restore that version of the project based on the project label.

Dialog Box Options

Item

The name of the file or project.

Label

Type a label up to 31 characters in length.

Comment

Type an optional comment.


Merge Branches Command (SourceSafe Menu)

See Also

Copies all the changes made in one branch of a file to another branch. Works for files only, not projects.

Access Rights

You must have the Check Out access right in the project being merged into, and the Read access right in the project being merged from, to use this command. You should have a working folder set before using this command.

Remarks

Merge copies the changes made in one file into another file (on a separate development path) in VSS. If the merge creates conflicts, VSS checks out the file to your working folder if it wasn't already checked out. You can then modify the file and resolve any conflicts before checking the file back into VSS.

For example, project $/Newapp is currently shipping version 5. The development team has started working on version 6, when suddenly a big customer calls with a serious bug in version 5. The Newapp project is branched at that point so that the development team can continue working on version 6 while a crack bug team works on fixing the version 5 bug (perhaps their project is named $/Bugfix). Up to the branch point, the projects are identical, but after the branch the code in each project differs.

Just before version 6 ships, the Bugfix team announces they have corrected the bug. You decide to merge their code into the Newapp project so version 6 of your product has the fix. You select one file at a time in the Newapp project and choose the Merge Branches command.

After the merge operation, you still have two independent development paths, but the changes made in $/Bugfix have been copied to $/Newapp. Before you choose the Merge Branches command, be sure you have the file selected that you want to merge changes into. (The file you are merging changes from will be unchanged.)

Note You cannot merge binary files.

Dialog Box Options

Projects

Select the project into which you want to merge your file. The Versions column shows you the version numbers you will be merging.

Merge

Merges branches.

Cancel

Cancels merge of branches.

Links

Shows all of the projects with which the file has share links.


VSS Web Site Command (Help Menu)

Microsoft on the Web Command (Help Menu)

Opens the Microsoft Internet Explorer (or your configured Web browser) to one of several Microsoft Web sites.

Visit the VSS Web site at http://www.microsoft.com/ssafe.

Access Rights

Any VSS user can use this command.


Move Projects Command (File Menu)

Move Project Command (File Menu)

See Also

Relocates a subproject from one parent project to another.

Access Rights

You must have the Add access right in the parent project being moved to, and the Destroy access right in the parent project being moved from, to use this command.

Remarks

The Move Project command redefines the path to a subproject. For instance, if the project TOOLMANAGER exists under $/JOE, and you move it to $/APPS, its new full name is $/APPS/TOOLMANAGER.

This command does not rename a project, and it does not change its contents or history. It does affect the histories of the old and new parent projects.

After you move a project, you cannot reconstruct an old version of its original parent project. In the preceding example, any attempt to use the Get Latest Version command recursively to retrieve a version of $/JOE that existed before you moved the TOOLMANAGER project generates a warning that TOOLMANAGER has been moved, and is unavailable.

Note You cannot move individual files with the Move Project command. Instead, to move a file, share the file with the new parent project, and then delete or destroy the file in the original project. The history of the file is retained.

Dialog Box Options

To move a project, first select that project in the VSS Explorer. Then select the new project location from this dialog box and choose OK.

To

Select the path of the project to which the subproject is to be moved.

OK

Moves the selected project to the new location.

Cancel

Cancels the Move operation.


Options Command (Tools Menu)

See Also

Enables you to customize your VSS environment.

Access Rights

Any VSS user can use this command.

Remarks

Click the tab with the information you want. Each tab contains groups of options you can set to customize VSS.

Dialog Box Tabs

General

Enables you to set general options applicable to a number of commands in VSS.

Local Files

Configures working folder files and how they are treated during the operation of different commands.

View

Sets viewing options, such as whether or not to show the toolbar or status bar, and file list options.

Difference

Allows you to specify options for viewing differences between files and projects. These options are used in other VSS dialog boxes such as the Project Difference dialog box and the Visual Merge dialog box.

Command Dialogs

Configures the display of intermediate dialog boxes related to several VSS commands. These intermediate dialog boxes usually present you with additional options.

Warnings

Determines when warning messages are displayed.

File Types

Sets how file type information is determined.

Command Line

Customizes how some command-line commands work.


Properties Command (File Menu)

See Also

Displays the Properties dialog box, which contains basic information about a VSS file or project, including the size, name, and type.

Access Rights

You must have the Read access right to view the Properties dialog box.

You must have the Add access right to change the type of a file.

You must have the Destroy access right to change the Store Only Latest Version state of a file.

Remarks

Click the tab with the information you want. Tab content differs according to whether a file or project is currently selected in VSS Explorer.

Note Click the Report button on any of the tabs to create a report to send to the clipboard, a text file, or a printer.

File Properties Dialog Box Tabs

General

Shows the file name, type, size, latest version number, last modification date, comment, and whether the entire file history is stored in the VSS database (or just the latest version). You can change the comment and set whether or not to store only the latest version of the file to save disk space. You can also change the file type here.

Check Out Status

Shows the file's name, who it is checked out by (if anyone), whether it is exclusively checked out, when it was checked out, the version that is checked out, the computer it's checked out to, the check out path, the project the file is in, and the check out comment. You can change the check out comment.

Links

Shows the current share links a file has to other projects.

Paths

Shows which projects have branched versions of this file in the past.

Project Properties Dialog Box Tabs

General

Shows the name of the current project, the number of files and subprojects it contains, the latest version number, when it was last changed, whether the project is cloaked, and the comment for the project. You can change the comment.

Deleted Items

Shows the files that have been deleted from the project since it was added to VSS. Use this dialog box to recover or purge a deleted file.


Refresh File List Command (View Menu)

See Also

Refreshes the file list in VSS Explorer.

Access Rights

Any VSS user can use this command.

Remarks

Refreshes the file list only, not the project list. To refresh both lists, collapse the project list to a parent project, then double-click that project to expand the project list.

You can refresh the file list automatically. Set the timing with the Automatically Refresh File List option on the View tab in the SourceSafe Options dialog box on the Tools menu.


Rename Command

Rename Command (File Menu)

See Also

Renames a file or project.

Access Rights

You must have the Add access right to use this command.

Remarks

To use the Rename command, select the file or project you want to rename, then choose the command. You will be able to edit the item name directly in the VSS Explorer window.

When you use the Rename command on a file or project, the item's file history is retained. If multiple projects share a file and the file is renamed, it is renamed in all projects that share it. However, if any share links have been broken by the Branch command, the branched files are not renamed. The Paths tab in the Properties dialog box shows how the name has changed in different branches of the file.


Search Command (View Menu)

See Also

Filters the file list in VSS Explorer to search for checked-out files whose names match a specified pattern or string. Search finds one or more specified files in your project list and limits the file list display to those files.

Access Rights

You must have the Read access right to use this command.

Remarks

A status search can be used to find only the files checked out by a specific user. When a file is shared among multiple projects, the Search command shows you which projects the file is checked out to.

Tip Press SHIFT+CTRL+S to search for all checked-out files in the current project. The Search dialog box is not displayed.

Search for Status Dialog Box Options

Display all checked out files

Shows all checked-out files, no matter who has them checked out.

Display files checked out to

Click this button and type a username if you want to see files checked out only by that user, instead of all checked-out files. You can also select usernames from the drop-down list. To see all checked-out files, select <All Users>.

Search Area

Specify which projects/subprojects you want to be included in the search. You can search the current project only, the current project and all its subprojects, or all projects in the database.

Search for Wildcard Dialog Box Options

Wildcard

Type a file name or string with wildcard characters; for example, file.*.

Search Area

Specify which projects/subprojects you want to be included in the search. You can search the current project only, the current project and all its subprojects, or all projects in the database.

Note If you clear the Wildcard boxes simultaneously, the search is cancelled. Also, if you enter * or *.* in the Wildcard box, and the Search in all Projects box is clear, the search is cancelled.

Remember that the VSS wildcard search is really a filtering operation. You are searching for those files in the current project that match specified criteria. Entering *.* in the Wildcard box effectively removes any filtering criteria; therefore the search is cancelled.


Select All Command (Edit Menu)

See Also

Selects all files currently displayed in the file pane of VSS Explorer so that you can perform a group operation on all the files.

Access Rights

Any VSS user can use this command.


Select Command (Edit Menu)

See Also

Selects one or more files to perform operations on. The file pane of VSS Explorer must be active for this command to be available.

Access Rights

Any VSS user can use this command.

Remarks

The Select command opens a dialog box into which you can type the name of a single file, multiple file names separated by semicolons (;), or the names of multiple files using wildcard characters.

Dialog Box Options

Item

Type the name of a single file or the names of multiple files. To select all files in the file list, type *.*; to select all files with the .rtf extension, type *.rtf, and so on. Use the semicolon (;) as a delimiter between file types you want included in the selection, for example "*.rtf; *.exe".

Select

Selects the file.

Deselect

Clears the selection of a file.

OK

Confirms the selection.

Cancel

Cancels the operation, closes the dialog box, and returns to VSS Explorer.


Set Working Folder Command (File Menu)

See Also

Sets your working folder.

Rights

Any VSS user can use this command.

Remarks

After creating a new project, it is important for you to designate a working folder in which to work on the project's files. If you do not, VSS prompts you for a working folder whenever you use a command that requires one to be set.

You can use an existing folder on your computer's hard disk as your working folder. You can also create a new folder from within VSS or Windows.

If you just click OK, this command temporarily sets the working folder for the project. The setting is saved after you close VSS. If you clear the Save as Default for Project check box, the folder is not saved as your default working folder for the current project.

Dialog Box Options

Name

Name and path of working folder.

Folder

Your current working folder.

Folders

Specifies a folder for the working folder.

Drives

Selects the drive that contains the working folder.

OK

Confirms selection.

Cancel

Cancels the selection, closes the dialog box, and returns to VSS Explorer.

Create Folder

Creates a new folder for the working folder. Type a new folder name in the Name box, then click Create Dir to create the folder.

Save as Default for Project

Saves the folder you specify as your default working folder for the project.


Share Command (SourceSafe Menu)

See Also

Makes a file a member of the current project, or creates a new branch project.

To share a specific version of a file to your current project, use the Share command on the SourceSafe menu to get the file into the proper project. Then, use the Show History command on the Tools menu on the file and click Pin on the version you want.

Access Rights

You must have the Check Out access right in the project you are sharing from, and the Add access right in the project you are sharing to, to use this command.

Remarks

To share a file, you create a share link between two projects. The file is then in two (or more) projects at the same time. When you check in the file to any one of the projects, your changes are automatically checked in to all of them. To display a list of all the projects that share a specific file, use the Links tab in the Properties dialog box.

If you create a branch, changes made in the branched file no longer propagate to the originating project, and vice versa. The Links command no longer shows a relationship, but you can use the Paths tab in the Properties dialog box to see the path of the file branch you created.

When you share a project, you create an entirely new project under the current project that is an exact duplicate of the project you specified. All the files in the new project are shared with the corresponding files in the originating project and changes in one are reflected in the other during check in.

Dialog Box Options

File To Share

Type the name of file(s) to share or click a file name displayed. Files listed are those that can be shared with your current project: Some files cannot be shared, such as files with the same name as a file already in your project.

Projects

The name of the project being shared from.

List Files of Type

Lists the file type, or tells VSS how to classify a file.

The list of file types available is determined by the File Types Included In File Group filter and the File Groups filter set on the File Types tab in the SourceSafe Options dialog box. All Files (*.*) lists all files in the current folder.

Close

Closes dialog box.

Share

Shares selected file or project.

View

Displays the file with the text editor associated with the file extension of the file. The editor is set with the File Viewer option on the General tab in the SourceSafe Options dialog box.

Branch After Share

Shares the file, then immediately branches it to create separate copies of the file.


Show Differences (File) Command (Tools Menu)

See Also

Compares two files, then shows you the differences, if any.

Note If you want to show differences among projects, select a project in the project pane of VSS Explorer, then click Show Differences.

Access Rights

You must have the Read access right to use this command. You should have a working folder set before using this command.

Remarks

Most commonly, the Show Differences command is used before checking in a file to compare your copy of the file to the master copy in VSS. This gives you a list of the changes you have made, which can be helpful for generating your comment.

When you use the Show Differences command on an ASCII text file, VSS displays a color-coded list of line differences between the respective files.

For binary files, VSS identifies differences, however, it cannot display the differences.

Note It is also possible to compare two earlier versions of a file to each other or to compare an earlier version to the current version. To do so, select the two versions in the History of File dialog box, and then click Diff.

Dialog Box Options

Note Enable the display of the Show Differences dialog box on the Tools menu, SourceSafe Options dialog box, Command Dialogs tab.

By default VSS uses the Visual Difference dialog box. If you specify a UNIX display, VSS uses the VSS display options for Ignore Case and Ignore White Space. The VSS display option has line widths calculated to fit on your screen, and no context lines.

Compare / To

If you are performing a routine file difference, by default the Compare field will contain the file in VSS and the To field will contain its counterpart in the working folder. You can edit the Compare field, or you can click the Browse button to specify your selection. Using the Browse buttons, you can also compare two files in VSS (in the same project or other projects), two local files (in the same directory or different directories), or a file in VSS and a local file.

Visual

Shows the entire file, with annotations for the changes.

SourceSafe

Shows a simple list of lines that were added, deleted, and changed, optimized for readability.

UNIX

Shows differences in the format used by the UNIX Diff utility.

Ignore White Space

Shows differences without regard for spacing characters, such as tabs.

Ignore Case

Shows differences without regard for upper- and lowercase.

Only show this dialog when the shift key is down

If this box is checked, the Show Differences dialog will only be displayed if you hold down the Shift key while executing the Show Differences command.

OK

Executes the Show Differences command.

Cancel

Cancels the Show Differences command.

Report

Sends a report to the clipboard, a text file, or to a printer.

Advanced Options

Ignore OS Differences

Specifies that VSS ignore operating system line-break character differences. This is useful if you are comparing files across a network where one computer is a Macintosh, for example, and the other is operating using Microsoft Windows NT.

Show Context Lines

Includes the specified number of context lines in the difference display. Context lines are the lines in your file surrounding the line identified as different by VSS. For example, setting Show Context Lines to three means you'll see three context lines above and three context lines below the difference line.

Note This option will be ignored if you're using Visual Difference.

Save Settings

Saves your selected settings for future use.


Show Differences (Project) Command (Tools Menu)

See Also

Compares a VSS project with another VSS project, a VSS project with a Windows folder, or two Windows folders, then shows the differences, if any. You can also see individual line differences in differing files, and reconcile differences between the projects.

Note If you want to show differences between a file in your project and that file in another VSS project or a Windows folder, select a file in the file pane of VSS Explorer, and then click Show Differences.

Access Rights

You must have the Read access right to use this command.

Remarks

The Show Differences command on a project generates a two-paned dialog box that lists the differences between a VSS project and another VSS project, a VSS project and a Windows folder, or two Windows folders. Before the lists of files are displayed, a command dialog box comes up that allows you to filter the file list if you'd like, so you can limit reporting to the files that interest you.

A common use of this command is to find the files another user has deleted from the project, so you can delete them from your working folder. It can also be useful if you take a project home for a while, to see if any project-level changes have been made.

If you are comparing a VSS project and a Windows folder, you can reconcile differences between the two projects in several ways. For example, you can get or check in all files that are different in each respective project, or you can also add missing files.

Project Difference Dialog Box Options

Note Enable the display of the Show Differences dialog box on the Tools menu, SourceSafe Options dialog box, Command Dialogs tab.

The options in this dialog box are not mutually exclusive [image] they can be combined to filter the file lists in each pane. Each one of the check boxes below potentially adds more files to the lists in each pane.

Compare / To

If you are performing a routine project difference, by default the Compare field will contain the project in VSS and the To field will contain its counterpart in the working folder. You can edit the Compare field, or you can click the Browse button to specify your selection. Using the Browse buttons, you can compare two projects in VSS (in the same project or other projects), two local projects (in the same directory or different directories), or a project in VSS and a local project.

Show files that are only in the project

Includes, in the left pane, project files that are not currently in the working folder. This option is selected by default.

Show files that are only in the working folder

Includes working folder files that are not currently in the VSS project. This option is selected by default.

Show files that are different in both places

Includes all files that are in both the working folder and VSS project, but are different from each other. Most often for these files, you need to get the file to update the version in your working folder. This option is selected by default.

Show files that are the same in both places

Includes files in both projects that are the same in both places. This option is selected by default.

Recursive

Scans the contents of either the current project or Windows folder and all its subprojects; shows all differences between the two respective projects or Windows folders.

Only show this dialog when the shift key is down

If this box is checked, the Show Differences dialog will only be displayed if you hold down the Shift key while executing the Show Differences command.

OK

Executes the Show Differences command.

Cancel

Cancels the Show Differences command.


Show History Command (Tools Menu)

See Also

Shows the history of a file or project in VSS.

Access Rights

You must have the Read access right to use this command.

Remarks

Every time you check in a file or project to VSS, the file or project is considered a new version. Use the Show History command to display a list of the past versions of a file or project.

The versions are listed starting with the most recent and going back to the creation of the file or project. VSS provides information about the version number, which can be used with other commands (such as Get Latest Version ) to indicate a specific version.

By default, the history of a project includes the histories of all its files, but does not include subprojects.

You can compare one version of a file with another by selecting the two versions simultaneously (hold down the CTRL key and click each version), then clicking Diff.

Dialog Box Options

Note Enable the display of this dialog box on the Command Dialogs tab in the SourceSafe Options dialog box on the Tools menu.

Include files (project history only)

Includes files in project history.

Recursive (project history only)

Includes subprojects and all files within them.

Labels Only

Includes only labels in project history.

From

Type a time, date, version, or label. Use the prefix D to indicate a date and/or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "Lbeta1". Dates can be entered in 08.15.97, 08-15-97, or 08/15/97 format, but not as August 15, 1997. Note that if you have a project selected to see the history on, you cannot search for file labels [image] you must select the file and use the Show History command to find a specific label.

To

Type time, date, version, or label. Use the prefix D to indicate a date and/or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "LBeta1". Dates can be entered in 08.15.95, 08-15-95, or 08/15/95 format, but not as August 15, 1995.

User

Shows a history of files worked on by the specified user.

OK

Displays the History of Project or History of File dialog box, depending on whether a file or project is selected in VSS Explorer. In these dialog boxes, click any of the items in the list, and then click Details to display the History Details dialog box. From within the History Details dialog box, you can click the Next and Previous buttons to move up and down in the history display. You can also edit the comment and label associated with the version you are viewing.

Skip This Dialog

Skips this dialog box during future Show History operations, and uses the settings you've entered as the default. To restore the dialog box, select the appropriate check box on the Command Dialogs tab of the Options dialog box.


Sort Command (View Menu)

Sorts the file list in VSS Explorer. Sort order options are by file name, type, user, date, or check out folder.

Access Rights

Any VSS user can use this command.

Remarks

The file list in VSS Explorer is usually sorted by file name. You can change the sort order:

  • Name (file name)

  • Type (file type extension)

  • User (usernames of users who have files checked out)

  • Date [image] Time

  • Check Out Folder

Type, Name, User, and Check Out Folder sort in ascending order; Date [image] Time sorts in descending order, so that the most recent files are on top. The current sort order is always displayed in the status bar.


Undo Check Out Command (SourceSafe Menu)

See Also

Cancels a Check Out operation, undoing all changes. You must have a working folder set for this command to work properly.

Access Rights

You must have the Check Out access right to use this command.

Remarks

The Undo Check Out command undoes all your changes [image] the file is no longer checked out by you, but instead of updating VSS with your edited copy, Undo Check Out retains the version VSS previously had and copies it over the file in your working folder.

You can use the Undo Check Out command only on files that you currently have checked out, not on files checked out by other users.

Note Your VSS administrator can undo the check out of another user. See Chapter 8, "Administration," of the Visual SourceSafe User's Guide for more information.

Dialog Box Options

Important The following are VSS-only options. Access and other integrated products may have different options.

Note Enable the display of this dialog box on the Command Dialogs tab in the SourceSafe Options dialog box on the Tools menu.

Local Copy

  • Replace [image] Replaces the file in your working folder [image] VSS performs the Get Latest Version command on the file. This keeps your working folder synchronized with the contents of the project, because all your changes are ignored.

  • Delete [image] Deletes the file in your working folder.

  • Leave [image] Leaves the file alone.

    By default, Local Copy uses defaults set on the Local Files tab (accessible from the Options command on the Tools menu) or inherited from a parent project. This option is used automatically when you explicitly (in the file list) or implicitly (by checking Recursive) select multiple files.

Skip This Dialog

Skips this dialog box during future Undo Check Out operations, and uses the settings you've entered as the default. To restore the dialog box, select the appropriate check box on the Command Dialogs tab of the Options dialog box.

Recursive (project-level Undo Check Out only)

Undoes the check out on all files in the selected project, and all files in all subprojects of the selected project.

Override Working Folders (project-level Undo Check Out only)

Overrides the working folder set for the subprojects involved in a recursive operation. This is useful if you have files checked out in more than one project, and want to undo the check out of all of them at the same time. Available only when you select the Recursive check box.


View File Command (Edit Menu)

See Also

Shows the text of the master copy of the file in VSS. To view an earlier version of a file, click the View button in the History of File dialog box on the Tools menu. To view a file before sharing it to your current project, click the View button in the Share dialog box.

Access Rights

You must have the Read access right to use this command.

Remarks

The View File command opens and displays a VSS master copy of a file using the editor associated with that file. You can also select an editor by clicking the Advanced button on the File dialog box. Viewing a file does not change anything in either the VSS database or your working folder.

The associated editor is selected by one of the following means, in the following order:

  1. VSS looks in its initialization files for a line with the extension of the file being viewed.

  2. VSS uses Microsoft Windows Explorer (the registration database and Win.ini) to associate an application with the file extension.

  3. VSS looks for your entry in the File Viewer option on the General tab in the SourceSafe Options dialog box.

  4. If VSS cannot determine a file association after using these methods, VSS displays the file using its own editor.


Glossary

A

access rights

Levels of permission users are granted by the VSS administrator to use the VSS database. The levels of access rights are Read, Check Out, Add, and Destroy.

Advanced dialog box

Dialog box that contains optional or additional settings. Many VSS dialog boxes have an Advanced button that displays additional settings.

automatic merge

When multiple users have the same file checked out, their changes to the file are merged by VSS during check in.

B

branched file

File whose share link has been broken using the Branch command.

branching

Process of sharing a file with another project and then separating it into two or more branches. Once a branch has been created, two files (the file in the project, and its counterpart in other projects) will have a shared history up to a certain point, and divergent histories after that time.

C

checked-in file

File stored in the VSS database and unavailable for modification.

checked-out file

File that has been reserved for work by a user. Users check out files to make changes to them. In the default configuration, VSS allows only one user at a time to check out a file. Checking out a file copies its latest version into the user's working folder.

check-out folder

Folder to which a file is checked out in VSS. It is not the working folder. If you check out a file, the file is checked out to your working folder. To another user, the file is in the check-out folder. The check-out folder is displayed in the Check Out Folder column of the file pane; the working folder is displayed under the toolbar.

cloaking

Preventing a project from being affected by certain commands, for example, Get Latest Version, Check Out, Check In, Undo Check Out, and Project Show Difference.

column format

Formatting option used with keyword expansion within a file. This option (using two colons instead of one in the keyword instructions) tells VSS to align columns of keyword information for a more readable display.

conflict

Two or more different changes to the same line of code in a multiple check out situation. VSS recognizes conflicts during a merge operation, and flags them in some way.

conflict marker

Symbol used to designate conflicting changes to a file. These symbols are:

Symbol | Description
<<<<<< | SourceSafe version
====== | Conflict separator
>>>>>> | Local version

VSS places these marks in the file after a conflicting check-in or merge operation, so conflicts can be easily found and resolved.

cross-platform development

VSS supports transparent file-compatibility across multiple processors and operating systems.

current project

Project selected in the project pane of the VSS Explorer window.

current version

Version of a file most recently stored in the VSS database. The current version has the highest version number of a file in VSS.

D

Delete command

Removes files and projects from a VSS project, and marks them as deleted; the items still exist, however, and can be recovered using the Recover command.

delta

In VSS, a delta is the difference between version x of a file and version x [image] 1 of the same file. VSS uses reverse delta technology to store changes.

Destroy command

Permanently removes deleted files and projects from the VSS database. Once destroyed, the items cannot be recovered.

development environment

Set of software development tools, presented as a unified environment in which the software developer can efficiently work. Microsoft Visual Basic and Microsoft Visual C++ are examples of such environments.

drag and drop

Combination of features that allows the user to drag an item and drop it onto another item using the mouse. An item can be a source (the item the user drags) or a target (the item on which the user drops a source).

To drag an object, click the object, then while holding down the mouse button, move it to the new location. Release the mouse button to drop the object.

F

file header

Text at the beginning of a file that contains information, such as the revision number of the file, the author, the date and time of last modification, and so forth. This information usually appears as comments in programming language files so it doesn't interfere with compiling.

file list

List of files in the current project, which can be found in the file pane of the VSS Explorer window.

file pane

Right side of the VSS Explorer window. This pane contains the file list, which is a list of all files in the current project.

H

history

Record of changes to a file since it was initially added to VSS. With the file history, you can return to any point in the file's history and recover the file as it existed at that point. The History of Project dialog box shows the record of significant events in the current project, such as labeling and deleting or adding files and subprojects.

I

inheritance

Inherited effect of variables in VSS initialization files that subprojects receive from their parent projects. Variables in these files can be grouped under headings to specify behavior. If a variable is set before any group heading in the initialization file, the variable affects all projects; the effect is inherited by the subproject variables.

J

journal file

A text file the admin sets up to record any action in VSS that generates a history entry for a file or project. This file is frequently used for auditing purposes.

K

keyword

Specific to VSS. You can use keywords in your text files to automatically create a file header with version-specific information. Use VSS keywords to place information from VSS directly into a text file.

keyword-enabled file

File that contains VSS keyword information.

keyword expansion

Process VSS uses to replace a VSS keyword with meaningful header information when you use the Check In and Add Files commands. For example, the string "$Revision:   $" tells VSS to expand the Revision keyword automatically with the current file version number.

L

label

User-defined name you can attach to a specific version number of a file or project.

local copy

Copy of a file stored in your working folder on your local computer. The local copy may differ from the VSS master copy if the local copy has been changed since the last check out, or if the master copy was changed by another user while you were working on the local copy.

locking

System of ensuring that two processes do not affect the same record in a database at the same time. To coordinate record access, VSS applies native locking, which uses native operating system functions. VSS also can be set to use lockfiles, which create temporary files in the LOCKS folder.

log on

Process of entering and verifying a user's name and password to access the VSS database.

M

master copy

Most recently checked-in version of a file stored in the VSS database, as opposed to the local copy of a file in your working folder.

merging

Process of combining differences in two or more changed copies of a file into a new version of the file. A merge involves at least two different files (which can be different versions of the same file or changes made to the same version of the file) and creates a new file made up of the results of the merge. Merging can occur when the user merges two branches or when the Check In or Get Latest Version command is used.

multiple check out

Simultaneous check outs by two or more users. The VSS administrator must enable multiple check out.

P

parent project

The project a file or subproject exists in. For example, the parent of the file $/Project/Abc.txt is $/Project and the parent of the project $/Project is the root ($/).

password

Text string used as security to verify the identity of a user. A user password is often required to use the VSS database.

project

Group of related files, typically all the files required to develop a software component. Files can be grouped within a project to create subprojects. Projects can be defined in any way meaningful to the user(s). For example, one project per version, or one project per language. Projects tend to be organized in the same way as file directories.

project list

List of all the projects available in the VSS database; the project list is found in the left pane of the VSS Explorer window.

project pane

Left side of the VSS Explorer window. The project pane contains the project list, a list of all available projects in the VSS database.

project security system

The more restrictive of the two security systems provided by VSS. By default, it is disabled. When enabled by the admin, this feature allows an admin to set access rights on a per user, per project basis. See Access Rights.

Purge command

Permanently removes previously deleted files and projects from the VSS database. Once purged, the items cannot be recovered.

R

read-only file

File marked as read-only in its file attributes. Such a file can be viewed in an appropriate text editor, but cannot be modified. VSS marks the file as read-only when you use the Check In and Get Latest Version commands.

recursive operation

Operation applied to a project and to all the files and subprojects of that project. For example, you can use the Check Out command recursively to check out all files in the project list simultaneously and avoid selecting each file individually.

Results pane

Portion of the VSS Explorer window where results from VSS operations are shown. For example, when you check in a file, this pane shows the file name being checked in.

reverse delta

Change-storage technology used by VSS, in which incremental changes to a baseline file are stored, rather than each successive version of the file in its entirety. In VSS, the current version of a file is used as the baseline, and changes from the previous versions are saved. This results in reduced disk storage requirements and faster access times, because only the current version is stored in the database in its entirety.

rights propagation

Default assignment of user-access rights in subprojects based on rights assigned in the parent project. This default assignment can be changed.

root project

The highest-level project with the name $/ in the project list. All projects in a VSS database are subprojects of the root project.

S

security

VSS has two levels of security: default security and project security. Default security provides two access rights: read/write and read-only. When project security is enabled, four access rights are available per user, per project: Read, Check Out, Add, and Destroy. Each succeeding right includes all rights preceding it. The Destroy access right provides unlimited access and is equivalent to Read/Write rights under default security.

shadow folder

Central, optional folder that contains current versions of all the files in a project. The shadow folder does not contain the master copy of a file or the local copy of a file. Instead, it provides a central location from which to view the overall structure of the project and serves as a convenient place to build or compile the project.

share link

Link between a file shared with one or more projects. This link serves to update the shared file with any checked-in changes, regardless of which project the file was checked out from.

shared file

File simultaneously used by, and part of, more than one project.

source code control

The management of a file's change history and the file's relation to a larger grouping of related files known as a project. Source code control is a vital part of the efficient development of software applications. VSS is a project-oriented source code control.

status bar

A bar at the bottom of the VSS Explorer window used for displaying project and file status information and current command information.

subproject

Project within a parent project.

U

user list

List of users who can use the VSS database. The list is maintained by the VSS administrator and displayed in VSS Administrator's main window.

username

Unique identifying string for a given user. Used for logging on.

V

version control

VSS maintains multiple versions of a file, including a record of the changes to the file from version to version.

version number

Number that indicates the number of revisions a file has undergone since it was added to VSS. This number is displayed in the History dialog box. Version numbers are always whole numbers.

version tracking

Record keeping process of tracking a file's history from the initial version to the current version. Changes to a file are tracked as part of this process.

visual merge

Merge operation where conflicts are resolved visually, in an easy-to-use graphical interface.

VSS Administrator

Individual responsible for the VSS database. The administrator uses VSS Administrator program to control the location of the database, the user list, and access rights of each user, and performs setup and backup duties on the database. The administrator's user name is always Admin.

VSS database

Central database where all master copies, history, project structures, and user information is stored. A project is always contained within one database; multiple projects can be stored in one database, and multiple VSS databases can exist to store multiple projects.

VSS Explorer

VSS’s graphical user interface. By default, it comprises three panes: the left project pane and the right file pane, as well as the toolbar, status bar, menus, and so on. VSS Explorer is displayed when you click the VSS icon.

W

Web site project

Project marked as a Web site project in the VSS Administrator. Such a designation allows special Web site commands, such as Deploy, to be used in this project.

wildcard characters

Asterisk (*) and question mark (?) are wildcard characters. You can use these characters to match patterns. You can also use wildcard characters and matching characters to further refine a search.

Symbol | Example | Usage
* | wh* finds what, white, and why; *at finds cat, bat, and what | Like the MS-DOS asterisk (*) wildcard character, this asterisk matches any number of characters.
? | b?ll finds ball, bell, and bill | Like the MS-DOS (?) wildcard character, this symbol matches any single character.

A backslash preceding an asterisk or question mark indicates a literal asterisk or question mark: \* or \? (This is necessary if you want to search for actual asterisks, question marks, or backslashes.) A double backslash (\\) indicates a backslash. Any other use of a backslash is ignored.

working folder

Specified folder on a user's local computer used to store files when they are checked out of the VSS database. A user makes changes to files in the working folder and then checks the modified files back into the VSS database for version tracking.


Append_EOL Initialization Variable

See Also

Indicates whether all text files must end with an end-of-line character. The default is No.

Syntax

Append_EOL = {Yes|No}

Example

Tells VSS not to append an end-of-line character to text files:

Append_EOL = No

Remarks

Some compilers require that all the files they compile end in an end-of-line character. If you are working in such an environment, you may want to set this variable to Yes; it causes VSS to append an end-of-line character whenever it retrieves a text file that does not already end with one.

You can also set this variable in your SS.INI file by using the Append End-of-Line to All Text Files check box on the Local Files tab in the SourceSafe Options dialog box.


Backup_Ext Initialization Variable

See Also

Specifies the extension used to create a backup file when merging. The default is .org, and this variable can be set only by editing SS.INI directly.

Syntax

Backup_Ext = file extension used for merge backups

Example

Sets .org as the extension to be used for backup files:

Backup_Ext = .org

Remarks

When VSS merges a branch of a file and finds a conflict, it replaces the original file with a merged copy that flags all conflicts, so that you can resolve them. If you specify a backup extension, the original (pre-merged) file is saved with the extension specified in this variable.

For example, when checking in Myfile.cpp, VSS creates Myfile.org. It contains the contents of Myfile.cpp before VSS begins the check in, merge, or get operation.


Binary_Masks Initialization Variable

See Also

Sets binary file storage for certain file types.

Syntax

Binary_Masks = mask [, additional masks]

Example

Tells VSS that any files with the .obj and .xls extensions are binary files:

Binary_Masks = *.OBJ, *.XLS

Remarks

This variable overrides VSS's automatic detection of text and binary files, so that you can indicate that certain file types are always binary. You can also set this variable in your SS.INI file by using the Binary File types option on the File Types tab in the SourceSafe Options dialog box.

Normally, VSS checks the contents of a file during an add or checkin to see if it contains text or binary data; but this check can be time-consuming for large files. Setting the Binary_Masks variable speeds up the Add Files and Check In commands for files that you know to be of one type or the other.


Check_Hyperlink_Masks Initialization Variable

Controls the file types in which hyperlinks are checked.

Syntax

Check_Hyperlink_Masks = *.HTM, *.HTML, *.ASP

Example

Specifies that when Web hyperlinks are checked, the links are checked in files with the *.htm, *.html, and *.asp file extension:

Check_Hyperlink_Masks = *.HTM, *.HTML, *.ASP


Checkout_Comment Initialization Variable

See Also

Sets the -C command-line option for the Check Out command. Applies only to the VSS command-line program (SS.exe).

Syntax

Checkout_Comment = valid -C setting

Example

Causes checkout to not prompt for comments by default:

Checkout_Comment = -

Remarks

VSS gives you the option of providing a comment for each file you check out. This is the default behavior. The checkout comment tells other users why you checked out the file, and is then erased when you check in the file with a permanent comment describing the change you made.

The Checkout_Comment variable controls VSS's prompt for a checkout comment. The following settings are all valid.

Does not prompt for a comment at check out:

Checkout_Comment = -

Prompts for one comment for all checked-out files:

Checkout_Comment =

Reads the specified text file as a comment:

Checkout_Comment = @filename

Uses the specified comment:

Checkout_Comment = comment

You can also set this variable in your SS.INI file under Check Out Comments on the Command Line Options tab in the SourceSafe Options dialog box.


Cloak Initialization Variable

See Also

Hides cloaked projects from recursive Get, Check Out, Check In, Undo Check Out, and Project Difference commands.

Syntax

Cloak = {Yes|No}

Example

Instructs VSS to cloak a project so that a recursive Get command, for example, would not affect that project:

Cloak = Yes

Remarks

No is the default setting. This variable can also be set from the File General Properties tab (when a project is selected)


Comment_Editor Initialization Variable

See Also

Determines which editor is used to enter comments. Applies only to the VSS command-line program (SS.exe).

Syntax

Comment_Editor = editor executable file

Example

Sets B.exe as the editor for entering comments:

Comment_Editor = C:\Editors\B.exe

Remarks

VSS normally receives comments by using a command-line prompt. This variable overrides that, telling VSS to bring up the specified editor whenever it has to prompt for a comment. This enables you to enter comments in a familiar editor. Setting it to blank restores prompt-driven comment entry.

If the Editor initialization variable is set, you can set the Comment_Editor to override it on comments while allowing an editor for viewing. You can also set this variable in your SS.INI file under the Comment Prompt options on the Command Line Options tab in the SourceSafe Options dialog box.


Comment_Editor_Prompt Initialization Variable

See Also

Controls the prompt used when entering a comment with an editor. Applies only to the VSS command-line program (SS.exe)

Syntax

Comment_Editor_Prompt = {Yes|No}

Example

Turns the editor prompt on:

Comment_Editor_Prompt = Yes

Remarks

When you are entering a file comment in the VSS command line, the Editor and Comment_Editor initialization variables invoke an editor or word processor in which you can enter your comment. When the editor is displayed, it provides a prompt such as the following:

Enter a comment for TEST.C; then save and exit.

This prompt is not included in your comment; you do not have to delete it (although you can, with no harm, delete it). You can set this variable to No (the default is Yes), so the prompt does not appear in your editor.

You can also set this variable in your SS.INI file under the Comment Prompt options on the Command Line Options tab in the SourceSafe Options dialog box.


Comment_Template Initialization Variable

Sets a template file to be used for comments in VSS Explorer or the comment editor.

Syntax

Comment_Template = template file

Example

Sets Template.txt as the template to be used when entering comments:

Comment_Template = R:\SS\Template.txt

Remarks

This variable points to a template [image] a text file that you create containing a comment template. When the user is prompted for a comment, either in VSS Explorer or in a Comment_Editor used by the command line, the template is placed into the comment field.


Compare Initialization Variable

See Also

Indicates how VSS does its file comparisons, for the purpose of determining whether to get a file.

Syntax

Compare = {Contents|Checksum|Time}

Example

Compares the full contents of the file to determine if a file has changed:

Compare = Checksum

Remarks

When you get or check out a file, VSS does not recopy the file into your working folder if you already have an up-to-date copy there. This variable sets how VSS determines if your local copy is up-to-date. The following options are in order of increasing speed:

  • Contents [image] Compares the full contents of your local copy to the master copy. This is the slowest method, but the only one that works in all cases.

  • Checksum [image] Compares by a checksum stored by VSS. If two files have the same checksum values, but are different, this method fails (this happens rarely).

  • Time [image] Compares the date/time flag. This is the fastest setting, but its accuracy is influenced by the time and date settings of other computers using the file. (This setting is usually used only when your network supports synchronizing all computers on the network.)

As the speed of these options increases, so does the risk that VSS may incorrectly retrieve a file. Accordingly, it is recommended that you use the Contents option.

When using Compare=Time, the exact method of date comparison depends on the setting of the SetTime initialization variable. If SetTime is set to Check In, VSS replaces the local copy if the time of the last checkin (or add) is more recent than the modification date of your local copy. If SetTime is set to Current (the default) or Modification, VSS replaces the local copy if the VSS file's modification time is different from the local copy's modification time.

You can also set this variable in your SS.INI file by using the Compare Files By option on the Local Files tab in the SourceSafe Options dialog box.


ComputerName Initialization Variable

Sets a user-specified computer name for optional display of checked-out files in the file pane of VSS Explorer.

Syntax

ComputerName = computer name string

Example

Sets your computer name to AccountingMachine1:

ComputerName = AccountingMachine1

Remarks

Spaces are allowed in the computer name; quotation marks are not necessary to delimit the string.

VSS displays the computer name in the Check Out Directory column of VSS Explorer. However, VSS cannot obtain the computer name information when running on MS-DOS, Windows 3.x, or the Macintosh. On these platforms, VSS retrieves the computer name from the ComputerName variable and uses it in the VSS Explorer display. If no computer name is specified with this variable, VSS cannot display the computer name.

You can assign the ComputerName variable value to an environment variable if desired. For example, (on MS-DOS).

ComputerName = %COMPUTERNAME%

The % character instructs VSS to read the environment variable to determine the name of the computer.

Note The ComputerName variable is ignored by Windows NT and Windows 95. These platforms always retrieve the computer name from the operating system itself.


CP_OnSelection Initialization Variable

See Also

Indicates whether selecting a project in VSS Explorer automatically sets the current project.

Syntax

CP_OnSelection = {Yes|No}

Example

Indicates that selecting a project automatically switches to it:

CP_OnSelection = Yes

Remarks

If this variable is set to Yes, every time you select a project in VSS Explorer (either with the keyboard arrows or with a mouse click) it becomes your current project. If the variable is set to No, you must press enter (or double-click with the mouse) to make a project your current project.

You can also set this variable in your SS.INI file by using the Make Selected Project the Current Project option on the View tab in the SourceSafe Options dialog box.


Data_Path Initialization Variable

Sets the folder path to the data folder used by VSS to keep version information. Used in SRCSAFE.INI only.

Syntax

Data_Path = folder path

Example

Sets the data folder to the DATA folder in the VSS folder on the \\MIS\Developers share:

Data_Path = \\MIS\Developers\SS4\DATA

Remarks

The VSS administrator should use the default or set this variable only once (before creating a new database).

By default, VSS creates a relative data path variable as part of its setup. This variable is set as Data_Path = DATA. This default causes VSS to look for the DATA subfolder on the path where the SRCSAFE.INI file is located.


Database_Name Initialization Variable

Sets the name of the current VSS database as displayed on the VSS Explorer title bar. Available in the SRCSAFE.INI file only.

Note If you want to use Database Name, either do so before anyone runs VSS or have users delete the listing from their registry HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\SourceSafe\Databases, then start a new session of VSS.

Syntax

Database_Name = character string

Example

Sets the database name to "Information Services":

Database_Name = Information Services

Remarks

Using a product name, project code name, or other descriptive project-oriented label is most appropriate when choosing a database name. If undefined, the VSS Explorer title bar contains the last point of the path to an installation. For example, the title bar for an installation at \\server\share\SS5.0 will contain SS5.0. Note that if the folder name is VSS, the title bar uses the share name instead.


Delete_Local Initialization Variable

See Also

Indicates during Add Files, Check In, and Undo Check Out commands whether or not you are maintaining a local copy of a complete project.

Syntax

Delete_Local = {Yes|No}

Example

Tells VSS not to delete local copies when you are finished with them:

Delete_Local = No

Remarks

By default, when you are working on a project, VSS keeps a copy of the entire project in your working folder. When you set Delete_Local to Yes, VSS only keeps copies of the files that you are currently working on. Therefore, when you add, check in, or undo the check out of a file, instead of flagging it read-only, VSS deletes your local copy of the file.

When this variable is set, you cannot compile out of your working folder, because crucial files may not be in that folder. For this reason, when you set Delete_Local to Yes, you also frequently set a shadow folder for that project.

Even if Delete_Local is set, you can still use the Get Latest Versions command to retrieve a file into your working folder. In that case, the file remains in your working folder until you delete it, or check out and then check in.


Deploy_Host_Local Initialization Variable

Lists the local hosts that do not require a proxy server for FTP deployment.

Syntax

Deploy_Host_Local = ftp.microsoft.com

Example

Specifies that when the Web site project is deployed, no proxy server is required for the ftp.microsoft.com site:

Deploy_Host_Local = ftp.microsoft.com

Remarks

If a Deploy_Proxy initialization variable is specified, it is used for all FTP deployment, except for the server(s) specified in Deploy_Host_Local.


Deploy_Path Initialization Variable

See Also

Specifies the location to which files are copied when a user chooses the Deploy command from the VSS Web menu.

Syntax

Deploy_Path = folder

Example

Instructs VSS to deploy files to the \\internet\server1\ssafe location when the Deploy command is selected:

Deploy_Path = \\internet\server1\ssafe

Remarks

Used only for projects marked as Web site projects by the URL initialization variable. (You can also mark a project as a Web site project using the VSS Administrator Web Sites tab from Options on the Tools menu.) The location for deploying files can also be set from the Web Sites tab. You can set multiple deployment paths, separated by a comma.


Deploy_Proxy Initialization Variable

Specifies the name of your proxy server.

Syntax

Deploy_Proxy = proxyname

Example

Specifies that the corporate intranet requires VSS to use the myproxy proxy server to access external FTP sites:

Deploy_Proxy = myproxy

Remarks

You can set only one proxy server here.


Diff_Format Initialization Variable

See Also!ALink()

Controls the format used with the Show Differences (File) command on the Tools menu.

Syntax

Diff_Format = {SS|UNIX|Visual}

Example

Tells VSS to use a visual (side-by-side) difference display:

Diff_Format = Visual

Remarks

When you use the Show Differences (File) command to show the differences between two files, VSS can display the file differences in three ways.

  • SS [image] Lists lines added, deleted, or changed.

  • UNIX [image] Displays the standard output form of the UNIX Diff utility.

  • Visual [image] Shows two files side by side, with different lines color-coded.

If you do not specify a preferred format, VSS Explorer defaults to Visual, and the command line defaults to the SS display. However, if you set this variable, both VSS Explorer and the command line switch their default to your setting. In any case, you can always override the default with command-line options and in the SourceSafe Options dialog box on the Tools menu.


Diff_Ignore Initialization Variable

Controls the factors that are considered or ignored when using the Show Differences (File) command on the Tools menu.

Syntax

Diff_Ignore = list of options

Example

Ignores end-of-line differences, and displays all others:

Diff_Ignore = c-es-w-

Remarks

The VSS Show Differences (File) command is used to display all the relevant changes to a file. This variable defines what is a relevant change. You can control four issues in this variable.

  • C [image] case sensitivity

  • E [image] end-of-line characters

  • S [image] small differences

  • W [image] white-space changes

The format of the variable is a list of these four letters, with a dash after any variable that should not be ignored. In the preceding example (also the default), E is the only letter that is not followed by a dash; consequently, end-of-line characters are the only differences ignored.


Dir Initialization Variable

See Also

Associates a working folder with a specific project. This variable is automatically set by the Set Working Directory command. It is recommended that you do not set this variable manually.

Syntax

Dir = directory path

Example

Associates the directory C:\Word with the project $/Word:

[$/WORD]
Dir (PC) = C:\WORD

Remarks

When you are working on a project, you generally have a local directory, on your hard disk or on the network, where you keep your source code and work on the project.

The Dir command displays where your working directory for a particular project is stored. When you change to a new project, VSS automatically sets your working directory to this directory.

The use of the Dir variable can be further strengthened by setting either or both of the Force_Dir and Force_Prj variables to Yes.


Double_Click Initialization Variable

Determines default behavior when you double-click on a filename in the VSS Explorer.

Syntax

Double_Click= {View|Edit|Ask}

Example

Instructs VSS to present a dialog box asking whether you want to edit or view a file double-clicked in the VSS Explorer:

Double_Click = Ask

Remarks

Ask is the default setting.


Editor Initialization Variable

See Also

Determines which editor is used to enter comments and view files.

Syntax

Editor = editor executable file

Example

Sets the comment and view editor to Me.exe:

Editor = C:\Me\Me.exe

Remarks

When you use the View command, VSS looks for the application it should run to display the file. The last place it looks is in the initialization files, for the Editor variable. Because this variable is not extension-specific, it is not generally the best place to specify an editor. However, it can be useful to set a default editor for all files whose extensions are not found.

The VSS command line also uses the variable specified here for comments, unless you override it with the Comment_Editor initialization variable.

You can also set this variable in your SS.INI file by using the File Viewer option on the General tab in the SourceSafe Options dialog box.


EOL Initialization Variable

See Also

Sets the end-of-line character used when VSS gets text files.

Syntax

EOL = {n|rn}

Example

Uses a carriage-return/line-feed pair at the end of each text line:

EOL = rn

Remarks

Different operating systems use different end-of-line characters in text files. UNIX uses a line feed; MS-DOS uses a carriage-return/line-feed pair.

No matter what end-of-line character VSS finds in a file, it reads it correctly. This initialization variable affects what character VSS outputs when it gets a text file. By default, VSS uses the standard for its operating system. If you set this variable, VSS uses whatever character you specify.


Expand_Keywords_Locally Initialization Variable

See Also

Controls whether VSS automatically replaces keyword-expanded files in your working folder.

Syntax

Expand_Keywords_Locally = {Yes|No}

Example

Performs the Get command automatically after any Check In or Add command that causes keyword expansion:

Expand_Keywords_Locally = Yes

Remarks

When you check in a file and have keyword expansion enabled, VSS may replace certain keywords in your file with version information. The modified file is copied back into VSS. If this variable is set to Yes, the modified file is then copied directly back into your directory. If you set this variable to No, the file is not copied back; this improves performance, but the copy in your working directory may not be completely up-to-date.

You can also set this variable in your SS.INI file by using the Copy Keyword-Expanded Files Into Working Directory option on the Local Files tab in the SourceSafe Options dialog box.


Extension_Association Initialization Variable

Associates a file extension with the editor used when viewing a file.

Syntax

extension association = name of executable editor file

Example

Sets the editor to WinHelp.exe when viewing files with the .hlp extension:

.hlp = winhelp.exe

Remarks

This variable is used to override (for VSS only) the extension associations you have in Windows File Manager or Windows Explorer. You only have to use this variable for VSS running on MS-DOS.


External_Link_File Initialization Variable

See Also

Specifies the location of the file used to list external Web links deemed valid by a VSS user.

Syntax

External_Link_File = file path

Example

Specifies that the Links.txt and Goodlinks.txt files hold the list of validated Web links associated with a VSS Web site project:

External_Link_File = \\VSSserver\links.txt, c:\webproj\goodlinks.txt

Remarks

The links file is a text file list of URLs that are considered valid, even though they have not been validated by VSS. You can specify a comma-delimited list of files to keep several copies of the link list. This can be set using the VSS Administrator Web Sites tab located in Options on the Tools menu.


File_Types Initialization Variable

See Also

Fills the List Files of Type combo box in the Add Files dialog box in Microsoft Windows.

Syntax

File_Types = file types

Example

Places two items in the combo box, C Files and Batch files:

File_Types = C Files (*.C; *.H), Batch files (*.BAT)

Remarks

In the VSS Add Files dialog box, the List Files of Type combo box is used to filter the file list to show only files of certain types. Showing all files is always an option. If you set the Relevant_Masks initialization variable, that setting is an option as well. This initialization variable is used to set other options that appear in the combo box. In the preceding example, for instance, C Files and Batch Files both appear as options; if you choose C Files, the file list shows all files with the extension .c or .h.

You can also set this variable in your SS.INI file by using the File Groups option on the File Types tab in the SourceSafe Options dialog box.


FileType Initialization Variable

See Also

Indicates which type of file is used.

Syntax

FileType = {Binary|Text|Auto-Detect}

Example

Automatically detects the file type:

FileType = Auto-Detect

Remarks

This variable overrides VSS's automatic detection of text and binary files, and indicates that all files are text or binary. Generally, this variable is defined globally for all projects. If you use it, you should apply it only to specific subprojects when you know that all files in a subproject are of a specific type. For example, if you have a project named $/Executables with two subprojects $/Executables/DLLs and $/Executables/EXEs, you may want to put the FileType=Binary variable setting under the heading [$/Executables] to speed up Add Files and Check In operations.


Force_Dir Initialization Variable

See Also

Strengthens the use of the Dir initialization variable.

Syntax

Force_Dir = {Yes|No}

Example

Indicates normal use of the Dir variable:

Force_Dir = Yes

Remarks

The Dir initialization variable is used to specify your working folder for a project. The Dir variable controls where VSS Explorer retrieves files. If Force_Dir is set to No, that is the only effect of the Dir variable. However, if you set Force_Dir to Yes (which it is by default), the Dir variable is used in two other circumstances.

  1. On the VSS command line, when you get or check out a file, the file goes into the current directory. But if Force_Dir is set to Yes, the file goes into your working directory for the project, even if that is not the current directory.

  2. When you perform a recursive get on a project, subdirectories are created for each subproject. For instance, for the subproject HELLO, a directory called HELLO is created, so the entire project list is copied into a directory tree. But if Force_Dir is set to Yes, subprojects go into their own respective working directories instead of into subdirectories under the main directory.

You can also set this variable in your SS.INI file by using the Assume a Directory, Based on the Current Project option on the Command Line Options tab in the SourceSafe Options dialog box.


Force_Prj Initialization Variable

See Also

Automatically sets the current project, based on the current directory. Applies only to the VSS command-line program (SS.exe).

Syntax

Force_Prj = {Yes|No|Ask}

Example

Instructs VSS not to automatically change the current project:

Force_Prj = No

Remarks

  • Yes [image] First looks at your current directory whenever you execute any VSS command. If this is the working folder for a VSS project, VSS automatically changes to that project before executing the command. You can change directories to move around your projects, without executing the SS CP command.

  • No [image] Does not change to your current project.

  • Ask [image] Prompts before changing your project.

If you set Force_Prj = Yes, it is highly recommended that you do not give two projects the same working directory, because VSS won't know which project to switch into.

You can also set this variable in your SS.INI file by using the Assume Project Based on Working Directory option on the Command Line Options tab in the SourceSafe Options dialog box.


History_Include_Files Initialization Variable

See Also

Sets whether files are included automatically in project history reports.

Syntax

History_Include_Files = {Yes|No}

Example

Sets VSS to automatically include files in the project-level Show History command:

History_Include_Files = Yes

Remarks

You can also set this variable using the Include Files check box in the Project History Options dialog box.


IMG_File Initialization Variable

Specifies the graphics file you want to use to represent a file when generating a site map from a Web site project.

Syntax

IMG_File = HTMLFILE.GIF

Example

Instructs VSS to use the REDDOT.JPG file instead of the default HTMLFILE.GIF in the site map it generates:

IMG_File = REDDOT.JPG


IMG_Folder Initialization Variable

Specifies the graphics file you want to use to represent a folder when generating a site map from a Web site project.

Syntax

IMG_Folder = FOLDER.GIF

Example

Instructs VSS to use the BLUEDOT.JPG file instead of the default FOLDER.GIF in the site map it generates:

IMG_Folder = BLUEDOT.JPG


Journal_File Initialization Variable

Sets a file name where all VSS commands that change stored data are logged. Used in the SRCSAFE.INI file only.

Syntax

Journal_File = filename

Example

Sets SSLog.txt as a journal of all VSS commands:

Journal_File = O:\Docs\SSLog.txt

Remarks

This variable is generally set in SRCSAFE.INI, rather than in SS.INI, so that it applies to all users. If this variable is set, the file becomes a journal of VSS actions. The journal is a text file that is updated automatically by VSS to show the various actions that users take. Only actions that change data stored in the database are logged.

To set this variable in the SRCSAFE.INI file, on the Tools menu, click Options, then select Log All Actions In Journal File from the General tab.


Keep_Checkedout Initialization Variable

See Also

Indicates whether you want to keep files checked out when you check in or add them.

Syntax

Keep_Checkedout = {Yes|No}

Example

Instructs VSS not to check all files back out to you immediately after updating or adding them:

Keep_Checkedout = No

Remarks

After you add or check in a file, you cannot immediately modify it, because it is no longer checked out. In some situations [image] particularly on one-person projects [image] you always want to have all the files checked out. In that case, set Keep_Checkedout to Yes, which instructs VSS to immediately check the file back out to you whenever you check in or add a file.

In VSS Explorer, Keep_Checkedout sets the default state of the Keep Checked Out box in the Check In dialog box, which you can toggle for specific cases. (On the command line, you can override this variable with the -K (or -K-) command-line option.)

You can also set this variable in your SS.INI file by using the Always Keep Files Checked Out option on the General tab in the SourceSafe Options dialog box.


Keyword_Masks Initialization Variable

See Also

Indicates which files to use or not to use with keyword expansion. Used in the SRCSAFE.INI file.

Syntax

Keyword_Masks = masks

Example

Indicates that all .C and .H files except for SS.C should be keyword expanded:

Keyword_Masks = *.C, *.H, !SS.C

Remarks

By default, VSS does not scan files for keyword expansion when it performs a Check In or Add Files command. Set this variable to indicate which VSS files should be keyword expanded, noting that the Add File and Check In commands may be slower for these files.

You can also set this variable in the SRCSAFE.INI file with the Expand Keywords In Files Of Type option, which is accessed by clicking Options on the Tools menu, then selecting the General tab.


Lock_Mode Initialization Variable

Sets the type of database locking used by VSS. Available in the SRCSAFE.INI file only.

Syntax

Lock_Mode = {Native|Lockfile}

Example

Indicates that native locking is used by VSS to avoid database record collisions:

Lock_Mode = Native

Remarks

Native locking uses the operating system's inherent file and record locking capabilities (through the fcntl system call). This system is very fast, but may not be supported if you are running VSS across multiple UNIX machines.

Lockfiles are a VSS-specific mechanism, involving creation of special files in the VSS Data\Locks folder, which achieve the same database record locking as the Native setting. This method is slower than native locking, but works in networked and cross-platform situations.

It is important to choose the right locking mechanism for your system. If you are running VSS exclusively on Microsoft Windows NT machines, use native locking (the default). If you are running VSS in an environment where byte locks to the database are not supported, use Lockfile. This prevents collisions that might cause unpredictable results in the VSS database. If you are not sure if your network supports native locking, use the Testlock.exe program.

Note If VSS does not exit normally, in some circumstances the UM.LCK file may be left in the Data\Locks directory. Delete this file manually to avoid Testlock errors or unpredictable behavior with the Lock_Mode variable.


Long_Filenames Initialization Variable

See Also

Controls VSS' use of filenames longer than the MS-DOS standard.

Syntax

Long_Filenames = {Yes|No}

Example

Instructs VSS to work with pathnames up to 255 characters long:

Long_Filenames = Yes

Remarks

This variable toggles VSS between long filename mode (in which complete paths, including filenames, must not exceed 255 characters) and short filename mode (in which MS-DOS format names are used for all files). The default is Yes. It is particularly relevant under Windows NT, which supports both long-filename file systems and the MS-DOS FAT system.

You can also set this variable in your SS.INI file by using the Always Display MS-DOS Format Filenames option on the View tab in the SourceSafe Options dialog box.


Lowercase_Files Initialization Variable

See Also

Controls how file names are displayed in VSS Explorer.

Syntax

Lowercase_Files = {Yes|No}

Example

Instructs the VSS Explorer to show all files in uppercase:

Lowercase_Files = No

Remarks

In its normal mode, VSS displays files in the case in which they were added. If this variable is set to Yes, however, VSS displays files and directories in all lowercase.

Note that this variable has no effect on the display of project names, which retain the case with which you created them.

You can also set this variable in your SS.INI file by using the Show Filenames in Lowercase Letters option on the View tab in the SourceSafe Options dialog box.


Mark_Merges Initialization Variable

See Also

Indicates whether VSS should make a note of all merges, including those with no conflicts. The default is No.

Syntax

Mark_Merges = {Yes|No}

Example

Instructs VSS to note conflict areas only:

Mark_Merges = No

Remarks

When you merge two files and a conflict occurs, VSS creates a temporary file with marks for all the conflicts. If you set this variable to Yes, VSS marks all the changes it has detected and merged, including those that did not result in a conflict of any kind. It also makes each mark more explicit, by showing the original code as well as the two changed sets.

If you set this variable to No, VSS marks only the changes that conflict. It uses conflict markers to indicate the changes so you can resolve the conflicts.

You can also set this variable in your SS.INI file by using the Display All Changes After a Merge option on the General tab in the SourceSafe Options dialog box.


Menu_Help Initialization Variable

Indicates whether the VSS status bar displays automatic help on selected menu items and icons.

Syntax

Menu_Help = {Yes|No}

Example

Instructs VSS to always display a Help line on the status bar when a menu item or icon is selected:

Menu_Help = Yes

Remarks

When this variable is set to Yes, as you scroll through a menu or click an icon, the status bar at the bottom of VSS Explorer shows a brief description of the currently selected command.


Merge_Ext Initialization Variable

See Also

Sets the extension used by VSS to create a temporary merge file. The default is .mrg.

Syntax

Merge_Ext = extension of temporary merge file

Example

Gives all temporary merge files the extension .mrg:

Merge_Ext = .mrg

Remarks

When VSS performs an automatic merge, it creates a temporary file with this extension in which to perform the merge. When the merge is complete, VSS either renames this file or deletes it; so, in general, you should never see this file. However, in case of failure during a merge, you can look for the .mrg copy of the file.


Merge_Ignore Initialization Variable

Tells VSS to ignore white space characters when merging files.

Syntax

Merge_Ignore = w

Example

Instructs VSS to ignore white space characters like tab and space while performing a merge operation:

Merge_Ignore = w

Remarks

You can also set this variable using the Tools, Options, Difference tab in the VSS Explorer. Check the Ignore white space differences when merging files checkbox to do this.


Multiple_Checkouts Initialization Variable

Controls the number of people checking out one file simultaneously. Used in the SRCSAFE.INI file only.

Syntax

Multiple_Checkouts = {Yes|No}

Example

Indicates that only one person can have a file checked out at one time (the default):

Multiple_Checkouts = No

Remarks

Under ordinary circumstances, a check out in VSS is exclusive, so that only one person can have a file checked out at one time. However, if you set this variable to Yes in your SRCSAFE.INI file, VSS allows multiple users to check out the same file. When the first user checks in the file, VSS updates the file. Thereafter, VSS merges all subsequent changes.

You can also set this variable in the SRCSAFE.INI file with the Allow Multiple Checkouts option, which is accessed by clicking Options on the Tools menu, then selecting the General tab.

Note Multiple checkouts are not allowed on binary files.


Output Initialization Variable

See Also

Sets the default method for displaying output.

Syntax

Output = valid -O setting

Example

Paginates all output by default:

Output =

Sends all output to the file Outlog.txt by default:

Output = Outlog.txt

Remarks

On the VSS command line, the Output initialization variable sets a default for the -O command-line option to any function. The first example above is equivalent to -O, and tells VSS to paginate its output. The second is equivalent to -oOutlog.txt, an instruction to redirect all output into a file.


OutputWindow Initialization Variable

See Also

Controls the use of the bottom pane which displays the results of VSS operations. Note that the old name of this variable, Results_Window, is obsolete.

Syntax

OutputWindow = {Yes|No}

Example

Displays the Results pane:

OutputWindow = Yes

Remarks

When you perform a command such as Get Latest Version, VSS displays the results of the command in the Results pane.

If you set this variable to No, the Results pane is not displayed. Errors are reported in the standard error message window.

You can also set this variable in your SS.INI file by using the Show Results pane option on the View tab in the SourceSafe Options dialog box.


Project Initialization Variable

Stores a user's current project. Set automatically when you exit VSS.

Caution Do not set the variable manually.

Syntax

Project = current Visual SourceSafe project

Example

Indicates that the root project is your current project:

Project = $/

Remarks

Your current project is stored in this variable in your SS.INI file.


Reconcile_Project Initialization Variable

See Also

Determines default behavior when reconciling differences between projects with the Show Differences command.

Syntax

Reconcile_Project = {Get|Ignore, Delete from folder|Recover deleted file|Add to project|Ignore, Add to project|Ignore, Check In|Undo Check Out|Get|Ignore, Get|Ignore}

Example

Instructs VSS to use the normal default behaviors for reconciling project differences in the Reconcile All Differences dialog box:

Reconcile_Project = Get, Delete, Add, Check In, Get

Remarks

Changing this variable allows you to customize the default choices in the Reconcile All Differences dialog box. The setting for this variable are used when you specify the -F option for the Project Difference command line command.

The first three settings are to specify behavior for reconciling files that appear in only one list:

For files that are not in your working folder. This specifies what you want to happen when VSS finds files that are not in your working folder, but are in the project. Specify Get (the default) to get files missing from your working folder. Specify Ignore to take no action with these files.

Files that are deleted in the project. This specifies what you want to happen when VSS finds files that are in your working folder, but have been deleted in the project. Specify Delete from folder (the default) to delete these files from your working folder. Specify Recover delted file to recover the deleted file and place a copy in your working folder. Specify Add to project to add these files back to your project. Specify Ignore to take no action with these files.

Files that are not in the project at all. This specifies what you want to happen when VSS finds files that are not in your project, but are in your working folder. Specify Add to Project (the default) to add these files to your VSS project. Specify Ignore to take no action with these files.

The last two settings specify behavior for reconciling files that appear in both lists:

Files that you have checked out. This specifies what you want to happen when VSS finds files that are checked out to you, and are different in your working folder. Specify Check In (the default) to check these files into your VSS project. Specify Undo Check Out to undo the check out on these files. Specify Get Latest Version to overwrite your checked out file with a read-only copy (losing any changes you may have made). Specify Ignore to take no action with these files.

Files that you do not have checked out. This specifies what you want to happen when VSS finds files that are not out to you, but are different in your working folder. Specify Get Latest Version (the default) to get the latest version of these files. Specify Ignore to take no action with these files.


Recursive Initialization Variable

See Also

Indicates whether VSS operations act recursively by default.

Syntax

Recursive = {Yes|No}

Example

Indicates that commands operate only on the current or specified project, without going into all subprojects:

Recursive = No

Remarks

Many VSS commands (such as Get or Show History) can be performed on a specific project (and all the files directly in it), or recursively down an entire project tree. You can always make a particular command recursive by choosing the appropriate check box in VSS Explorer, or specifying the -R command-line option. If you set this variable to Yes, however, all commands are recursive by default.

You can also set this variable in your SS.INI file by using the Act on Projects Recursively option on the General tab in the SourceSafe Options dialog box.


Refresh_Display Initialization Variable

See Also

Controls whether VSS automatically refreshes its file list in the file pane of VSS Explorer.

Syntax

Refresh_Display = {Yes|No}

Example

Instructs VSS Explorer to periodically rebuild its file list:

Refresh_Display = Yes

Remarks

Periodically, VSS Explorer refills its file list, so that any changes users have made are reflected in the display. Refreshing keeps the VSS screen up-to-date, but it also causes a momentary delay. This variable controls whether VSS automatically refreshes its file list; if it is set to Yes (the default), Refresh_Interval controls how often. If this variable is set to No, you may want to manually refresh the file list periodically, using the Refresh File List command on the View menu.

You can also set this variable in your SS.INI file by using the Automatically Refresh File List option on the View tab in the SourceSafe Options dialog box.


Refresh_Interval Initialization Variable

See Also

Sets the time between file list auto-refreshes.

Syntax

Refresh_Interval = number of seconds

Example

Sets the refresh interval to 300 seconds (5 minutes):

Refresh_Interval = 300

Remarks

Periodically, VSS Explorer refills its file list, so that any changes other users have made are reflected in the display. Refreshing keeps the VSS screen up-to-date, but it also causes a momentary delay.

You can force refreshes manually with the Refresh File List option in the View menu, but if automatic refresh is on (as it is by default), this variable can be used to change the time delay between refreshes.

You can also set this variable in your SS.INI file by using the Automatically Refresh File List option on the View tab in the SourceSafe Options dialog box.


Relevant_Masks Initialization Variable

See Also

Sets the VSS Add command mask.

Syntax

Relevant_Masks = masks

Example

Restricts the Add command to files with the extensions .c, .h, or none:

Relevant_Masks = *.C, *.H, *.

Restricts the Add command to all files except those with the extension .obj:

Relevant_Masks = !*.OBJ

Remarks

A typical VSS working folder contains a number of important code files that are in the VSS project, and a number of unimportant intermediate files that are not in the project. For instance, in a C directory, the .c and .h files contain the code; the .obj files, which are byproducts of the process, are not placed in the project.

Relevant_Masks indicates which files you would typically place into a project. This does not prevent you from placing other files into the project; however, it does have several potentially useful effects.

First, if you add an entire directory into VSS in one command (by typing ss add * on the VSS command line, or dragging a directory from File Manager into VSS), only files matching the relevant masks are added. Other files can then be added individually.

Second, when you run the VSS Show Differences command on a project level to compare the current project to your working directory, files that do not match the relevant masks are not displayed as differences.

Finally, the relevant masks are used as the default option in the Add Files of Type combo box in the Add Files dialog box; therefore, by default, only these files are displayed.

You can also set this variable in your SS.INI file by using the File Types tab in the SourceSafe Options dialog box.


Replace_Writable Initialization Variable

See Also

Controls what happens when you attempt to get or check out a file on top of a writable file. The default is Ask.

Syntax

Replace_Writable = {Merge|Replace|Ask|Skip}

Example

Instructs VSS not to overwrite writable files:

Replace_Writable = No

Remarks

When you get or check out a file, VSS copies the file into your working folder. If there is already a writable (non-read-only) copy of the file in your working directory [image] for instance, if you have the file checked out [image] overwriting the file may destroy your work.

VSS provides four ways to handle this situation.

  • Merge [image] Merges any differences between the master copy of the file and the file in your working directory into your working directory copy. This is useful when you want to ensure that you are getting changes from other users and you have the file checked out. If you have this option set and don't have the file checked out, VSS automatically treats the file as if you had the Skip option set.

  • Replace [image] Replaces the file.

  • Ask [image] Gives you an option each time VSS encounters this situation.

  • Skip [image] Does not replace the file, and does not generate an error.

You can also set this variable in your SS.INI file by using the Replace Other Writable Files option on the Local Files tab in the SourceSafe Options dialog box.

Use the Replace_Checkout initialization variable to control how VSS treats writable files in your working directory when you get or check out files that you previously checked out.


Results_Window Initialization Variable

See Also

Controls the use of a scrolling window that displays the results of a VSS operation.

Syntax

Results_Window = {Yes|No}

Example

Places command results in a window:

Results_Window = Yes

Remarks

When you perform a command such as Get, VSS displays the results of the command in the Results window. After the command is completed, the window closes, but can be retrieved by the Last Results command on the View menu.

If you set this variable to No, the Results window is never displayed. Errors are reported in the standard error message window.

You can also set this variable in your SS.INI file by using the Show Results Window option on the View tab in the SourceSafe Options dialog box.


Reuse_Comment Initialization Variable

See Also

Instructs VSS Explorer to fill in comments with the last comment entered.

Syntax

Reuse_Comment = {Yes|No}

Example

Turns off last-comment use:

Reuse_Comment = No

Remarks

When VSS Explorer prompts you for a comment, if you do not have a Comment_Template set, the comment is initially blank. However, if you set this variable to Yes, the comment field is automatically filled in with the most recent comment you entered. This makes it easy to use the same comment repeatedly; or, you can start typing to replace the previous comment with a new one.

You can also set this variable in your SS.INI file by using the Reuse Last Comment option on the General tab in the SourceSafe Options dialog box.


Save_Settings Initialization Variable

See Also

Sets whether a file-level Show Differences command's optional settings are saved between VSS sessions.

Syntax

Save_Settings = {Yes|No}

Example

Instructs VSS to save the file-level Show Differences settings between sessions:

Save_Settings = Yes

Remarks

Affects only the file-level settings for the Show Differences command on the Tools menu.


SetTime Initialization Variable

See Also

Controls the date and time given to your local copies by a Get command.

Syntax

SetTime = {Current|Mod|Update}

Example

Gives files a new date/time stamp when VSS gets them:

SetTime = Current

Remarks

  • Current [image] Sets the date and time of the file to the current date and time by default, whenever VSS gets a file (with the Get, Check Out, or Undo Check Out command). This signals the compiler that the file has just changed, and has to be recompiled.

  • Modification [image] Sets the local copy to the date and time the file was last modified.

  • Update [image] Sets the local copy to the date and time the file was last checked in.

You can also set this variable in your SS.INI file by using the Set Date/Time on Local Files option on the Local Files tab in the SourceSafe Options dialog box.


Shadow_DOSName Initialization Variable

See Also

Controls whether VSS places long file names in the shadow folder. Used in the SRCSAFE.INI file only.

Syntax

Shadow_DOSName = {Yes|No}

Example

Allows long file names in the shadow folder:

Shadow_DOSName = No

Remarks

Versions of VSS that support long file names (Windows NT and Macintosh) can place these long file names into a shadow folder. However, in a cross-platform environment, this may not be wanted, as it may create file names that are unreadable to MS-DOS. This variable can therefore be used to force all versions of VSS to truncate names to MS-DOS standard names in the shadow folder.


Shadow_EOL Initialization Variable

See Also

Sets the end-of-line character used in the shadow folder. Used in the SRCSAFE.INI file only.

Syntax

Shadow_EOL = {n|r|rn}

Example

Terminates all lines in the shadow folder with carriage-return/line-feed pairs:

Shadow_EOL = rn

Remarks

When VSS copies a file into the shadow folder, it uses the end-of-line character used by its own operating system. For instance, VSS for MS-DOS uses a carriage-return/line-feed pair. In a multiple-platform environment, the files in the shadow folder are therefore a mixture of end-of-line characters, based on which operating system each file was updated from most recently.

This variable overrides that mechanism, forcing all versions of VSS to use the specified end-of-line character. Set the variable to n for line feeds (the UNIX default), r for carriage returns, or rn for carriage-return/line-feed pairs (the Intel default).

You can also set this variable in the SRCSAFE.INI file with the End of Line Characters For Files option, which is accessed by clicking Options in the Tools menu, then selecting the Shadow Folders tab.


Shadow_Extension Initialization Variable

See Also

Changes the extension of files placed in the VSS shadow folder. Used in the SRCSAFE.INI file only.

Syntax

Shadow_Extension = extension

Example

Sets the shadow extension to ??V:

Shadow_Extension = ??V

Remarks

By default, all files are given the same name in the shadow folder that they have in VSS. However, in some cases (especially for the sake of Make utilities), you may want files in the shadow folder to have extensions different from their real counterpart. Therefore, you can use this variable to set the extension that is used for files in the shadow folder.

For example, if you set this variable to .sdw, all files in the shadow folder are given the extension .sdw. However, this does not enable you to distinguish different file types; the question mark is therefore provided as a special character, which tells VSS to use the actual character. Hence, in the above example ??V, the extension .pas turns into .pav. The extension .c turns into .c_v.


Shadow_ReadOnly Initialization Variable

See Also

Controls whether files in the shadow folder are read-only. Used in the SRCSAFE.INI file only.

Syntax

Shadow_ReadOnly = {Yes|No}

Example

Specifies that all VSS files in the shadow folder are read-only (the default):

Shadow_Readonly = Yes

Remarks

This variable turns on the read-only flag for all files that VSS places in the shadow folder.

You can also set this variable in the SRCSAFE.INI file with the Set Read Only Flag For All Files option, which is accessed by clicking Options on the Tools menu, then selecting the Shadow Folders tab.


Shadow_SetTime Initialization Variable

See Also

Controls the date and time given to files in the shadow folder. Used in the SRCSAFE.INI file only.

Syntax

Shadow_SetTime = {Current|Mod|Update}

Example

Stamps shadow files with the date and time they are placed into the shadow folder (the default):

Shadow_SetTime = Current

Remarks

This variable affects the date and time stamp given to files in the shadow folder, in the same way SetTime affects files in your working folder.

You can also set this variable in the SRCSAFE.INI file with the File Date/Time option, which is accessed by clicking Options on the Tools menu, then selecting the Shadow Folders tab.


Shadow Initialization Variable

See Also

Sets a shadow folder for a project. Used in the SRCSAFE.INI file only.

Syntax

Shadow = shadow folder

Example

Sets M:\Masters\Word as a shadow folder for the project $/WORD:

[$/WORD]
Shadow = M:\MASTERS\WORD

Remarks

This variable references a shadow folder created for your project. This folder shadows the project, reflecting every file change in its own contents, and remains up-to-date. Before setting this variable, you must create the shadow folder somewhere and populate it with the files you want maintained there (using the Get Latest Versions command to that folder is the easiest way). From that point on, the files you've put in this shadow folder are kept up-to-date. Also, any new files added or deleted from the project in the VSS database are updated in the shadow folder.

The shadow folder should not be the folder you work from and modify code in. It is a separate folder that is maintained by VSS. However, you can go there and build your project or examine the code, as the folder reflects the exact current state of the project.

You can also set this variable in the SRCSAFE.INI file with the Set Shadow Folder For Project option, which is accessed by clicking Options on the Tools menu, then selecting the Shadow Folders tab. If you use the Shadow Folders tab, you do not need to use the Get Latest Versions command to initialize the folder.


SiteMap Initialization Variable

See Also

Specifies the location of the HTML file generated when a user selects the Create Site Map command from the VSS Web menu.

Syntax

SiteMap = file path

Example

Specifies that the Sitemap.html file is the auto-generated site map for the project under which this variable appears:

SiteMap = c:\webproj\sitemap.html

Remarks

This variable can also be set from the Web Sites tab that can be accessed from the Tools menu, by clicking Options, then selecting Administrator.


Skip Initialization Variables

Controls the use of option dialog boxes on commands in VSS Explorer.

Syntax

Skip_variable name = {Yes|No}

Examples

Skip_FCheckout = No
Skip_PCheckout = Yes
Skip_FGet = No
Skip_PGet = Yes
Skip_FUncheckout = No
Skip_Pdeploy = Yes
Skip_Psitemap = Yes
Skip_PUncheckout = Yes
Skip_FDiff = No
Skip_PDiff = Yes
Skip_FHistory = No
Skip_PHistory = No

Remarks

When you execute a command in VSS Explorer, you can choose whether to display a dialog box that gives you a variety of options to set. The advantage of the dialog box is that it enables you to treat each execution of a command differently. The disadvantage is that it adds at least one extra step to every common operation.

By default, VSS does not display each dialog box when you perform a command on a file; it displays the dialog box when you perform a command on a project. These variables can be used to alter those defaults; for instance, if you set Skip_PGet = Yes, no dialog box is displayed when you perform a project-level Get command. If you set Skip_FCheckout = No, VSS displays the Check Out command dialog box when you use the file-level Check Out command.

You can also set these variables in your SS.INI file by using the options on the Command Dialogs tab in the SourceSafe Options dialog box.


Smart_Mode Initialization Variable

See Also

Enables and disables the VSS SmartMode feature.

Syntax

Smart_Mode = {Yes|No}

Example

Disables the VSS SmartMode feature:

Smart_Mode = No

Remarks

Smart_Mode tells VSS whether or not to use its SmartMode features. The SmartMode features are:

  • When you create or recover a project, VSS sets the new project as the current project.

  • When you delete or destroy a file, VSS deletes the corresponding local copy.

  • When you rename a file, VSS renames the corresponding local copy.

You can also set this variable in your SS.INI file by using the Remove Local Files After Delete option on the Local Files tab in the SourceSafe Options dialog box.


Status_Bar Initialization Variable

Shows and hides the status bar in VSS Explorer.

Syntax

Status_Bar = {Yes|No}

Example

Displays the status bar:

Status_Bar = Yes

Remarks

The status bar shows information on the files displayed in the file pane of VSS Explorer, such as sort order, check out name, number of files in the project, and so on. It also displays status and Help messages.

You can also set this variable in your SS.INI file by using the Show Status Bar option on the View tab in the SourceSafe Options dialog box.


Store_Deltas Initialization Variable

Sets whether VSS stores change information between versions of a file. The default is Yes.

Syntax

Store_Deltas = {Yes|No}

Example

Stores all changes between file versions:

Store_Deltas = Yes

Remarks

You should use this variable rarely. Setting this variable to No saves disk space on the VSS server, but doesn't allow you to re-create past versions of files.

When you add files to VSS, the Add Files command lets you decide if VSS retains its old version of a file or only the latest version by using the Store Only Latest Version check box in the Advanced options in the Add Files dialog box. Setting the Store_Deltas variable controls the default setting of this option. The default is Yes, but you can manually override this setting for individual files in the Add Files dialog box.


Temp_Path Initialization Variable

See Also

Sets the folder where VSS stores temporary files.

Syntax

Temp_Path = path to Visual SourceSafe temporary folder

Example

Indicates that the temp path is a folder called Temp immediately under the folder that contains SRCSAFE.INI:

Temp_Path = Temp

Remarks

This variable can also be set in your SS.INI file by using the Folder for Temporary Files option that can be accessed from the Tools menu, by clicking Options, then selecting the General tab.


Toolbar Initialization Variable

See Also

Shows or hides the toolbar in VSS.

Syntax

Toolbar = {Yes|No}

Example

Displays the toolbar:

Toolbar = Yes

Remarks

At the top of VSS Explorer is the toolbar, or icon bar, which gives quick mouse access to some of the most common VSS features.

You can also set this variable in your SS.INI file by using the Show Toolbar option on the View tab in the SourceSafe Options dialog box.


ToolTips Initialization Variable

See Also

Sets whether ToolTips are displayed as you drag the mouse pointer over a toolbar button.

Syntax

ToolTips = {Yes|No}

Example

Displays ToolTips:

ToolTips = Yes

Remarks

You can also set this variable using the Show ToolTips check box with the Customize Toolbar command on the Tools menu.


Update_No_Change Initialization Variable

See Also

Controls what happens when you check in a file that you have not changed.

Syntax

Update_No_Change = {Update|Uncheckout|Ask}

Example

Undoes check out of files that have not changed:

Update_No_Change = Uncheckout

Remarks

When you check in a file that has not changed since you checked it out, VSS has three options:

  • Update the file.

  • Undo the check out of the file.

  • Ask you how to handle the file.

Because no changes have been made, the only difference between the first two cases is that checkin creates an entry in the file history with a comment but no change record; undo check out does not.

This variable can also be set in your SS.INI file by using the Check In Unchanged Files option that can be accessed from the Tools menu, by clicking Options, then selecting the General tab.


URL Initialization Variable

See Also

Marks a project as a Web site project. When a Web site project is selected, VSS Explorer's Web menu is activated.

Syntax

URL = url

Example

Specifies that the project under which this variable is listed corresponds to a Web site Uniform Resource Locator (URL):

URL = http://www.microsoft.com/ssafe

Remarks

This variable can also be set on the Web Sites tab that is accessed from the Tools menu, by clicking Options.


Use_Network_Name Initialization Variable

Sets whether VSS reads users' logon names from the operating system. Used in the SRCSAFE.INI file only.

Syntax

Use_Network_Name = {Yes|No}

Example

Uses network logon names as VSS logon names:

Use_Network_Name = Yes

Remarks

Set this to No only if you want all the VSS users to use logon names different from their network logon names. If you set it to No, VSS displays a logon dialog box unless you are supplying a username in some other way (such as through an environment variable).

When set to Yes, VSS uses the network logon name for Windows as the VSS username. If the network name matches a VSS username, the logon to VSS is automatic.

This variable can also be set in your SS.INI file by using the Use Network Name For Automatic User Log In option that can be accessed from the Tools menu, by clicking Options, then selecting the General tab.


Use_ReadOnly Initialization Variable

Controls VSS's use of the read-only flag for files that are not checked out.

Syntax

Use_ReadOnly = {Yes|No}

Example

Flags local copies of non-checked-out files as read-only:

Use_ReadOnly = Yes

Remarks

By default, VSS assumes the files in your working folder that you do not have checked out [image] that is, files you should not be modifying [image] are read-only. VSS sets the read-only flag when you get, add, check in, or undo check out of a file, and uses it as a signal that you have not been modifying the file (so VSS can overwrite it). If you set this variable to No, VSS does not set the read-only flag on files in your working directory.

You can also set this variable in your SS.INI file by using the Use Read-Only Flag for Files That Are Not Checked Out option on the Local Files tab in the SourceSafe Options dialog box.


Users_Txt Initialization Variable

Sets the location of the Users.txt file used to store the location of users' SS.INI files. Available in the SRCSAFE.INI file only.

Syntax

Users_Txt = folder path

Example

Tells VSS to use the Users.txt file located in the SRCSAFE.INI folder:

Users_Txt = USERS.TXT

Remarks

Change this only if you have to move the Users.txt file. You can specify a different file name or a complete path to the users text file; for example, \\SRCSRVR\SS5\Users.txt.


Virtual_Root Initialization Variable

Sets the virtual root for a particular Web project.

Syntax

Virtual_Root = [/Project name]

Example

Specifies that when Web hyperlinks are checked, links including a virtual root designation (supported by Microsoft Internet Information Server) of /VBASIC are checked:

Virtual_Root = /VBASIC

Remarks

If your Web project doesn't include hyperlinks to URLs with a virtual root, you do not need to set this variable.


Visual_Diff_ChangeClr Initialization Variable

See Also

Sets the color used to indicate lines changed in the Differences for File dialog box, available with the Show Differences (File) command on the Tools menu.

Syntax

Visual_Diff_ChangeClr = {R,G,B|Color}

Example

Sets the inserted lines color to blue:

Visual_Diff_ChangeClr = <0,0,255>

Sets the inserted lines color to blue:

Visual_Diff_ChangeClr = Blue

Remarks

If you set this variable, make sure you set the Visual_Diff_InsertClr and Visual_Diff_DeleteClr variables to something else. You can specify any color with the RGB syntax (3 numbers between 1 and 255 separated by commas), or use the following color names: Black, Blue, Red, Green, Cyan, Magenta, Gray, White, Yellow, Light Blue, Light Yellow, Light Green, Light Red, Light Magenta, Light Cyan.


Visual_Diff_DeleteClr Initialization Variable

See Also

Sets the color used to indicate lines deleted from the Differences for File dialog box, available with the Show Differences (File) command on the Tools menu.

Syntax

Visual_Diff_DeleteClr = {R,G,B|Color}

Example

Sets the inserted lines color to red:

Visual_Diff_DeleteClr = <255,0,0>

Sets the inserted lines color to red:

Visual_Diff_DeleteClr = Red

Remarks

If you set this variable, make sure you set the Visual_Diff_InsertClr and Visual_Diff_ChangeClr variables to something else. You can specify any color with the RGB syntax (3 numbers between 1 and 255 separated by commas), or use the following color names: Black, Blue, Red, Green, Cyan, Magenta, Gray, White, Yellow, Light Blue, Light Yellow, Light Green, Light Red, Light Magenta, Light Cyan.


Visual_Diff_InsertClr Initialization Variable

See Also

Sets the color used to indicate lines inserted in the Differences for File dialog box, available with the Show Differences (File) command on the Tools menu.

Syntax

Visual_Diff_InsertClr = {R,G,B|Color}

Example

Sets the inserted lines color to green:

Visual_Diff_InsertClr = <0,255,0>

Sets the inserted lines color to green:

Visual_Diff_InsertClr = Green

Remarks

If you set this variable, make sure you set the Visual_Diff_DeleteClr and Visual_Diff_ChangeClr variables to something else. You can specify any color with the RGB syntax (3 numbers between 1 and 255 separated by commas), or use the following color names: Black, Blue, Red, Green, Cyan, Magenta, Gray, White, Yellow, Light Blue, Light Yellow, Light Green, Light Red, Light Magenta, Light Cyan.


Visual_Merge Initialization Variables

See Also

Sets whether the Visual Merge feature is used when merging files.

Syntax

Visual_Merge = {Yes|No|Only if there are conflicts}

Example

Instructs VSS to use the Visual Merge feature only when conflicts between changes in the two files being merged exist, otherwise use the standard merge:

Visual_Merge = Only when there are conflicts

Remarks

You can also set this variable using the Use Visual Merge check box on the General tab of the Tools Options dialog box.


Warning Initialization Variables

Controls warnings given by VSS Explorer. Does not apply to the VSS command line (that is, no warnings are generated on the command line regardless of this variable's setting.)

Syntax

Warn_Destroy = {Yes|No}

Warn_Exit = {Yes|No}

Warn_Multiple_Checkout = {Yes|No}

Warn_Purge = {Yes|No}

Warn_Remove = {Yes|No}

Warn_Rollback = {Yes|No}

Warn_UnCheckout = {Yes|No}

Example

Displays a warning before deleting files or projects:

Warn_Remove = Yes

Remarks

Whenever you take an action that could result in the loss or accidental deletion of data, VSS displays a warning. While most users find these warnings useful for preventing accidental changes, some users prefer to eliminate the extra step of answering the warning.

These variables can be set (independently of each other) to turn various warnings off. By default, all warnings are considered on. Note that the Multiple_Checkouts initialization variable warns you when you are about to check out a file that another user has checked out; this is only relevant when Multiple_Checkouts = Yes.

You can also set these variables in your SS.INI file by using the Warnings tab in the SourceSafe Options dialog box.


Web_Default_Filename Initialization Variable

See Also

Specifies the default file name for your Web project. The default file is the one used by Web browsers if someone specified a URL to your site without a file name specification. Common default file names are Default.htm and Index.htm.

Syntax

Web_Default_Filename = c:\website\default.htm

Example

Specifies that the Index.html file is the default file when a user enters the URL to your Web site without a file name specification:

Web_Default_Filename = c:\website\index.html


Explorer Keyboard Guide

The following tables list keys that can be used to navigate within VSS Explorer.

Navigating within VSS Explorer

Press | To
tab | Move between the file list and the project list.
up arrow | Move up the file list or project list.
down arrow | Move down the file list or project list.
home | Move to the top of the file list or project list.
end | Move to the bottom of the file list or project list.
f6 | Go to next pane.
shift+f6 | Go to previous pane.
shift+down arrow | Move to next file or project, extend selected range.
shift+up arrow | Move to previous file or project, extend selected range.

File List Navigation Keys

Press | To
home, then shift+end | Select all files in the current project. (Or, simply select the project in the project list.)
enter | View a file.

Project List Navigation Keys

Press | To
enter | Show (or hide) subprojects.
numpad * | Include projects and subprojects.
numpad + | Expand a project.
numpad - | Collapse a project.


File Viewer Keyboard Shortcuts

The following tables list keyboard shortcuts that can be used to navigate within any VSS file viewer and to carry out certain commands.

Navigation Keys

Press | To
home | Go to beginning of line (scroll display).
ctrl+home | Go to beginning of file (scroll display).
ctrl+end | Go to end of file (scroll display).
ctrl+left arrow | Go left one word.
ctrl+n | Go to next difference (supported in Visual Difference Viewer only).
ctrl+p | Go to previous difference (supported in Visual Difference Viewer only).
ctrl+right arrow | Go right one word.
down arrow | Go down one line.
end | Go to end of line (scroll display).
left arrow | Go left one character.
page down | Go down one page.
page up | Scroll display up one page.
right arrow | Go right one character.
shift+home | Go to beginning of line (scroll display). If a selection is active, the accelerator key maintains the selection state and modifies the selection.
shift+ctrl+home | Go to beginning of file (scroll display). If a selection is active, the accelerator key maintains the selection state and modifies the selection.
shift+ctrl+end | Go to end of file (scroll display). If a selection is active, the accelerator key maintains the selection state and modifies the selection.
shift+ctrl+left arrow | Go left one word. If a selection is active, the accelerator key maintains the selection state and modifies the selection.
shift+ctrl+n | Go to next difference (supported in Visual Difference Viewer only). If a selection is active, the accelerator key maintains the selection state and modifies the selection.
shift+ctrl+p | Go to previous difference (supported in Visual Difference Viewer only). If a selection is active, the accelerator key maintains the selection state and modifies the selection.
shift+ctrl+right arrow | Go right one word. If a selection is active, the accelerator key maintains the selection state and modifies the selection.
shift+down arrow | Scroll display down one page. If a selection is active, the accelerator key maintains the selection state and modifies the selection.
shift+end | Go to end of line (scroll display). If a selection is active, the accelerator key maintains the selection state and modifies the selection.
shift+left arrow | Go left one character. If a selection is active, the accelerator key maintains the selection state and modifies the selection.
shift+page down | Go down one page. If a selection is active, the accelerator key maintains the selection state and modifies the selection.
shift+page up | Go up one page. If a selection is active, the accelerator key maintains the selection state and modifies the selection.
shift+right arrow | Go right one character. If a selection is active, the accelerator key maintains the selection state and modifies the selection.
shift+up arrow | Go up one page. If a selection is active, the accelerator key maintains the selection state and modifies the selection.
up arrow | Go up one line.

Shortcut Keys

Press | To
ctrl+ins | Copy text.
ctrl+c | Copy text.
alt+g | Go to specified line number.
alt+s | Find a string in the viewed file.
f1 | Get online Help on a specific item.
f3 | Find next search string occurrence.
shift+f3 | Find previous search string occurrence.
shift+ctrl+o | Select difference text (supported in Visual Difference Viewer only).


Menu Shortcut Keys for Commands

Each command has a key combination associated with it that enables you to execute a command with keystrokes. Typically, you press the ctrl or alt key and simultaneously press the underlined letter from the appropriate menu command.

Menu Shortcut Keys for Commands

Press | To
alt+enter | Show properties of a file or project.
alt+x | Close VSS.
ctrl+* | Globally expand all projects.
ctrl+a | Add files to the current project.
ctrl+c | Copy text.
ctrl+d | Set the working directory for the current project.
ctrl+enter | View a file.
ctrl+f | Show differences for the selected file or project.
ctrl+g | Get the selected file or project.
ctrl+h | Show the history of the selected file or project.
ctrl+i | Check in the selected file(s).
ctrl+ins | Copy selected text to Clipboard.
ctrl+k | Check out the selected file(s).
ctrl+l | Select files.
ctrl+o | Check out a file.
ctrl+q | Cancel a search display or status. Return to normal file display.
ctrl+r | View a file.
ctrl+s | Search for a file checked out to a specific user. Use ctrl+q to return to normal file display.
ctrl+u | Check in the selected file(s).
ctrl+v | Paste text from the clipboard.
ctrl+w | Perform a wildcard character search.
ctrl+x | Cut text and place it on the Clipboard.
ctrl+z | Undo editing in dialog box.
delete | Delete the selected file or project.
enter | View a file.
f1 | Get online Help for a specific item.
f5 | Refresh file list.
insert | Create project (if focus is in project pane), or add files (if focus is in file pane).
shift+ctrl+l | Select all files.
shift+ctrl+s | Search for all files currently checked out. Use ctrl+q to return to normal file display.
shift+delete | Cut selected text and copy to Clipboard.
shift+insert | Paste text on Clipboard to text box.


Administrator Keyboard Guide

The following table lists keys that can be used to navigate within VSS Administrator.

Navigating within VSS Administrator

Press | To
up arrow | Move up the user list.
down arrow | Move down the user list.
home | Move to the top of the user list.
end | Move to the bottom of the user list.


Menu Shortcut Keys for Commands

Each command has a key combination associated with it that enables you to execute a command with keystrokes. Typically, you press the ctrl or alt key and simultaneously press the underlined letter from the appropriate menu command.

Menu Shortcut Keys for Commands

Press | To
ctrl+a | Add a user to the user list.
ctrl+d | Delete a user from the user list.
ctrl+e | Edit a user in the user list.
f1 | Get online Help for a specific item.


VSS Naming Syntax, Conventions and Limitations

VSS has the following naming syntax, conventions and limitations:

  • User names and label names can be up to 31 characters long.

  • User passwords can be up to 15 characters long.

  • Filenames can be up to 255 characters long. Filenames can include spaces on operating systems that support them.

  • Project paths can be up to 259 characters long (including the filename).

  • Project or file labels can be up to 31 characters long.

  • Search strings can be up to 63 characters long.

  • Comments can be up to 63 characters long for the check out command, and 4K characters long for other comments.

  • Lines in the VSS initialization files can be up to 511 characters long.

  • Files and projects (added together) in the VSS database can total no more than 4 billion.

  • Files and projects (added together) in any project of the VSS database can total no more than 8191.

  • The size of a file stored in the VSS database is limited to 2 gigabytes.

  • The number of versions of a given file that VSS can store is limited to 32,767.

Most names in VSS cannot begin or end with spaces or tabs. Any character can be used for names or labels, except the following:

  • Dollar sign ($)

  • At sign (@)

  • Angle brackets (< >), brackets ([ ]), braces ({ }), and parentheses (( ))

  • Colon (:) and semicolon (;)

  • Equal sign (=)

  • Caret sign (^)

  • Pipe (vertical bar) (|)

  • Asterisk (*)

  • Exclamation point (!)

  • Forward (/) and backward slash (\)

  • Percent sign (%)

  • Question mark (?)

  • Comma (,)

  • Quotation mark (single or double) (' ")

  • Tab

VSS supports Universal Naming Convention (UNC) filenames. If your network operating system supports UNC pathnames, you can use them anywhere you specify a path name.

VSS does not support the use of @ characters on Banyan Vines networks. Banyan Vines users can access all VSS functionality by using mapped network drive letters.


VSS Command Line

Using the VSS Command Line

See Also

You can use the VSS command line to run batch files and macros. In addition, you can use the command line to perform all VSS Explorer commands.

Carrying Out Commands on the Command Line

You can start a command shell from Windows 95 or Windows NT and type VSS commands from there. To do this, the VSS folder must be on your path (set with the PATH environment variable).

You can also use the Run command on the Windows Start menu to run a specific command. For example, you can type ss Get *.* to get all files in the current project.

Command-Line Syntax

Command-line commands have the following general syntax:

ss command [one or more items] [one or more options]

What an item is depends on the command. For instance, for the Get command, an item is a VSS file or project; for the Add command, an item is an operating system file.

In almost all cases where you can specify an item to act on, you can specify more than one item. For instance, any of the following are valid ways of executing the Get command:

ss Get HELLO.C
ss Get HELLO.C HELLO.H TEST.H makefile
ss Get *.C *.H makefile linkfile
ss Get *.*

The command line is case-insensitive, that is, the command ss Get HELLO.C can also be typed as ss get Hello.c.

Note You do not have to type an entire command name for the VSS command line to recognize it; you need only type enough of the name for VSS to be able to distinguish it from every other command. In most cases, typing the first two or three characters is sufficient.

Command-Line Options

In addition to the command and the items, you can specify options, or parameters. Options are preceded by a hyphen and modify the command. A few options are specific to a command, and are described in that command's command-line Help topic. There is also a set of general options applicable to many commands. They are described in the following table.

Option | Description
-C | Use one (or no) comment for all specified items. (The Dir command uses this option in a different way.)
-O | Redirect or paginate the output of the command.
-V | Operate on a specific version of an item.
-R | Perform a command recursively.
-S | Turn SmartMode on or off for the command.
-G | Change the way the Get command works on any file retrieved to the local drive.
-W | Indicate whether local copies are read-only.
-N | Change between long and short file name mode.
-I- | Ignore: Do not ask for input under any circumstances.
-Y | Specify username and password.
-?, -H | Request online Help with a command: The -H command-line option obtains the same result.

Use quotation marks around the entire parameter whenever an item or option contains the space character as part of a string of text. For example, use "-CThis is the comment" rather than -C"This is the comment". Otherwise, VSS treats the space as a separator between different parameters, and the command either fails or yields unexpected results.


Starting VSS from the Command Line

You can use command-line options to start the VSS client against a specified database. With these options, you can easily assign different VSS icons to different VSS local or remote databases.

The following command-line options are supported:

Command-Line option | Description
-yuser,pwd | Identifies the user's name and password, avoiding the Login dialog box.
-s\\server\share\path | Identifies a specific SRCSAFE.INI file, overriding VSS's normal search method for SRCSAFE.INI.
-d var | Identifies a data path to use in the SRCSAFE.INI file. If specified, this value specifies a DATA_PATH variable used in the SRCSAFE.INI file.
-pproject | Identifies the project to open VSS in. For example, SSEXP -p$/Word/Code would launch VSS in that project.

All of these options are optional, and none are dependent on others.

Remarks

To use these options effectively, assign the appropriate command line to different VSS icons in your VSS program group. For example, to use one icon to access a VSS database at \\DEV1\SourceSafe, assign the following line to one icon:

SSEXP -s\\DEV1\SourceSafe

The -d option is a powerful feature that can be used to configure a SRCSAFE.INI file with multiple data path variables. (See the VSS Administrator's Help file for more information on the Data_Path variable.) For example:

Data_Path (Word) = \\Office\WORD\SSDB
Data_Path (Excel) = \\Office\EXCEL\SSDB
Data_Path (PowerPoint) = \\Office\PPT\SSDB

Using an icon to launch the VSS Explorer on the Powerpoint database, for example, you would assign this command line to a VSS icon:

SSEXP -s\\Office\Source -dPowerpoint

This command causes VSS to search the root folder of the \\Office\Source share for SRCSAFE.INI. In SRCSAFE.INI, VSS would look for the Powerpoint Data_path variable assignment and would be directed to the VSS database at \\Office\PPT\SSDB.

The -p option can be used in e-mail software (that supports icons) to send a pointer to your VSS project, or to create a Windows icon that always opens VSS in a particular project.


About Microsoft VSS (Command Line)

About (Command Line)

Displays information about your copy of Microsoft VSS, including the version number and the copyright, legal and licensing notices.

Access Rights

Any VSS user can use this command.


Add (Command Line)

See Also

Adds new files into the VSS database.

Syntax

ss Add local files [-B] [-C] [-D-] [-H] [-I-] [-K] [-N] [-O] [-R] [-W] [-Y] [-?]

Examples

Adds file HELLO.C to the current project:

ss Add C:\HELLO.C

Adds files TEST.C and MY LONG FILENAME.H to the current project:

ss Add TEST.C "My long filename.H"

Adds all files in current folder to the current project:

ss Add *

Adds all files in current folder and all subfolders to the current project:

ss Add -R *

The following table describes the command-line options available with this command.

Option | Description
-C | Use the same comment for all added files.
-D- | Do not track old versions of this file.
-R | Recursively add an entire folder tree, creating a project list in VSS.
-K | Check out the file immediately after adding it.
-B | Assume the file is binary. Use -B- to assume the file is text.
-W | Leave the local copy of the file writable.
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Add access right to use this command.

Remarks

You can specify a file on any drive and folder, and add that file to the current VSS project. To add a folder recursively, that is, to add all of its subfolders and files, specify a folder instead of a file name and use the -R option.

Note This command supports Universal Naming Convention (UNC) names: it's not necessary to specify a drive. You can type, for example, \\COMPUTER\SHARE\FILE.TXT to add the FILE.TXT file from \\COMPUTER\SHARE.

When you specify *.* as the item to add, or use the -R option, the Add command first checks the Relevant Masks variable in the VSS initialization files.

The -D- option indicates that you don't want to store anything but the latest version of the file in the VSS database. When you add a file with this option, VSS keeps a file history of change records with comments. However, the change record that tracks the actual changes to your file is not stored; consequently, VSS can retrieve the latest version, but no earlier versions of this file. This option is frequently used with binary files to increase speed and save disk space.

The -B option indicates that all the files you are adding are binary files in cases where you don't want to use the VSS AutoDetect feature; -B- specifies text files. Both override the VSS default AutoDetect mode.


Branch (Command Line)

See Also

Breaks a share link and creates a branch of a file in a project.

Syntax

ss Branch VSS file [-C] [-H] [-I-] [-N] [-O] [-Y] [-?]

Examples

Branches HELP.C in the current project away from its counterpart in other projects:

ss Branch HELP.C

The following table describes the command-line options available with this command.

Option | Description
-C | Use the same comment for all branched files.
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Add access right to use this command.


Checkin (Command Line)

See Also

Updates VSS with changes made to a checked-out file, and unlocks the VSS master copy. You can also use the command name Update (for backward compatibility).

Syntax

ss Checkin VSS files [-C] [-H] [-I-] [-K] [-N] [-O] [-P[project]] [-R] [-W] [-Y] [-?]

Examples

Checks in your changes to the file TEST.C:

ss Checkin TEST.C

Checks in all files that you have checked out from the current project:

ss Checkin * -P

The following table describes the command-line options available with this command.

Option | Description
-C | Use the same comment for all checked-in files.
-K | Keep the file checked out after checking it in.
-G | Set options for the retrieved local file.
-W | Make the retrieved local copy writable.
-R | Check in an entire project list recursively.
-P | Check in only files checked out from the current or specified project.
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Check Out access right to use this command.

Remarks

If you check in many files at once, VSS asks for a comment for each file individually: If you want them all to have the same comment, use the -C option.

It is possible to check in a file and create a new version while leaving the file checked out. To keep a file checked out, use the -K option. You can also make this behavior the default by setting the Keep_Checkedout initialization variable in the SS.INI file. Use the -K- option to indicate that you do not want to keep the file checked out.

Sometimes you check in a file that has not changed and create a new version. VSS displays a message asking if you actually want to perform a Check In; if you say No, VSS performs an Undo Check Out, so that the file is unlocked, but no new version is logged. You can avoid this prompt by setting the Update_No_Change initialization variable in your SS.INI file.

The -P option acts only on items that are checked out from the specified project. If you do not specify a particular project after the -P, the current project is assumed.


Checkout (Command Line)

See Also

Copies a file from the current project to the current folder, for the purpose of editing.

Syntax

ss Checkout VSS files [-C] [-F] [-G] [-H] [-I-] [-N] [-O] [-R] [-V] [-Y] [-?]

Examples

Checks out file TEST.C from project $/TESTDATA:

ss Checkout $/TESTDATA/TEST.C

Checks out files TEST.C and TEST.H:

ss Checkout TEST.C TEST.H

Checks out all files in the TESTDATA project and all subfolders:

ss Checkout -R $/TESTDATA

The following table describes the command-line options available with this command.

Option | Description
-C | Use the same comment for all checked-out files.
-G | Set options for the retrieved local file.
-R | Recursively check out the specified items.
-O | Paginate or redirect the command output.
-V | Specify which file version to check out.
-F | Display files only; do not display projects.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Check Out access right to use this command.

Remarks

Only one user can check out binary files at a time.

Check out comments are requested for all files included in the operation, by default. You can use the -C option to type just one comment, which will be applied to all files included in the operation.


Cloak (Command Line)

See Also

Hides a project from recursive Get, Check Out, Check In, Undo Check Out, and Project Differences commands.

Syntax

ss Cloak VSS project path

Examples

Cloaks the $/Word/Code project:

ss Cloak $/Word/Code

Access Rights

Any VSS user can use this command.


Comment (Command Line)

See Also

Changes the previously entered comment for a specific version of a file or project. Available only from the command line. (To change the comment from the Explorer, use the File Properties dialog box after selecting the appropriate file or project.)

Syntax

ss Comment VSS items [-C] [-H] [-I-] [-N] [-O] [-V] [-Y] [-?]

Examples

Changes the comment for version 5 of TEST.C:

ss Comment TEST.C -V5

Changes the comment for the most recent version of TEST.C:

ss Comment TEST.C

Changes the comment for the project TESTDATA:

ss Comment $/TESTDATA

The following table describes the command-line options available with this command.

Option | Description
-C | Use the same comment for all files being changed.
-O | Paginate or redirect the command output.
-V | Specify the file version to change the comment of.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Add access right to use this command.

Remarks

Every version of every file or project in VSS is associated with a user-defined comment, which you can change with the Comment command. After you type the command, you are prompted for the new comment (or you can specify it on the command line using the -C option).

The new comment replaces the old comment, which cannot be recovered.


CP (Command Line)

See Also

Sets the current project path.

Syntax

ss Cp project [-H] [-I-] [-Y] [-?]

Examples

Makes $/WORD the current project:

ss Cp $/WORD

Moves up to the parent of the current project:

ss Cp ..

Moves up to the root project:

ss Cp $/

The following table describes the command-line options available with this command.

Option | Description
-I- | Ignore: Do not ask for input under any circumstances.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

Any VSS user can use this command.

Remarks

The CP command sets the current project. After you set the current project on the command line, most commands assume the current project if you simply specify a file name. For example, if you follow ss Cp $/WORD with ss Get TEST.C, VSS retrieves $/WORD/TEST.C.

Note Use the Project command to find the current project from the command line.

On the VSS command line, when you get or check out a file, the file goes into the current folder. But if the Force_Dir initialization variable is set to Yes, the file goes into your working folder for the project, even if that is not the current folder.


Create (Command Line)

See Also

Creates a new subproject.

Syntax

ss Create projects [-C] [-H] [-I-] [-O] [-S] [-Y] [-?]

Examples

Creates subproject WORD under the root project $/:

ss Create $/WORD

Creates subproject WORD under the current project:

ss Create WORD

The following table describes the command-line options available with this command.

Option | Description
-C | Use the same comment for all created projects.
-S | Turn SmartMode on, so that VSS switches to the new project immediately after creating it.
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Add access right in the parent project to use this command.


Decloak (Command Line)

See Also

Removes the cloaked attribute from a project.

Syntax

ss Decloak VSS project path

Examples

Decloaks the $/Word/Code project:

ss Decloak $/Word/Code

Access Rights

Any VSS user can use this command.


Delete (Command Line)

See Also

Removes files and projects from VSS Explorer, and marks them as deleted; the items still exist, however, and can be recovered using the Recover command.

Syntax

ss Delete VSS items [-H] [-I-] [-N] [-O] [-S] [-Y] [-?]

Examples

Deletes the file TEST.C from the project $/PRJ:

ss Delete $/PRJ/TEST.C

Deletes the project $/PRJ:

ss Delete $/PRJ

Deletes all the files in the current project:

ss Delete *.*

The following table describes the command-line options available with this command.

Option | Description
-S | Turn SmartMode on, deleting the local copy of the file after deleting the VSS master copy.
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Add access right to use this command.

Remarks

After you have deleted a file from a project, you cannot delete another file with the same name from the same project: If you delete file TRASH.C from a project, then add a new file called TRASH.C to the project, that is OK. Trying to delete TRASH.C again is not allowed, however.


Deploy (Command Line)

See Also

Deploys a project to a server or FTP location specified by the Deploy_Path initialization variable.

Syntax

ss Deploy VSS project path [-O] [-R] [-V] [-G] [-W]

Examples

Deploys a Web project ($/SSAFE) to the deployment location specified by the Deploy_Path initialization variable:

ss Deploy $/SSAFE

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-R | Recursively deploy an entire project list.
-V | Deploy an old project version.
-G | Set options for the retrieved copy.
-W | Make the retrieved local copy writable.
-?, -H | Request online Help on a command.

Access Rights

You must have the Destroy access right to use this command.

Remarks

The Deploy command places files into a location specified by the Deploy_Path variable. This variable can be set directly in the SRCSAFE.INI file, or by using the Administrator program. Deploy is very similar to the Get Latest Version command, except that you are not limited to putting the files into your working folder and you cannot avoid overwriting existing files. Used recursively on a project (the -R option), VSS deploys all the files in the project and subprojects, and places them into subfolders of the same name.

By default, Deploy copies the most recent version of the projects you specify. However, you can deploy earlier versions as well by using the -V option. (Note that "ss Deploy -V*" does not work.)

Note Deploying an earlier version of a project gets the files that were in the project at a particular time, as they were at that time. For instance, if you use the Deploy command to retrieve version 7 of the project $/WORD, you may get TEST.HTML version 3, HELP.HTM version 10, and TEST.MAP version 5.


Destroy (Command Line)

See Also

Permanently removes a file or project.

Syntax

ss Destroy VSS items [-H] [-I-] [-N] [-O] [-S] [-Y] [-?]

Examples

Destroys the file TEST.C in the project $/PRJ:

ss Destroy $/PRJ/TEST.C

Destroys the project $/PRJ:

ss Destroy $/PRJ

The following table describes the command-line options available with this command.

Option | Description
-S | Turn SmartMode on, so that VSS deletes your local copies of the files after destroying the master copies.
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Destroy access right to use this command.

Use the Delete command if you don't want the file or project to be removed permanently.


Difference (Command Line)

  • If you're performing a difference on a file, see Difference (File) (Command Line)

  • If you're performing a difference on a project, see Difference (Project) (Command Line)


Difference (File) (Command Line)

See Also

Shows the differences between the lines in a VSS master copy and the corresponding local copy in your working folder, or a previous version.

Note For binary files, VSS can tell you if two files are different, but not how they are different. VSS stores reverse deltas for all files, but in the case of a binary file, the binary record stored cannot be displayed to the user. Only ASCII text files can be compared line-by-line.

Syntax

ss Diff VSS files [-B] [-D] [-H] [-I] [-I-] [-N] [-O] [-V] [-Y] [-?]

Examples

Compares the VSS file HELP.C to the local file HELP.C:

ss Diff HELP.C

Compares the version 2 VSS file HELP.C to the local copy of HELP.C:

ss Diff HELP.C -V2

Compares versions 2 and 4 of the VSS file HELP.C:

ss Diff HELP.C -V4~2

Compares file HELP.C in the VSS database against the file BAR.C on your local computer:

SS Diff $/HELP.C C:\BAR.C

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-V | Specify the old file version(s) to compare.
-I [C|E|S|W] | Specify which informational messages are ignored. The -IS option means ignore small matches [image] prevents a large section of changes from looking like there are matches when there really aren't.
-I- | Ignore: Do not ask for input under any circumstances.
-D <S|U|V> [width] | Specify the format of the difference display.
-DX [ - |number of lines] | Specify the number of displayed context lines.
-B | Create a brief difference report.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Read access right to use this command.

Remarks

The -B option provides a brief difference report. It checks to see if the specified files are different and is faster than computing actual line differences. This can be useful in batch files and scripts that react differently when a file has been modified.

The -D option controls how VSS displays the differences. A file difference can be displayed in one of three manners:

  • V (visual) [image] shows the entire file, with annotations for the changes. This display shows differences side-by-side.

  • S (SourceSafe) [image] displays a list of lines that were added, deleted, changed, and optimized for readability; for example, an inserted line might be displayed as follows:
    27  Ins: hello, world
  • U (UNIX) [image] display gives similar information in the standard format used by the UNIX diff utility:
    26a27
> hello, world

Immediately after the V, S, or U in the -D option, you can specify a number indicating the line width. If you specify more characters than your screen permits, long lines wrap, which may affect the readability of the display.

Finally, X controls how many context lines VSS displays around each change. Seeing these lines may help you understand why a change was made. X by itself shows three lines of context; X- shows no context; X followed by a number specifies how many lines to show.

By default, VSS uses the VSS display, with line width calculated to fit on your screen, and no context lines. If you specify a UNIX display, the other defaults are the same; the visual display, by default, shows all lines (infinite context).

The following table demonstrates some uses of the -D option.

Example | Description
-DV35 | Visual display, 35-character width
-DX | Three context lines
-DU70X5 | UNIX-style display, 70-character width, five context lines

The -I option indicates which of four factors VSS should ignore when comparing two files:

  • (C)ase: The letter A is considered the same as the letter a, and so on, and a change of one to the other is not reported.

  • (W)hite space: Any change in spacing or tabbing is ignored; only the insertion or deletion of functional characters is reported.

  • (E)nd-of-line character: Every line is not reported as a change simply because of differences on a different operating system.

  • (S)mall changes: Small changes are ignored.

The default setting, -IE, ignores end-of-line characters and reports any other difference as a change.


Difference (Project) (Command Line)

See Also

Compares the contents of a project with the current folder.

Syntax

ss Diff VSS projects [-B] [-F] [-H] [-I-] [-N] [-O] [-R] [-V] [-Y] [-?]

Examples

Compares the VSS project WORD to the current folder:

ss Diff $/WORD

Compares the current project with the current folder:

ss Diff

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-V | Compare an earlier file or project version.
-R | Recursively compare an entire project list to a local folder tree.
-B | Create a brief difference report.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-F | Reconcile project differences using the user-specified reconciliation behavior stored in the Reconcile_Project initialization variable.
-?, -H | Request online Help on a command.

Access Rights

You must have Read access right to use this command.

Remarks

The project-level difference compares the contents of your current project to the contents of the current folder assigned to that project, and reports on the differences found. These differences could be that a file is in one place but not the other, or that a file in both places is different. The -R option looks not only in the contents of the current project, it also looks in subprojects under the current project, and displays all differences between the entire project and your working folder.

The -B option creates a brief difference report: It does not check file contents at all, but simply looks for files that exist in one place and not the other. The -F option reconciles the project differences using the decision rules stored in the Reconcile_Project initialization variable. See the Reconcile_Project Initialization Variable for more information.

The Relevant_Masks initialization variable affects this command by filtering the list of files being compared between projects.


Directory (Command Line)

See Also

Shows a list of all the files and projects in the specified project, or in the current project. Available only from the command line.

Syntax

ss Dir project path [-C] [-D] [-E] [-F-] [-H] [-I-] [-N] [-O] [-R] [-V] [-Y] [-?]

Examples

Shows a directory of the project $/WORD:

ss Dir $/WORD

Shows a directory of the current project:

ss Dir

Equivalent to the MS-DOS dir command:

ss ls

The following table describes the command-line options available with this command.

Option | Description
-D | Display deleted files instead of nondeleted files.
-O | Paginate or redirect the command output.
-R | Recursively display an entire project list.
-E | Display extended display, including check out information.
-V | Display a directory of an earlier version of a project.
-C | Display files and projects in columns.
-F- | Display projects only; do not display files.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have Read access right to use this command.

Remarks

The Directory command in VSS functions very much like the MS-DOS dir command, and displays all the files and subprojects in a project. If a project is sharing a specific version of a file (rather than the most recent version), the version number of the file is shown. The Directory command sets the operating system exit code for use in batch files and scripts.

The -R option displays a recursive folder, that is, shows subprojects, the files and subprojects inside them, and so on.

The -D option displays all files and subprojects that have been deleted. This can be useful, for instance, for obtaining a list of files that you want to recover or purge.

The -E option displays check out information for any checked-out files. The Dir -E is similar to the Status command on the command line, with one notable difference: Status shows only checked-out files; Dir -E shows all files, but notes the check out status of the ones that are checked out.

The -F- option shows projects only, and does not show files [image] ss Dir $/ -F -R creates a complete list of all the projects in the VSS database without listing any files.


Filetype (Command Line)

See Also

Displays the type (text or binary) of a file. Available only from the command line. To find this information in the Explorer, use the File Properties command.

Syntax

ss Filetype VSS items [-B] [-H] [-I-] [-N] [-O] [-R] [-Y] [-?]

Examples

Tells whether HELP.C is text or binary:

ss Filetype HELP.C

Changes HELP.C to a binary file:

ss Filetype HELP.C -B

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-R | Recursively work on an entire project list.
-B | Change the type of a file. -B changes the file type to binary; -B- changes it to text.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Read access right to check the type of a file, and the Add access right to change it.

Remarks

The Filetype command can be used to determine, or change, the type of one or more files. Every file in VSS is classified as either binary or text. If you do not specify a -B option, VSS simply displays the file type.


Find (Command Line)

FindinFiles (Command Line)

See Also

Shows all instances of a specified string in one or more files.

Syntax

ss FindinFiles string [VSS items] [-H] [-I-] [-IC] [-N] [-O] [-R] [-V] [-Y] [-?]

Examples

Looks for the string "giGlobal" in all .C files:

ss FindinFiles giGlobal *.C

Looks for the string "Hello world" in the current project:

ss FindinFiles "Hello world"

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-R | Recursively scan through an entire project list.
-V | Look through an earlier version of all specified files or projects.
-IC | Ignore case when looking.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Read access right to use this command.

Remarks

The FindinFiles command displays a list of all occurrences of a character string in the VSS files specified (in the same way the Grep command does in UNIX systems). You can look through a file, or through a project (which scans all the files in that project); if you don't specify VSS items, it is assumed you are looking through the files in the current project.

The VSS FindinFiles command supports two wildcard characters [image] * and ?.

Ordinarily, the VSS FindinFiles command is case-sensitive and looks for exact matches: the letter "A" does not match the letter "a". The -IC option makes the search case-insensitive, so "A" matches "a".

FindinFiles returns an exit code of 1 if there were 1 or more matches, 0 if there were no matches, and 100 if an error occurred.


Get Latest Version (Command Line)

Get (Command Line)

See Also

Retrieves a read-only copy of the specified VSS file(s).

Syntax

ss Get VSS items [-G] [-H] [-I-] [-N] [-O] [-R] [-V] [-W] [-Y] [-?]

Examples

Retrieves a read-only copy of the file TEST.C in the current project:

ss Get TEST.C

Retrieves read-only copies of all the files in the current project:

ss Get *

Retrieves read-only copies of all the files in the project $/WORD, and all its subprojects:

ss Get $/WORD -R

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-R | Recursively get an entire project list.
-V | Get an old file or project version.
-G | Set options for the retrieved local copy.
-W | Make the retrieved local copy writable.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Read access right to use this command.

Remarks

The Get Latest Version command places files into your working folder. Used recursively on a project (the -R option), VSS gets all the files in the project and subprojects, and places them into subfolders of the same name. If you set the SS.INI variable Force_Dir to Yes, subprojects go into their respective working folders instead of into subfolders of the same name.

By default, Get Latest Version retrieves the most recent version of the files or projects you specify. However, you can get earlier versions as well by using the -V option. (Note that "ss Get -V*" does not work.)

Note Getting an earlier version of a project gets the files that were in the project at a particular time, as they were at that time. For instance, if you use the Get Latest Version command to retrieve version 7 of the project $/WORD, you may get TEST.C version 3, HELP.C version 10, and TEST.H version 5.


Help (Command Line)

See Also

Displays Help on using VSS in general, or on a specific command.

Syntax

ss Help [Command] [-H] [-I-] [-Y] [-?]

Examples

Shows general help:

ss Help

Shows help on the Share command:

ss Help Share

The following table describes the command-line options available with this command.

Option | Description
-I- | Ignore: Do not ask for input under any circumstances.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

Any VSS user can use this command.

Remarks

Help for VSS command-line commands is displayed in a Microsoft Windows Help file. You must be running Microsoft Windows for Help to be displayed [image] there is no separate command-line help.


History (Command Line)

See Also

Shows the history of a file or project in VSS.

Syntax

ss History VSS items [-B] [-D] [-F-] [-H] [-I-] [-L] [-N] [-O] [-R] [-U[username]] [-V] [-Y] [-#] [-?]

Examples

Displays the history of the file TEST.C:

ss History TEST.C

Displays the history of the project $/WORD:

ss History $/WORD

Displays the last three items in the history list for the current project, or for file TEST.C, respectively:

ss history . -#3
ss history TEST.C -#3

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-V | Display only versions that fall within specified range.
-R | Display the history of an entire project list.
-L | Display only versions that have labels.
-F- | Do not display individual file updates in the project history.
-B | Display a brief history.
-U | Display only changes made by a particular user.
-D | Display line-by-line file changes.
-#<#> | Display the specified number of history entries for the selected file or project.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have Read access right to use this command.

Remarks

The History command has a number of options that can be used to customize its display. For example, -L shows only the versions that have labels; because these versions tend to be the major release milestones, the -L option can help generate a general overview of the history of an item.

The -B option shows a brief history [image] only enough information about a version to fit on one line.

The -U option shows only changes that were made by a particular user (the current user if none is specified on the command line).

The -D option shows all the changes actually made with each file update.

The -V option specifies a range: -V5 starts with version 5, and goes back to version 1. A tilde (~) is used to specify both sides of a range, so -V5~3 gives the history of versions 5, 4, and 3. The range must be specified beginning with the later version, as in the example.

The -R option indicates that you want to see all the changes made to every subproject under the project, and the files and subprojects under those, and so on.

By default, the history of a project includes the histories of all its files, but does not include subprojects.


Label (Command Line)

See Also

Assigns a label to the specified version or current version of a file or project.

Syntax

ss Label VSS items [-C] [-H] [-I-] [-L label] [-N] [-O] [-V] [-Y] [-?]

Examples

Assigns a label to the current version of the current project:

ss Label

Assigns a label to the current version of the project $/WORD:

ss Label $/WORD

Assigns a label to version 5 of the file HELP.C:

ss Label HELP.C -V5

The following table describes the command-line options available with this command.

Option | Description
-C | Use the same comment for all labels.
-V | Label an existing file or project version.
-L | Specify the new label on the command line (instead of being prompted).
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Add access right to use this command.

Remarks

The Label command creates a new version of the specified project or file, and assigns your label to that version. However, if you use the -V option to refer to a specific version, the label is simply applied to that version.

If you assign a label to a version that already has a label, or if you assign a label to an item that already uses that label for a different version, the old label is replaced. In either case, VSS issues a warning before replacing the old label.

If you specify multiple items on the command line, VSS prompts you for a different label for each item. The -C option asks for only one label, which VSS applies to all the items you have listed. The -L option bypasses the label prompt entirely by specifying the label on the command line, for example, -L2.00b.


Links (Command Line)

See Also

Shows the projects sharing a specified file.

Syntax

ss Links VSS files [-H] [-I-] [-N] [-O] [-Y] [-?]

Examples

Shows all projects that are sharing the file TEST.C:

ss Links TEST.C

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Read access right to use this command.

Remarks

The Links command displays all the current share links from a specified file to all other projects that share it. In contrast, the Paths command displays links that existed previously but were branched.


Locate (Command Line)

See Also

Searches through VSS projects for file or project names. Available only from the command line. In the Explorer, you can use the Search Wildcard Search command to get equivalent information.

Syntax

ss Locate filename [-H] [-I-] [-N] [-O] [-Y] [-?]

Examples

Looks for files called TEST.C:

ss Locate TEST.C

Looks for file names that match the wildcard mask *.old:

ss Locate *.OLD

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

This command locates only files in projects for which you have the Read access right.

Remarks

The Locate command searches through the entire VSS project hierarchy for a file name you specify, and displays the project path to any matches it finds. In many respects, the results are similar to the results on the Links tab. For instance, if several projects share the file TEST.C, both commands give you a list of all those projects. However, if a project contains a file that is unrelated to the file TEST.C in your project, but has the same name, Locate finds the file; Links ignores it.

You can also use Locate to find a file when you do not know any of the projects it is in, whereas the Links tab requires that you start with one specific file.


Merge (Command Line)

See Also

Copies all the changes made in one branch to another branch.

Syntax

ss Merge VSS files [-C] [-H] [-I-] [-N] [-O] [-Y] [-?]

Examples

Merges the file TEST.C in $/WORD into TEST.C in the current project:

ss Merge $/WORD/TEST.C

The following table describes the command-line options available with this command.

Option | Description
-C | Use the same comment for all merged files that are checked in.
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Check Out access right in the project being merged into, and the Read access right in the project being merged from, to use this command.

Remarks

You cannot perform a merge on a binary file.


Move (Command Line)

See Also

Relocates a subproject from one parent project to another.

Syntax

ss Move <project to move> <new project path> [-H] [-I-] [-Y] [-?]

Examples

Moves the project $/WORD from $/JOE to $/APPS, creating $/APPS/WORD:

ss Move $/JOE/WORD $/APPS

The following table describes the command-line options available with this command.

Option | Description
-I- | Ignore: Do not ask for input under any circumstances.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Add access right in the parent project being moved to, and the Destroy access right in the parent project being moved from, to use this command.


Password (Command Line)

See Also

Sets the password for the current user.

Syntax

ss Password [-H] [-?]

Examples

Triggers the password prompt:

ss Password

The following table describes the command-line options available with this command.

Option | Description
-?, -H | Request online Help on a command.

Access Rights

Any VSS user can use this command. VSS will prompt for the username and password.


Paths (Command Line)

See Also

Shows all share links that have been branched.

Syntax

ss Paths VSS files [-I] [-N] [-O] [-Y]

Examples

Shows all current and broken shared file links to the file TEST.C:

ss Paths TEST.C

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Read access right to use this command.

Remarks

The display generated by Paths on the VSS command line is formatted differently from the display generated by the Paths tab in the Properties dialog box on the File menu. Both contain the same information, but users who switch between the two should take extra care to avoid confusion.

In the VSS command-line program, the Paths command might show a display like the following.

TEST.C
$/A
 TEST.C (Branched at version 5)
 $/B
 $/C
 TEST.C (Branched at version 4)
 $/D

The preceding display shows that the file began in project $/A, one branch was created at version 5 in project $/B, which is also shared in $/C; and another branch, also directly off of the file in $/A, was created at version 4 in $/D.


Pin (Command Line)

See Also

Pins a specific version of a file in the current project.

Syntax

ss Pin VSS items [-G] [-H] [-N] [-V] [-W] [-Y] [-?]

Examples

Pins the file JUSTIFY.CPP in $/WORD/CODE to version 2:

SS Pin $/WORD/CODE/JUSTIFY.CPP -V2

Pins all the files in the $/EXCEL/PIVOTTBL project to the label "beta4." In this example, "beta4" is assumed to be a project label:

SS Pin $/EXCEL/PIVOTTBL/*.* -Vbeta4

Pins all header files in the SPECS project to version 2.

SS Pin *.H -V2

The following table describes the command-line options available with this command.

Option | Description
-V | Version number you want to pin to the current project.
-G | Set Get options for the retrieved local copy.
-W | Make the retrieved local copy writable.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Check Out access right in the project you are pinning from to use this command.

Remarks

The Pin command is similar to the Share command with the -V switch, but the Pin command is the preferred method of locking a file at a certain version. However, Pin operates directly on files in projects specified on the command line. Without the -V option, Pin does not share files with the current project as the Share command does. Essentially, Pin freezes a file at a specified version number.

For VSS items, specify files in the current project or a project path containing a wildcard specification or file name. Pin only operates on the files in the current project or project specified.

If the file to be pinned is currently pinned to another version, the Pin command unpins the file from it and pins it to the version specified on the command line. If the file is already pinned to the specified version, no action is taken.

The command pins one version of the file in the current folder or working folder, depending on the state of the initialization variable Force_Dir: Setting Force_Dir = Yes pins files to the working folder. Setting Force_Dir = No pins files to the current folder. This variable can also be set in the Command Line tab of the Options dialog box on the Tools menu.

The -G and -W options control the file attributes of the retrieved file.


Project (Command Line)

See Also

Displays the current project path.

Syntax

ss Project [-H] [-I-] [-O] [-Y] [-?]

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

Any VSS user can use this command.

Remarks

The Project command displays the current project path. It tells you what project you are in, for example, $/WORD; if you type ss Get TEST.C, VSS looks for $/WORD/TEST.C.

Use the CP command to change your current project.


Properties (Command Line)

See Also

Shows basic information about a VSS file or project.

Syntax

ss Properties VSS Items [-B] [-F-] [-H] [-I-] [-L] [-N] [-O] [-R] [-Y] [-?]

Examples

Shows property information on the file TEST.C, and changes its file type to binary:

ss Properties -B TEST.C

The following table describes the command-line options available with this command.

Option | Description
-B | Change the type of a file. -B changes the file type to binary; -B- changes it to text.
-F- | Disable the display of file properties. The -B, -B-, -L, and -L- options only operate on displayed files.
-O | Paginate or redirect the command output.
-R | Show information on an entire project list recursively. Ignored if a file name or file mask is specified on the command line.
-L | Store only the most recent version (not past versions). -L stores only the most recent version during checkin. -L- stores delta information on each checkin.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Read access right to view an item's properties.

You must have the Add access right to change the type, text or binary, of a file.

You must have the Destroy access right to use the -L option.

Remarks

The Properties command displays information about whether a file is text or binary, and additionally enables you to store only the latest version or all versions of a file.

If the Properties command is executed without the -B or -L option, it displays information about the file or project without changing the attributes of the file. With either the -B or -L option, it changes the attributes of the file first, then displays the results of the change.


Purge (Command Line)

See Also

Permanently removes previously deleted files and projects from the VSS database.

Note Purged items cannot be recovered.

Syntax

ss Purge VSS items [-H] [-I-] [-N] [-O] [-Y] [-?]

Examples

Purges the deleted file TEST.C:

ss Purge TEST.C

Purges the deleted project $/PRJ:

ss Purge $/PRJ

The following table describes the command-line options available with this command.

Option | Description
-I- | Ignore: Do not ask for input under any circumstances.
-O | Paginate or redirect the command output.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Destroy access right to use this command.

Remarks

When you use the Delete command to delete a file or project in VSS, the deleted item is removed from VSS Explorer, but VSS is still storing it internally. You can use the Dir -D command on the VSS command line to show a list of the files that are deleted from the current project. Then, you can purge them if you want to destroy them permanently, or rebuild earlier versions of the project that required them with the Recover command.


PVCS_SS (Command Line)

The following provides information on the PVCS command line.

Syntax

PVCS_SS logfile [more logfiles] [project] [-PPVCS folder] [-SVisual SourceSafe folder] [-Upassword] [-?]

The order of the parameters is not important. Options are recognized by a hyphen (-) or forward slash (/); the project is recognized by a dollar sign ($); any parameter without a hyphen, forward slash, or dollar sign is read as a PVCS logfile.

Remarks

  • Logfiles - PVCS logfiles can be specified as individual filenames (TEST.C_V) or as masks (*.??V). You can specify as many as you want during one running of PVCS_SS, but you must specify at least one. They can be in other folders, although the current drive and folder are used as the default. Whatever logfiles you pass to PVCS_SS, and however you specify them, you should be able to pass the exact same parameters to the PVCS program, VLOG.EXE.

  • Project - The project is optional, because PVCS_SS.EXE assumes the default is the current project for the Admin user. If you do specify a project, use VSS project syntax. For example, $/TEST/SUBPROJECT. PVCS_SS.EXE attempts to create the project you specify, if it does not already exist.

  • PVCS Folder - The PVCS folder stores PVCS executable files such as GET.EXE and VLOG.EXE. If you have the PVCS folder on your MS-DOS path, it is not necessary to specify the -P option. If the PVCS folder is not on your path, use -P to enable PVCS_SS.EXE to locate PVCS. For example:

-pd:\pvcs

  • VSS Folder - The VSS folder is where the VSS SRCSAFE.INI is located. If you do not have SRCSAFE.INI on your path, use -S to enable PVCS_SS.EXE to locate VSS. For example:
   -sh:\ss3
  • Password - This is the password for the VSS Administrator. If you are already logged on to VSS as Admin, you do not have to specify the password. (Use Whoami on the command line to determine if you are logged on as Admin.) If you are not logged on as Admin, use -U to give the Admin password. For example:
   -uAdmin,R2D2nC3P0

By default, the Admin user has no password. If you have not assigned one, you can skip this switch.

  • -? (or -H) If you use this option, PVCS_SS.EXE displays a description of its command line. No files are converted.


Recover (Command Line)

See Also

Recovers files and projects that have been deleted.

Syntax

ss Recover VSS items [-G] [-H] [-I-] [-N] [-O] [-S] [-W] [-Y] [-?]

Examples

Undeletes the removed file TEST.C:

ss Recover TEST.C

Undeletes the removed project $/WORD:

ss Recover $/WORD

The following table describes the command-line options available with this command.

Option | Description
-S | Turn SmartMode on, making a recovered project the current project.
-G | Set options for the retrieved local copy.
-W | Make the retrieved local copy writable.
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Add access right to use this command.


Rename (Command Line)

See Also

Renames a file or project.

Syntax

ss Rename <VSS item> <new name> [-H] [-I-] [-N] [-O] [-S] [-Y] [-?]

Examples

Changes the VSS file named TEST.C to MISC.C:

ss Rename TEST.C MISC.C

Changes the VSS project named WORD to EDITOR. (The new project is $/APPS/EDITOR.):

ss Rename $/APPS/WORD EDITOR

The following table describes the command-line options available with this command.

Option | Description
-S | Turn SmartMode on, renaming the local copy after renaming the VSS master copy.
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Add access right to use this command.


Rollback (Command Line)

See Also

Undoes all changes since an earlier version of a file.

Syntax

ss Rollback VSS file [-G] [-H] [-I-] [-N] [-O] [-V] [-W] [-Y] [-?]

Examples

Rolls back TEST.C to version 10:

ss Rollback TEST.C -V10

Rolls back TEST.C to version 2.01b:

ss Rollback TEST.C -VL2.01b

The following table describes the command-line options available with this command.

Option | Description
-V | Specify which file version to roll back to; required unless you are sharing an earlier version of a file.
-G | Set Get options for the retrieved local copy.
-W | Make the retrieved local copy writable.
-O | Paginate or redirect the command output.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Destroy access right to use this command.

Remarks

Rollback performs a Get operation when it is done, unless the Delete_Local initialization variable in SS.INI is set to Yes, or you use the -G- command-line option to prevent it.


Share (Command Line)

See Also

Makes the specified file or project a member of the current project.

Syntax

ss Share VSS files [-C] [-E] [-G] [-H] [-I-] [-N] [-O] [-P] [-R] [-V] [-W] [-Y] [-?]

Examples

Makes $/WORD/TEST.C a member of the current project:

ss Share $/WORD/TEST.C

Makes version 6 of TEST.C a member of the current project (note the command verb, Pin):

ss Pin TEST.C -V6

Creates a branch from the project $/WORD:

ss Share $/WORD -R -E

The following table describes the command-line options available with this command.

Option | Description
-V | Share an earlier version of a file (or project).
-G | Set Get options for the retrieved local copy.
-W | Make the retrieved local copy writable.
-R | Share an entire project list recursively.
-P | Specify a new name for the shared project.
-C | Use the same comment for all shared projects (Available only when sharing projects.).
-O | Paginate or redirect the command output.
-E | Branch after sharing.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Check Out access right in the project you are sharing from, and the Add access right in the project you are sharing to, to use this command.

Remarks

To share a file, first set the current project path to the project that you want to share the file into with the CP command. Then execute the Share command, specifying the existing file(s) that you want to bring into your current project.

If you use the -E option, the file becomes a member of your current project, but it is branched: changes made in this project do not propagate to the originating project, and vice versa. The Links tab in the Properties dialog box on the File menu no longer shows a relationship, but you can use the Paths tab in the Properties dialog box to see the path of the file branch you have created.

Sharing an Explicit Version of a File or Project

To share an explicit version of a file, use the Pin command. With files, the -V option on Share is supported, but is not recommended. It specifies a file (that may or may not already be in the current project) and shares a specific version of it. When a project is sharing a specific version, it always uses that version no matter what changes are made in other projects. (If you are sharing a specific version, the ss Dir command displays this information.) The advantage of sharing a specific version of a file is that it allows you to control, in your project, the pace of changes being made by other users in other projects.

With projects, the -V option specifies an earlier project version to share. This creates a new project based on an existing one, but the new project is based on a specific version of the original project, rather than the current version. If you do not branch, the new project still shares all its files with the original, but it shares earlier versions of those files. If you branch, the new files are not shared with the old; it is as if you had rolled back all the files in the new project.

Sharing a Project

When you specify a project to share, instead of sharing a file from another project, you create an entirely new project under the current project that is an exact duplicate of the project you specified.

The -R option recursively shares a project and creates a new project list that shares all its files with the project list you specify.

If you use the -E option with a project, the new project does not share its files with the original project; all the files are branched.

The -P option specifies a new name for the newly created project. By default, the new project has the same name as the project you are sharing from. This default does not work, however, if you want the new project to be under the same parent as the old: Use the -P option to create a new branch with a new name. For example, if you share the project $/TESTDATA into your project $/GIZMO/TESTDATA without using the -P option, you create a situation where the subproject has the same name as the parent. With -P, you can avoid this as follows: SS SHARE -PSHARDATA $/TESTDATA


Status Search (Command Line)

Status (Command Line)

See Also

Shows check out information on files.

Syntax

ss Status [VSS items] [-H] [-I-] [-N] [-O] [-P[project]] [-R] [-U[username]] [-Y] [-?]

Examples

Lists all checked-out files in the current project:

ss Status

Indicates whether TEST.C is checked out by user Joyce:

ss Status TEST.C -UJoyce

Shows every file in the system that is checked out by the current user:

ss Status $/ -R -U

Shows files in the $/TESTDATA project that are checked out in $/TESTDATA. Does not show files shared into $/TESTDATA but checked out in other projects:

ss Status -P$/TESTDATA $/TESTDATA

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-R | Display recursive status through an entire project list.
-U | Display only files checked out to a certain user.
-P | Filters the list of checked-out files to include only files checked out to the current or specified project.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Read access right to use this command.

Remarks

If you have the same file checked out to multiple computers, the Status command shows the computer name as well as the check out path. If you checked out the file using UNC path format, the Status command uses this format in its return.

The -U option lists files checked out by the specified user. If you use the -U option with no username, the current user (you) is assumed. If you do not use the -U option at all, all checked-out files are displayed.

When a file is shared among multiple projects, if it is checked out from one project, it is checked out from all projects. For this reason, the Status Search command may actually show you files that are checked out to multiple projects, because they are shared. The -P option restricts the display to files that were checked out from a certain project. By default, this is the project on which you are performing the Status Search.


Undocheckout (Command Line)

See Also

Cancels a check out, voiding all changes.

Syntax

ss Undocheckout VSS files [-G] [-H] [-I-] [-N] [-O] [-P[project]] [-R] [-W] [-Y] [-?]

Examples

Cancels your check out of the file TEST.C:

ss Undocheckout TEST.C

Cancels all check outs made from the current project:

ss Undocheckout * -P

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-G | Set Get options for the retrieved local copy.
-W | Make the retrieved local copy writable.
-R | Undo Check Out of an entire project list recursively.
-P | Undo Check Out only of files checked out to the current or specified project.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Check Out access right to use this command.

Remarks

If you specify the -P option, the command acts only on items that are checked out from the specified project. If you do not specify a particular project after the -P, the current project is assumed.

Undocheckout performs a Get operation when it is finished, unless the Delete_Local initialization variable in the SS.INI file is set to Yes, or you use the -G- option.

Undocheckout ignores files not checked out to you.


Unpin (Command Line)

See Also

Undoes a Pin operation.

Syntax

ss Unpin VSS items [-G] [-H] [-N] [-W] [-Y] [-?]

Examples

Cancels the pinned status of MYFILE.CPP and MYFILE.H:

ss Unpin MYFILE.CPP MYFILE.H

Cancels the pinned status of all .DOC files in the current project:

ss Unpin *.DOC

Cancels the pinned status of all files in the SPECS project:

ss Unpin $/CEDAR/SPECS/*.*

The following table describes the command-line options available with this command.

Option | Description
-G | Set Get options for the retrieved local copy.
-W | Make the retrieved local copy writable.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Check Out access right in the project you are unpinning to use this command.

Remarks

The Unpin command searches the files specified. For files pinned to a specific version, the Unpin command returns them to sharing the latest version in the project.

The Unpin command ignores files that are not pinned.


View (Command Line)

See Also

Displays the text of a file.

Syntax

ss View VSS files [-H] [-I-] [-N] [-O] [-V] [-Y] [-?]

Examples

Shows the contents of the VSS file TEST.C:

ss View TEST.C

Retrieves version 5 of TEST.C into a file called TEST.OLD (text files only):

ss View TEST.C -V5 -OTEST.OLD

The following table describes the command-line options available with this command.

Option | Description
-O | Paginate or redirect the command output.
-V | View an earlier version of a file.
-I- | Ignore: Do not ask for input under any circumstances.
-N | Change between long and short file name mode.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

You must have the Read access right to use this command.

Remarks

The View command displays the text of a VSS file on the screen in much the same manner as the type command in MS-DOS. It does not perform a Get operation on the file or change anything in either VSS or your working folder.

By default, VSS displays the file by scrolling it on the command line. If you want the text displayed differently, set the Editor initialization variable to specify the text editor in which you want to view the text of the file. You can also use the Extension_Association initialization variable to set the editor associated with different file extensions.


Whoami (Command Line)

See Also

Shows your current VSS username. Available only from the command line. To see who you are logged in as in the Explorer, check the status bar.

Syntax

ss Whoami [-H] [-I-] [-Y] [-?]

The following table describes the command-line options available with this command.

Option | Description
-I- | Ignore: Do not ask for input under any circumstances.
-Y | Specify a username and/or password.
-?, -H | Request online Help on a command.

Access Rights

Any VSS user can use this command.


WorkFold

See Also

Sets the working folder. In the VSS Explorer, use the Set Working Folder command.

Syntax

SS Workfold [Project] [Folder]

Examples

Sets the $/Website project working folder to c:\External Web\Website:

ss Workfold $/WEBSITE c:\External Web\Website

The following table describes the command-line options available with this command.

Option | Description
Project | Specifies the VSS project you want to set a working folder for.
Folder | Specifies the working folder for the specified project.
-?, -H | Request online Help on a command.

Access Rights

You must have the Read access right to use this command.

Remarks

This command makes the specified folder the working folder for the specified project.

Note that both the project and the directory are optional. If either one is not specified, the current project or folder is used. That is, if you do not specify a folder, the current folder is used. If you do not specify a project, the current project is used. If you specify more than one project or more than one folder, that is an error.

The output of the command is simply the string:

%s successfully set as the working folder for %s.

The Force_Dir and Force_Prj initialization variables are completely ignored by this command.


VSS Utilities

See Also

Several utility programs are included with VSS. The following table lists these utilities.

Utility | Purpose
Analyze.exe | Scans a VSS database for database integrity and errors.
DDCONV.exe | Updates a VSS database from an older format to the current format.
DDUPD.exe | Upgrades the VSS database to a new format. The new format will initialize the database to take advantage of the Label Promotion and the Performance Enhancements introduced in VSS 6.0. During installation the database may have been upgraded. If a ..\data\labels folder exists, the database is in the new format. The database can also be 'downgraded' with this utility.
Delta_SS.exe | Converts Microsoft Delta projects or files to VSS projects.
MKSS.exe | Creates an empty, old format VSS database. Runs automatically when VSS is installed for the first time.
PVCS_SS.exe | Converts PVCS projects or files to VSS projects.
SS.exe | Allows MS-DOS command-line syntax to be used in Windows.
SSARC.EXE | Archives part or all of your VSS database to a compressed archive file.
SSLogin.exe | Used by integration scripts and macros to find or set a username and optionally the SS.INI file and current project.
SSRestor.exe | Restores part or all of a VSS archived database file to a VSS database.
Testlock.exe | Tests file locks to help you determine the network locking mechanism.
Unlock.exe | Frees database locks after a power failure or other unexpected loss.
Updini.exe | Converts VSS .ini files that are in a format used prior to version 3.0, to the current format.


Analyze

See Also

Analyze.exe scans a VSS database for integrity and/or errors, displays them and, if set to do so, fixes them. VSS administrators should run Analyze.exe every week to verify that there are no problems in the VSS database.

Administrators can use the 32-bit command-line utility to repair version 4.0 VSS databases (and later). For example, a database problem exists when you select a file that you know exists in the VSS database, use a command, such as GET, and receive the error message, “File does not exist.”

Administrators can run Analyze.exe manually from the command line, or as part of a script for unattended operation, to analyze or fix the problem. Analyze.exe is in the WIN32 folder under the folder in which you installed VSS.

We recommend that you run Analyze.exe twice [image] first with the -F option (to fix any errors found), and the second time to check if any errors remain. If you still have errors after the first run, you can check the Microsoft Knowledge Base at http://www.microsoft.com/kb) article Q152807 for more information.

Syntax

ANALYZE [-B<folder>] [-C] [-D] [-F] [-I-] [-V] [-X] [-?] [-H] <Full Database Path | @Response File | List of Files>

Option | Description
-B<folder> | Specify a backup folder.
-C | Clean up and compress the database. This option can be slow.
-D | Delete any unused files.
-F | Attempt to repair any inconsistencies and corruption that are detected.
-I- | Continue without stopping for user input (allowing unattended operation). By default, Analyze.exe leaves the results window on display.
-V n | Specify the verbosity of output. -V1 displays only critical errors, -V2 displays critical and significant errors, -V3 displays all errors, and -V4 shows all errors and warnings. The -V4 option shows its output in the lower pane of the Analyze Results window and contains detailed information on what the utility attempted and accomplished. The default is -V1. -V (without a number) is equivalent to -V4.
-X | Directs Analyze.exe to not lock files as it processes. Allows Analyze.exe to run against a live database. This option cannot be used with the -c, -d, or -f options and use of this option is not recommended unless absolutely necessary.
Full Database Path | Path of the VSS data folder to analyze. This parameter must be the first non-switch parameter. A data path, list of files, or response file must be present on the command line.
@Response File | File produced by running Analyze.exe, containing listing of problem files, named Analyze.bad by default. Using this file as input directs Analyze.exe to work on fewer files, thereby improving performance.
List of Files | List of files to analyze. List can include only log files, or complete data paths, such as C:\VSS\Data\A\AAAAAAAA.
-?, -H | Displays usage message containing descriptions of valid options.

Order of options is not important, but the full database path, response file, or list of files must be included on the command line as the first non-option item.

Examples

ANALYZE -C -D -F -V4 C:\VSS\Data

Analyzes and repairs the complete database and generates verbose output.

ANALYZE -BC:\Temp C:\VSS\Data

Analyzes the database, but does not fix it. Creates a list of corrupted files in C:\Temp.

ANALYZE -F -C -D @C:\Temp\Analyze.bad

Fixes any problems in the files listed in the Analyze.bad file generated by the preceding example.

Remarks

The types of problems that Analyze.exe can correct include:

  • Parent/child mismatch. Possible situations include those in which a project thinks it has a file or subproject but the child disagrees, a child thinks it has a parent but the parent disagrees, or child and parent don't reference each other but the child counts are off.

  • Corrupt database files. These files include the following: Names.dat (stores long filenames longer than 34 characters), Rights.dat (stores relationships between users and project rights), Status.dat (stores check out status for files), Um.dat (stores all users in a VSS database), and Version.dat (stores the VSS version).

  • Removing unused items from the database.

Administrators should run Analyze.exe regularly to verify that no problems exist in their VSS databases. All results of Analyze/Repair are logged to the file, Analyze.log, which is placed in the \VSS\Data\Backup folder and is replaced each time Analyze.exe is run. When you analyze the database, Analyze.exe creates a file listing all corrupted files. This file is called Analyze.bad and is also placed in the \VSS\Data\Backup folder. In addition, the original versions of files that have been repaired are placed in the \VSS\Data\Backup folder.

Under normal conditions, all users should be logged out of VSS before Administrators run Analyze.exe. Users must be logged out to run Analyze.exe with the - F option to repair problems. Analyze.exe does not run if any users are logged into VSS unless the -X option is supplied.

Analyze.exe writes output to the Analyze Results window. This window may contain two panes. You must close any open results windows before running Analyze.exe another time.

The top (or only) pane contains summary information. For example:

Analyze Version 4.00[Build 1110]
Database analysis in progress.
The Parent Project for item acctapp is corrupt and the link to the child file has been lost until the project is recovered.
Analysis complete.

This is the information provided in the output window when you run Analyze.exe using the -V or -V4 option for verbose output. When you use the -V option, the information provided is written to the bottom pane of the Analyze Results window. The following example shows verbose output:

Started analyzing user management system.
Successfully completed analyzing the user management system.
Rebuilding corrupted project for item aaaaaaaa.
Building the project list.
Checking cross file relationships.
Checking parent/child relationships.
Validating the Security System.
Writing a new copy of ‘c:\vss\data\a\aaaaaaaa’.
The count of children of item ‘aaaaaaaa’, as given in its header, does not match the number of children found on disk. The count will be adjusted.
The count of sub-projects of item ‘aaaaaaaa’, as given in its header, does not match the number of sub-projects found on disk. The count will be adjusted.

Note that the actual output in the Analyze Results window does not wrap; it scrolls within the pane.

When the Rights.dat database file is rebuilt by Analyze.exe, it turns on project security, even if security was disabled before the rebuild. As a result, only the Administrator can log on to VSS after the rebuild of Rights.dat. Therefore, the Administrator must then run the SSAdmin program to turn off Project Security or re-assign all user rights.


DDCONV

See Also

Ddconv.exe updates a VSS database from an earlier format to the current format.

Ddconv.exe is primarily used by installation scripts to make sure the format of an installed VSS database is correct after an update. Ddconv.exe is also one step in the process of creating a new VSS database with the Mkss.exe utility.

If VSS cannot find all of the installed database during installation, the VSS administrator may have to run this utility manually. Ddconv.exe can also be used with the -S option to rebuild the status file.

Syntax

DDCONV [-S] [-MSSpath]|[data path]

The following table describes command-line options available with this command.

Option | Description
-MSSpath | The path of a SRCSAFE.INI file from which Ddconv.exe can determine the data folder.
Data path | The path to a data folder to convert.
-S | Rebuild the VSS check-out status index file.


DDUPD

See Also

DDUPD upgrades the Visual SourceSafe database to a new format. The new format will initialize the database to take advantage of the Label Promotion and the Performance Enhancements introduced in VSS 6.0. During installation the database may have been upgraded. If a ..\data\labels folder exists, the database is in the new format. The database can be 'downgraded' with this utility also.

Notes about upgrading:

  • Back up your VSS database before upgrading!

  • Make sure all users exit VSS before upgrading to the new version. They can, however, have files checked out during the upgrade.

  • By default, when you upgrade to VSS 6.0 the database format is the same as that of VSS 5.0 (and 4.0a). If you have Macintosh, UNIX, NT 3.51, or 16-bit clients, you must stay with the older database format. (You also must stay with the 5.0 database format until you own VSS 6.0 licenses for everyone.)

  • If you don't have issues with backward compatibility, you can upgrade the database to the new format, which will allow you to take advantage of some performance enhancements in VSS 6.0. With the new database format, any command that asks VSS to copy a file to your local drive (such as Get, Check Out, Undo Check Out, Deploy, etc.), will be faster. The greatest performance enhancement is seen in situations where the file already exists and no copy is needed.

  • Upgrading the database allows you to take advantage of the new Label Promotion feature. For more information, see Maintaining Multiple Versions of a Project.


Delta_SS

See Also

Delta_SS.exe extracts files from Microsoft Delta libraries and converts them to VSS internal format.

If you have projects saved in Delta, you can convert them to VSS. The Delta files themselves are not changed. You can convert entire Delta projects or individual Delta files. After the conversion, all of the files reside in a VSS project of the same name.

If you want to convert one or only a few files from Delta to VSS, you must run the Delta_SS.exe utility for each file. You can also use wildcard characters to match multiple files in a single project.

The file to be converted must not be locked or have "broken" status. To prevent inconsistent versions of files when multiple files are being converted, make sure the project is not in active use. You can use the Lock Project command in Delta to deactivate the project while you are converting it.

Delta_SS.exe requires the current version of VSS and installation of the Delta version 1.0 command-line tools. It also requires sufficient free disk space on the VSS destination drive to accommodate the new files: Approximately two times the disk space used by your Delta log files is required for working space and for the new files.

Note Before using Delta_SS.exe, back up your Delta project files and your VSS database.

To convert a single file or folder:

  • On the command-line, type Delta_SS -V -D [Delta project location] -P [Delta project name] -S [VSS location] -U [VSS password] [file | folder] [VSS project name].

    For example:

    Delta_SS -v -d c:\Delta -p ToolVer1 -s c:\SS -u drowssap File1.txt

    This provides a verbose report of the conversion of File1.txt from Delta to VSS. Because no VSS project was specified, the converted file is placed in a project with the same name as the Delta project.

To convert an entire project:

  • On the command-line, type Delta_SS -V -R -D [Delta project location] -P [Delta project name] -S [VSS Project] -U [VSS password] [file | folder] [VSS project name].

    For example:

    Delta_SS –v -r -d c:\Delta -p ToolVer1 -s c:\SS -u drowssap

    This converts the ToolVer1 project (and recursively, all of its subprojects) from Delta to VSS. This conversion includes complete history for each file.

Remarks

Only the VSS administrator can run the Delta_SS.exe. The -U option is used to specify the VSS administrator password, if one exists.

If you don't supply the VSS database location on the command line with the -S option, Delta_SS.exe determines the VSS location as follows:

  • If the SSDIR environment (operating system) variable is defined, then the specified location is used.

  • If the parent folder to the folder containing Delta_SS.exe contains SRCSAFE.INI, then that folder is used.

  • If the current folder contains SRCSAFE.INI, then the current folder is used.

  • If none of the above is found, Delta_SS.exe terminates with an error message.

The -R option converts all projects under the specified Delta project recursively.

The -P option specifying the VSS project name is not required. If it is not specified, Delta_SS.exe uses the Delta project name as the default. (The Delta project name must be specified with the -D option.)

Either -? or -H (from a Windows command line) can be used to get a listing of the Delta_SS.exe syntax.

After a successful conversion, the file(s) are placed into the named VSS project. If the destination project does not exist, it is created during the conversion. A log file (called Delta_SS.log) describing the conversion is created and placed in the folder in which VSS is installed.

Delta_SS.exe saves the entire history of each selected file by default. If you want to convert only the latest version, you can retrieve that version from Delta and add it to VSS manually using VSS's Add Files command.

Note You must specify the location of the source Delta master project folder. Delta_SS.exe does not operate on checked out Delta files in your working folder.


MKSS

See Also

Mkss.exe creates an empty VSS database in an old format. Mkss.exe is installed in the ADMIN subfolder by default.

To create a new VSS database:

  1. Create a folder.

  2. Run the Mkss.exe utility on the folder.

  3. Run the Ddconv.exe utility on the folder.

Syntax

MKSS [folder]


PVCS_SS

See Also

PVCS_SS.exe converts a PVCS project or file into a VSS project or file.

VSS and PVCS use different internal file storage methods, so PVCS users cannot simply switch to using VSS; they must first extract all PVCS log files and enter them into VSS projects.

You can convert a project manually by getting a PVCS file and then adding it to VSS. However, there are disadvantages: It takes a lot of time and is error pron since it does not retain file histories and comments; only the latest version of each file is converted.

PVCS_SS.exe provides an automatic solution. It converts PVCS log files into VSS files, with histories and comments intact.

Note Only the VSS administrator can run PVCS_SS.exe.

Preparing to run PVCS_SS.exe:

  1. Back up your PVCS project files and VSS database.

  2. Make sure both PVCS and VSS are fully installed on your system. PVCS_SS.exe does not replace the installation process for VSS; it is run after VSS installation.

  3. Log on to VSS as the Admin user. The best way to do this is by setting environment (operating system) variables at the command prompt. SSUSER and SSPWD are environment variables that indicate your username and password, respectively. For example:
    Set ssuser = admin
Set sspwd = hoof

    By default, the VSS administrator is not assigned a password; specify a password only if you have assigned Admin a password.

  4. Make sure that the PVCS folder (where executable files such as Get.exe and VLog.exe are located), and the VSS folder, are both on your MS-DOS path. While adding these folders to the path is not required, it makes running PVCS_SS.exe easier.

You are now ready to run the PVCS_SS.exe and convert all your files.

To run PVCS_SS.exe:

  1. Change to the folder where the PVCS log files are located.

    PVCS log files store all your data, comments, histories, and so on. In general, they are named with the extensions that your filenames use, terminated with a V, so that Test.C becomes Test.C_V, and Test.pas becomes Test.pav. However, the PVCS configuration setting LOGSUFFIX can change the log file extension name.

  2. Type PVCS_SS <PVCS logfiles> <VSS project>

    The destination VSS project name must start with a dollar sign ($). Otherwise, this variable is assumed to be a PVCS log file. A few examples are given below.

    PVCS_SS *.??V $/Project
PVCS_SS TEST.C_V TEST.H_V $/Test
PVCS_SS *.PAV TEST.TXV $/
  3. Repeat steps 1 and 2 for all PVCS log files you want to convert.

Remarks

  • The filename in VSS is not the name of the PVCS log file; it is the name of the PVCS work file, that is, the real name of the file. For example, Test.C_V becomes Test.C in VSS.

  • If the VSS project you specify exists, the converted files are added to it. If the project does not exist, it is created. If you do not specify a project, the current project for the VSS Admin user is used.

  • If a file has gone through ten revisions in PVCS, there are ten versions of the file in VSS. However, the numbering systems used by the two programs are different. PVCS starts off with 1.0, followed by 1.1, 1.2, 1.3, and so forth. VSS uses whole numbers: 1, 2, 3, and so on. Therefore, what was 1.3 in PVCS becomes version 4.0 in VSS.

  • While PVCS_SS.exe is running, it displays all files that it is converting and all branches that it is ignoring. This is logged in a file called PVCS_SS.log in the folder in which VSS is installed.

  • A null revision in PVCS is a revision of a file that encodes no changes to the file contents. PVCS_SS.exe determines how to treat these revisions based on the Update_No_Change initialization variable in the Admin user's SS.INI file. If the Update_No_Change variable is not set, PVCS_SS.exe assumes the default value, updates, and converts all null revisions.

  • Both PVCS and VSS support Branches, but PVCS_SS.exe does not convert PVCS branches to VSS branches. You must manually convert the branches you want to keep. PVCS_SS.exe assists with this process by reporting and logging in PVCS_SS.log all the branches that it passes over.


SS

See Also

SS.exe is used to integrate other applications with VSS by creating batch files or by calling SS.exe commands from your application. SS.exe uses the following syntax.

Syntax

SS command name <item(s) to operate on> [switches]

Example

Issues a VSS Get Latest Version command on the file Filename.txt:

ss Get Filename.txt

All commands in the command set are described in VSS Help.


SSARC

See Also

SSARC.EXE and SSrestor.exe together constitute the VSS Archive utility. This combination:

  • Allows a user to archive files, projects, or old versions from a VSS database, and restore them at a later date if necessary.

  • Allows wide area VSS installations to move files and projects among databases.

  • The ability to move information from one database to another is crucially important, especially for the largest users of VSS, which are the most likely to need to use more than one database.

Syntax

SSARC [-d] [-v] [-s] [-c] [-o] [-i-] [-y] [-x] <archive file to create> <files/projects to archive>

The following table describes command-line options available with this command.

Option | Description
[-d] | Deletes the archived items from the database.
[-d-] | -d- controls whether VSS actually deletes anything from the database. If this parameter is not used, the default is to ask.
[-v] | Specifies a version number to archive (standard VSS parameter).
[-s] | Specifies a path to SRCSAFE.INI and the data directory.
[-c] | Comment (standard VSS parameter).
[-o] | Redirects output (standard VSS parameter).
[-i-] | No input (standard VSS parameter).
[-y] | Username, Password (standard VSS parameter).
[-x] | Archive only deleted items in the files and projects specified in the files/projects to Archive parameter. (Deleted items are still stored in the VSS database unless the Destroy Permanently option was selected when performing the Delete operation.) Note that this parameter is not required on a subsequent restore.

Note VSS asks only once before it deletes the files, each time you run SSARC.EXE.

The –v option specifies a version, in standard VSS format (number, date or label). This is an important parameter. If not used, you archive off entire files or projects. When used, you archive off all versions up to and including the one specified here. Note that the archive utility is generally inclusive. That is, if you type –v9 you create an archive file that contains version 9.0 and everything before it. The delete pass is also inclusive; that is, version 9.0 is actually deleted unless it is a label. If that version is a label, the label is stored in the archive file, but is not deleted. If –v is specified, you never delete the current version, even if the specification is
–vd9/9/99. If you are using a label, and the label has a space in it, you must enquote the entire option (for example, “-vThisOne”).

The –s option allows the user to specify the path to SRCSAFE.INI and/or the Data path. The full syntax looks like the following:

-sc: \VSS, OldDB

The item before the comma is the full path to SRCSAFE.INI, and the item after the comma, if present, is the string in parentheses in a Data_Path setting. If there is no comma, the user is specifying a SRCSAFE.INI path but no data string. If the first character after the –s is a comma, the user is specifying a data string but no SRCSAFE.INI path.

Note Most users do not need this option. The SRCSAFE.INI file and SSARC.EXE are properly positioned during VSS installation.

The –c option is the standard VSS comment option. The comment is inserted into the VSS history, if the items are deleted from the database as part of the “archived” record. The comment is also inserted into the archive file itself, if there is one.

The –o and -i- options are standard VSS options.

As with SSRestor.exe, the –y option lets you specify the administrator’s password. For example:

-yAdmin, Bunny


SSLogin

See Also

SSLogin.exe is used by integration scripts and macros to find the user's username, and optionally to get .INI file and current project information for that user. If you are running SS.exe, SSLogin.exe can also be used to set the logon name stored by SS.exe.

Syntax

SSLOGIN [-exitcode] [-E] [-Ofilename] [username] [password]

The following table describes command-line options available with this command.

Option | Description
-exitcode | Displays a line of the format "Exit code: 0" so that calling programs can determine if SSLogin.exe ran successfully. A zero indicates SSLogin.exe ran successfully; anything else indicates it did not.
-E | Displays the user's current project and path to their .ini file in addition to the username.
-O filename | Output the information to the specified file instead of to the screen.
username | Shows information for the specified user. If the user does not exist, a non-zero exit code is displayed. If no username is specified, the current VSS user is used. If SS.exe is running, specifying a username passes that username to SS.exe, effectively logging in a new user.
password | Validates the user.


SSRestor

See Also

SSRestor.exe restores information from a previously created archive.

Syntax

SSRESTOR [-pProject] [-l] [-t] [-s] [-o] [-i-] [-y] [-x] [-c] <archive file to restore> [files/projects]

The following table describes command-line options available with this command.

Option | Description
[-p] | Specifies a project to restore into.
[-l] | List.
[-la] | List all
[-t] | Test the archive file for corruption, but do nothing else.
[-s] | Specifies a path to SRCSAFE.INI and the data directory.
[-o] | Redirects output (standard VSS parameter).
[-i-] | No input (standard VSS parameter).
[-y] | Username,Password (standard VSS parameter).
[-x] | Identifies which item to restore when the item has been deleted from the project. -x means restore the deleted item. For example, assume you have both a deleted and non-deleted $/a/b. If you archive and delete $/a, you actually get three projects ($/a, $/a/b, and $/a/b) deleted. What, therefore, does ssrestor $/a/b really mean? If you don't specify -x, it means use the non-deleted $/a/b. If you do specify -x, it means restore the deleted $/a/b. Even though they have the same name, these are two different projects.
[-c] | Specifies the comment applied to the history entry for the restored item(s).

The -p option specifies a project to restore into. For instance, if you archive off $/A/BAR.C and then restore it, it will be restored as $/A/BAR.C. Use the -p parameter only if you want to restore the file into a different project.

Note If restoring attempts to create a duplicate file or project name, the restore fails.

The -l option specifies “don’t restore anything, just list what’s in this archive file.” Suppose you archived $/A into this archive file. If you use –l, it will simply tell you that $/A is there. If you use –la, it will actually show you all the files and subprojects under $/A. In general, -l only shows you the items you explicitly put into the file; -la shows you all the child projects and files.

The -t option is analogous to pkunzip -t. It says, “don’t actually restore this archive, just let me know whether it is corrupt.”

The -s option is described in detail under SSARC.EXE.

The –o and -i- options are standard VSS options.

As with SSARC, the -y option lets you specify the administrator’s password. For example:

-yAdmin,Moggy


Testlock

See Also

Testlock.exe determines whether your network supports native locking. Testlock.exe is installed in the platform-specific (for example, WIN32) subfolder by default.

The locking system is set in the SRCSAFE.INI file. The primary variable is Lock_Mode, which can be set to either Native or Lockfile. The default is Native.

To determine the locking system in use on your network:

  1. Install VSS to a drive accessible from two or more computers.

  2. From one of the computers, go to the WIN32 folder and run:

    Testlock.exe <folder name>

    Testlock.exe locks a file, and displays the message "Press any key to continue." Do not press a key yet; leave the program running, and go to step 3.

    If Testlock.exe fails and does not display the message, go to the specified folder and delete the file(s) Testlock.*, then try again. Make sure not to delete anything else.

  3. From another computer, run Testlock.exe again, providing the same folder path as before.

    Testlock.exe attempts to lock the same records that the first computer has locked, and report the results. If the lock fails, your network file system supports native locking. If the lock succeeds, you must use the Lockfile variable setting.

  4. Press a key on both computers to end the program.

    If native locking is supported, repeat steps 2 through 4 on various computers on your network, testing each platform combination to make certain the necessary features are supported across your entire network.

    To save time, you may leave Testlock.exe running on one computer, and repeat step 3 on every other computer. Then switch to a different "first" computer and repeat the pattern, and so on.


Unlock

See Also

Unlock.exe clears orphaned locks by specifying the lock (from the error message) on the command line.

VSS uses different mechanisms to implement mutual exclusion within the database. (This has nothing to do with checking out files). If VSS stops unexpectedly, it may leave some of these mutual exclusion locks behind. The next time VSS tries to access the protected records, it reports an error.

Syntax

UNLOCK lock

Lock is the lock name displayed in the "time-out locking" error message.


Updini

See Also

Updini.exe converts VSS's .ini files from an earlier version to the current version.

VSS configuration is stored in a set of .ini files. Updini.exe is primarily used by installation scripts so that all .ini files are in the appropriate format after an upgrade.

This utility may also be necessary if you have moved your earlier version .ini files from their default installation location. When you install VSS 3.1 or later, the Setup program runs Updini.exe to convert your .ini files to the new format. If your .ini files are in their default locations, Setup converts them automatically. However, if you have moved your SS.INI file, Setup may miss the file. You then have to manually run Updini.exe to update your SS.INI file after installing VSS.

Syntax

UPDINI [-MSSpath]|[.INI file]

The following table describes command-line options available with this command.

Options | Description
-MSSpath | If this parameter is specified instead of an .ini file, Updini.exe looks for the System.ini file (the old name for SRCSAFE.INI). If it finds System.ini, it opens it, finds all of the user .ini files, updates the contents of all .ini files, and then renames System.ini to SRCSAFE.INI.
.INI file | Provides Updini.exe with the name of an .ini file to update.


Topic Not Found

No matching topic was found. Some possible reasons and remedies are as follows:

  • The file (.chm) that contains the destination topic is not in the expected location.

    Remedy: Rerun the MSDN Library Setup.

  • The file (.chm) that contains the current topic or destination topic is out-of-date and the link is no longer valid.

    Remedy: Install the latest version of the MSDN Library.

  • The MSDN Library CD is not in the CD-ROM drive.

    Remedy: Insert the MSDN Library CD into the CD-ROM drive.


Enter Comments at the Command Line

See Also Concept_AltCmdlineWords;

To enter comments at the command line:

  1. At the command prompt, type ss comment "the itemname.*"

  2. When the command-line prompts you for a comment, type the comment and then press ENTER.

    Note Comments are not limited to one line; if you reach the end of the line and continue to type, VSS wraps the comment to the next line.

  3. If you want to force a carriage return without ending the comment, type a backslash (\) and then press ENTER. The backslash is not part of the comment, but the carriage return is included in the comment and you can continue typing.

    Note After you enter a forced carriage return, you are not able to backspace to previous lines.

You can use the -C command-line option for many items as well as for one item. This enables you to type one comment and apply it to all the files.


Use Alternate Command Line Commands

See Also CmdLine_Comment;

VSS provides two ways to customize VSS to accept alternate command syntax in place of built-in VSS command syntax.

You can define alternate commands and place them in the initialization files under the [Commands] heading. The syntax takes the form Alternate Command = Visual SourceSafe Command. For instance, a Microsoft Windows NT user might place the following in SS.INI.

[Commands]
Grep = Find
Ls = Dir

You can type the alternate command in place of the VSS command, with the same parameters and results; VSS commands continue to work too.

VSS also provides hard-coded alternate commands. The following table lists alternate commands and their VSS equivalents.

Alternate | VSS
CD | CP
ChPro | CP
Copy | Share and Branch
Remove | Delete
Grep | Find
LS | Directory
MD | Create
MkPro | Create
MP | Create
Type | View
Undelete | Recover
WhereIs | Locate
Scan | FindInFiles
Separate | Branch
Uncheckout | UndoCheckout
Update | CheckIn


Use Command Line Exit Codes

See Also

Whenever you run the VSS command line, it sets the exit code to indicate its running status. You can use this operating system variable in batch files, scripts, and macros to react based on what happened when you ran VSS.

The exit code is set as follows:

Code | Description
100 | Something went wrong. For example, VSS could not find its data files, or a file you want to check out is already checked out.
1 | Indicates a milder sort of failure, and occurs in three circumstances: When you run ss Dir and no items are found. When you run ss Status and at least one item is checked out. When you run ss Diff, and at least one file is different. All of these circumstances indicate that your next VSS command may fail, even though this command ran successfully.
0 | VSS executed successfully.


Add this project to <project>?

This message has the following cause and solution:

  • You have not added this project to source control.

Choose Yes to add this project to source control. Choose No to leave this project out of source control (for instance, to debug code first).


Another user (<user>) has placed this database under source code control and is the only person who should work with it.

This message has the following cause and solution:

  • You are trying to open a database owned by another user.

You were not the last user to use this file. If you continue, you will overwrite their changes and check out status. Log out from VSS, and then get your own copy of the file using the Create <object> From SourceSafe command.


You have not added the .ACB file to source code control to have a complete database.

This message has the following cause and solution:

  • You added an Access project, but chose not to add a .ACB file.

Re-add the project to source control, and include the .ACB file.


A database by this name already exists in the source code control project <project>.

A database by this name already exists in the source code control project <project>. Would you like to reconnect to it?

This message has the following cause and solution:

  • You tried to add a project, but a project with that name was already under source control.

Choose Yes to reconnect to the existing project, or choose No if the project in source control is a different project by the same name. Then, choose a new name for the new project.


Could not create a valid file name for <file>.

This message has the following cause and solution:

  • You can only add modules to VSS if the module name is a valid filename. The file name you chose is not valid.

Rename your object to something with a valid filename.

If you mistyped the file name, please try again with a valid file name. If you believe the file name is valid, and are working in a mixed-operating system environment, the problem may be that the file name you chose does not translate properly in one of the other operating system environments connected to your VSS database. In this case, try another filename.


Failed to add file '<file>' to source code control.

Failed to add file "<file>" to source code control.

This message has the following cause and solution:

  • There is a file with the selected name already in the source code control project.

You can save your new file as a different name, or accept the file already in source code control (overwriting any changes).


Failed to add files to <project>.

This message has the following cause and solution:

  • VSS couldn't save the files that you want to add, and they contain unsaved changes.

The VSS operation may have failed, you may not have add rights in this project, or you could have run out of memory. Save your files manually and try again. If that fails, check your VSS connection and try again.


Add this project to <project>?

This message has the following cause and solution:

  • You created a new project, or opened a project which hasn't been under source control before.

Choose Yes to add the project, or No to cancel the operation.


Required supporting files could not be added to source code control, the Check In operation failed.

This message has the following cause and solution:

  • You tried an Add operation, but it failed when VSS tried to add supporting project files (for example, the .frx form file).

Add each file separately to source control.


Failed to create a new project based on a <source code control provider> project.

This message has the following cause and solution:

  • You encountered an internal error while trying to create a new folder.

Quit and restart Microsoft Access, and VSS if it is running.


Not all options could be set correctly.

This message has the following cause and solution:

  • You encountered an error writing to your system registry.

Ensure that you have enough space on your drive for changes to the system registry.


Unable to access file "<file>".

This message has the following cause and solution:

  • The source code control provider could not make a temporary file writable.

Check the read-write permissions on your files and directories, check your disk space, and ensure the database is on a drive that you have write permission for.


Unable to use the selected source code control project.

This message has the following cause and solution:

  • When you add a host project to source code control, you must select a source code control project into which the files will be placed. The source code control provider checks the selected source code control project to make sure it is suitable for the operation. If a problem is found, this error occurs.

Follow the rules imposed by the source code control provider regarding suitable projects for the Add command.


Could not create a working folder for this project.

This message has the following cause and solution:

  • The working folder you specified could not be created.

You may not have permission to create a folder on the computer you specified, or the drive may be full, or the name you choose may already be in use. Try specifying another name.


Unable to initialize the host application for source code control.

This message has the following cause and solution:

  • The source provider could not connect properly to the host development environment..

Rerun the setup programs for your host development environment and source control provider..


Failed to initialize the source code control provider.

This message has the following cause and solution:

  • The source provider could not connect properly to the host development environment..

Rerun the setup programs for your source control provider..


The source code control provider did not initialize properly.

This message has the following cause and solution:

  • The source code control provider was loaded, but was unable to initialize.

Rerun the Setup program for your source code control provider.


'<object>" is checked out somewhere else - you cannot rename it now.

"<object>" is checked out somewhere else - you cannot rename it now.

This message has the following cause and solution:

  • You are trying to rename a file that is currently checked out.

You can wait for the other user to check the file in, or get your VSS administrator to undo the user's checkout (which will overwrite his or her changes.)


Failed to update project location information in the host application.

This message has the following cause and solution:

  • Another application is using the .mdb file.

Make sure no other application is using the database (be sure to check for programmatic use through DAO).


The Check In operation failed.

This message has the following cause and solution:

  • You have unsaved objects that would be lost if the operation proceeded.

Save all objects in your project to a file, and then try again.


The Check Out operation failed.

This message has the following cause and solution:

  • You have unsaved objects that would be lost if the operation proceeded.

Save all objects in your project to a file, and then try again.


Differences could not be shown.

This message has the following cause and solution:

  • You encountered an internal error while trying to check differences between objects.

Quit and restart Microsoft Access, and VSS if it is running.


Another user (<user>) has placed this project under source code control and is the only person who should work with it.

This message has the following cause and solution:

  • Another user has this database under source control and you opened it. You will overwrite all of the other user's changes unless you exit immediately. If the other user had anything checked out, his or her changes will be lost the next time they use the Get Command.

Exit immediately, or sacrifice the other user's changes.


<source code control provider> did not disconnect properly.

This message has the following cause and solution:

  • The source code control provider could not disconnect from your project.

Quit and restart Microsoft Access to clear this error.


An error occurred opening file '<file>' to check for changes.

An error occurred opening file "<file>" to check for changes.

This message has the following cause and solution:

  • You have encountered an internal source code control error.

Quit and restart VSS. If that doesn't solve the problem, reinstall VSS and then reboot your computer. If that doesn't solve the problem, check for adequate memory and disk space, check disk space on the server, and check the network connection to your computer.


An error occurred reading file '<file>' to check for changes.

An error occurred reading file "<file>" to check for changes.

This message has the following cause and solution:

  • You have encountered an internal source code control error.

Quit and restart VSS. If that doesn't solve the problem, reinstall VSS and then reboot your computer. If that doesn't solve the problem, check for adequate memory and disk space, check disk space on the server, and check the network connection to your computer.


The file <file> already exists in the source code control project, but your local copy is different.

This message has the following cause and solution:

  • You tried to add a file to your project when a file by that name already existed in the project. The file was not added, and your local copy has not been changed.

Choose a different name for the file you want to add.


The Get operation failed.

This message has the following cause and solution:

  • You have unsaved objects that would be lost if the operation proceeded.

Save all objects in your project to a file, and then try again.


The Get operation failed.

The History operation failed.

This message has the following cause and solution:

  • You have unsaved objects that would be lost if the operation proceeded.

Save all objects in your project to a file, and then try again.


The file could not be reloaded into the host IDE.

This message has the following cause and solution:

  • This is usually caused by an internal application error.

Close the project and re-open it.


You have not added enough files to source code control to have a complete project.

This message has the following cause and solution:

  • You tried to add some files to source control, but they are not enough to completely define a project. This project has not been connected to source code control.

VSS needs to maintain all the files in the project. Add the complete set to the VSS project.


Failed to initialize the current project.

Failed to initialize the current project. Please exit and reload this project.

This message has the following cause and solution:

  • This is usually caused by an internal VSS error.

Exit and reload the project. If that doesn't solve the problem, exit and reload your development environment application. If the problem persists, reboot your computer.


# The new name cannot be used because it is not a valid filename.

This message has the following cause and solution:

  • You are attempting to rename a file/object, and the new name is not a valid filename (typically because it contains invalid characters).

Choose a different name for the file/object.


An error occurred while trying to connect to the <project> project.

This message has the following cause and solution:

  • The source control provider could not initialize the source control project.

Exit your development environment and re-start it. If this does not clear the error, re-run your source control provider’s setup program. Check your system resources, especially memory and disk space.


Out of Memory - could not complete operation.

This message has the following cause and solution:

  • Your computer has run out of memory.

Close unused applications. If the problem persists, restart your computer.


The new name cannot be used because an object with that name already exists in <provider>.

This message has the following cause and solution:

  • You are attempting to rename a file/object, and the new name is the name of an object/file that already exists in source code control.

Choose a different name for the file/object, or rename/delete the existing object that has the desired name.


All available files have already been added to source control.

This error has the following cause and solution:

  • All the files in your current development project have already been added to source control.

    If you want to check in a file that is not yet in your development project, first add the file to your development project. VSS will prompt you to add it to source control.


No files are available to be checked out from source control.

This error has the following cause and solution:

  • There are no unchecked-out files in the current VSS project.

    To check out a file not yet added to source control, use the Add Files command to add files. If the file is already in your project, make sure it is not already checked out.

    This error sometimes occurs if someone deletes the file that you wanted to operate on (or deletes the whole project, for that matter)- make sure your project is still there.


No files are available to get from source code control.

This message has the following cause and solution:

  • You chose the Get command, but after careful checking, no files were available for the operation.

This error sometimes occurs if someone deletes the file that you wanted to operate on (or deletes the whole project, for that matter)- make sure your project is still there. Next, make sure you have something checked out.


Since you have not logged into <project>, source code control features are not enabled for this session.

Since you have not logged into <source control provider>, source code control features are not enabled for this session.

This message has the following cause and solution:

  • You did not log on to the source control provider.

Re-open your project, and log on to the source control provider to use source control features.


Unable to check out the file <file> because it is already checked out.

This message has the following cause and solution:

  • The file you chose is already checked out.

Files stored in binary format cannot be checked out by more than one person at once, because VSS could not merge in conflicting changes made by multiple users.


You do not have any files checked out from source code control.

This message has the following cause and solution:

  • You chose the Add, Checkout, Get, Check In, Undo Check Out command, but after careful checking, no files were available for the operation.

This error sometimes occurs if someone deletes the file that you wanted to operate on (or deletes the whole project, for that matter)- make sure your project is still there. Next, make sure you have something checked out.


You don't have a source code control program (such as Microsoft Visual SourceSafe) installed on your machine.

This message has the following cause and solution:

  • You have not added source control programs to your computer.

The source code control commands are therefore not available. Choose Yes to display this warning the next time you try to use source control commands, or No to disable this warning message.

For VSS users, run NETSETUP.EXE from your VSS folder to get source control capabilities. For other source control providers, re-run Setup for your provider.


<source code control provider> does not support this operation.

This message has the following cause and solution:

  • Your source code control provider does not support the menu item you chose.

Contact your source code control vendor, or purchase Microsoft Visual SourceSafe.


Unable to load the source code control provider - you need a newer version.

This message has the following cause and solution:

  • You are using a version of the source code control provider older than the supported version.

Reinstall the latest version of your source code control provider.


The file <file> is no longer under source code control, the operation failed.

This message has the following cause and solution:

  • Some user deleted a file from your VSS database during your session, and you tried to use a context menu to get it.

Re-add the file to source control, check to find out who deleted it and why, etc.


Failed to reload the project.

This message has the following cause and solution:

  • An internal application error occurred.

Close this project from the file menu and re-open it to get the correct version of all files loaded into memory.


A project by this name already exists in the source code control project "<project>".

This message has the following cause and solution:

  • You tried to add a database to source code control in an existing project.

Click Yes to reconnect to the existing project, No to cancel this operation.


The project <project> no longer exists under source code control. You must either recover or re-create the project before you can use this project with source code control.

This message has the following cause and solution:

  • Your project has been deleted (or moved) by another user.

Click OK if you want to try to find the project. If the project has been deleted, choose Cancel. Once you click Cancel, the database will be detached from source code control, and you can re-add the project to source control (but you will lose any historical information on this project).

If you can find out who deleted or moved your project, you may be able to recover the project and its history (for example, if your source control administrator has archived your project to a backup tape).


This project was named '<name>' but has been moved, copied, or renamed.

This message has the following cause and solution:

  • Once you place an Access database under source code control, you are not allowed to rename it or move it to a different directory, or to work with copies of it. When you open a database under source code control which has been moved, renamed, or copied, this message will be displayed and all source code control functions will be disabled for this database.

Do not work with a copy of an Access database which is under source code control. Use the Create Database from SCC command to make a new database in the desired location.

If the database has been moved, return it to its original location and reopen it. Source code control functions will return to normal. Likewise, if it has been renamed, restore its original name.


Properties could not be shown.

This message has the following cause and solution:

  • You encountered an internal error while trying to view properties.

Quit and restart Microsoft Access, and VSS if it is running.


The item was not removed from the <provider> project.

This message has the following cause and solution:

  • This is usually caused by an internal VSS error.

Remove each file separately from source control.


You have created a new project with a different name.

You have created a new project with a different name. The new project is no longer associated with source code control.

This message has the following cause and solution:

  • You have renamed a project and the renamed project is no longer in source control.

Add the new project to source control, if desired.


The item was not renamed in the <provider> project.

This message has the following cause and solution:

  • This is usually caused by an internal VSS error.

Rename each file separately in source control.


The file that was renamed had a tagalong file which could not be automatically renamed in source control.

This message has the following cause and solution:

  • This is usually caused by an internal VSS error.

Manually rename the tagalong file.


"<file>" does not have a valid file name. It must have a legal file name to be added to source code control.

This message has the following cause and solution:

  • Although the name of this object is valid for the host application, it isn't a valid file system name (it contains illegal characters).

Rename the object, and then add it to source code control.


Some file(s) could not be saved. The project was not added to <provider>.

This message has the following cause and solution:

  • You are adding a project to source control without saving changes.

VSS was not able to save some of your changes. You may not have write permission on some files, or you may have a network error.


The operation failed because some file(s) could not be saved. Save your project and try again.

This message has the following cause and solution:

  • Some files could not be saved to disk.

Make sure that you have permission and space to save files on the destination disk. Try to save the files manually, then try the operation again.


The project could not be properly closed in <source code control provider>.

This message has the following cause and solution:

  • The source code control provider could not close the source code control project.

Quitting and restarting Microsoft Access will usually clear this error.


The Share operation failed.

This message has the following cause and solution:

  • You have tried to share a file that has the same name property as one in the target project.

There are several possible causes for this message. One is if you have not assigned the name property in one of your files, you could be conflicting with a file in the target project (where the name property also was not assigned or is identical). In this case, assign the name property of the file in your current project, and then try again.

Other possibilities are that the project file is checked out to someone else, or you were not able to check out the project file. Check the file check out status to determine if this is the case. Or, there could have been a VSS internal error.


The share operation succeeded, but the files could not be added to the current project.

This message has the following cause and solution:

  • The share operation succeeded, but trying to add the file to the project failed.

Check that the name property of the file does not conflict with the name property of an existing form, module, class module, or other Visual Basic file.


Only a single project can be under source control at a time with this source code control provider.

This message has the following cause and solution:

  • Some source control providers can handle only one project at a time.

Contact your vendor for an updated version of the source code control provider. Or, choose a more advanced source control provider, or don't use multiple projects..


The Get operation failed.

The Undo Check Out operation failed.

This message has the following cause and solution:

  • You have unsaved objects that would be lost if the operation proceeded.

Save all objects in your project to a file, and then try again.


The <file> may have changed. Undo checkout and lose changes?

This message has the following cause and solution:

  • This confirmation message asks if you want to continue with your Undo Check out command, even though it may mean losing changes you have made to your local file.

Choose Yes to undo your check out, and No to cancel the operation.


Unable to connect Visual Basic to source control.

Unable to connect Visual Basic to source control. Please check the installation of the source code control add-in.

This message has the following cause and solution:

  • VSS could not connect properly to your development host.

Rerun the setup program for VSS.


This operation requires the Visual Basic project file to be checked out first.

This operation requires the Visual Basic project file to be checked out first. Would you like to check out the Visual Basic project file?

This message has the following cause and solution:

  • You need to check out the Visual Basic project file before you can make changes to it.

You must check out the project file and then make your changes.


The source code control provider was not able to connect.

A Visual Basic OLE Automation method failed. This error has the following cause and solution:

  • There was an internal OLE, Visual Basic, or source code control provider error.

    Reinstall the source code control provider.


The source code control add-in did not disconnect from Visual Basic.

This error has the following solution:

  • Close Visual Basic and re-open it; this is most likely a temporary internal error.


You can share another makefile into this source code control project, but the makefile has not been added to the VB project.

This error has the following cause and solution:

  • You tried to share a makefile from another project into the current project, but have not added the makefile into VSS.

Add the makefile into the proper project first.


The file <file> already exists in the source code control project, but your local copy is different.

You (or another user) has added this project to the source code control provider. However, when you tried to add files to the project, a different file with the same name was already in the project. You should use the source code control provider's difference command to see what the differences are, and then check in the proper version.

Rather than using the Add Project command, you could also get the entire project to your local drive, then check out the files you need. Using this method, you would get back in synchronization with the project, but would lose any local changes you had made to the project files.


You have not added the makefile to source code control.

You have not added the makefile to source code control. This project has not been connected to source code control.

This error has the following cause and solution:

  • You added a new project to source control, but did not include the makefile.

Re-add the project and include the makefile.


The copy of the Visual Basic project file in the version control database has changed, you can no longer save your current changes.

The copy of the Visual Basic project file in the version control database has changed, you can no longer save your current changes. You must check-out the project file and remake your changes.

This message has the following cause and solution:

  • This is a warning that another user changed the project file while you were working.

Check out the new version of the project file and redo your changes.


You have chosen not to check out the Visual Basic project file, all the changes you have made to the project during this session will be lost.

This message has the following cause and solution:

  • This is a warning that if you do not check out the project file, any changes you make in this editing session will not be saved in source control.

Check out the project file if you want to save your changes.


You have tried to change the Visual Basic project file without checking it out first.

This message has the following cause and solution:

  • You need to check out the Visual Basic project file before you can make changes to it.

You must check out the project file and then make your changes.


There is no makefile associated with this project, unable to create a Visual Basic project from this <project> project.

This message has the following cause and solution:

  • You tried to create a Visual Basic project from source control, but specified an invalid project.

Check the project name, and try again.


Some files have not been named yet.

This error has the following cause and solution:

  • You have not named all your files.

Name your files using the Visual Basic Save File command before proceeding with your operation.


A VB project by this name already exists in the source code control project <project>.

A VB project by this name already exists in the source code control project <project>. Would you like to reconnect this VB project to the existing source code control project?

This error has the following cause and solution:

  • You tried to add a project, but a project with that name was already under source control.

Choose Yes to reconnect to the existing project, or choose No if the project in source control is a different project by the same name. Then, choose a new name for the new project.


Would you like to check out file '<file>'?

This error has the following cause and solution:

  • You tried to edit the Visual Basic file <file>, without having it checked out.

Choose Yes to check out the file, or No to cancel the operation.


(Untitled)

The <project> project that you selected does not contain this VB project.

This message has the following cause and solution:

  • This warning informs you that while trying to browse for a deleted project you picked the wrong project.

Re-try the browse operation.


Would you like to add the new file(s) to the current source code control project?

This message has the following cause and solution:

  • You are adding, either directly or indirectly through a wizard or other tool, several files to source control.

Choose Yes to add the file(s), or No to cancel the operation.


Would you like to check in all files which are checked out to you in project <project>?

This message has the following cause and solution:

  • You are closing the development environment leaving files checked out.

When you close your development environment, VSS reminds you that you have files checked out of the project and prompts you to check them back in. You do not have to check them back in, but leaving them checked out may prevent other users from checking them out.


Would you like to get the latest version of all files in project <project>?

This message has the following cause and solution:

  • This query is asking if you want to get all the latest file versions in your project’s working folder.

Choose Yes to get the latest versions of all files in the project. Choose No to cancel. You can use the Options command to turn this query message off.


Would you like to remove the file '<file> from source code control?

This message has the following cause and solution:

  • You have removed an object from the development project.

Choose Yes to remove the object from source control as well, or No to leave the object in the source control project.


The <project> project that you selected does not contain this IDE project.

This message has the following cause and solution:

  • This warning informs you that while trying to browse for a deleted project you picked the wrong project.

Re-try the browse operation.


No application is associated with this file type

This error has the following cause and solution:

  • You have attempted to view a file for which no file association exists. Without this association, VSS doesn't know which editor to use to display the file.

    Use File Manager to add an association from this file to the appropriate editor, then try your command again.

    If you want to override the File Manager association for a specific file type, you can enter specific associations in your SS.INI file, for example:

    .C = C:\VC\VC.EXE
.FRM = C:\WINDOWS\NOTEPAD.EXE


Too many file handles open

This error has the following cause and solution:

  • You have too many files open at once.

    Close some open files.


This command operates on only one item

For many VSS dialog box lists, you can choose more than one item at once, and then act on all the items together. Some actions, however, cannot operate on more than one item at a time.

This warning has the following cause and solution:

  • You selected more than one item and then applied a command that operates on only one item at a time. For example, you may have tried to use the View command, which works with one file at a time.

    Press the space bar on an item to make it the only item selected in the list.


<string> contains an invalid character.

This error has the following cause and solution:

  • You have entered a data path value in the Connect to VSS dialog that contains an invalid character.

Data path names should not contain the ( )[ ] or blank characters.


SRCSAFE.INI file not found in folder <folder>.

This error has the following cause and solution:

  • You have chosen a folder path in the Connect to VSS dialog that does not contain a SRCSAFE.INI file.

You need to choose the folder where their database information exists. This is typically on the server where VSS is installed.


A deleted link to <File> already exists

See Also

A deleted file remains part of a project, but it doesn't appear in the file list. This error has the following cause and solution:

  • You are attempting to share a file from another project with the current project. However, the file already exists in the current project. It doesn't appear in the file list because it has been deleted.

    To make the file appear in the file list, don't share it from another project; rather, recover it in this project using the Recover button on the Deleted Items tab in the Properties dialog box on the File menu.


A more recent version is checked out

You currently have a more recent version of the file checked out.


<File> is already checked out by <user>. Continue?

See Also

This warning has the following cause and solution:

  • You attempted an operation on a VSS file that is checked out by another user.

    VSS gives you the option to continue, which means any differences between the changes you make to the file and the changes made by the other user will need to be merged in the future. Click Yes to continue your operation and create a multiple-check out situation; click No to cancel the check out action.


User <user> already exists

This error has the following cause and solution:

  • You attempted to add a user with a username that already exists. You may want to select another name; for instance, if there is already a Joyce, add JoyceF.

    Note that names are not case-sensitive, so if you already have a Joyce, adding JOYCE generates this error.


Internal error: please exit and restart Visual Basic.

This error has the following cause and solution:

  • An internal error has occurred in Visual Basic or VSS.

Save your work, exit from Visual Basic and VSS, and restart those programs if you still need to use them.


Add Files command failed: The files were not added to source code control.

This error has the following solution:

  • Open the source code control provider application and manually add the files to the project.


Unable to add the new project to source code control.

This error has the following cause and solution:

  • There are insufficient source code control provider access rights.

    Ask your source code control administrator to increase your access rights, and try again, or try to add the project to a different place in the project tree.

    Log on again to VSS with the proper password.

    (If you have had other errors just proceeding this one, review their causes for more possible causes.)


Not all requested files could be added into the version control project.

Not all requested files could be added into the source code control project.

This error has the following cause:

  • While adding files to the source code control provider, not all files could be properly replaced.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Add this project to source code control?

In most cases, click Yes to keep the Visual Basic and source code control projects synchronized. You may want to click No if you are experimenting with a file that you may add at a later date, or a file that you do not want to add.

Click Yes to add the file to source code control.

Click No to add the file to your Visual Basic project without adding it to the source code control project.


This project is not under source code control.

This error has the following cause and solution:

  • VSS has determined that the current project is not stored in the VSS database.

    If you want to add this project to source code control now, save your project and on the Add-Ins source code control provider menu, click Add Project.


The file '<file>' is no longer connected to this source code control project.

This error has the following cause and solution:

  • You have selected a file that is no longer under source code control in this project.

The file has possibly been deleted from the source code control provider, or moved to a different project. Use the Add Files command to add the file to your source code control provider in the proper project, or search the source code control database for the file if it may be part of another.


The Open Project command from the source code control provider failed.

This error has the following solution:

  • Open the source code control provider application, and then manually get the project. Then, open the project in Visual Basic.


No corresponding Visual Basic project file for this SourceSafe project.

This error has the following cause and solution:

  • The source code control provider could not locate the Visual Basic project file (.VBP or .MAK file). A project file is required because it stores the list of files included in the project, and the source code control provider uses this list to keep track of file status.


The file <filename> could not be added to the Visual Basic project.

This error has the following cause and solution:

  • The file could not be added to Visual Basic.

    Try another filename.


Can't add .FRX file to source code control.

This error has the following cause and solution:

  • An .FRX file was automatically generated to hold resources for the .FRM file, but the .FRX file could not be added to source code control.

    Add the file manually.


The source code control provider was unable to connect to Visual Basic.

This error has the following causes and solutions:

  • An internal error occurred with OLE and Visual Basic.

  • You are using an incorrect version of Visual Basic.

    Reinstall Visual Basic and the source code control provider.


The source code control provider did not initialize properly.

This error has the following solution:

  • Your system is low on memory or system resources.

    Close some applications and try again.

    If that doesn't help, reinstall the source code control provider.


The source code control provider was not able to successfully install menus.

This error has the following cause and solution:

  • There was an internal OLE error.

    Reinstall Visual Basic first, the source code control provider next (if necessary), and then OLE (if necessary).


Can't re-load file <file> in the Visual Basic project.

This error has the following cause and solution:

  • The file cannot be re-loaded in the Visual Basic project.

    Be sure the Visual Basic project file is checked out. Check the filename, and if it is correct, you may have to reload the file in the Visual Basic project. This may require getting a new copy of the file from your source code control provider and placing it into your working folder, or may require restarting Visual Basic.


Not all options could be set correctly.

This error has the following solution:

  • In most cases, options cannot be set correctly due to low memory or disk space. Free some memory or disk space and try again.


Check In command failed: The files were not checked in.

This error has the following solution:

  • Open the source code control provider application and manually check in the files.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Some files could not be checked in.

This error has the following cause and solution:

  • An error occurred during a Check In command.

    Check for free disk space, or restart Windows.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Check Out command failed: The files were not checked out.

This error has the following solution:

  • Open the source code control provider application and manually check out the files.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Some files could not be checked out.

This error has the following cause and solution:

  • An error occurred during a Check Out command.

    Check for free disk space, or restart Windows.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


The previously loaded project could not be properly closed.

This error has the following cause and solution:

  • While attempting to open a new project, the source code control provider could not properly close the last one.

    Exit and restart Visual Basic.


The visual difference operation failed.

This error has the following solution:

  • Open the source code control provider application and manually use the differences command.


Errors during load of file <file>.

This error has the following cause and solution:

  • Errors were encountered while loading the file.

The file may or may not have been loaded successfully by Visual Basic. Try opening the file again, or check the file for corruption.


Get command failed: The files were not downloaded from source code control.

This error has the following solution:

  • Open the source code control provider application and manually get the files.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Source code control could not refresh some files.

This error has the following cause and solution:

  • An error occurred during a Get Latest Version command.

    Check for free disk space, or restart Windows.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Unable to obtain history for this item.

This error has the following cause and solution:

  • Visual Basic was not able to get the history for this file or project from the source code control provider.

    Run the source code control provider and get the history from there.


Unable to start the source code control provider.

This error has the following cause and solution:

  • Visual Basic is not able to start a component of the source code control provider.

    Run the source code control provider from the icon, Windows Explorer, or File Manager.


Could not connect the source code control project to the current Visual Basic project.

This error has the following cause and solution:

  • The source code control provider could not associate the current Visual Basic project with a source code control provider project.

    Run VSS and get the project (if it is already in VSS).

    Try to perform the same operation on another project. If this works, rename the original project and perform the operation again. If this doesn't work, call Microsoft Technical Support Services.


The source code control project already has a makefile named the same as the one you are adding. Is this the same file?

The source code control project already has a makefile with the same name as the one you are adding. Is this the same file?

This message has the following cause and solution:

  • You are attempting to add a makefile with the same name as a file already in the source code control provider project.

    Check the filename, and rename if necessary.

    Click Yes to add the currently selected file, overwriting the old one with the same name.

    Click No to cancel the operation.


You must check out the project file before you can perform this command.

This error has the following cause and solution:

  • You attempted to perform a command that requires check out of the Visual Basic project file before you can check out the project file.

    Check out the Visual Basic project file before proceeding, and then try the command again.


Out of memory; could not complete operation.

You do not have sufficient computer memory to perform the desired operation. This error has the following causes and solutions:

  • You have too many applications, documents, or source files open.

    Close any unnecessary applications, documents, or source files that are open.

  • You are running Microsoft Windows in standard mode.

    Restart Microsoft Windows in enhanced mode.

  • You are running Microsoft Windows in enhanced mode, but have run out of virtual memory.

    Increase virtual memory by freeing some disk space, or ensure that some space is available.

  • You have terminate-and-stay-resident programs running.

    Eliminate terminate-and-stay-resident programs.

  • You have many device drivers loaded.

    Eliminate unnecessary device drivers.


Unable to set up the source code control menus correctly for this project.

This error has the following cause and solution:

  • There was an internal error during set up of the source code control menu system.

    Exit and restart Visual Basic, or exit and restart Windows.


All available files have been added to the source code control project.

All files in the Visual Basic project have already been added to the source code control provider.


You do not have any files to check in.

This error has the following cause and solution:

  • You attempted to check in files, but there are none checked out.

If you have made changes to a file that you want to check in, run VSS Explorer, select the file, and on the VSS menu, click Check Out. Be sure to click the Don't Get Local Copy option in the Check Out dialog box so you don't lose your changes.


All available files have already been checked out.

You attempted to check out a file, but all files are already checked out.


No files are available to get in this project.

This error has the following cause and solution:

  • There are no files in the current VSS project.

    Use the Add Files command to add files.


Because you have not logged on to <provider>, source code control features are not enabled for this project.

This error has the following cause and solution:

  • You canceled your logon to the source code control provider; the source code provider features are not available.

    Open a different project, then return to this project and log on.


Unable to load the source code control provider.

This error has the following causes and solutions:

  • The registry strings used to find the source code control provider dynamic-link library [image] for example, SSSCC.DLL [image] aren’t correct, or you have the wrong version of Visual Basic, or the file SSSCC.DLL is missing.

  • You moved the source code control folder after setup without updating the registry.

  • The setup program failed.

    Check your source code provider's setup instructions.

    Rerun the VSS setup program.


File <file> could not be mapped to the Visual SourceSafe project <project>.

This error has the following cause:

  • The code development environment prohibits copying files directly into VSS.


The file '<file>' is not under source code control.

This error has the following cause and solution:

  • You have selected a file that is not under source code control.

Use the Add Files command to add the file to your source code control provider before trying to check it out or use source code control provider functions on it.


This operation is not supported by the source code control provider.

Some source code providers don’t support all possible source code control commands. This error has the following cause and solution:

  • You attempted to launch an unsupported operation.

    Exit and restart Windows, and report this error to Microsoft Technical Support Services.


File <file> is already checked out.

This error has the following cause and solution:

  • .FRM files can be checked out to only one user at a time.

    If necessary, run your source code control provider to find out who the file is checked out to.


The project cannot be added to source code control because the path is too long.

This error has the following cause and solution:

  • The path name for this project is too long.

Use a shorter path name and try again.


Please save and check-in your makefile.

Please save and check-in your Visual Basic project file.

This error has the following cause and solution:

  • You have made changes that modify your Visual Basic project file.

You need to save and check-in your makefile. Otherwise, your project will contain references to the copied-in files in their old locations instead of the current locations.


This operation requires the Visual Basic project file to be checked out first.

Many operations, such as adding a new file, removing a file, renaming a file, and so forth, require that the Visual Basic project file be checked out first.

  • You performed an operation without first checking out the Visual Basic project file.

    Check out the Visual Basic project file before proceeding, and then try the command again.


The project <project> no longer exists in <provider>.

The project <project> no longer exists under <provider>.

This error has the following cause and solution:

  • The specified project has been deleted (or moved). You must recover (or select) the specified project before any source code control commands can be applied to it.

    If the project was moved, you receive a dialog box to help you search for the new project. If the project was deleted, you must run the source code control provider to reinstate the project.


Project <project> was not found.

This error has the following cause and solution:

  • A project was renamed, moved, or deleted.

    Click Browse if you want to look through the source code control provider database for the project.


Unable to determine the properties of this item.

This error has the following cause and solution:

  • Visual Basic was not able to find the properties of this item.

    Run the source code control provider and get the properties from there.


Unable to automatically remove the file from the source code control provider.

This error has the following solution:

  • Open the source code control provider application and manually remove the file.


The file could not be automatically renamed inside the source code control provider.

This error has the following solution:

  • Open the source code control provider application and manually rename the file.


You have created a new project.

This error has the following cause and solution:

  • You choose to save your project to a different folder, but your source code control provider can't map the new folder name directly.

The old project is still under source code control, but the new one is not. Use the Add Project command to manually add the new project name to source code control.


The Results window is full; early entries will be removed from the Results window.

When performing an operation on multiple files, the Results window may quickly fill with status messages. This warning message has the following cause:

  • The Results window is full. You won't be able to view some of the earliest entries.


Some old results have been removed to make space for newer results.

This message notifies you that old results have been removed; no action is required.


The file rename operation has been stopped, not all files were saved.

This error has the following cause and solution:

  • You choose not to allow your source code control provider to check out the project file you are renaming.

If you choose not to allow the source code control provider to check out the project file while renaming a file, the operation cannot proceed so that the file does not get renamed in the source code control provider.


Your project file has not been saved. Save your project file before using source code control operations.

This error has the following cause and solution:

  • Source code control requires that you save your project file so that it has a true file to work with.


Your project has not been saved. Save your project before adding it to source code control.

This error has the following cause and solution:

  • Source code control requires that you save your project so that no project changes are lost.


The file <file> could not be mapped to the source code control provider project <project>.

The file <filename> could not be mapped to the source code control provider project <project>.

This error has the following cause and solution:

  • The source code control provider does not know which source code control provider project to place the file into, or get the file from.

    The source code control provider determines this based on which folder the file is in. Though the source code control provider can map projects to directories within a project/folder subfolder, files in subdirectories or on other drives create problems, unless there already is an association between the folder that the file is coming from and a source code control provider project.

    Add the specified file to a folder at the same level as, or under, the specified project. If the file is already in the source code control provider, share the file to the current project.


File <file> could not be mapped to the Visual SourceSafe project <project>.

This error has the following cause and solution:

  • You must have the file in VSS before continuing the operation.

    Click Yes to copy the file to the specified project and continue.

    Click No to cancel the operation.


Unable to successfully share a file from the source code control provider.

This error has the following solution:

  • Run the source code control provider and share files from there.


Your project has not been saved.

This error has the following cause and solution:

  • You have to save your project before using it with source code control.

    Save the project, then try your command again.


Only one copy of the source code control provider can run at a time.

This error has the following cause:

  • Although multiple, simultaneous sessions of Visual Basic can be run, only one source code control provider can run at a time; this session of Visual Basic has source code control disabled.


Undo Check Out command failed. Check files to verify their version status.

This error has the following solution:

  • Open the source code control provider application and manually undo the check out of the files.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Some files could not have their check out status undone.

This error has the following cause and solution:

  • An error occurred during an Undo Check Out command.

    Check for free disk space, or restart Windows.

    Check the Results window for other error conditions. If found, correct them and retry this operation.


Would you like to add file <file> to the current source code control project?

In most cases, click Yes to keep the Visual Basic and source code control projects synchronized. You may want to click No if you are experimenting with a file that you may add at a later date, or a file that you do not want to add.

Click Yes to add the file to source code control.

Click No to add the file to your Visual Basic project without adding it to the source code control project.


Would you like to check in all changed files now?

Click Yes to check in all files.

Click No to defer check in until a later time.


The change you just made has changed the Visual Basic project file, but you have not checked the Visual Basic project out yet.

This error has the following cause and solution:

  • You made a change to your Visual Basic project file, but you did not check out the file from the source code control provider first.

    Click Yes to check out the project file so you can save your changes.

    Click No to keep the project file checked in. You will not be able to save your changes in the source code control provider.


Would you like to get the latest checked-in copy of the files in this project?

Click Yes to get the latest version of the file(s).

Click No to keep the file versions you already have.


The file <file> is not a normal file type for adding to a Visual Basic project.

This error has the following cause and solution:

  • The file you are adding to the source code control provider is of a type not generally recognized by Visual Basic.

    Click Yes to continue adding it to the source code control provider.

    Click No to cancel the add operation.


The file has been removed from the Visual Basic project. Would you also like to remove the file from source code control?

Click Yes to remove the file from the source code control project. (Deleted files can be recovered later if necessary.)

Click No to remove the file from your Visual Basic project, but keep it in the source code control project.


Would you like to save your files before proceeding with this <provider> operation?

This error has the following cause and solution:

  • You did not save files before performing a source code control provider operation.

    Click Yes to save your files.

    Click No to allow VSS to overwrite changes made since the last save operation.


That source code control project didn't contain the loaded Visual Basic project file. Try again?

This error has the following cause and solution:

  • You selected a source code control project that didn't contain the proper Visual Basic project file.

    Click Yes to resume browsing through the source code control database for the correct project.

    Click No to cancel the operation.


Help Menu Commands

The Help menu commands provide Help on using VSS and Help on specific VSS commands. In addition, you can press f1 at any time to see Help on the currently selected menu item or dialog box.

Help command | Action
Contents | Runs Help and displays the VSS Table of Contents.
Search For Help On | Displays the Help Search dialog box so you can quickly find the information you need.
Technical Support | Displays information on Microsoft Technical Support Services.
About VSS/Administrator | Displays a dialog box with information on your copy of VSS, including the version number and the copyright, legal, and licensing notices.

Remarks

A quick way to find information is to use Search, an automated index with hundreds of index entries and extensive cross-referencing.

You can also look for Help topics in the VSS Table of Contents.

As you read a topic in VSS Help, you can scroll through the topic with the scroll bar, the arrow keys, or the page up and page down keys.

In the Help window, click Search to open the VSS index. Click Back to go to the last Help topic viewed.


Technical Support

Getting Help from Microsoft Technical Support

If you can’t find the answers you need in the product Help file or manual, you can resolve problems quickly through one of several options.

Note The services and prices listed here are available in the United States and Canada only and are subject to change without notice. Support outside the United States and Canada may vary. Contact the Microsoft subsidiary nearest you, using the Worldwide Subsidiary list in this product Help file.

Support Online

Standard No-Charge Support

Pay-Per-Incident Support

Web Response

Additional Support

Support Outside the United States and Canada


Add Project To Source Code Control Command (Development Environment)

See Also

Adds the current development environment project to the source code control database.

To use the Add Project To Source Code Control command

  • On the Tools SourceSafe menu, click Add Project to Source Code Control.

Note If you specify the name of your source code control provider, that name is displayed in place of "Source Code Control."

Remark

The Add Project to Source Code Control command takes the selected files in the development environment project window and creates a new source code control project containing those files. This command is available only when you select a project not already under source code control. Each selected file is automatically added at this time.


Create Project from SourceSafe Command (Development Environment)

Copies a project to your hard disk when the project is in source code control but not on your hard disk.

To use the Open New Project command

  • On the Tools SourceSafe menu, click Download SourceSafe Project.

Note After you locate a project you want, this command opens it in your development environment and automatically gets all of its files from the VSS database.


Run Command (Development Environment)

Starts your source code control provider.

To use the Run command

  • On the Tools SourceSafe menu, click Run. In some cases, you may need to type your username and (if applicable) your password, and then click OK.

Remark

Note When you use the Run VSS command, you have access, through VSS Explorer, to all of the VSS features and commands. The VSS commands available from the Tools SourceSafe menu are a subset of the full VSS command set.


Refresh File Status (Development Environment)

Refreshes the file status display in the Visual Basic project window.

To use the Refresh File Status command

  • On the Visual Basic Tools SourceSafe menu, click SourceSafe Refresh File Status.

Remark

Use this command when you have checked a file in or out, or want to check the project status in a multi-developer environment where other source code control users may have changed a project file's status.


Visual SourceSafe

Visual SourceSafe (VSS) is the leading source control tool for code and Web developers. It can store and protect any type of file. For more information, open the VSS Help file on your system (if you have VSS installed).


File Difference Dialog Box (Visual SourceSafe)

By default, VSS uses the Visual display option, with line width calculated to fit on your screen, and no context lines. If you specify a UNIX display, VSS uses the Ignore Case and Ignore White Space options. The Visual display shows all lines (infinite context).

Visual

Shows the entire file, with annotations of the changes.

SourceSafe

Shows a list of lines that were added, deleted, and changed, optimized for readability.

Unix

Shows differences information in the format used by the UNIX Diff utility.

Ignore Case

Shows differences without regard for upper- and lowercase differences.

Ignore White Space

Shows differences without regard for spacing characters, such as tabs.

Report

Sends a report to the clipboard, a text file, or a printer.

Project

Displays the Project Difference dialog box.

Advanced Options

Ignore OS Differences

Tells VSS to ignore operating system line-break character differences. This is useful if you are comparing files across a network where one computer is a Macintosh, for example, and the other is operating with Microsoft Windows NT.

Show Context Lines

Includes the specified number of context lines in the differences display. Context lines are the lines in your file surrounding the line identified as different by VSS. For example, setting Show Context Lines to three means you'll see three context lines above and three context lines below the difference line.

Save Settings

Saves your selected settings for future use.


Find MakeFile Dialog Box (Development Environment)

Identifies your development environment project file so the source code control provider can properly perform its operations. Appears only when you perform operations on projects that contain more than one makefile is in the same folder.

Dialog Box Options

Select the Visual Basic project file

Select the development environment project file for the project you want to work with.

OK

Opens the selected project file.

Cancel

Cancels the command.


Properties Command (File Menu)

Displays the Properties dialog box, which contains basic information about a VSS file or project, including the size, name, and type.

Access Rights

You must have the Read access right to view the Properties dialog box.

You must have the Add access right to change the type of a file.

You must have the Destroy access right to change the Store Only Latest Version state of a file.

Remark

Click the tab with the information you want. Tab content differs according to whether a file or project is currently selected in VSS Explorer.

Note Click the Report button on any of the tabs to create a report to send to the clipboard, a text file, or a printer.

File Properties Dialog Box Tabs

General

Shows the filename, type, size, latest version number, last modification date, comment, and whether the entire file history is stored in the VSS database (or just the latest version). You can change the comment and set whether or not to store only the latest version of the file to save disk space. You can also change the file type here.

Check Out Status

Shows the file's name, who it is checked out by (if anyone), whether it is exclusively checked out, when it was checked out, the current version, the check out path (with the computer name), the project the file is in, and the check out comment. You can change the check out comment.

Links

Shows the current share links a file has to other projects.

Paths

Shows which projects have branched versions of this file in the past.


Deleted Items Properties Tab

See Also

Displays a list of files and subprojects removed from the current project.

To display the Deleted Items tab:

  1. Select a project in the project pane of VSS Explorer.

  2. On the File menu, click Properties, and then click the Deleted Items tab.

Access Rights

You must have Read access right to use this dialog box.

Remarks

When you use the Delete command to delete a file or project in VSS, the deleted item is removed from VSS Explorer. However, VSS continues to store the item, so you can retrieve it should you want to build an earlier version of the project.

After you recover or purge an item, it no longer appears in the list in the Deleted Items tab. If no files or sub-projects have been deleted from the project this dialog will simply say “There are no deleted items for this project.”

Tab Options

Items

The list of all removed files and subprojects in the current project.

Recover

Recovers (undeletes) an item, and places it in the file list or project list.

Purge

Permanently deletes an item, so that it can no longer be recovered.

Close

Closes the Deleted Items tab and returns to VSS Explorer.

Report

Sends a report to the Clipboard, a text file, or to a printer.


Add SourceSafe Project Dialog Box (Visual SourceSafe)

Project

Type the name of the VSS project you want, or click in the project list to choose a project. You can enter a full project path specification (as in $/CODE/RESOURCES) or just type a project name to have a project created under the current project.

OK

Adds the current development environment project to VSS.

Cancel

Cancels the Add Project to SourceSafe command.

Create

Creates a new VSS project. Type a name under Project and click Create.


Show Differences Command (Development Environment)

Compares a selected file in your development environment project to the current version stored in the source code control provider database and shows you the differences, if any.

To use the Show Differences command

  • After you've added a project to your source code control provider, on the Tools SourceSafe menu, click Show Differences.

Remark

Most commonly, you use the Show Differences command immediately before you check in a file to compare your modified copy of the file to the master copy. This gives you a list of the changes you have made, which can be helpful for generating your comment.

When you use the Show Differences command on an ASCII text file, your source code control provider displays a color-coded list of line differences between the database-stored version of the file and your local copy.

For binary files, your source code control provider tells you if the local copy of the file is different from the master copy, but cannot display the differences.


Find Makefile Dialog Box

Allows you to locate a project file so you can open it under source control.

Once the project file (make file) is located, click OK to open it under source control, or click Cancel to cancel the operation.


File History Options Dialog Box (Visual SourceSafe)

Labels Only

Includes only labels in the project or file history.

From

Type a time, date, version, or label. Use the prefix D to indicate a date or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "LBeta1."

To

Type a time, date, version or label. Use the prefix D to indicate a date or time, and the prefix L to indicate a label. For example "D02/29/95;12:15" or "LBeta1."

User

Type a username to show a history of the files worked on by the specified user.

OK

Displays the History of File dialog box.

Cancel

Cancels the Show History command.

Project

Displays the Project History Options dialog box. The Project History Options dialog box contains the same options as those in the File History Options dialog box, along with two additional options: Include Files includes file information in the History of Project display; Recursive includes subprojects and all files within the subprojects. Click OK to display the History of Project dialog box.


Show History Command (Development Environment)

See Also

Shows the history of a file or project under source code control.

To use the Show History command

  • After you've added a development environment project to your source code control provider, on the Tools SourceSafe menu, click Show History.

Remark

Every time you check in a file or project to your source code control provider, the file or project is given a new version number. Use the Show History command to display a list of a file's or project's past versions.

Note By default, the Show History command displays the File History Options dialog box; click Projects to display the Project History options dialog box.

The versions listed start with the most recent and return to the creation of the file or project. VSS provides information about the version number, which can be used with other commands (such as Get Latest Version) to indicate a specific version.

By default, the history of a project includes the histories of all its files, but is not recursive and does not include subprojects.


Source Code Control Results Window (Development Environment)

Displays the results of the last source code control command.

Dialog Box Options

Close

Closes the Source Code Control Results window.


Share Files Command (Development Environment)

Makes the selected file a member of the current project, or creates a new branch project.

To use the Share Files command

After you've added a development environment project to your source code control provider, on the Tools SourceSafe menu, click Share Files.

Remark

Note To share a file, you create a share linkGloss_sharelink among projectsGloss_project. The file then exists simultaneously in two (or more) projects. When you check in the file to any one of the projects, your changes are automatically checked in to all of them.

If you create a branch, changes made in the branched file no longer propagate to the originating project, and vice versa.

When you share a project, you create a new project under the current project that is an exact duplicate of the specified project. All the files in the new project are shared with the corresponding files in the originating project, and changes to one are reflected in the other during check in.

Note When sharing a project with Visual Basic form files (.FRM), be sure to share the associated .FRX file created by Visual Basic. If you don't, the shared project will not have all the files it needs and will not work correctly.


Add Files to Source Code Control Command (Development Environment)

See Also

Copies a file, or group of files, from your development environment project into a VSS project.

To use the Add Files to Source Code Control command

  • After you've added a development environment project to source code control, on the Tools SourceSafe menu, click Add Files to Source Code Control.

Remark

Use the Add To Source Code Control dialog box to place a development environment file into the source code control database. You can use this command only with files that are already part of your development environment project. If you have a file you want to add to source code control that isn't part of any project, add it to your development environment project first.

Note Development environment files already added to the current source code control project are not displayed under Files To Be Added.

Dialog Box Options

Files To Be Added

Files available to be added to the source code control database. Click the check box next to the file(s) you want to add.

Comment

Type an optional comment for all selected files.

OK

Adds file(s) to source code control.

Cancel

Cancels the Add Files To Source Code Control command.

Select All

Selects all files listed.


Check In Command (Development Environment)

Checks in changes made in your development environment working folder to your source code control database.

To use the Check In command

  • On the Visual Basic Tools SourceSafe menu, click Check In.

Dialog Box Options

Files To Be Checked In

Lists the files available for check in. Click the files you want to check in, or click Select All to select all the files listed.

Comment

Type an optional comment.

Keep Checked Out

Updates the source code control database with your changes but keeps the file checked out to you.

OK

Checks in the selected files.

Cancel

Cancels the Check In command.


Check Out Command (Development Environment)

See Also

Checks out a copy of the selected file(s) from your source code control provider and places a writable copy in the corresponding development environment working folder.

To use the Check Out command

  • On the Visual Basic Tools SourceSafe menu, click Check Out.

Dialog Box Options

Files to be Checked Out

Lists the files available for check out. Click the files you want to check out, or click Select All to select all files listed.

Comment

Type a brief description of the reason for the check out.

OK

Confirms Check Out.

Cancel

Cancels the Check Out command.

Select All

Selects all files listed.


Get Latest Version Command (Development Environment)

See Also

Gets the selected files from your source code control provider and places a read-only file in the development environment project.

To use the Get Latest Version command

  • On the Visual Basic Tools SourceSafe menu, click Get Latest Version.

Dialog Box Options

Files to Get/Check In

Selects the file or files you want to get or check in.

OK

Confirms your selections.

Cancel

Cancels your selections.

Select All

Selects all files listed.


Options Command (Development Environment)

Customizes your source code control provider environment.

To use the Options command

  • After you've added a development environment project to your source code control provider, on the Tools SourceSafe menu click Options.

Remark

The Options command displays the Source Code Control Options dialog box.

Dialog Box Options

For each option, you can specify Yes, No, or Ask.

  • Get checked in version of project files when opening a project? (No is the default.)

  • Check in files when closing the project? (Ask is the default.)

  • Add files to source code control when adding them to Visual Basic? (Yes is the default.)

  • Remove files from source code control when deleting them from Visual Basic? (Ask is the default.)

Advanced

Displays advanced options.

OK

Confirms selections.

Cancel

Cancels selections.


Undo Check Out Command (Development Environment)

Overwrites your changes to a file, and copies the latest checked in version to your development environment working folder.

To use the Undo Check Out command

  • On the Visual Basic Tools SourceSafe menu, click Undo Check Out.

Dialog Box Options

Files to Un-Check Out

Lists the currently checked out files. Click the files whose check out you want to undo, or click Select All to select all the listed files.

OK

Confirms the selection.

Cancel

Cancels the selection.

Select All

Selects all files listed.


For additional support needs

If you don’t have access to the Internet

FastTips is an automated toll-free, fax-back service that provides popular Knowledge Base articles and quick answers to common technical questions. To gain access, dial (800) 936-4300.

If you need support services for a small, medium-sized, or large business

Priority Annual Support, Priority Plus, and Premier Support provide a selection of annual support packages that are geared for businesses. To determine which account best meets your business needs, go to http://support.microsoft.com/support. Or call (800) 936-3500 for information on support options for small- to medium-sized businesses or (800) 936-3200 for large, enterprise businesses.

If you need on-site, multivendor, or proprietary product support

Microsoft Certified Solution Providers and Authorized Support Centers specialize in providing support packages for hardware, network, and software products from both Microsoft and other vendors. For more information or a referral to a Microsoft Certified Solution Provider, call (800) 765-7768 between 6:30 A.M. and 5:30 P.M. Pacific time, Monday through Friday, excluding holidays, or visit http://support.microsoft.com/support. For more information on Authorized Support Centers, contact your Microsoft account representative, or visit http://www.microsoft.com/enterprise/asc.htm.

If you need text telephone (TTY/TDD) services

In the United States, call (425) 635-4948, or in Canada, call (905) 568-9641.

Microsoft’s support services are subject to Microsoft prices, terms, and conditions in place at the time the service is used and are subject to change without notice.


(Untitled)

If you have a simple question and need an answer fast

Quickly find your answers online

Use Support Online to search the Microsoft Knowledge Base and other technical resources for fast, accurate answers. You can also customize the site to control your search. To begin your search, go to http://support.microsoft.com/support. For additional technical resources and information on developing with Microsoft products and technologies, visit MSDN online at http://www.microsoft.com/msdn.


If you need support outside the United States and Canada

Microsoft Technical Support Worldwide

If you are outside the United States and have a question about a Microsoft product, first:

  • Check the information in this Help file or the product manual.

  • Check the readme files that come with your product disks or discs. These files provide general information that became available shortly before the product was released.

  • Go to Support Online from Microsoft Technical Support at http://support.microsoft.com/support.

If you cannot find a solution, you can receive information on how to obtain technical support by contacting the Microsoft subsidiary office in your area.

Important Phone numbers for Microsoft Subsidiaries are subject to change. For the most recent listing, see the options and phone number section on the Support Online Web site at http://support.microsoft.com/support. If there is no Microsoft subsidiary office in your country/region, contact the establishment from which you obtained your Microsoft product.

  • Argentina

    Microsoft de Argentina S.A.
    Customer Service: (54) (1) 316-4600
    Fax: (54) (1) 316-4698
    Technical Support: (54) (1) 316-4664

  • Armenia

    See Russia

  • Australia

    Microsoft Pty. Ltd.
    Fax: (61) (02) 9805 1108
    Sales Information Centre: (61) (02) 9870-2100
    Internet: //www.microsoft.com.au/
    Technical Support: (61) (02) 9870-2131
    Fax: (61) (02) 9805 0519

  • Austria

    Microsoft Ges.m.b.H.
    Phone: (+43) 1 610 64 -0
    Fax: (+43) 1 610 64 -200
    Information: 0660-6520
    Prices, updates, etc.: 0660-6520
    Standard Support:
    Installation and Handling: 01 50222-2255
    General information about Support Network in Central Europe:
    Fax: 01805-251191

  • Azerbaijan

    See Russia

  • Belgium

    Microsoft NV
    Phone: +32-2-730 39 11
    Fax: +32-2-726 96 09
    Microsoft Information Center: +32-2-481 52 52
    Bulletin Board: +32-2-726 85 45 (14400/1200/2400/9600 bd, 8N1, ANSI)
    Technical Support:
    +32-2-513 32 74 (Dutch speaking)
    +32-2-502 34 32 (English speaking)
    +32-2-513 22 68 (French speaking)

  • Belorussia

    See Russia

  • Bolivia

    See Argentina

  • Brazil

    Microsoft Informatica Ltda.
    Phone: (55) (11) 5514 -7100
    Fax: (55) (11) 5514 - 7106/5514-7107
    Technical Support: (55) (11) 5506-8087
    Fax: (55) (11) 5506-7621
    Automatic Fax: (55) (11) 5506-8506
    Technical Support Bulletin Board Service: (55) (11) 5506-1234
    Customer Support: (55) (11) 822-5764

  • Canada

    Microsoft Canada Inc.
    Head Office Phone: 1 (905) 568-0434
    Customer Information Centre: 1 (800) 563-9048
    Technical Support:
    Desktop Systems including Microsoft Windows 95: (905) 568-4494
    Microsoft Office and Office Components: (905) 568-2294
    Other Standard Technical Support: (905) 568-3503
    Priority Support Information: (800) 668-7975
    Text Telephone (TTY/TDD) (905) 568-9641
    Technical Support Bulletin Board Service: (905) 507-3022

  • Caribbean

    Microsoft Caribbean, Inc.
    Phone: (809) 273-3600
    Fax: (809) 273-3636
    Technical Support: (214) 714-9100

  • Central America

    See Latin America

  • Chile

    Microsoft Chile S.A.
    Phone: 56-2-330-6000
    Fax: 56-2-330-6190
    Customer Service: 56-2-800-213121
    Personal Operating System and Desktop Applications:
    Phone: 56-2-330-6222
    Fax: 56-2-341-1439

  • China

    Microsoft (China) Co. Ltd
    4/F Kai Yuen Commercial Building
    No.28 Zhichunli, Hai Dian District
    Beijing 100086, PRC
    Phone: 011-86-10-6261-7711
    Fax: 011-86-10-6253-6630

  • Colombia

    Microsoft Colombia
    Phone: (571) 618 2245
    Fax: (571) 618 2269
    Technical Support:
    Línea de Respuesta Microsoft
    Phone: (571) 5230022
    Fax: (571) 5231220
    Voice Mail: (571) 5034216

  • Croatia

    Microsoft Hrvatska d.o.o.
    Phone: (+385) (1) 304 555
    Fax: (+385) (1) 335 051
    Technical Support: (Please, contact the subsidiary.)

  • Czech Republic

    Microsoft s.r.o.
    Phone (+42) (2) 611 97 111
    Fax: (+42) (2) 611 97 100
    Technical Support: (+420) (2) 2150 3222

  • Denmark

    Microsoft Denmark
    Phone: (45) 44 89 01 00
    Fax: (45) 44 68 55 10
    Technical Support:
    Phone: (45) 44 89 01 11
    Microsoft Sales Support: (45) 44 89 01 90
    Microsoft FastTips: (45) 44 89 01 44
    (Document 303030 in FastTips contains detailed instructions)
    Microsoft MSDL (BBS): (45) 44 66 90 46

  • Dominican Republic

    See Central America

  • Dubai

    Microsoft Middle East
    Phone: (971) 4 513 888
    Fax: (971) 4 527 444
    Technical Support:
    Personal Operating Systems and Desktop Applications ONLY:
    Phone: (971) (4) 524 488
    Fax: (971)- 4 - 524 495
    email: mts@emirates.net.ae
    Priority Support Information: (971) (4) 555 752
    Customer Service Center:
    (Version upgrade / TechNet and MSDN subscription)
    Phone: (971) (4) 655 082
    Fax: (971) (4) 655 097

  • Ecuador

    Corporation Microsoft del Ecuador S.A.
    Phone: (593) 2 460-447, (593) (2) 460-451
    Customer Service: (593) (2) 460-453, (593) (2) 460-458
    Technical Support: (593) (2) 463-094

  • Egypt

    Microsoft Egypt
    Phone: +202-418-6101
    Fax: +202-4174766
    Technical Support:
    Personal Operating Systems and Desktop Applications ONLY:
    Phone: (202) 261 3991 / 6
    Fax: (971) 403 2718

  • England

    See United Kingdom

  • Estonia

    See Germany
    Technical Support: (+372) 650 49 99

  • Finland

    Microsoft OY
    Phone: +358-(0) 9-525 501
    Fax: +358-(0) 9-878 8770
    Technical Support:
    Phone: +358-(0) 9-525 502 500
    Sales Support: +358-(0) 9-525 5026
    Microsoft MSDL: +358-(0) 9-878 77 99
    (Information in Swedish and English)
    Microsoft FastTips: +358-(0) 9-525 502 550
    (Information in Swedish and English)

  • France

    Microsoft France
    Phone: (33) 01 69-86-46-46
    Fax: (33) 01 64-46-06-60
    Telex: MSPARIS 604322
    Technical Support:
    Phone: (33) 01-69-86-10-20
    Fax: (33) (01) 69-28-00-28

  • French Polynesia

    See France

  • Georgia

    See Russia

  • Germany

    Microsoft GmbH
    Phone: 089/3176-0
    Fax: 089/3176-1000
    Telex: (17) 89/83 28 MS GMBH D
    Information: 089/3176 1199
    Prices, updates, etc.: 08105-25-1199
    Internet: www.microsoft.com/germany
    Standard Support:
    Installation and Handling: 01805/67 22 55
    General information about Microsoft support in Central Europe: Fax: 1805-25-1191

  • Greece

    Microsoft Hellas, S.A.
    Phone: (30)(1) 6806-775 through (30)(1) 6806-779
    Fax: (30)(1) 6806-780
    Technical Support:
    Phone: (30) (1) 9247-030
    Fax: (30) (1) 9215-363

  • Hong Kong SAR, PRC

    Microsoft Hong Kong Limited
    Fax: (852) 2560-2217
    Product support Faxback Service: (852) 2535-9293
    Microsoft Club Hotline: (852) 28044277
    Technical Support: (852) 2804-4222

  • Hungary

    Microsoft Hungary
    Phone: +36 (1) 327-2800
    Fax: +36 (1) 327-2899
    Technical Support: +36 (1) 267-4636 (2MSINFO)

  • Iceland

    See Denmark

  • Ireland

    See United Kingdom

  • India

    Microsoft India
    Phone: (011) (91) (80) 5092678, (011) (91) (11) 646 0767, 646 0813
    Fax: (011) (91) (80) 509-2601, (011) (91) (11) 647- 4714

  • Indonesia (SP)

    Microsoft Indonesia - Jakarta
    Technical Support:
    Phone: 62 21 5721060
    Fax: 62 21 5732077

  • Israel

    Microsoft Israel Ltd.
    Phone: 972-3-613-0833
    Fax: 972-3-613-0834

  • Italy

    Microsoft SpA
    Phone: (39) (2) 7039-21
    Fax: (39) (2) 7039-2020
    Microsoft Rome Office: (39) (6) 5095-01 - Fax: (39) (6) 5095-0600
    Microsoft by Fax (Fax-on-demand service): (39) (2) 70-398-888
    Customer Service (New product info, product literature): (39) (2) 70-398-398
    Dealer Support (Customer Service for resellers only): (39) (2) 70-398-388
    Technical Support: (39) (2) 70-398-398
    Microsoft Consulting Service: (39) (2) 7039-21

  • Japan

    Microsoft Company Ltd.
    Technical Support (Standard Support): (81) (424) 41-8700
    (Technical Support options/ Support Contract)
    Phone: 0120-37-0196 (toll free domestic only)
    Channel Marketing Information Center:
    (Presales Product Support)
    Tokyo Phone: (81) (3) 5454-2300
    Osaka Phone: (81) (6) 245-6995
    Customer Service Phone:
    (Version upgrade/Registration)
    Phone: (81) (48) 226-5500
    Fax: (81) (48) 226-5511

  • Kazakhstan

    See Russia

  • Kirgizia

    See Russia

  • Korea

    Microsoft CH
    Phone: (82) (2) 531-4500
    Fax: (82) (2) 531-1724
    Customer Service: 080-022-7337 (toll free domestic only)
    Technical Support:
    Office Technical Support: (82) (2) 508-0040
    Windows Technical Support: (82) (2) 563-0054
    Developer Technical Support: (82) (2) 566-0071
    Microsoft FastTips: (82) (2) 3453-7555
    Support Sales: (82) (2) 531-4544

  • Latin America

    Microsoft
    Latin American Headquarters (U.S.A.)
    Phone: (305) 489-4800
    Fax: (305) 491-1616
    Customer Service: (425) 936-8661
    Technical Support: (214) 714-9100
    http://www.microsoft.com/latam/soporte

  • Liechtenstein

    See Switzerland (German speaking)

  • Luxembourg

    Microsoft NV
    Phone: +32-2-730 39 11
    Microsoft Information Center: +32-2-481 52 52
    Bulletin Board: +32-2-726 85 45
    (1200/2400/9600/14400 bd, 8N1, ANSI)
    Technical Support:
    +32-2-513 32 74 (Dutch speaking)
    +32-2-502 34 32 (English speaking)
    +32-2-513 22 68 (French speaking)

  • Malaysia (SP)

    Microsoft (Malaysia) Sdn Bhd:
    Phone: (60-3) 793-9595
    Fax: (60-3) 791-6080

  • México

    Microsoft México, S.A. de C.V.
    267-2110 Atencion a Distribuidores
    265-3380 Atencion a Clientes
    265-3399 Soporte Sistemas Operativos y Applicaciones de Escritorio
    267-2190 Soporte de Servidores y Herramientas de Desarrollo
    Fast Tips: (52)(5) 2612199
    Microsoft BBS 628-6200/02 MSMEXICO sin password

  • Morocco

    Microsoft Afrique Du Nord
    Phone: (212) 2 47 10 72
    Fax: (212) 2 47 10 86

  • Netherlands

    Microsoft BV
    Phone: 023-5689189
    Customer Service: 023-5677700
    Bulletin Board: 023-5634221
    (1200/2400/9600/14400bd, 8N1, ANSI)
    Technical Support:
    023-5677877 (Dutch speaking)
    023-5677853 (English speaking)

  • New Zealand

    Microsoft New Zealand Ltd
    Phone: 64 (9) 357-5800
    Fax: 64 (9) 358-3726
    Technical Support:
    Phone: 64 (9) 357-5575
    Fax: 64 (9) 307-0516 and 357-5577

  • Northern Ireland

    See United Kingdom

  • Norway

    Microsoft Norway AS
    Phone: +(47) 22 02 25 00
    Fax: +(47) 22 95 06 64
    Technical Support: +(47) 22 02 25 50
    Microsoft Sales Support: +(47) 22 02 25 80
    Microsoft MSDL: +(47) 22 18 22 09
    Microsoft FastTips: +(47) 22 02 25 70
    (Document 404040 in FastTips contains detailed instructions)

  • Papua New Guinea

    See Australia

  • Paraguay

    See Argentina

  • Peru

    See Latin America

  • Philippines (SP)

    Microsoft Philippines
    Phone: 632 811 0062
    Technical Support:
    Phone: 632 892 2295/2495
    Fax: 632 813 2493

  • Poland

    Microsoft Sp. z o.o.
    Phone: +(48-22) 661-54-00
    Fax: +(48-22) 661-54-34
    Information Service: +(48-22) 865-99-33
    Technical Support: +(48-22) 865-99-66

  • Portugal

    Microsoft Portugal MSFT, Lda.
    Phone: (351) 1 4409200
    Fax: (351) 1 4412101
    Technical Support:
    Standard Support: (351) 1 4409280/1/2/3
    Fax: (351) 1 4411655
    Republic of Ireland
    See United Kingdom

  • Romania

    Microsoft s.r.l.
    Phone: (+40) (1) 222 90 16
    Fax: (+40) (1) 222 90 12
    Technical Support: (+40) (1) 312 09 48

  • Russia

    Microsoft A/O
    Microsoft Information Center: (095)-913-99-88

  • Scotland

    See United Kingdom

  • Saudi Arabia

    Microsoft Saudi Arabia
    Phone: +966-1-488-1165
    Fax: +966-1-488-1576
    Technical Support:
    (Personal Operating System and Desktop Applications only):
    Phone: 800 124 0500
    (toll free within Saudi Arabia)
    Fax: 966-1-4740576

  • Singapore

    Microsoft Singapore Pte Ltd
    Phone: (65) 337-6088
    Fax: (65) 337-6788
    Customer Services:
    Phone: (65) 433-5488
    Fax: (65) 339-9958
    Product Support Services:
    Phone: (65) 337-9946
    Fax: (65) 337-6700

  • Slovenia/Slovenija

    Microsoft d.o.o.
    Phone: (+386) (61) 1800 8-00
    Fax: (+386) (61) 1800 822
    Technical Support: (+386) (61) 185 3449

  • Slovak Republic

    Microsoft Slovakia s.r.o.
    Phone (+421) (7) 37 63 02
    Fax: (+421) (7) 37 66 71
    Technical Support: (+421) (7) 531 20 83

  • South Africa

    Microsoft South Africa
    Phone: (27) 11 445 0000
    Fax: (27) 11 445 0046
    Technical Support:
    (Toll Free): 0 802 11 11 04
    (Toll): (27) 11 445 0000
    Fax: (+27) 11 445-0343

  • South East Africa and Indian Ocean Islands

    See South Africa

  • Spain

    Microsoft Iberica SRL
    Phone: (34) 1-807-9999
    Fax: (34) 1-803-8310
    Technical Support: (34) 1 -3754004
    Customer Service: (34) 1-3754004
    Fax Back telephone: (34) 1-3754004

  • Sweden

    Microsoft AB
    Phone: +46-(0)8-752 56 00
    Fax: +46-(0)8-750 51 58
    Technical Support: +46-(0)8- 752 09 29
    Sales Support: +46-(0)8- 752 56 30
    Microsoft MSDL: +46-(0)8-750 47 42
    Microsoft FastTips: +46-(0)8-752 29 00
    (Document 202020 in FastTips contains detailed instructions)

  • Switzerland

    Microsoft AG
    Phone: 01-839 61 11
    Fax: 01-831 08 69
    Prices, updates, etc.: 01/839 61 11
    Documentation:
    Phone: 155 59 00
    Fax: 064-224294, Microsoft Info-Service, Postfach, 8099 Zürich
    Standard Technical Support: Installation and Handling:
    0848 80 - 2255
    Technical support (French speaking): 022-738 96 88
    General information about Microsoft Support in Central Europe:
    FAX: 0049/2622/167006

  • Tadzhikistan

    See Russia

  • Taiwan

    Microsoft Taiwan Corp.
    Phone: (886) (2) 2504-3122
    Fax: (886) (2) 2504-3121
    Technical Support: (886) (2) 2508-7149

  • Thailand

    Microsoft (Thailand) Limited
    Phone: (662) 266-3300
    Fax: (662) 266-3310
    Product Support:
    Phone: (662) 613-7208 through 11
    Fax: (662) 613-7198

  • Turkey

    Microsoft Turkey
    Phone: 90 (212) 258 59 98
    Fax: 90 (212) 258 59 54
    Support Hotline:
    Phone: 90 (212) 258 96 66
    Fax: 90 (212) 258 95 99
    Bulletin Board Service: 90 (212) 227 93 90

  • Turkmenistan

    See Russia
    United Kingdom
    Microsoft Limited
    Fax: (0870) 60 20 100
    Phone: (0870) 60 10 100
    Microsoft KeyData:
    (Bulletin Board Service)
    (0870) 50 30 200 (up to 28.8Kbaud, n, 8, 1)
    Microsoft KeyFax:
    (Faxback Information Service)
    (0870) 50 30 100
    Technical Support:
    Desktop Applications, Home Products, Desktop Systems and hardware:
    0870 50 10 100
    Developer Products: 0870 50 10 200
    Business Systems: 0870 50 10 300
    Customers phoning from Ireland should dial 706 5353 for technical support.
    Minicom Line 0870 50 30 400
    Pre-Sales Information: Microsoft Connection (0345) 00 2000

  • Uruguay

    Technical Support: (598) (2) 77-4934

  • Uzbekistan

    See Russia

  • Venezuela

    Corporation MS 90 de Venezuela S.A.
    Other information: (582) 265-9922
    Fax: (582) 265-0863
    Technical Support: (582) 993-6755

  • Wales

    See United Kingdom


If your question isn't urgent

Send E-mail to a Microsoft Technical Support Engineer

With Web Response, you can conveniently submit questions via e-mail. This option is ideal for detailed questions or questions with attached files. You can submit questions 24 hours a day and will receive a response from an engineer within one business day. To submit your question, go to http://support.microsoft.com/support, find the Web Response option and choose from one of the following options.

Standard No-Charge Web Response

The amount of no-charge support for which you are eligible is described in the preceding Standard No-Charge Support section.

Pay-Per-Incident Web Response

If you have used up your Standard No-Charge Support as described above, you can submit your question for a fee of $95 U.S.


If your question is urgent and more complex

Telephone a Microsoft Technical Support engineer

Microsoft Technical Support provides no-charge and fee-based support via telephone. The amount of no-charge support will vary depending on which edition of the product you purchased, as described below.

Standard No-Charge Support for help during regular business hours

Note No-charge support is available for current versions only.

  • If you acquired Visual Studio Professional Edition, Visual Basic Enterprise Edition, or Visual C++ Enterprise Edition

    You will receive a total of two support incidents at no charge. You can apply these two no-charge incidents toward any of the products included in the edition you acquired. For additional information, see note below.

  • If you acquired Visual Studio Enterprise Edition

    You will receive a total of four support incidents at no charge. You can apply these four no-charge incidents toward any of the products included in the Visual Studio Enterprise Edition. For additional information, see note below.

  • If you acquired Visual Basic Professional Edition, Visual C++ Professional Edition, Visual J++, Visual InterDev, Visual FoxPro, or Visual Source Safe

    You will receive a total of two support incidents at no charge for the product you acquired.

To receive Standard No-Charge Support for the products described above

You can receive Standard No-Charge Support via e-mail or via telephone by calling (425) 635-7012 between 6:00 A.M. and 6:00 P.M. Pacific time, Monday through Friday, excluding holidays.

Note Microsoft Internet Explorer, Windows NT Option Pack, and FrontPage may have been included with one of the products you have purchased, however the available support options are separate from those listed above. If you have a question regarding any of these products, please see the technical support section of the individual product’s Help file.

  • If you acquired Visual Basic Learning Edition, Visual C++ Standard Edition, Visual J++ Standard Edition, or MSDN Library Edition

    You will receive no-charge support for issues related to setup and installation only. For all other issues you will need to purchase Pay-Per-Incident Support as described below. You can receive Standard No-Charge Support via telephone by calling (425) 635-7033 between 6:00 A.M. and 6:00 P.M. Pacific time, Monday through Friday, excluding holidays.

Pay-Per-Incident Support - for help after-hours or to supplement Standard Support

If you need help after-hours, or if you have used up your incidents of Standard No-Charge Support as described above, you can purchase Pay-Per-Incident Support for a fee of $95 U.S. per incident by calling (800) 936-5800. Support fees will be billed to your VISA, MasterCard, or American Express card. In the United States, you can also call (900) 555-2300 to have support fees applied to your telephone bill.


Always Keep Files Checked Out

See Also

When you select this option, the file is checked out to your working folder. The file is copied to the VSS database, but left checked out to the user, so the database is updated with changes. You can continue working on the file.

Note This option is not recommended for team programming environments.

To always keep files checked out:

  1. On the VSS Explorer Tools menu, click Options to display the SourceSafe Options dialog box.

  2. Click the General tab, if it isn't already selected.

  3. Select the Always Keep Files Checked Out check box.

  4. Click OK.


Accessibility for People with Disabilities

Microsoft is committed to making its products and services easier for everyone to use. This Help file provides information about the following features, products, and services, which make Microsoft Windows, Microsoft Windows NT, and Microsoft Visual Studio more accessible for people with disabilities:

Microsoft Services for People Who Are Deaf or Hard-of-Hearing

Microsoft Documentation in Alternative Formats

Third-Party Utilities to Enhance Accessibility

Customizing Windows or Windows NT

More Accessibility Information

Note The information in this section applies only to users who purchased Windows or Windows NT in the United States. If you purchased Windows or Windows NT outside the United States, your Windows package contains a subsidiary information card listing Microsoft Support Services telephone numbers and addresses. You can contact your subsidiary to find out whether the type of products and services described in this Help file are available in your area.


Add Files and Folders Using Drag and Drop

See Also

To add a file or folder using drag and drop:

  1. Open VSS Explorer and resize it so you have enough room to display Windows Explorer.

  2. Open Windows Explorer and resize it so you have enough room to display VSS Explorer.

  3. Select one or more files or folders from the list view (on the right pane) in Windows Explorer.

  4. Drag the selected files or folders onto VSS Explorer. Files are added to the VSS project. Folders are added as subprojects of the project.


Add Folders

See Also

You can add folders by following the steps below or by using drag and drop. See Add Files and Folders Using Drag and Drop.

To add an entire folder to VSS:

  1. Select the project you want to add a folder to.

  2. On the File menu, click Add Files to display the Add File dialog box.

  3. Select a folder from the Folders list.

  4. Click Add to display the Add Folder dialog box.

  5. Type a comment in the Comment box to describe the file or folder you are adding.

  6. If you want subfolders included, click Recursive.

  7. Click OK to add the folder with a comment.

    — Or —

    Click Cancel to cancel the operation and return to the Add File dialog box. Click Close.


Add Multiple Files

See Also

You can add multiple files to VSS by following the steps below or by using drag and drop. See Add Files and Folders Using Drag and Drop.

To add multiple files to VSS:

  1. Select the project you want to add files to.

  2. On the File menu, click Add Files to display the Add File dialog box.

  3. In the Drives list, select the drive where the file resides.

  4. In the Folders list, select the folder where the file resides.

  5. In the List files of type list, select a file type. This is an optional step used to filter the list down to a more manageable size.

  6. In the File name list, hold down the CTRL key and click all the files you want to add.

    Note To select all displayed files, press the HOME key to move to the beginning of the list, then SHIFT+END to move to the end. This dialog box will only accommodate 256 characters.

    Files already in the current project are not displayed in the File name list.

  7. Click Add.

  8. VSS displays a dialog box in which you can enter a comment. Select the Apply Same Comment For All check box to have this comment applied to all the files being added; otherwise the dialog box is repeated for each file you have selected.

  9. Click OK to add the files with a comment or click Cancel to cancel the Add File operation. VSS returns to the Add File dialog box.

  10. Click Close.


Add Single Files

See Also

You can add single files, multiple files, and folders to VSS. You can also add a file using drag and drop. See Add Files and Folders Using Drag and Drop.

To add a single file to VSS:

  1. Select the project you want to add files to.

  2. On the File menu, click Add Files to display the Add File dialog box.

  3. In the Drives list, select the drive where the file resides.

  4. In the Folders list, select the folder where the file resides.

  5. In the List files of type list, select a file type. This is an optional step used to filter the list down to a more manageable size.

  6. In the File name list, select a file and click Add to add it to VSS.

    Note Files already in the current project are not displayed in the File name list.

  7. VSS displays a dialog box in which you can enter a comment. Enter applicable comment, if any, then click OK.

  8. Click Close to close the Add File dialog box.


Always Include Subprojects

See Also

To always include subprojects:

  1. On the Tools menu, click Options, and then click the General tab if it isn't already selected.

  2. Select the Acts on Projects Recursively check box.

  3. Click OK.


Append End-of-Line to all Text Files

See Also

Set this option to append an end-of-line character whenever VSS retrieves a text file that does not already end with one. Some compilers require that all the files they compile end in an end-of-line character.

To Append End-of-Line to all Text Files:

  1. On the VSS Explorer Tools menu, click Options to display the SourceSafe Options dialog box.

  2. Click the Local Files tab.

  3. Select the Append End-of-Line to All Text Files check box.

  4. Click OK.

VSS reads end-of-line characters as follows:

  • CR — Macintosh

  • CR/LF — Macintosh/UNIX

  • LF — UNIX

  • RN — Intel center line feed


Avoid the Logon Prompt

See Also

Each time you enter a command from the command line, VSS prompts you for your username and, if one is set, your password. You can avoid this step by performing certain actions based on your environment.

Set the SSUSER Environment Variable to your User Name

In Windows NT and Windows 95, the command-line interface queries the operating system for the name of the currently logged-on user. If this name matches a username in the VSS database, the user is automatically logged onto the VSS database. If the username does not match, the command-line interface uses other methods to determine the VSS username, such as prompting for a username with each command.

You can set the SSUSER environment variable on your computer to your user name to avoid the logon prompt each time you enter a command from the command prompt. For example, user Kim would enter the following from the command prompt:

set ssuser=kim

Set SSUSER in the Autoexex.bat File

You can also include a line similar to the preceding example in your Autoexec.bat file in Windows 95, or set it in the System control panel in Windows NT. If you do include such a line or setting, you can change users by entering the SET SSUSER command from the command prompt at any time.

Note Be sure that you do not enter any spaces on either side of the equal sign when setting the user.


Branch Shared Files

See Also

Branching a file breaks the shared link, making the file in that project independent of all other projects.

Note To view the branch history of a file, click the Paths tab in the Properties command on the File menu.

To branch a file:

  1. Select the file(s) you want in VSS Explorer.

  2. On the SourceSafe menu, click Branch to display the Branch dialog box.

  3. Type a comment describing the branching in the Comment box, if desired.

  4. Click OK.


Cancel Search

See Also

To cancel a search:

  • On the View menu, click Cancel Search.


Check Hyperlinks on a Web Project

See Also

You can use this command to check Web links in your HTML files, either the files in your working folder or those in a VSS project. VSS checks links that jump to other files in your project and links to external pages.

The links checked are HTML tags, including the <A HREF> tag. Links to other Web addresses created using code, such as VBScript or Java, are not checked.

To check Web project hyperlinks:

  1. Select a Web site project. Web site projects have a this icon: ( [image])

  2. On the Web menu, click Check Hyperlinks.

  3. If you want to check links to external pages, click the Check External Links on World Wide Web box.

  4. Click OK.

    When the link check is complete, VSS displays a dialog box with three list boxes:

    • The top box shows all files in which errors were found.

    • The middle box shows links (jumps to other files within the Web project) that appear to be invalid in the selected file in the top box.

    • The bottom box shows links found, but not checked.


Check In Files or Projects

See Also

To check in a file or project, saving your changes:

  1. Select the item(s) in VSS Explorer you want to check in.

  2. On the SourceSafe menu, click Check In to display the Check In dialog box.

  3. If you'd like, enter a comment in the Comment box describing changes you've made to the item.

  4. Click OK.


Check Out Files or Projects

See Also

Note Set your working folder before using this command. See How to Set a Working Folder for more information.

To check out a file or project:

  1. Select the item(s) you want in VSS Explorer.

  2. On the SourceSafe menu, click Check Out.

  3. If you haven't previously set a working folder, VSS will ask you if you'd like to do so now. Click OK, then set your working folder.

  4. If you have set options to display a dialog box for the Check Out command (using the Command Dialogs tab in the Options command on the Tools menu), VSS displays the Check Out dialog box. Click OK to check out the item(s).

  5. VSS places the item(s) in your working folder. You can now edit the item(s).

For information on how to undo a checkout or how to check in a file, see:

How to Check In Files or Projects

How to Undo Check Out


Check Out Multiple Files

See Also

Note Multiple checkout is not possible unless it is enabled by the VSS administrator.

By default, VSS prevents more than one user from checking out the same file at the same time. However, your VSS administrator can allow multiple users to check out a file simultaneously.

When multiple checkouts are allowed, VSS keeps track of all users who have the file checked out at any given time, and compares changes made to the file when each user checks in changes. In most cases, users have changed different lines of code in the file, so VSS simply merges the changes into the master copy of the file. However, if VSS detects that two users have both modified the same line of the file, VSS displays a message alerting the user checking in changes to resolve conflicting line changes before proceeding. When this happens, no checkin occurs. The user receiving the message should edit the local copy of the file in the user's working folder to resolve the conflicts.


Close a Database

Since you can only work in one database at a time, to close a database, you must open another one. See How to Open an Existing VSS Database . You can also quit VSS to close a database.


Copyright

Microsoft® Visual Studio™ 6.0 Development System

Information in this document is subject to change without notice. The names of companies, products, people, characters, and/or data mentioned herein are fictitious and are in no way intended to represent any real individual, company, product, or event, unless otherwise noted. Complying with all applicable copyright laws is the responsibility of the user. No part of this document may be reproduced or transmitted in any form or by any means, electronic or mechanical, for any purpose, without the express written permission of Microsoft Corporation. If, however, your only means of access is electronic, permission to print one copy is hereby granted.

Microsoft may have patents, patent applications, trademarks, copyrights, or other intellectual property rights covering subject matter in this document. Except as expressly provided in any written license agreement from Microsoft, the furnishing of this document does not give you any license to these patents, trademarks, copyrights, or other intellectual property.

© 1991-1998 Microsoft Corporation. All rights reserved.

MSDN, the Microsoft Developer Network.

Microsoft, MS, MS-DOS, MSN, ActiveX, DataTips, FoxPro, the Fox head design, IntelliSense, Developer Studio, J/Direct, Microsoft Press, Microsoft QuickBasic, PivotTable, Rushmore, Visual Basic, Visual C++, Visual FoxPro, Visual InterDev, Visual J++, Visual SourceSafe, Windows, Windows NT, Win32, and Win32s are either registered trademarks or trademarks of Microsoft Corporation in the U.S.A. and/or other countries.

Java is a trademark of Sun Microsystems, Inc.

MMX is a registered trademark of Intel Corporation.

TrueType is a registered trademark of Apple Computer, Inc.

Other product and company names mentioned herein may be the trademarks of their respective owners.


Create a Site Map

See Also

Site maps are becoming more popular as methods of navigating through a Web site. This command lets you generate a list of HTML files in your Web project. The list is created as an HTML file with links to each file within the project. You can then add the resulting file to your Web site and provide your users with a classic method of navigation.

Each time you run this command, a totally new file is created. That is, this command does not compare new material to old and just make the changes. So, if there is some customization you have added to the resulting site map file, you should be prepared to add it again each time you run this command, or to use technology such as Server-Side Include Files to store it in a separate place. Also, the HTML generated by this command is fairly rudimentary HTML 2.0 tags. If you want a more customized page, you can cut and paste from the HTML provided by this command, or add your own more advanced HTML tags directly to the file.

To create a site map for HTML files:

  1. Select a Web site project. Web site projects have a this icon: ( [image])

  2. On the Web menu, click Create a Site Map to display the Create Site Map dialog box.

  3. Click OK.


Create File Links and Paths

See Also

Sharing a file creates links from the file to multiple projects. For more information on sharing, see Sharing Files. Branching a file creates different paths from project to project. For more information on branching, see Branch and Share Files and Projects.

  • To create a file link, see How to Share Files.

  • To create a file path, see How to Branch Shared File.

Note To view projects sharing a file, click the Links tab in the Properties command on the File menu. To view the branch history of a file, click the Paths tab in the Properties command on the File menu.


Customize SS.INI and SRCSAFE.INI Files

See Also

You can customize the SS.INI and SRCSAFE.INI files in two ways, either by using the options dialog boxes or a text editor.

Using Options Dialog boxes

You can set most SS.INI initialization variables directly in VSS in the Options dialog box on the Tools menu. Only administrators should set SRCSAFE.INI variables, using the VSS Administrator Options dialog box. When you use the Options dialog box, note that VSS saves your changes in memory, but does not write the changes to the file until you quit VSS or open a different database. Therefore, if you start a second VSS session before exiting the first, your changes are not yet in effect.

Using a Text Editor

You can read and modify initialization files with any text editor. There is a limit of 511 characters on an initialization file line, although this maximum may be restricted by specific variable requirements (such as project path limitations).

Location of SS.INI File

Usually, SS.INI is located in the Users subfolder of the folder in which VSS is installed, for example, SS\Users\Username. You can move your SS.INI file from this location, provided you tell VSS of the change by editing the Users.txt file appropriately (see your VSS administrator).

The SRCSAFE.INI file is usually placed in the main VSS folder of the server installation.

Note Initialization variables set in SS.INI override settings in SRCSAFE.INI.

The Format

There are three kinds of lines in SS.INI and SRCSAFE.INI.

  • Initialization variables, which are the functional lines, take the following format:
    Initialization variable = value

    Boolean variables can be set with "Yes", "No", "True", or "False."

  • Comments begin with a semicolon:
    ; Here I am, JP.

    VSS ignores all comments.

  • Headers are provided in brackets:
    [$/Word]

    Most headers specify particular project paths. Other headers, such as [Keyword Comments], are used for specific purposes.

The order of variables inside an initialization file does not matter at all; however, the header under which a variable is placed matters a great deal. If a variable is placed under the wrong header [image] for instance, if a general-purpose variable is placed under [Keyword Comments] [image] it is ignored.

SS.INI on Multiple Platforms

If you are running a multi-platform VSS installation, you may want certain variables to have different values on the different platforms or on different computers. You can therefore place a platform or computer name in parentheses after the variable, to indicate that the variable applies only on that platform. For example:

Use_ReadOnly (WIN) = Yes
Comment_Editor (JOE1)= c:\MSOFFICE\WINWORD\WINWORD.EXE

The setting in the first example applies only under Microsoft Windows. The setting in the second example applies only to a computer named JOE1. Other possible settings include Win, UNIX, UI, CL, NT, MAC, and PC [image] the last is a catchall for Intel operating systems.

Every variable in SRCSAFE.INI can be followed by a platform specifier, that is, a computer name, in parentheses. This specifier enables one variable to have different settings on different platforms. Not all variables recognize different computer names, but many do. Only 10 platform specifiers are allowed per user, or 10 per each SS.INI file.

Different versions of VSS look for different specifiers. For example, the VSS interface on a Windows NT computer looks for the platform specifiers in following order:

JOE1, NT, Win, PC, UI

This looks for a variable set for Joe's computer named JOE1; if it does not find that, it looks for Windows NT; then Win, then PC, then UI, and finally, for a variable with no platform specifier.

However, you can override this setting by setting the environment variable SSiniENV. For example:

Set SSiniENV = Ragiv, MS-DOS, PC, CL

Then VSS would look for variables specified for Ragiv before looking for MS-DOS, PC, CL, or no specifier. If the following two lines were in the SRCSAFE.INI:

Data_Path (Ragiv) = R:\SS\DATA
Data_Path (Kim) = R:\SS2\DATA

VSS would use the first setting and ignore the second. If SSiniENV were set to Kim, VSS would use the second string and ignore the first. Hence, by setting the SSiniENV variable appropriately, you can control which Data_Path variable VSS reads and which DATA folder is used.


Customizing Windows or Windows NT

There are many ways you can customize Windows or Windows NT to make your computer more accessible.

  • Beginning with Windows 95, accessibility features are built in to Windows. These features are useful for individuals who have difficulty typing or using a mouse, have moderately impaired vision, or who are deaf or hard-of-hearing. The features can be installed during setup, or you can add them later from your Windows 95 installation disks. Look up "accessibility" in the Windows Help Index for information about installing and using these features.

  • Many of the features which make Windows 95 more accessible can be added to Windows NT, earlier versions of Microsoft Windows, and MS-DOS through Access Packs. You can download these files by modem, or you can order them on disks from Microsoft.

  • You can also use Control Panel and other built-in features to adjust the appearance and behavior of Windows or Windows NT to suit varying vision and motor abilities. These include adjusting colors and sizes, sound volume, and the behavior of the mouse and keyboard.

  • Dvorak keyboard layouts make the most frequently typed characters on a keyboard more accessible if you have difficulty using the standard "QWERTY" layout. There are three Dvorak layouts: one if you are a two-handed user, one if you type with your left hand only, and one if you type with your right hand only. You do not need to purchase any special equipment to use these features.

The specific features available, and whether they are built-in or must be obtained separately, depend on which operating system you are using.

For full documentation on the accessibility features available in the operating system you are using, obtain the appropriate application notes listed below. Accessibility features are also documented in the Microsoft Windows 95 Resource Kit and the Microsoft Windows NT Resource Kit.

Which Files to Download or Order

You can obtain these files by downloading them with your modem, or you can order them on disks by phone. Specific information about downloading or ordering these files immediately follows this list of files.

These files include:

  • Application notes providing more complete documentation on ways to customize Windows and Windows NT

  • Access Packs and Dvorak keyboard layouts provide additional features for versions of Windows or Windows NT in which they are not already included
For | You need
Application notes for Microsoft Windows 95 | Ww1062.exe
Application notes for Microsoft Windows NT 3.1 and 3.5 (includes Access Pack for Microsoft Windows NT) | Wn0789.exe
Application notes for Microsoft Windows for Workgroups 3.1 | Wg0788.txt
Application notes for Microsoft Windows 3.1 | Ww0787.txt
Application notes for Microsoft Windows 3.0 | Ww0786.txt
Access Pack for Microsoft Windows 3.0 and 3.1 | Accp.exe
Dvorak keyboard layouts for people who type with one hand (already included in Windows NT 3.5 and higher) | Ga0650.exe (Most network services), Ga0650.zip (Microsoft Download Service)

To Download the Access Packs, Application Notes, and Alternative Keyboard Layouts by Modem

If you have a modem, you can download these files from the following network services:

  • Microsoft's World Wide Web site on the Internet. On the www.microsoft.com home page, click Support. click Knowledge Base, and select MS-DOS as the product. Enter KBFILE GA0650.EXE, and click GO! Open the article, and click the button to download the file.

  • Microsoft’s Internet servers, ftp.microsoft.com and gopher.microsoft.com, in /softlib/mslfiles

  • MSN™, The Microsoft Network online service

  • CompuServe®, type GO MSL.

  • GEnie™

  • Microsoft Download Service (MSDL), which you can reach by calling (206) 936-6735 any time except between 1:00 A.M. and 2:30 A.M. Pacific time.

  • MSDL supports 1200, 2400, 9600, 14400, or 28800 baud rates (V.32 and V.42), with 8 data bits, no parity, and 1 stop bit.

  • Various user-group bulletin boards (such as the bulletin-board services on the Association of PC User Groups network)

To Order the Access Packs, Application Notes, and Alternative Keyboard Layouts on Disks by Phone

If you do not have a modem, within the United States you can order the Access Packs, Application Notes, and Alternative Layouts on disks by calling Microsoft Sales Information Center at (800) 426-9400 (voice) or (800) 892-5234 (text telephone).

In Canada, you can call (905) 568-3503 or (905) 568-9641 (text telephone).


Delete a File or Project

See Also

After a file or subproject is deleted in VSS, it can be recovered until the file is purged or destroyed.

To delete a file or project in VSS:

  1. Select the file or project in VSS Explorer.

  2. On the File menu, click Delete to display the Delete dialog box.

  3. Click OK.


Deploy Web Files to a Server

See Also

When you have completed development and testing of your Web pages, the Deploy command can be used to copy your project files to a live Web server. The location of this server is a folder or FTP site specified by your VSS administrator. When you choose the Deploy command, the contents of your current project are copied to that location.

To deploy Web files to a server:

  1. Select a Web site project of files. Web site projects have a this icon: ( [image])

  2. On the Web menu, click Deploy to display the Deploy dialog box.

  3. Click OK.


Designing and Organizing Projects

VSS does not impose project design criteria. However, to ensure that your project is organized carefully and runs efficiently, consider the following design guidelines:

  • You may want to make each existing folder in your operating system a project in VSS. Each subfolder can be a subproject. For example, if you store code in a folder with three subfolders in your operating system folder, create a project with three subprojects within VSS.

  • Divide files logically among projects and subprojects. VSS handles up to 8,000 files in a project, but breaking large projects into subprojects makes files easier to manage.

  • Don't add the same file separately to multiple projects if you want the same changes to be applied to the separate projects. Instead, share the file among projects.

  • Don't create a new project if you are simply moving to a new version of a project. You can label the project to mark the version.

  • Place all the files necessary to build one program in one VSS project. Such files are generally code but can also include makefiles, libraries, bitmaps, dynamic-link libraries, and even subsidiary programs.

  • Don't keep executable files in VSS projects unless they take a long time to build. Don't take up space in VSS when you can compile and link to build an executable file on demand.

  • Ensure that the project only contains the latest tested code that compiles and runs. While this is sometimes not possible, especially at the inception of a project, a good rule of thumb is that nobody should check code into VSS unless it compiles and runs. If this rule is followed, anyone can get a project, compile it, and see the state of the project at any time.

  • Store your current documentation files, icons, graphics files, and other files in VSS projects.

  • In any multi-user project, no file should be checked out for longer than it takes to make and test the changes to the file. If a file is checked out for several days, other people may not be able to use the most current version containing the changes that have been made to the file.

  • When you nest subprojects, observe the supported limit of 15 levels of nesting. This may also be restricted by the project path string length of 259 characters.


Destroy a File or Project

See Also

Warning When you destroy a file permanently, you cannot recover it within VSS. All previous history information pertaining to that file is lost.

To destroy a file or project:

  1. Select the file or project in VSS Explorer.

  2. On the File menu, click Delete to display the Delete dialog box.

  3. Select the Destroy Permanently check box.

  4. Click OK.


Disable Input

See Also

If you are creating a batch file containing a series of VSS commands (to run overnight, for instance), you don't want the program to pause in the middle to ask you a question. There are three command-line parameters you can use together to ensure that VSS does not prompt a user for input.

By default, VSS prompts you for a comment on many commands such as Add and Check In. However, you can use the -c option in the following three ways to avoid this prompt.

Command | Action
–c– | No comment is added.
"–cHello" | Uses the string Hello as the comment.
-c@COMMENT.TXT | Uses the contents of the file Comment.txt as the comment.

In addition to prompting for comments, VSS frequently asks yes or no questions. You can use the -i option to avoid these questions, as in the following examples.

Command | Action
-i-y | Automatically answers Yes to all Yes/No questions.
-i-n | Automatically answers No to all Yes/No questions.
-i | Use the default.

VSS may also prompt for a logon name. If you receive this prompt, you can use the -y option to supply the necessary information.


Drag and Drop

See Also

Several drag and drop operations are enabled with VSS. For example, you can drag a file from the file pane to the project pane to quickly share the file with another project. By holding down the CTRL key while dragging a file to a project, you can share and immediately branch the file.

You can also drag a file from Windows Explorer into VSS Explorer to add it to a project, or drag a folder from Windows Explorer into VSS Explorer to create a new project under the project you drop on. You can also select multiple files or folders and do the same thing with several items at once.

If you drag a file you have checked out from Windows Explorer into the VSS project containing that file, you have checked the file in. If you don't have the file checked out, VSS displays an error. You can also drag your working folder for a project from Windows Explorer into the appropriate VSS project to check in all checked-out files in that folder.

Finally, if you drag a Windows shortcut into VSS, VSS allows you to save the shortcut itself, or the file the shortcut points to, in VSS.


Edit Files

See Also

Use the Edit File command to check out and edit a file in one operation. VSS automatically displays the file in the editor associated with that file. For instance, a file with the .doc file type is associated with Microsoft Word, thus the file is opened in Word. To select a different editor, click the Advanced button on the File dialog box.

To edit a file:

  1. Select the file you want in VSS Explorer.

  2. On the Edit menu, click Edit File to display the File dialog box.

  3. Click the Check out this file and edit in your working folder box, if it isn't already selected.

  4. If you want to specify an editor, click the Advanced button and do so in the last text box.

  5. Click OK to display the Check Out dialog box for files and projects.

  6. Specify your working folder in the To box.

    — Or—

    Click Browse to search for and set a working folder.

  7. Click OK.


Edit Properties

See Also

To edit the properties of a file:

  1. In VSS Explorer, select the file whose properties you want to change.

  2. On the File menu, click Properties, then click the General tab if it isn't already selected.

  3. Make your changes.

  4. Click Close after your changes are complete.


Expand Keywords

See Also

Note Keyword expansion is by default disabled for all files. See your VSS administrator to enable keyword expansion.

Keyword expansion refers to VSS's ability to place certain information directly into your file to create a file header for you.

To do this, you place certain keywords into the text of your file, in comments so that they do not affect your code. When you add or check in the file, VSS looks for these keywords, and places the relevant information after them.

This topic describes the traditional way VSS expands keywords. With VSS, you can also expand keywords in a different way that makes using keywords with HTML files much more useful. See Use Keyword Expansion in HTML Files for details.

VSS Keywords

The following table is a list of all the VSS keywords. Some of the keywords are redundant, either for convenience or for backward compatibility with other version-control systems, such as RCS.

Note Keywords are case-sensitive, so be sure to capitalize them properly.

To expand keywords:

Type this keyword | To add the following
$Archive: $ | VSS archive file location
$Author: $ | User who last changed the file
$Date: $ | Date and time of last checkin
$Header: $ | Logfile, Revision, Date, Author
$History: $ | File history, VSS format
$JustDate: $ | Date, without the time addendum.
$Log: $ | File history, RCS format
$Logfile: $ | Same as Archive
$Modtime: $ | Date and time of last modification
$Revision: $ | VSS version number
$Workfile: $ | File name
$NoKeywords: $ | No keyword expansion for all keywords that follow

For example, you could place the following in a file:

$Revision: $

Upon checkin, VSS would replace it with:

$Revision: 23 $

The next time you check in the file, the 23 is replaced by a 24, and so on. Without running VSS, you can always look at the top of your file to see what version your copy of the file is.


Fast Get

Because of VSS 6.0 performance enhancements, you can perform a Get operation up to two times faster than in older versions of VSS.

In order to take advantage of VSS' Fast Get feature, you must first have your VSS Administrator run the DDUPD utility. See Using DDUPD to Take Advantage of Performance Enhancements for more information

When you do a Get, Check Out, Deploy or anything else that puts a copy of a file on your local drive, a vssver.scc file is created (or updated if one already exists) in your working folder. There's one vssver.scc for all the files in that folder. Vssver.scc contains information needed to identify the local file, so VSS can determine which files have and haven't changed.

Note If you delete the vssver.scc file, nothing will happen except that your new Get commands will be a bit slower and another vssver.scc file will be created. The vssver.scc file is ignored by the Project Difference command, and therefore will not show up as a file to Add to a VSS Project.


File List Symbols

See Also

The symbols listed in the following table are used in the VSS Explorer file list.

VSS Explorer File List Symbols

Symbol | Description
 | File
 | Checked-out file
 | File checked out to multiple users
 | Shared file
 | File exclusively checked out
 | File pinned to a specific version
 | Shared file, checked out
 | Shared file, exclusively checked out


Format Keywords

See Also

By default, VSS replaces the space between a keyword and the subsequent dollar sign with the value you've specified. This can, however, make it difficult to create an attractive columnar display.

To fix this, you can place two colons instead of one after the keyword and then add the amount of space that you want displayed. This tells VSS that the dollar sign after the keyword is exactly where you want it: VSS either adds space or truncates the value to ensure that the columns stay intact.

Binary Files

In addition to creating attractive columns, this feature is very useful when you want to embed keyword information in binary files (such as executable files), where the exact length of the data is important.

For example:

$Revision::     $

VSS expands the keyword with the version number of the file, and keeps the extra space you added inside the dollar sign character so that the revision number column maintains its width.

Formatting the History and Log Keywords

The History and Log keywords instruct VSS to put history information after the keyword. VSS places the file name between the colon and the dollar sign; in the lines following the keyword, it places the latest entry in the file's history.

To make sure the history is read as comments (to keep code compilable), your VSS administrator can define comment characters that VSS places before and after the History and Log lines.

Each file extension is associated with a string that is placed before every line, followed, optionally, by a string to be placed after every line. Both strings are in quotes, separated by commas.

Important If no keyword comments are specified, the following comments are assumed:

*.asm = "; "

*.bas = "rem "

*.bat = "rem "

*.s = "; "

<All others> = "* "

Suppose your administrator does not have a setting for *.c in your SRCSAFE.INI file. VSS uses its default, which is an asterisk. You could then put the following into the header of your SS.INI file:

/*
 * $History: $
 */

Expanding this, VSS would place an asterisk before each line, and nothing after. The resulting file, after you add it to VSS, might look like the following:

/*
 * $History: IDRANGE.TXT $
 *
 * ***** Version 1 *****
 * User:mariaj Date:8/01/92 Time:11:02a
 * Created
 * Comment: Defined ranges for IDs.
 */


Get Earlier Version

See Also

Note When you Get a file, the file is placed in your working folder as read-only — any modifications you make to the file at this point cannot be saved in the project.

To get an earlier version of a file or project:

  1. Select the item(s) you want to see an older copy of.

  2. On the Tools menu, click Show History to display the History Options dialog box.

  3. Click OK to display the History dialog box.

  4. Select the version of the item you want a copy of.

  5. Click Get to display the Get dialog box.

  6. If you haven't previously set a working folder, VSS will ask you if you'd like to do so now. Click OK, then set your working folder.

  7. Click OK in the Get dialog box. The selected item is then copied from the current project into your working folder.


Get Latest Version

See Also

Note When you Get a file, the file is placed in your working folder as read-only — any modifications you make to the file at this point cannot be saved in the project.

To get the most recent version of a file or project:

  1. Select the item(s) you want. You can select a file, multiple files, or a whole project.

  2. On the SourceSafe menu, click Get Latest Version.

  3. If you haven't previously set a working folder, VSS will ask you if you'd like to do so now. Click OK, then set your working folder.

  4. If you have specified in options that the Get Latest Version dialog box be displayed, VSS displays the dialog box. Click OK to get the item you selected. It is copied from the current project into your working folder.


How to Work with Explorer

To learn more about how to work with VSS Explorer files and projects, see the following:

  • Drag and Drop

  • File List Symbols

  • Project List Symbols

  • Refresh List View

  • Resize List View

  • Right Mouse Button

  • Sort List View

  • Toolbar Command Buttons


Merge Branched Files

See Also

To merge files:

  1. Select the file or project you want in VSS Explorer.

  2. On the SourceSafe Menu, click Merge Branches to display the Merge To dialog box.

  3. In the Projects box, select the project that has the version of the file from which you want to merge changes.

  4. Click Merge to display the Comment dialog box.

  5. If desired, enter a comment.

  6. Click OK.

Note If you use the Find function while in Visual Merge, only one of the three Visual Merge panes will be searched, namely the pane that the cursor is in.


Microsoft Documentation in Alternative Formats

In addition to the standard forms of documentation, many Microsoft products are also available in other formats to make them more accessible.

Many of the Visual Studio 6.0 documents are also available in online viewer format, or in print. If you have difficulty reading or handling printed documentation, you can obtain many Microsoft publications from Recording for the Blind & Dyslexic, Inc. Recording for the Blind & Dyslexic distributes these documents to registered, eligible members of their distribution service, either on audio cassettes or on floppy disks. The Recording for the Blind & Dyslexic collection contains more than 80,000 titles, including Microsoft product documentation and books from Microsoft Press.

You can contact Recording for the Blind & Dyslexic at the following address or phone numbers for information about eligibility and availability of Microsoft product documentation and books from Microsoft Press:

Recording for the Blind & Dyslexic, Inc.

20 Roszel Road, Princeton

NJ 08540

Phone:(609) 452-0606

Fax:(609) 987-8116

World Wide Web:http://www.rfbd.org


Microsoft Services for People Who Are Deaf or Hard-of-Hearing

If you are deaf or hard-of-hearing, complete access to Microsoft product and customer services is available through a text telephone (TT/TDD) service.

Sales Information

You can contact Microsoft Sales Information Center on a text telephone by dialing (800) 892-5234 between 6:30 a.m. and 5:30 p.m. Pacific time.

Technical Assistance

For technical assistance in the United States, you can contact Microsoft Support Network on a text telephone at (206) 635-4948 between 6:00 a.m. and 6:00 p.m. Pacific time, Monday through Friday, excluding holidays. In Canada, dial (905) 568-9641 between 8:00 a.m. and 8:00 p.m. Eastern time, Monday through Friday, excluding holidays. Microsoft support services are subject to Microsoft prices, terms, and conditions in place at the time the service is used.


More Accessibility Information

Other products, services, and resources are available from Microsoft and other organizations.

Additional Microsoft Products and Services for People with Disabilities

For more information, contact:

Microsoft Sales Information Center
One Microsoft Way
Redmond, WA 98052-6393 		World Wide Web:
Voice telephone:
Text telephone: 		http://www.microsoft.com
(800) 426-9400
(800) 892-5234

Directories of Computer Products that Help People with Disabilities

The Trace R&D Center at the University of Wisconsin–Madison produces a book and a compact disc that describe products that help people with disabilities use computers. The book, titled Trace ResourceBook, provides descriptions and photographs of about 2,000 products. The compact disc, titled CO-NET CD, provides a database of more than 18,000 products and other information for people with disabilities. It is issued twice a year.

To obtain these directories, contact:

Trace R&D Center
University of Wisconsin
S-151 Waisman Center
1500 Highland Avenue
Madison, WI 53705-2280 		World Wide Web:
Fax:
 http://trace.wisc.edu
(608) 262-8848

Referrals to Assistive Technology Programs and Trained Evaluators

For general information and recommendations on how computers can help specific needs, you should consult a trained evaluator. An assistive technology program in your area will provide referrals to programs and services that are available to you.

To locate the assistive technology program nearest you, contact:

National Information System
University of South Carolina
Center for Developmental Disabilities
Columbia, SC 29208 		Voice/text telephone:
Fax: 		(803) 935-5231
(803) 935-5059


Move Files

See Also

The only way to move a file is to share it with the new parent project, and then delete or destroy the file in the original project. The history of the file will be retained. You cannot move individual files with the Move Project command.

To move a file:

  1. Select the file you want in VSS Explorer.

  2. On the File menu, click Move to display the Move dialog box.

  3. Click the new location for the file.

  4. Click OK.


Move Projects

See Also

To move a subproject to a different parent project:

  1. In the VSS Explorer project view, click the subproject you want to move.

  2. On the File menu, click Move Project to display the Move Project dialog box.

  3. Click the new location for the subproject.

  4. Click OK.


Open an Existing Database

See Also

When you run VSS, you must connect to a VSS database where your files are stored. This should happen automatically, but if it doesn't or if you need to connect to a different database, follow the steps below. If a database has not been set up, contact your VSS administrator.

Note If you've never opened a database before, from the VSS Logon dialog box, click Browse to search for an existing database, then click OK.

To open an existing VSS database from within VSS:

  1. On the File menu, click Open SourceSafe Database to display the Open SourceSafe Database dialog box.

  2. Select a database from the Available databases list.

    — Or —

    To search for an existing database, click Browse. After you locate the database, select its SRCSAFE.INI file, then click Open.

    Note If the database you want is not in the Available databases list, or you cannot find it using Browse, consult your VSS administrator.

  3. Click Open in the Open SourceSafe Database dialog box.


Optimize Performance

See Also

VSS's default installation, while simple to create and use, is not necessarily optimized for performance. Therefore, VSS provides two ways you can customize your system to improve performance:

  • Copy as much as possible from the network to your hard disk. This change is extremely useful for all network users, but is essential for Macintosh users on Intel networks. You can use the VSS Netsetup.exe program (on the VSS server) to copy necessary executable files to your local computer.

  • Fine-tune your initialization files for performance. Most fine-tuning, described below in General Optimizations, involves compromises of various sorts, such as disabling certain kinds of functionality. None of these optimizations provides as much benefit as the measures described in the following list, however.

To Optimize Performance in VSS

Set the following variables in the SS.INI or SRCSAFE.INI file:

  • Diff_Ignore (PC) = c-e-s-w-

    Tells VSS not to ignore end-of-line differences, which speeds up the comparison. By default, VSS ignores all end-of-line differences, which slows the algorithm significantly.

  • CP_OnSelection = No

    Disables the selection of a project as you use the mouse or arrow keys to move through the project list. If you set this initialization variable to No, you must use the ENTER key or double-click to set your current project.

General Optimizations

You can set the following options on the Local Files tab and the General tab in the Options dialog box on the Tools menu:

  • Copy keyword-expanded files into working folder

    Useful if you use keyword expansion. Clearing this check box may increase VSS's speed, as it tells VSS not to get a file after checkin.

  • Compare files by

    Controls how VSS determines if you already have the latest copy of a file in your working folder. The Time setting sometimes does not behave as you expect when you try to get earlier versions. A solution is to occasionally delete your local copy to force a Get operation to occur.

  • Folders for Temporary Files

    Specifies where you store temporary files. The default setting is to store temporary files on the server, but your administrator can also set the Temp_Path variable in your SS.INI file to a local folder which speeds up operations like viewing files. For example:

    Temp_Path = c:\windows\temp

Ask your VSS administrator to verify the following variable in the SRCSAFE.INI file:

  • Lock_Mode = Native

    This is the default setting for this SRCSAFE.INI variable. Setting this initialization variable to Native speeds up almost every VSS operation.

    Important: This variable must be set by the VSS administrator.

Features You Can Disable to Improve Performance

Your VSS administrator can disable any of the following to optimize the speed of many VSS commands:

  • Shadow folders

  • Journal files

  • Project security system

  • Keyword expansion


Perform an Exclusive Checkout

See Also

You can check items out exclusively, checking them out so that no one else can check them out while you have the file or project.

There are two ways to achieve this. Your VSS administrator can set an administrative option to disable multiple checkouts for an entire project all the time, or you can do the following.

To perform an exclusive checkout:

  1. Select the file or project you want to check out.

  2. On the SourceSafe menu, click Check Out to display the Check Out dialog box.

    Note If this dialog box does not appear, you need to display it using the Command Dialogs tab in the Options command on the Tools menu.

  3. Click Advanced.

  4. Clear the Allow Multiple Checkouts check box.

  5. Click OK.

Note This exclusively checks the file or project out on a session-by-session basis only.

How to Tell if a File is Exclusively Checked Out:

There are three ways to tell if a file is exclusively checked out, including:

  • A red outline around the file icon.

  • The Check Out Status tab in the File Properties dialog box changes. A line is added under the file name that says "Exclusive Check Out."

  • On the command line, the SS Status command indicates the status:
    Ssus.rc    Charry v572    4/08/98 2:37 (Exclusive Check Out)


Pin Files

See Also

You can pin any file.

To pin a particular version of a file:

  1. In VSS Explorer, select the file you want to pin.

  2. On the Tools menu, click Show History to display the History Options dialog box.

  3. Click OK to display the History of File dialog box.

  4. Select the version of the file you want, then click Pin. A pushpin icon appears next to the pinned file.

  5. Click Close.

When it is time to use the most recent version of the file, you unpin it.


Project List Symbols

See Also

The symbols listed in the following table are used in the VSS Explorer project list.

VSS Explorer Project List Symbols

Symbol | Description
 | Project
 | Current open project
 | Indicates that subprojects exist in this project. Click the icon to expand the project list.
 | Click to collapse the project list.
 | Cloaked project
 | Web site project


Purge Deleted Files

See Also

Purging permanently removes deleted files and projects from the VSS database.

Note Purged items cannot be recovered.

To purge a file that was previously deleted:

  1. Select a project in the project pane of VSS Explorer.

  2. On the File menu, click Properties, and then click the Deleted Items tab.

  3. Select the file(s) you want to purge.

  4. Click Purge.

  5. Click Yes when VSS asks you if you want to continue.


Recover Deleted Files

See Also

To recover a deleted file:

  1. Select the project the file was deleted from in the project pane of VSS Explorer.

  2. On the File menu, click Properties, and then click the Deleted Items tab.

  3. Select the file(s) you want to recover.

  4. Click Recover.


Redirect Output

See Also

By default, VSS directs all its output to the screen. Command-line users can use the -o option to paginate the output, which is exactly the opposite of what you want in a batch file. However, you can also use -o to disable or redirect the output.

To redirect or disable output:

Type This Command | Resulting Action
-o- | No output
-oRESULTS.TXT | Redirect all output into the text file Results.txt. If this file already exists, the output is appended to it.


Refresh List View

See Also

While you are using VSS, other people may change the contents of the current project. For instance, they may check out and check in files. To stay up-to-date, VSS automatically refreshes its list view periodically. You can change how often VSS autorefreshes by using the File List section on the View tab of the Options command on the Tools menu.

You can also refresh the list view manually.

To refresh the list view manually:

  • From the View menu, click Refresh File List, or press the F5 key.


Rename Files or Projects

See Also

VSS allows you to edit the name of a file and still retain its history. If a file is shared by multiple projects and it is renamed, it will be renamed in all the projects that share the file. However, if any of the share links have been broken by the Branch command, branched files are not renamed.

To rename a file:

  1. In VSS Explorer, select the item whose name you want to change.

  2. On the File menu, click Rename.

  3. Type the item's new name.

  4. Press ENTER when finished.


Resize List View

See Also

You can resize the amount of space allocated to the VSS project view and list view.

To resize the list view:

  1. Place the mouse over the horizontal bar between the project view and list view; hold the mouse still until it turns into a double-sided arrow.

  2. Clicking, drag the bar either left or right to resize the project/list view.

You can also resize the height of the results pane, if it appears.


Resolve Merge Conflicts with Visual Merge

See Also

When there is a conflict, VSS uses its visual merging format, shown below, by default. This is true regardless of whether you initiate the merge or VSS does.

The Visual Merge dialog box

  • The top two panes represent two versions being merged. In the example dialog box shown above, the merge is being performed automatically as a result of multiple checkouts; hence, the file on the left is the one in VSS, and the file on the right is one on your hard disk. In the "Merge Branches" case, the two versions are from different projects.

  • The lower pane represents the result of the merge. It starts off with all nonconflicting changes already made, and changes dynamically as you work. If you are merging branches, the lower pane contains the original file from just before you created the branch.

  • All three panes scroll vertically together, to the extent that this is possible. (Under some circumstances, VSS may temporarily lose synchronization.) The upper panes also scroll together horizontally; the lower pane's horizontal position is independent.

  • The colors and font are controlled by the same options used for difference checking. Font style (bold, italic, and so on) cannot be changed.

  • The lower pane is directly editable, but the upper panes are not.

  • You can also cut/copy from the top two panes and paste into the lower pane.

  • Use the right-click menu to resolve conflicts.


Resolve Merge Conflicts without Visual Merge

See Also

If you choose not to use the visual merge, and want to customize how VSS displays merge conflicts in the manual merge, one way is to set the Mark_Merges initialization variable in your SS.INI file. For example in the file, type:

Mark_Merges = yes

Using the visual merge means you don't have to worry about conflict markers. But, if you use Mark_Merges, VSS:

  • Marks all changes, even if they are not conflicts. This gives you the opportunity to see and approve all changes. Of course, you should remove all the change markers before checking in the file or compiling the code.

  • Shows you the original lines as well as both modified lines.

The following is an example of what the VSS conflict markers may look like.

<<<<<< SourceSafe version
if (a <= 5)
|||||| Original version
if (a < 5)
======
if (a < 6)
>>>>>> Local version

The format is similar to the manual merge conflict marker, except that VSS displays the original (pre-checkout version) between the master and local versions, which can be helpful to you in determining how best to clean up the file.

Setting Merge Options in the Initialization Files

You can set the following two initialization variables to change the file extensions used by the merge process.

Backup_Ext = .ORG
Merge_Ext = .MRG

Backup_Ext controls what happens to your original (pre-merged) file after the merge has taken place. By default, VSS deletes the file if there was no conflict; it renames the file .org if there was a conflict. When you set this variable, however, VSS always renames the file, so you always have a copy of your original. You can set this to the default .org extension, or to a different extension if .org is already used by your system.

Merge_Ext controls the extension that VSS uses for its temporary merge file. This file is always deleted after the merge process is completed [image] the only reason to change it is if the extension .mrg is already used by your system.


Right Mouse Button

See Also

VSS Explorer provides another way of working with the file list and project list. If you click a file with the right mouse button, VSS displays a shortcut menu of common file commands. If you click a project with the right mouse button, VSS displays a menu containing commands that operate on projects.

When you click the right mouse button, then drag items from Windows Explorer into VSS, a list of options including Add File(s), Check In, Undo Check Out, and Cancel becomes available.

Note You cannot drag items from one copy of VSS to another unless you have the same VSS database open in both copies.


Rollback to a Previous Version of a File

See Also

Caution When you roll back a file, you lose all changes made to that file after the version you roll back to. For example, if you click on version 5 and then click Rollback, all changes since version 5 are lost.

To rollback a file:

  1. Select the file in VSS Explorer.

  2. On the Tools menu, click Show History to display the History Options dialog box.

  3. Click OK to display the History of File dialog box.

  4. Select a previous version of the file, then click Rollback.


Search by String

See Also

Search strings can be up to 63 characters long.

To search by a string of text:

  1. On the Tools menu, click Find in Files to display the Find dialog box.

  2. Type the string of text for which you are searching.

    Note If you're using an asterisk in your text string as part of a wildcard search, select the Use Regular Expressions check box. If you're using an asterisk as an ordinary text character, clear the Use Regular Expressions box.

  3. If you want your search to be case-sensitive, select the Match Case check box.

  4. Click OK. VSS will start the search.


Search for Checked Out Files

See Also

Note You stay in search mode until you explicitly cancel the search.

To search by check out status:

  1. On the View menu, click Search Status Search to display the Search for Status dialog box.

  2. To display files checked out to a particular user, click Display Files Checked Out To, then select a user from the dropdown list.

  3. For a global search, click Search in All Projects.

  4. Click OK to start the search.


Search with a Wildcard

See Also

Search strings can be up to 63 characters long.

Note You stay in search mode until you explicitly cancel the search.

To search by a wildcard name:

  1. On the View menu, click Search Wildcard Search to display the Search for Wildcard dialog box.

  2. In the Wildcard box, type the part of the file name you know, using an asterisk (*) for parts you don't know.

    For example, if you're looking for a file you think is called TodaysProject, but you can't recall the entire file name, enter Today*.* as your wildcard search. VSS will identify all files that start with the words Today, helping you narrow the search.

    You can also search using multiple masks, separating your search with semicolons, such as *.exe; ?.dll; !ga*.exe.

  3. Select a Search Area.

  4. Click OK to start the search.


Set a Working Folder in SS.INI

See Also

When you save a working folder as the default with the Save As Default For Project check box in the Set Working Folder dialog box, VSS stores that information in your SS.INI file. The following is an example of what it might look like.

[$/Spelling/American]
Dir (PC) = C:\DEV\SPELL\ENGLISH

The first line is a project header, indicating that variables below the header apply to the specified project. The second line uses the Dir initialization variable to specify your working folder. The platform identifier in parentheses indicates that the setting is machine-specific; if you were working on the same project on a Macintosh, you would want to specify a different working folder, or the syntax of your folder path.

It is possible to set these variables yourself in your SS.INI file, although generally it is easier to let VSS set them for you.


Share and Branch a File in One Operation

See Also

Sharing a file means it exists equally in all the projects to which it is shared. Branching a file breaks the shared link, making the file in that project independent of all other projects.

Note To view projects sharing a file, click the Links tab in the Properties command on the File menu. To view the branch history of a file, click the Paths tab in the Properties command on the File menu.

To branch and share a file on one operation:

  1. In VSS Explorer, select the project into which you want to branch/share a file.

  2. On the SourceSafe menu, click Share to display the Share dialog box.

  3. In the File to share list, select the file you want to share. If the file you want to share is not displayed, select the project containing the file from the Projects list.

  4. Select the Branch after share check box.

  5. Click Share to display the Share File dialog box.

  6. In the Comment box, type a comment describing the branch/share, if desired.

  7. Click OK to close the Share File dialog box.

  8. Click Close to close the Share dialog box.


Share, Pin and Branch to Create Service Pack Projects (Bug Fixes)

If the need for a bug fix occurs after a project has been labeled and further developed, use the following share, pin and branch scenario. This will use a minimal amount of hard drive space.

To share, pin, and branch a project:

  1. In the drive toward Version 2.0, develop and test your project (e.g., $/Application).

  2. Label the project "Version 2.0."

  3. Begin changing files in the project in the drive toward Version 3.0 of the project, which will introduce new features.

  4. If you realize an interim Version 2.1 is needed for bug fixes, select the project.

  5. On the Tools menu, click Show History to display the Project History Options dialog box.

  6. Select the Include Labels box.

  7. Click OK to display the History of Project dialog box.

  8. Select the label version "Version 2.0."

  9. Click Share to display the Share From dialog box.

  10. Select the project you want to be the parent of the newly created project. This is usually the $/ project. Also be sure the Branch after Share box is not checked.

  11. Click OK to display the Share dialog box.

  12. Give the project a New Name (e.g., $/Application V 2.1).

  13. If the project has subprojects, select Recursive.

  14. Add comments in the Comment box as needed, then click OK.

  15. Click Close to exit the History of Project dialog box.

  16. Select the newly created project (i.e., $/Application V 2.1). All files in this project should now be pinned.

  17. Select only those files that need to be changed to address bug fixes, then branch the file(s). See Branch Shared Files for more information. Leave pinned any files that do not need to be changed.

You can later merge bug fix changes back into your Version 3.0 project.


Share Files

See Also

VSS projects are in many ways analogous to operating system folders. However, whereas every file in an operating system exists uniquely in a folder, a VSS file can simultaneously exist in many different projects.

In VSS, you can share files. Inside the VSS database, there is only one copy, the master copy, of the file; each project to which the file belongs simply has a pointer to that copy. When you change the file in any one project, VSS immediately updates it in all the projects that share it.

Example

When you add a file called Test to Project A and to Project B, you have added two unconnected files with the same name. When you add the file to one of the projects, and share it with the other project, the two projects are linked to the same file.

A shared file exists equally in all the projects to which it is shared [image] that is, each project in which the file is shared has an equal pointer to the one master copy of the file.

Note It is important to understand what happens when you carry out the Destroy and Purge commands on shared files.

If a file is shared by multiple projects, destroying or purging it in one project does not delete the file from the VSS database, and consequently does not free any disk space.

For information on how to share files, refer to:

  • How to Share Files


Sort List View

See Also

To sort the VSS Explorer list view:

  • Click any of the headings in the list. For example, click Name to sort the list by name, or click User to sort the list by user.

  • Click again on the same heading to reverse the sorting order.


Third-Party Utilities to Enhance Accessibility

A wide variety of third-party hardware and software products are available to make it easier to use personal computers. Among the different types of products available for the MS-DOS, Windows, and Windows NT operating systems are:

  • Programs that enlarge or alter the color of information on the screen for people with visual impairments.

  • Programs that describe information on the screen in Braille or synthesized speech for people who are blind or have difficulty reading.

  • Hardware and software utilities that modify the behavior of the mouse and keyboard.

  • Programs that enable people to "type" using a mouse or their voice.

  • Word or phrase prediction software that enables people to type more quickly and with fewer keystrokes.

  • Alternate input devices, such as single switch or puff-and-sip devices, for people who cannot use a mouse or a keyboard.

To learn more about these products, see the topic "Getting More Information."


Toolbar Command Buttons

See Also

The command buttons listed in the following table are used in the VSS Explorer toolbar. You can add or remove any of the command buttons by using the Customize Toolbar command on the Tools menu.

VSS Explorer Toolbar Command Buttons

Button | Description
 | Separate command buttons
 | Search
 | Merge branched files
 | View links
 | View paths
 | Rename
 | Move
 | Change font
 | Create a new project
 | Add files
 | Label a version
 | Delete
 | Get latest version
 | Check out
 | Check in
 | Undo checkout
 | Share
 | Branch
 | View
 | Edit
 | View differences
 | Properties
 | History
 | Find
 | Set working folder
 | Refresh
 | Help


Undo Check Out

See Also

To undo a checkout:

  1. Click the item(s) you want in VSS Explorer.

  2. On the SourceSafe menu, click Undo Check Out to display the Undo Check Out dialog box.

  3. Click OK.

Warning If you choose the Undo Check Out command, you will lose any changes you have made to the local copy of the file or project.


Unpin Files

See Also

To unpin a file:

  1. In VSS Explorer, select the file you want to unpin.

    Note VSS displays a pushpin icon next to a pinned file.

  2. On the Tools menu, click Show History to display the History of File dialog box.

  3. Select the pinned version, then click Unpin.

  4. Click Close.

VSS unpins the file so the most recent version is the current version in the project.


Use Command Line Commands and Options

See Also CmdLine_Comment; Concept_AltCmdlineWords;

The following is a list and general description of all the command-line commands.

For additional information on use of the commands, see How to Use Command Line Syntax.

Important Do not put spaces between an option and the value it acts on. For example, the following command produces an error message:

ss view readme.txt -v 2

Command | Action
Add | Adds a file to the VSS database.
Branch | Allows parallel development of two versions of a file.
Checkin | Checks in a file to the VSS database.
Checkout | Checks out a file to your working folder.
Cloak | Cloaks a VSS project.
Comment | Enters a comment into the VSS database.
CP | Sets the current project path.
Create | Creates a new subproject.
Decloak | Decloaks a VSS project.
Deploy | Deploys a Web project or file to a server.
Destroy | Permanently destroys a file or project.
Diff | Shows the differences between the master copy and local copy of a file.
Dir | Lists contents of the current project or a specified project.
FileType | Displays the type (text or binary) of a file.
Find | Shows all instances of a specified string in one or more files.
Get | Gets a read-only copy of the specified file(s).
Help | Displays Help on using VSS or on a specific command.
History | Shows the history of a file or project in VSS.
Label | Assigns a label to the specified version or current version of a file or project.
Links | Shows the projects sharing a specified file.
Locate | Searches through VSS projects for file or project names.
Merge | Copies all the changes made in one branch to another branch.
Move | Relocates a subproject from one parent project to another.
Password | Sets the password for the current user.
Paths | Shows all share links that have been branched.
Pin | Makes a previous version of a file in the current project behave as if it were the most recent version.
Project | Displays the current project path.
Properties | Shows basic information about a VSS file or project.
Purge | Permanently removes previously deleted files and projects from the VSS database.
Recover | Recovers files and projects that have been deleted.
Remove | Alternate command name for Delete.
Rename | Renames a file or project.
Rollback | Undoes all changes since an earlier version of a file.
Share | Makes the specified file or project a member of the current project.
Status | Shows checkout information on files.
UndoCheckout | Undoes the checkout of a file.
Unpin | Undoes a Pin operation.
View | Displays the text of a file.
Whoami | Shows your current VSS username.
Workfold | Sets the working folder.

The following list contains a general set of options applicable to many commands. The options are listed in uppercase, but you can also enter them in lowercase.

Option | Description | Command(s)
-?, -H | Give Help on a command instead of executing it. | All
-C[-] | Use one comment for all specified items. To use no comment, type a dash following the C. | Add, Branch, Checkin, Checkout, Comment, Create, Label, Merge, Rollback, and Share
-G | Set options for local copy. | Check Out, Deploy, Get, Recover, Rollback, Share, and Undo Check Out
-I- | Do not ask for input under any circumstances. | All
-N | Use long or short file name mode (Windows NT and Windows 95 only). | All
-O[-] | Paginate or redirect the output of the command. To suppress output, type a hyphen after the O. | All except CP, Move, Password, Pin, Unpin, and Whoami
-R | Do a command recursively. | Add, Checkin, Checkout, Deploy, Diff, Dir, Filetype, Find, Get, History, Properties, Share, Status, and Undo Check Out
-S | Set Smartmode, performing different actions depending on the particular command. | Create, Delete, Destroy, Recover, and Rename
-V | Operate on a specific version of an item. | Checkout, Comment, Deploy, Dir, Diff, Find, Get, History, Label, Pin, Rollback, Share, and View
-W[-] | Make local files read-only or read/write. To override the variable and make a file read-only for one instance of the command, type a hyphen after the W. | Add, Checkin project, Deploy Get, Pin, Recover, Rollback, Share, Undocheckout, and Unpin
-Y | Specify username and password. Use with all commands. | All


Use Command Line Syntax

See Also

All VSS commands entered from the command line must begin with ss.

The syntax for VSS commands is as follows:

ss Command [item(s)] [option(s)]

Items

An item can be a project or a file. The nature of an item depends on the command. For the Get command, each item must be a VSS file or project. For the Add command, each item must be an operating system file or folder.

Options

Options are parameters you use to modify the action of a command and consist of a hyphen ( - ), a letter, and a value. The value must follow the option letter directly, with no space between them. For example:

ss Get hello.c -v22

In almost all cases where you can specify an item to act on, you can also specify many items. For example, any of the following are valid ways of executing the Get command:

ss Get "My File.doc"
ss Get hello.c hello.h test.h makefile
ss Get *.c *.h makefile linkfile
ss Get *.*

The command line is not case-sensitive. Anything on the command line can be either uppercase or lowercase. For example, the second command above could also be entered as:

SS get HELLO.C Hello.H test.h MakeFile

You can get Help on any command-line command by entering:

SS [command] -?

The following table lists other commands you can enter from the command line:

Command | Action
ss dir | Displays the contents of the current project.
ss add sort.bas | Adds the file Sort.bas to the current project.
ss checkout reference.doc | Checks out the file Reference.doc.
ss create $/newproj | Creates a new project, $/newproj, directly under the root project.
ss cp .. | Changes the current project to the project one level above the one where you are now.
ss locate Readme.txt | Performs a global search for the project containing the file Readme.txt. If the file is shared, the results show all projects sharing the file.
ss find database Readme.txt | Finds instances of the string "database" in the file Readme.txt.
ss workfold $/Myprj C:\Mystf\Myfld | Sets C:\Mystf\Myfld to be the working folder for the $/Myprj project.

For a complete list of commands, see Key to Command Line Commands and Options.


Use Keyword Expansion in HTML Files

See Also

Note Do not use HTML keywords in non-HTML files.

Keyword expansion refers to VSS's ability to place certain information directly from the VSS database into your file for you. This can be handy, for example, if you want to place the string "Last modified on: date" in your Web pages. For more information, see How to Expand Keywords.

VSS HTML Keywords

HTML keywords are identical to traditional VSS keywords [image] except that they have an extra dollar sign in front of them. For example, $$JustDate $ instead of $JustDate $.

Note Keywords are case-sensitive, so be sure to capitalize them properly.

For example, you would place the following in a file:

Last modified on <!--$$JustDate:--!> <!--$-->

Upon checkin, VSS would replace it with:

Last modified on <!--$$JustDate:-->5/16/96<!--$-->

The next time you check in the file, the 5/16/96 is replaced by the current date, and so on. This automates updating your HTML pages each time they are modified.


Use Project Headers in SS.INI

See Also

Project headers allow you to specify variables on a project-by-project basis. Because almost every variable can be placed under a project header, you can customize VSS so that different projects act very differently.

If a variable occurs in the SS.INI file before any header, it applies to all projects. If a variable is placed under a project header, it applies only under that project. Consider the following example, in which the Diff_Format variable is set three times:

;the following variable applies to all projects
Diff_Format = Visual
;the following variables apply under $/Reports
[$/Reports]
Diff_Format = SS
Dir = C:\DEV
;the following variable applies under $/Reports/JournalLogs
[$/Reports/JournalLogs]
Diff_Format = UNIX

The first setting of Diff_Format occurs before any header; consequently, it sets the default for all projects. The second setting of Diff_Format overrides this setting for the project $/Reports. The setting also, by default, is inherited by all subprojects under $/Reports. However, under $/Reports/JournalLogs, the variable is explicitly set to UNIX; this setting blocks other inheritance, and applies only to JournalLogs and its subproject.


Use the Command Line after Running a Client Setup

When working at the Command Line, if you get a message stating "No VSS database (SRCSAFE.INI) found. Use the SSDIR environment variable or run netsetup.", set the SSDIR variable. This will tell VSS where to find the SRCSAFE.INI file for the VSS server installation to which you want to connect. You can do this by typing the following at the MS-DOS prompt:

set ssdir=\\server\share\vss

Where \\server\share\vss is the folder where the srcsafe.ini file is located.

Note Do not put a space between the equal sign and the location of the VSS server installation. The following will not work: set ssdir= \\server\share\vss.


Use the Working Folder at the Command Line

See Also CmdLine_Comment; Concept_AltCmdlineWords;

When you are working with the VSS command-line interface, commands such as Get and Check Out place files into your current folder, not into your working folder for the project as they do in the Windows interface.

VSS does not, by default, change your current folder when you issue an ss CP command (change current project); nor does it change your project if you move from folder to folder. That is, the working folder has, by default, no effect on the command line and vice versa.

To change the working folder of a project:

  • At the command prompt, type ss workfold $/the project name C:\the working folder name

    For example, to change the working folder for a project $/myprj from C:\default to C:\Mystf\Myfld, type the following:

    ss workfold $/Myprj C:\Mystf\Myfld


View Check In Comments

See Also

To view comments on a checked-out file:

  1. In VSS Explorer, select the file you want to view comments on.

  2. On the Tools menu, click Show History to display the History Options dialog box.

  3. Click OK to display the History of File dialog box.

  4. Click Details to display the History Details dialog box.

  5. View comments in the Comment box.


View Check In Information

See Also

This displays information about when the file was checked in.

To view checkin information on a file:

  1. In VSS Explorer, select the file you want to view checkin information on.

  2. On the Tools menu, click Show History to display the History Options dialog box.

  3. Click OK to display the History of File dialog box. VSS displays checkin information, such as version of the file, the user, date of the checkout, and action taken on the file.


View Deleted Files List

See Also

To view a project's deleted files list:

  1. In VSS Explorer, select the project in which you want to view deleted files.

  2. On the File menu, click Properties.

  3. Click the Deleted Items tab.

  4. Click Close when you are finished viewing the list.


View Details of File History

See Also

To view details of a file's history:

  1. In VSS Explorer, select the file you want to view details on.

  2. On the Tools menu, click Show History to display the History Options dialog box.

  3. Click OK to display the History of File dialog box.

  4. Click Details to display the History Details dialog box.


View File Links

See Also

File links are the locations where the file is shared.

To view file links:

  1. In VSS Explorer, select the file whose properties you want to view.

  2. On the File menu, click Properties, then click the Links tab.

  3. Click Close when you are finished viewing links.


View File Paths

See Also

A file path is the branch history of a file.

To view file paths:

  1. In VSS Explorer, select the file whose properties you want to view.

  2. On the File menu, click Properties, then click the Path tab.

  3. Click Close when you are finished viewing paths.


View File Properties

See Also

To view file properties:

  1. In VSS Explorer, select the file whose properties you want to view.

  2. On the File menu, click Properties, then click the General tab if it isn't already selected.

  3. Click Close when you are finished viewing properties.


View Files without a Working Folder

See Also

You can view the master copy of a file without placing a local copy of the file in your working folder.

To view a file:

  1. Click the file you want in VSS Explorer.

  2. On the Edit menu, click View File to display the File dialog box

  3. Click the View SourceSafe's copy of this file box, if it isn't already selected.

  5. If you want to specify an editor, click the Advanced button and do so in the last text box.

  6. Click OK.


View Files without Getting or Checking Out

See Also

You can view the master copy of a file without placing a local copy of the file in your working folder.

To view a file:

  1. Click the file you want in VSS Explorer.

  2. On the Edit menu, click View File.

  3. If you want to specify an editor, click the Advanced button.

  4. Click OK.


View Size of Selected File

See Also

To view the size of a selected file:

  1. In VSS Explorer, select the file whose size you want to view.

  2. On the File menu, click Properties, then click the General tab if it isn't already selected.

  3. Click Close when you are finished viewing the file size.


Virtual Rollback to a Previous Version of a File

See Also

To perform a virtual rollback on a file:

  1. Select the file in VSS Explorer.

  2. Check out the file using the Check Out command on the SourceSafe menu.

  3. On the Tools menu, click Show History to display the History Options dialog box.

  4. Click OK to display the History of File dialog box.

  5. Select a previous version of the file, then click Get.

  6. Click Close to quit the History of File dialog box.

  7. Check the file back into VSS Explorer using the Check In command on the SourceSafe menu.